/* A Bison parser, made by GNU Bison 2.6.1.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2012 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.6.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         cf_parse
#define yylex           cf_lex
#define yyerror         cf_error
#define yylval          cf_lval
#define yychar          cf_char
#define yydebug         cf_debug
#define yynerrs         cf_nerrs

/* Copy the first part of user declarations.  */
/* Line 336 of yacc.c  */
#line 1 "cf-parse.y"

/* Headers from ../../conf/confbase.Y */

#define PARSER 1

#include "nest/bird.h"
#include "conf/conf.h"
#include "lib/resource.h"
#include "lib/socket.h"
#include "lib/timer.h"
#include "lib/string.h"
#include "nest/protocol.h"
#include "nest/iface.h"
#include "nest/route.h"
#include "nest/cli.h"
#include "filter/filter.h"

/* FIXME: Turn on YYERROR_VERBOSE and work around lots of bison bugs? */

/* Defines from ../../conf/confbase.Y */

static void
check_u16(unsigned val)
{
  if (val > 0xFFFF)
    cf_error("Value %d out of range (0-65535)", val);
}

/* Headers from ../../sysdep/unix/config.Y */

#include "lib/unix.h"
#include <stdio.h>

/* Headers from ../../sysdep/unix/krt.Y */

#include "lib/krt.h"

/* Defines from ../../sysdep/unix/krt.Y */

#define THIS_KRT ((struct krt_config *) this_proto)
#define THIS_KIF ((struct kif_config *) this_proto)

/* Headers from ../../sysdep/linux/netlink.Y */

/* Headers from ../../nest/config.Y */

#include "nest/rt-dev.h"
#include "nest/password.h"
#include "nest/cmds.h"
#include "lib/lists.h"

/* Defines from ../../nest/config.Y */

static struct proto_config *this_proto;
static struct iface_patt *this_ipatt;
static struct iface_patt_node *this_ipn;
static struct roa_table_config *this_roa_table;
static list *this_p_list;
static struct password_item *this_p_item;
static int password_id;

static inline void
reset_passwords(void)
{
  this_p_list = NULL;
}

static inline list *
get_passwords(void)
{
  list *rv = this_p_list;
  this_p_list = NULL;
  return rv;
}

#define DIRECT_CFG ((struct rt_dev_config *) this_proto)

/* Headers from ../../filter/config.Y */

/* Defines from ../../filter/config.Y */

#define P(a,b) ((a << 8) | b)

static inline u32 pair(u32 a, u32 b) { return (a << 16) | b; }
static inline u32 pair_a(u32 p) { return p >> 16; }
static inline u32 pair_b(u32 p) { return p & 0xFFFF; }


/*
 * Sets and their items are during parsing handled as lists, linked
 * through left ptr. The first item in a list also contains a pointer
 * to the last item in a list (right ptr). For convenience, even items
 * are handled as one-item lists. Lists are merged by f_merge_items().
 */

static inline struct f_tree *
f_new_item(struct f_val from, struct f_val to)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from = from;
  t->to = to;
  return t;
}

static inline struct f_tree *
f_merge_items(struct f_tree *a, struct f_tree *b)
{
  if (!a) return b;
  a->right->left = b;
  a->right = b->right;
  b->right = NULL;
  return a;
}

static inline struct f_tree *
f_new_pair_item(int fa, int ta, int fb, int tb)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_PAIR;
  t->from.val.i = pair(fa, fb);
  t->to.val.i = pair(ta, tb);
  return t;
}

static inline struct f_tree *
f_new_pair_set(int fa, int ta, int fb, int tb)
{
  struct f_tree *lst = NULL;
  int i;

  if ((fa == ta) || ((fb == 0) && (tb == 0xFFFF)))
    return f_new_pair_item(fa, ta, fb, tb);
  
  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  for (i = fa; i <= ta; i++)
    lst = f_merge_items(lst, f_new_pair_item(i, i, fb, tb));

  return lst;
}

#define EC_ALL 0xFFFFFFFF

static struct f_tree *
f_new_ec_item(u32 kind, u32 ipv4_used, u32 key, u32 vf, u32 vt)
{
  u64 fm, to;

  if (ipv4_used || (key >= 0x10000)) {
    check_u16(vf);
    if (vt == EC_ALL)
      vt = 0xFFFF;
    else
      check_u16(vt);
  }

  if (kind == EC_GENERIC) {
    fm = ec_generic(key, vf);
    to = ec_generic(key, vt);
  }
  else if (ipv4_used) {
    fm = ec_ip4(kind, key, vf);
    to = ec_ip4(kind, key, vt);
  }
  else if (key < 0x10000) {
    fm = ec_as2(kind, key, vf);
    to = ec_as2(kind, key, vt);
  }
  else {
    fm = ec_as4(kind, key, vf);
    to = ec_as4(kind, key, vt);
  }

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_EC;
  t->from.val.ec = fm;
  t->to.val.ec = to;
  return t;
}

static inline struct f_inst *
f_generate_empty(struct f_inst *dyn)
{ 
  struct f_inst *e = f_new_inst();
  e->code = 'E';

  switch (dyn->aux & EAF_TYPE_MASK) {
    case EAF_TYPE_AS_PATH:
      e->aux = T_PATH;
      break;
    case EAF_TYPE_INT_SET:
      e->aux = T_CLIST;
      break;
    case EAF_TYPE_EC_SET:
      e->aux = T_ECLIST;
      break;
    default:
      cf_error("Can't empty that attribute");
  }

  dyn->code = P('e','S');
  dyn->a1.p = e;
  return dyn;
}


static inline struct f_inst *
f_generate_dpair(struct f_inst *t1, struct f_inst *t2)
{
  struct f_inst *rv;

  if ((t1->code == 'c') && (t2->code == 'c')) {
    if ((t1->aux != T_INT) || (t2->aux != T_INT))
      cf_error( "Can't operate with value of non-integer type in pair constructor");

    check_u16(t1->a2.i);
    check_u16(t2->a2.i);

    rv = f_new_inst();
    rv->code = 'c';
    rv->aux = T_PAIR;
    rv->a2.i = pair(t1->a2.i, t2->a2.i);
  }
  else {
    rv = f_new_inst();
    rv->code = P('m', 'p');
    rv->a1.p = t1;
    rv->a2.p = t2;
  }

  return rv;
}

static inline struct f_inst *
f_generate_ec(u16 kind, struct f_inst *tk, struct f_inst *tv)
{
  struct f_inst *rv;
  int c1 = 0, c2 = 0, ipv4_used = 0;
  u32 key = 0, val2 = 0;

  if (tk->code == 'c') {
    c1 = 1;

    if (tk->aux == T_INT) {
      ipv4_used = 0; key = tk->a2.i;
    }
    else if (tk->aux == T_QUAD) {
      ipv4_used = 1; key = tk->a2.i;
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }

#ifndef IPV6
  /* IP->Quad implicit conversion */
  else if (tk->code == 'C') {
    c1 = 1;
    struct f_val *val = tk->a1.p;
    if (val->type == T_IP) {
      ipv4_used = 1; key = ipa_to_u32(val->val.px.ip);
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }
#endif

  if (tv->code == 'c') {
    if (tv->aux != T_INT)
      cf_error("Can't operate with value of non-integer type in EC constructor");
    c2 = 1;
    val2 = tv->a2.i;
  }

  if (c1 && c2) {
    u64 ec;
  
    if (kind == EC_GENERIC) {
      ec = ec_generic(key, val2);
    }
    else if (ipv4_used) {
      check_u16(val2);
      ec = ec_ip4(kind, key, val2);
    }
    else if (key < 0x10000) {
      ec = ec_as2(kind, key, val2);
    }
    else {
      check_u16(val2);
      ec = ec_as4(kind, key, val2);
    }

    NEW_F_VAL;
    rv = f_new_inst();
    rv->code = 'C';
    rv->a1.p = val;    
    val->type = T_EC;
    val->val.ec = ec;
  }
  else {
    rv = f_new_inst();
    rv->code = P('m','c');
    rv->aux = kind;
    rv->a1.p = tk;
    rv->a2.p = tv;
  }

  return rv;
}



/* Headers from ../../proto/bgp/config.Y */

#include "proto/bgp/bgp.h"

/* Defines from ../../proto/bgp/config.Y */

#define BGP_CFG ((struct bgp_config *) this_proto)

/* Headers from ../../proto/ospf/config.Y */

#include "proto/ospf/ospf.h"

/* Defines from ../../proto/ospf/config.Y */

#define OSPF_CFG ((struct ospf_config *) this_proto)
#define OSPF_PATT ((struct ospf_iface_patt *) this_ipatt)

static struct ospf_area_config *this_area;
static struct nbma_node *this_nbma;
static list *this_nets;
static struct area_net_config *this_pref;
static struct ospf_stubnet_config *this_stubnet; 

#ifdef OSPFv2
static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  ip->passwords = get_passwords();

  if ((ip->autype == OSPF_AUTH_CRYPT) && (ip->helloint < 5))
    log(L_WARN "Hello or poll interval less that 5 makes cryptographic authenication prone to replay attacks");

  if ((ip->autype == OSPF_AUTH_NONE) && (ip->passwords != NULL))
    log(L_WARN "Password option without authentication option does not make sense");
}
#endif

#ifdef OSPFv3
static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  if ((ip->autype != OSPF_AUTH_NONE) || (get_passwords() != NULL))
    cf_error("Authentication not supported in OSPFv3");
}
#endif

static void
ospf_area_finish(void)
{
  if ((this_area->areaid == 0) && (this_area->type != OPT_E))
    cf_error("Backbone area cannot be stub/NSSA");

  if (this_area->summary && (this_area->type == OPT_E))
    cf_error("Only Stub/NSSA areas can use summary propagation");

  if (this_area->default_nssa && ((this_area->type != OPT_N) || ! this_area->summary))
    cf_error("Only NSSA areas with summary propagation can use NSSA default route");

  if ((this_area->default_cost & LSA_EXT_EBIT) && ! this_area->default_nssa)
    cf_error("Only NSSA default route can use type 2 metric");
}

static void
ospf_proto_finish(void)
{
  struct ospf_config *cf = OSPF_CFG;

  if (EMPTY_LIST(cf->area_list))
    cf_error( "No configured areas in OSPF");

  int areano = 0;
  int backbone = 0;
  struct ospf_area_config *ac;
  WALK_LIST(ac, cf->area_list)
  {
    areano++;
    if (ac->areaid == 0)
     backbone = 1;
  }
  cf->abr = areano > 1;

  if (cf->abr && !backbone)
  {
    struct ospf_area_config *ac = cfg_allocz(sizeof(struct ospf_area_config));
    ac->type = OPT_E; /* Backbone is non-stub */
    add_head(&cf->area_list, NODE ac);
    init_list(&ac->patt_list);
    init_list(&ac->net_list);
    init_list(&ac->enet_list);
    init_list(&ac->stubnet_list);
  }

  if (!cf->abr && !EMPTY_LIST(cf->vlink_list))
    cf_error( "Vlinks cannot be used on single area router");
}

static inline void
check_defcost(int cost)
{
  if ((cost <= 0) || (cost >= LSINFINITY))
   cf_error("Default cost must be in range 1-%d", LSINFINITY-1);
}

static inline void
set_instance_id(unsigned id)
{
#ifdef OSPFv3
  OSPF_PATT->instance_id = id;
#else
  cf_error("Instance ID requires OSPFv3");
#endif
}

/* Headers from ../../proto/pipe/config.Y */

#include "proto/pipe/pipe.h"

/* Defines from ../../proto/pipe/config.Y */

#define PIPE_CFG ((struct pipe_config *) this_proto)

/* Headers from ../../proto/radv/config.Y */

#include "proto/radv/radv.h"

/* Defines from ../../proto/radv/config.Y */

#define RADV_CFG ((struct radv_config *) this_proto)
#define RADV_IFACE ((struct radv_iface_config *) this_ipatt)
#define RADV_PREFIX this_radv_prefix
#define RADV_RDNSS (&this_radv_rdnss)
#define RADV_DNSSL (&this_radv_dnssl)

static struct radv_prefix_config *this_radv_prefix;
static struct radv_rdnss_config this_radv_rdnss;
static struct radv_dnssl_config this_radv_dnssl;
static list radv_dns_list;	/* Used by radv_rdnss and radv_dnssl */
static u8 radv_mult_val;	/* Used by radv_mult for second return value */


/* Headers from ../../proto/rip/config.Y */

#include "proto/rip/rip.h"
#include "nest/iface.h"

/* Defines from ../../proto/rip/config.Y */

#define RIP_CFG ((struct rip_proto_config *) this_proto)
#define RIP_IPATT ((struct rip_patt *) this_ipatt)

/* Headers from ../../proto/static/config.Y */

#include "proto/static/static.h"

/* Defines from ../../proto/static/config.Y */

#define STATIC_CFG ((struct static_config *) this_proto)
static struct static_route *this_srt, *this_srt_nh, *last_srt_nh;


/* Line 336 of yacc.c  */
#line 561 "cf-parse.tab.c"

# ifndef YY_NULL
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULL nullptr
#  else
#   define YY_NULL 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "cf-parse.tab.h".  */
#ifndef CF_CF_PARSE_TAB_H
# define CF_CF_PARSE_TAB_H
/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int cf_debug;
#endif

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     END = 258,
     CLI_MARKER = 259,
     INVALID_TOKEN = 260,
     ELSECOL = 261,
     DDOT = 262,
     GEQ = 263,
     LEQ = 264,
     NEQ = 265,
     AND = 266,
     OR = 267,
     PO = 268,
     PC = 269,
     NUM = 270,
     ENUM = 271,
     RTRID = 272,
     IPA = 273,
     SYM = 274,
     TEXT = 275,
     PREFIX_DUMMY = 276,
     DEFINE = 277,
     ON = 278,
     OFF = 279,
     YES = 280,
     NO = 281,
     LOG = 282,
     SYSLOG = 283,
     ALL = 284,
     DEBUG = 285,
     TRACE = 286,
     INFO = 287,
     REMOTE = 288,
     WARNING = 289,
     ERROR = 290,
     AUTH = 291,
     FATAL = 292,
     BUG = 293,
     STDERR = 294,
     SOFT = 295,
     TIMEFORMAT = 296,
     ISO = 297,
     SHORT = 298,
     LONG = 299,
     BASE = 300,
     NAME = 301,
     CONFIRM = 302,
     UNDO = 303,
     CHECK = 304,
     TIMEOUT = 305,
     CONFIGURE = 306,
     DOWN = 307,
     KERNEL = 308,
     PERSIST = 309,
     SCAN = 310,
     TIME = 311,
     LEARN = 312,
     DEVICE = 313,
     ROUTES = 314,
     KRT_SOURCE = 315,
     KRT_METRIC = 316,
     ASYNC = 317,
     TABLE = 318,
     KRT_PREFSRC = 319,
     KRT_REALM = 320,
     ROUTER = 321,
     ID = 322,
     PROTOCOL = 323,
     TEMPLATE = 324,
     PREFERENCE = 325,
     DISABLED = 326,
     DIRECT = 327,
     INTERFACE = 328,
     IMPORT = 329,
     EXPORT = 330,
     FILTER = 331,
     NONE = 332,
     STATES = 333,
     FILTERS = 334,
     RECEIVE = 335,
     LIMIT = 336,
     ACTION = 337,
     WARN = 338,
     BLOCK = 339,
     RESTART = 340,
     DISABLE = 341,
     KEEP = 342,
     FILTERED = 343,
     PASSWORD = 344,
     FROM = 345,
     PASSIVE = 346,
     TO = 347,
     EVENTS = 348,
     PACKETS = 349,
     PROTOCOLS = 350,
     INTERFACES = 351,
     PRIMARY = 352,
     STATS = 353,
     COUNT = 354,
     FOR = 355,
     COMMANDS = 356,
     PREEXPORT = 357,
     GENERATE = 358,
     ROA = 359,
     MAX = 360,
     FLUSH = 361,
     LISTEN = 362,
     BGP = 363,
     V6ONLY = 364,
     DUAL = 365,
     ADDRESS = 366,
     PORT = 367,
     PASSWORDS = 368,
     DESCRIPTION = 369,
     SORTED = 370,
     RELOAD = 371,
     IN = 372,
     OUT = 373,
     MRTDUMP = 374,
     MESSAGES = 375,
     RESTRICT = 376,
     MEMORY = 377,
     IGP_METRIC = 378,
     SHOW = 379,
     STATUS = 380,
     SUMMARY = 381,
     ROUTE = 382,
     SYMBOLS = 383,
     ADD = 384,
     DELETE = 385,
     DUMP = 386,
     RESOURCES = 387,
     SOCKETS = 388,
     NEIGHBORS = 389,
     ATTRIBUTES = 390,
     ECHO = 391,
     ENABLE = 392,
     FUNCTION = 393,
     PRINT = 394,
     PRINTN = 395,
     UNSET = 396,
     RETURN = 397,
     ACCEPT = 398,
     REJECT = 399,
     QUITBIRD = 400,
     INT = 401,
     BOOL = 402,
     IP = 403,
     PREFIX = 404,
     PAIR = 405,
     QUAD = 406,
     EC = 407,
     SET = 408,
     STRING = 409,
     BGPMASK = 410,
     BGPPATH = 411,
     CLIST = 412,
     ECLIST = 413,
     IF = 414,
     THEN = 415,
     ELSE = 416,
     CASE = 417,
     TRUE = 418,
     FALSE = 419,
     RT = 420,
     RO = 421,
     UNKNOWN = 422,
     GENERIC = 423,
     GW = 424,
     NET = 425,
     MASK = 426,
     PROTO = 427,
     SOURCE = 428,
     SCOPE = 429,
     CAST = 430,
     DEST = 431,
     LEN = 432,
     DEFINED = 433,
     CONTAINS = 434,
     RESET = 435,
     PREPEND = 436,
     FIRST = 437,
     LAST = 438,
     MATCH = 439,
     ROA_CHECK = 440,
     EMPTY = 441,
     WHERE = 442,
     EVAL = 443,
     LOCAL = 444,
     NEIGHBOR = 445,
     AS = 446,
     HOLD = 447,
     CONNECT = 448,
     RETRY = 449,
     KEEPALIVE = 450,
     MULTIHOP = 451,
     STARTUP = 452,
     VIA = 453,
     NEXT = 454,
     HOP = 455,
     SELF = 456,
     DEFAULT = 457,
     PATH = 458,
     METRIC = 459,
     START = 460,
     DELAY = 461,
     FORGET = 462,
     WAIT = 463,
     AFTER = 464,
     BGP_PATH = 465,
     BGP_LOCAL_PREF = 466,
     BGP_MED = 467,
     BGP_ORIGIN = 468,
     BGP_NEXT_HOP = 469,
     BGP_ATOMIC_AGGR = 470,
     BGP_AGGREGATOR = 471,
     BGP_COMMUNITY = 472,
     BGP_EXT_COMMUNITY = 473,
     RR = 474,
     RS = 475,
     CLIENT = 476,
     CLUSTER = 477,
     AS4 = 478,
     ADVERTISE = 479,
     IPV4 = 480,
     CAPABILITIES = 481,
     PREFER = 482,
     OLDER = 483,
     MISSING = 484,
     LLADDR = 485,
     DROP = 486,
     IGNORE = 487,
     REFRESH = 488,
     INTERPRET = 489,
     COMMUNITIES = 490,
     BGP_ORIGINATOR_ID = 491,
     BGP_CLUSTER_LIST = 492,
     IGP = 493,
     GATEWAY = 494,
     RECURSIVE = 495,
     MED = 496,
     TTL = 497,
     SECURITY = 498,
     DETERMINISTIC = 499,
     SECONDARY = 500,
     OSPF = 501,
     AREA = 502,
     OSPF_METRIC1 = 503,
     OSPF_METRIC2 = 504,
     OSPF_TAG = 505,
     OSPF_ROUTER_ID = 506,
     RFC1583COMPAT = 507,
     STUB = 508,
     TICK = 509,
     COST = 510,
     COST2 = 511,
     RETRANSMIT = 512,
     HELLO = 513,
     TRANSMIT = 514,
     PRIORITY = 515,
     DEAD = 516,
     TYPE = 517,
     BROADCAST = 518,
     BCAST = 519,
     NONBROADCAST = 520,
     NBMA = 521,
     POINTOPOINT = 522,
     PTP = 523,
     POINTOMULTIPOINT = 524,
     PTMP = 525,
     SIMPLE = 526,
     AUTHENTICATION = 527,
     STRICT = 528,
     CRYPTOGRAPHIC = 529,
     ELIGIBLE = 530,
     POLL = 531,
     NETWORKS = 532,
     HIDDEN = 533,
     VIRTUAL = 534,
     LINK = 535,
     RX = 536,
     BUFFER = 537,
     LARGE = 538,
     NORMAL = 539,
     STUBNET = 540,
     TAG = 541,
     EXTERNAL = 542,
     LSADB = 543,
     ECMP = 544,
     WEIGHT = 545,
     NSSA = 546,
     TRANSLATOR = 547,
     STABILITY = 548,
     GLOBAL = 549,
     LSID = 550,
     INSTANCE = 551,
     REAL = 552,
     NETMASK = 553,
     TOPOLOGY = 554,
     STATE = 555,
     PIPE = 556,
     PEER = 557,
     MODE = 558,
     OPAQUE = 559,
     TRANSPARENT = 560,
     RADV = 561,
     MIN = 562,
     RA = 563,
     INTERVAL = 564,
     MANAGED = 565,
     OTHER = 566,
     CONFIG = 567,
     MTU = 568,
     REACHABLE = 569,
     RETRANS = 570,
     TIMER = 571,
     CURRENT = 572,
     VALID = 573,
     PREFERRED = 574,
     MULT = 575,
     LIFETIME = 576,
     SKIP = 577,
     ONLINK = 578,
     AUTONOMOUS = 579,
     RDNSS = 580,
     DNSSL = 581,
     NS = 582,
     DOMAIN = 583,
     TRIGGER = 584,
     SENSITIVE = 585,
     RIP = 586,
     INFINITY = 587,
     PERIOD = 588,
     GARBAGE = 589,
     MULTICAST = 590,
     QUIET = 591,
     NOLISTEN = 592,
     VERSION1 = 593,
     PLAINTEXT = 594,
     MD5 = 595,
     HONOR = 596,
     NEVER = 597,
     ALWAYS = 598,
     RIP_METRIC = 599,
     RIP_TAG = 600,
     STATIC = 601,
     PROHIBIT = 602,
     MULTIPATH = 603,
     BLACKHOLE = 604,
     UNREACHABLE = 605
   };
#endif


#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{
/* Line 350 of yacc.c  */
#line 489 "cf-parse.y"

  int i;
  u32 i32;
  ip_addr a;
  struct symbol *s;
  char *t;
  struct rtable_config *r;
  struct f_inst *x;
  struct filter *f;
  struct f_tree *e;
  struct f_trie *trie;
  struct f_val v;
  struct f_path_mask *h;
  struct password_item *p;
  struct rt_show_data *ra;
  struct roa_show_data *ro;
  struct sym_show_data *sd;
  struct lsadb_show_data *ld;
  struct iface *iface;
  struct roa_table *rot;
  void *g;
  bird_clock_t time;
  struct prefix px;
  struct proto_spec ps;
  struct timeformat *tf;


/* Line 350 of yacc.c  */
#line 982 "cf-parse.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

extern YYSTYPE cf_lval;

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int cf_parse (void *YYPARSE_PARAM);
#else
int cf_parse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int cf_parse (void);
#else
int cf_parse ();
#endif
#endif /* ! YYPARSE_PARAM */

#endif /* !CF_CF_PARSE_TAB_H  */

/* Copy the second part of user declarations.  */

/* Line 353 of yacc.c  */
#line 1010 "cf-parse.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  64
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2612

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  372
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  267
/* YYNRULES -- Number of rules.  */
#define YYNRULES  833
/* YYNRULES -- Number of states.  */
#define YYNSTATES  1554

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   605

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    31,     2,     2,     2,    30,     2,     2,
     362,   363,    28,    26,   368,    27,    32,    29,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   365,   364,
      23,    22,    24,   369,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   370,     2,   371,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   366,     2,   367,    25,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     6,     9,    10,    13,    15,    19,    21,
      27,    33,    35,    37,    39,    41,    43,    44,    46,    48,
      49,    52,    55,    57,    59,    62,    65,    67,    69,    70,
      75,    78,    79,    81,    84,    86,    88,    92,    94,    98,
     100,   102,   104,   106,   108,   110,   112,   114,   116,   121,
     125,   127,   129,   131,   133,   136,   141,   145,   149,   153,
     158,   164,   168,   172,   177,   180,   181,   183,   184,   186,
     189,   192,   195,   199,   202,   206,   209,   213,   217,   221,
     226,   232,   234,   236,   238,   243,   244,   247,   250,   253,
     255,   257,   258,   260,   264,   268,   269,   278,   280,   285,
     287,   289,   290,   292,   296,   297,   300,   303,   306,   309,
     312,   315,   319,   323,   327,   332,   335,   339,   342,   345,
     347,   349,   351,   352,   355,   358,   361,   364,   367,   369,
     371,   375,   379,   380,   382,   384,   387,   388,   390,   394,
     396,   400,   401,   404,   407,   411,   415,   419,   420,   424,
     426,   428,   432,   434,   438,   440,   442,   444,   446,   448,
     450,   452,   454,   458,   460,   464,   466,   468,   473,   475,
     476,   480,   485,   487,   490,   491,   497,   503,   509,   515,
     520,   524,   528,   533,   539,   541,   542,   546,   551,   556,
     557,   560,   564,   568,   572,   575,   578,   581,   584,   588,
     592,   595,   598,   600,   602,   607,   608,   612,   616,   620,
     621,   623,   625,   630,   631,   634,   637,   640,   643,   646,
     649,   652,   653,   656,   666,   676,   681,   685,   689,   693,
     697,   701,   705,   709,   714,   716,   718,   720,   721,   723,
     727,   731,   735,   739,   744,   749,   754,   759,   762,   764,
     766,   768,   770,   771,   773,   774,   779,   782,   784,   786,
     788,   790,   792,   794,   796,   798,   800,   802,   804,   806,
     809,   812,   813,   817,   819,   823,   825,   827,   829,   832,
     836,   839,   844,   845,   851,   852,   854,   856,   859,   861,
     865,   867,   869,   871,   873,   875,   877,   881,   883,   885,
     887,   889,   891,   895,   897,   903,   915,   917,   919,   921,
     924,   926,   934,   944,   952,   954,   956,   958,   962,   964,
     966,   968,   972,   974,   978,   980,   984,   988,   990,   993,
     996,  1003,  1005,  1009,  1010,  1015,  1019,  1021,  1025,  1029,
    1033,  1036,  1039,  1042,  1045,  1046,  1049,  1052,  1053,  1055,
    1057,  1059,  1061,  1063,  1065,  1067,  1071,  1075,  1077,  1079,
    1085,  1093,  1094,  1099,  1101,  1103,  1105,  1107,  1109,  1111,
    1113,  1115,  1117,  1121,  1125,  1129,  1133,  1137,  1141,  1145,
    1149,  1153,  1157,  1161,  1165,  1169,  1173,  1176,  1181,  1183,
    1185,  1187,  1189,  1192,  1195,  1199,  1203,  1210,  1214,  1218,
    1222,  1226,  1232,  1239,  1246,  1253,  1260,  1265,  1274,  1279,
    1281,  1283,  1285,  1287,  1289,  1291,  1293,  1294,  1296,  1300,
    1302,  1306,  1307,  1309,  1314,  1321,  1326,  1330,  1336,  1342,
    1347,  1354,  1358,  1361,  1367,  1373,  1382,  1391,  1400,  1409,
    1412,  1416,  1420,  1426,  1433,  1441,  1448,  1453,  1458,  1464,
    1471,  1478,  1484,  1488,  1493,  1499,  1505,  1511,  1517,  1523,
    1528,  1533,  1539,  1545,  1551,  1557,  1563,  1569,  1575,  1581,
    1588,  1595,  1604,  1611,  1618,  1624,  1629,  1635,  1640,  1646,
    1651,  1657,  1662,  1668,  1674,  1677,  1681,  1685,  1687,  1690,
    1693,  1698,  1701,  1703,  1706,  1711,  1712,  1716,  1719,  1721,
    1724,  1728,  1732,  1736,  1740,  1743,  1747,  1748,  1754,  1755,
    1761,  1764,  1767,  1769,  1774,  1776,  1778,  1779,  1783,  1786,
    1789,  1792,  1798,  1801,  1802,  1806,  1807,  1810,  1813,  1817,
    1820,  1823,  1827,  1830,  1833,  1836,  1838,  1842,  1845,  1848,
    1851,  1854,  1857,  1860,  1864,  1867,  1870,  1873,  1876,  1879,
    1882,  1885,  1888,  1892,  1896,  1900,  1903,  1907,  1910,  1914,
    1918,  1923,  1926,  1929,  1932,  1936,  1940,  1944,  1946,  1947,
    1950,  1954,  1956,  1957,  1959,  1962,  1963,  1966,  1967,  1969,
    1973,  1974,  1975,  1978,  1979,  1983,  1984,  1988,  1993,  1995,
    1996,  2001,  2008,  2015,  2022,  2030,  2037,  2045,  2051,  2052,
    2055,  2059,  2062,  2066,  2070,  2073,  2077,  2080,  2083,  2087,
    2091,  2097,  2102,  2107,  2110,  2112,  2115,  2118,  2119,  2123,
    2124,  2128,  2131,  2132,  2136,  2142,  2143,  2148,  2153,  2157,
    2160,  2164,  2168,  2172,  2176,  2181,  2186,  2189,  2190,  2194,
    2195,  2199,  2203,  2207,  2208,  2209,  2213,  2214,  2218,  2223,
    2225,  2228,  2231,  2234,  2239,  2244,  2245,  2246,  2250,  2251,
    2255,  2259,  2261,  2262,  2263,  2266,  2269,  2270,  2271,  2275,
    2277,  2283,  2285,  2286,  2287,  2290,  2293,  2294,  2295,  2299,
    2301,  2307,  2309,  2312,  2313,  2316,  2319,  2323,  2327,  2332,
    2337,  2342,  2348,  2354,  2359,  2363,  2368,  2373,  2378,  2383,
    2385,  2387,  2389,  2391,  2393,  2395,  2397,  2399,  2400,  2403,
    2406,  2407,  2411,  2412,  2416,  2417,  2421,  2424,  2428,  2432,
    2438,  2444,  2448,  2451,  2455,  2459,  2461,  2464,  2469,  2473,
    2477,  2481,  2484,  2487,  2490,  2493,  2496,  2501,  2503,  2505,
    2507,  2509,  2511,  2513,  2515,  2517,  2519,  2521,  2523,  2525,
    2527,  2529,  2531,  2533,  2535,  2537,  2539,  2541,  2543,  2545,
    2547,  2549,  2551,  2553,  2555,  2557,  2559,  2561,  2563,  2565,
    2567,  2569,  2571,  2573,  2575,  2577,  2579,  2581,  2583,  2585,
    2587,  2589,  2591,  2593,  2595,  2597,  2599,  2601,  2603,  2605,
    2607,  2609,  2611,  2613,  2615,  2617,  2620,  2623,  2626,  2629,
    2632,  2635,  2637,  2640,  2643,  2647,  2651,  2655,  2659,  2663,
    2667,  2671,  2673,  2675,  2677,  2679,  2681,  2683,  2685,  2687,
    2689,  2691,  2693,  2695,  2697,  2699,  2701,  2703,  2705,  2707,
    2709,  2711,  2713,  2715
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     373,     0,    -1,   374,     3,    -1,     4,   634,    -1,    -1,
     374,   633,    -1,    15,    -1,   362,   532,   363,    -1,    19,
      -1,    33,    19,    22,   375,   364,    -1,    33,    19,    22,
      18,   364,    -1,   375,    -1,    34,    -1,    36,    -1,    35,
      -1,    37,    -1,    -1,    18,    -1,    19,    -1,    -1,    30,
      19,    -1,   378,   382,    -1,   380,    -1,   378,    -1,    29,
     375,    -1,   365,   378,    -1,    20,    -1,    20,    -1,    -1,
      38,   387,   388,   364,    -1,    57,    20,    -1,    -1,    20,
      -1,    39,   386,    -1,    50,    -1,    40,    -1,   366,   389,
     367,    -1,   390,    -1,   389,   368,   390,    -1,    41,    -1,
      42,    -1,    43,    -1,    44,    -1,    45,    -1,    46,    -1,
      47,    -1,    48,    -1,    49,    -1,   130,   106,   440,   364,
      -1,   130,    20,   364,    -1,   138,    -1,    79,    -1,    56,
      -1,    38,    -1,   392,    20,    -1,   392,    20,   375,    20,
      -1,   392,    53,    54,    -1,   392,    53,    55,    -1,    52,
     393,   364,    -1,    62,   401,   402,     3,    -1,    62,    51,
     401,   402,     3,    -1,    62,    58,     3,    -1,    62,    59,
       3,    -1,    62,    60,   401,     3,    -1,    63,     3,    -1,
      -1,    20,    -1,    -1,    61,    -1,    61,   375,    -1,   418,
      64,    -1,    65,   377,    -1,    66,    67,   375,    -1,    68,
     377,    -1,    69,    70,   377,    -1,   418,    69,    -1,    66,
      67,   375,    -1,   108,   384,   381,    -1,    64,    74,   375,
      -1,    77,    78,   409,   364,    -1,    77,    78,   101,   432,
     364,    -1,    15,    -1,    17,    -1,    18,    -1,   118,   119,
     411,   364,    -1,    -1,   411,   412,    -1,   122,   378,    -1,
     123,   375,    -1,   120,    -1,   121,    -1,    -1,   126,    -1,
      74,    19,   413,    -1,   115,    74,    19,    -1,    -1,   416,
     115,   380,   116,    15,   202,    15,   364,    -1,   415,    -1,
     415,   366,   416,   367,    -1,    79,    -1,    80,    -1,    -1,
      19,    -1,    19,   101,    19,    -1,    -1,    81,   375,    -1,
      82,   377,    -1,    41,   437,    -1,   130,   440,    -1,    85,
     421,    -1,    86,   421,    -1,    91,    92,   423,    -1,    85,
      92,   423,    -1,    86,    92,   423,    -1,    85,    98,    99,
     377,    -1,    74,   424,    -1,    77,    78,   409,    -1,   125,
      20,    -1,    87,   496,    -1,   497,    -1,    40,    -1,    88,
      -1,    -1,    93,    94,    -1,    93,    95,    -1,    93,    96,
      -1,    93,    97,    -1,   375,   422,    -1,    35,    -1,    19,
      -1,    41,   106,   437,    -1,    41,   112,   375,    -1,    -1,
      20,    -1,   381,    -1,    20,   381,    -1,    -1,    27,    -1,
     426,   428,   427,    -1,   429,    -1,   430,   368,   429,    -1,
      -1,   431,   430,    -1,   418,    83,    -1,   433,   419,   366,
      -1,   434,   420,   364,    -1,   434,   436,   364,    -1,    -1,
      84,   435,   430,    -1,    40,    -1,    35,    -1,   366,   438,
     367,    -1,   439,    -1,   438,   368,   439,    -1,    89,    -1,
      70,    -1,    90,    -1,   107,    -1,   104,    -1,   105,    -1,
      40,    -1,    35,    -1,   366,   441,   367,    -1,   442,    -1,
     441,   368,   442,    -1,    89,    -1,   131,    -1,   124,   366,
     444,   367,    -1,   445,    -1,    -1,   445,   364,   444,    -1,
     446,   366,   447,   367,    -1,   446,    -1,   100,    20,    -1,
      -1,   114,   101,   383,   364,   447,    -1,   114,   103,   383,
     364,   447,    -1,   154,   101,   383,   364,   447,    -1,   154,
     103,   383,   364,   447,    -1,    78,   375,   364,   447,    -1,
     135,   136,     3,    -1,   135,   133,     3,    -1,   135,   106,
     487,     3,    -1,   135,   106,    40,   487,     3,    -1,    19,
      -1,    -1,   135,   107,     3,    -1,   135,   107,   137,     3,
      -1,   135,   138,   456,     3,    -1,    -1,   456,   380,    -1,
     456,   111,   381,    -1,   456,    74,    19,    -1,   456,    87,
     496,    -1,   456,   497,    -1,   456,    40,    -1,   456,   108,
      -1,   456,    99,    -1,   456,   457,    19,    -1,   456,    79,
      19,    -1,   456,   109,    -1,   456,   110,    -1,   113,    -1,
      86,    -1,   135,   115,   459,     3,    -1,    -1,   459,   460,
     380,    -1,   459,   202,    15,    -1,   459,    74,    19,    -1,
      -1,   128,    -1,   111,    -1,   135,   139,   462,     3,    -1,
      -1,   462,    74,    -1,   462,   149,    -1,   462,    87,    -1,
     462,    79,    -1,   462,    80,    -1,   462,   115,    -1,   462,
      19,    -1,    -1,    74,    19,    -1,   140,   115,   380,   116,
      15,   202,    15,   463,     3,    -1,   141,   115,   380,   116,
      15,   202,    15,   463,     3,    -1,   117,   115,   463,     3,
      -1,   142,   143,     3,    -1,   142,   144,     3,    -1,   142,
     107,     3,    -1,   142,   145,     3,    -1,   142,   146,     3,
      -1,   142,    70,     3,    -1,   142,   106,     3,    -1,   147,
     475,   476,     3,    -1,    40,    -1,    35,    -1,    15,    -1,
      -1,    15,    -1,    97,   486,     3,    -1,   148,   486,     3,
      -1,    96,   486,     3,    -1,   127,   486,     3,    -1,   127,
     128,   486,     3,    -1,   127,   129,   486,     3,    -1,    41,
     486,   437,     3,    -1,   130,   486,   440,     3,    -1,   132,
       3,    -1,    19,    -1,    40,    -1,    20,    -1,    19,    -1,
      -1,    20,    -1,    -1,    87,    19,   489,   495,    -1,   199,
     532,    -1,   157,    -1,   158,    -1,   159,    -1,   160,    -1,
     161,    -1,   162,    -1,   163,    -1,   165,    -1,   166,    -1,
     167,    -1,   168,    -1,   169,    -1,   491,   164,    -1,   491,
      19,    -1,    -1,   492,   364,   493,    -1,   492,    -1,   492,
     364,   494,    -1,   499,    -1,    19,    -1,   495,    -1,   198,
     532,    -1,   362,   494,   363,    -1,   362,   363,    -1,   493,
     366,   502,   367,    -1,    -1,   149,    19,   501,   498,   499,
      -1,    -1,   503,    -1,   538,    -1,   503,   538,    -1,   538,
      -1,   366,   502,   367,    -1,    18,    -1,   375,    -1,    17,
      -1,   505,    -1,    16,    -1,    15,    -1,   362,   532,   363,
      -1,    17,    -1,   505,    -1,    16,    -1,   532,    -1,   508,
      -1,   508,     7,   508,    -1,    28,    -1,   362,   509,   368,
     509,   363,    -1,   362,   509,   368,   509,   363,     7,   362,
     508,   368,   508,   363,    -1,   532,    -1,   176,    -1,   177,
      -1,   178,    15,    -1,   179,    -1,   362,   512,   368,   511,
     368,   511,   363,    -1,   362,   512,   368,   511,   368,   511,
       7,   511,   363,    -1,   362,   512,   368,   511,   368,    28,
     363,    -1,   510,    -1,   513,    -1,   506,    -1,   506,     7,
     506,    -1,   510,    -1,   513,    -1,   507,    -1,   507,     7,
     507,    -1,   514,    -1,   516,   368,   514,    -1,   515,    -1,
     517,   368,   515,    -1,    18,    29,    15,    -1,   518,    -1,
     518,    26,    -1,   518,    27,    -1,   518,   366,    15,   368,
      15,   367,    -1,   519,    -1,   520,   368,   519,    -1,    -1,
     521,   517,   365,   502,    -1,   521,     6,   502,    -1,   530,
      -1,   362,   532,   363,    -1,    13,   524,    14,    -1,    29,
     525,    29,    -1,    15,   524,    -1,    28,   524,    -1,   369,
     524,    -1,   522,   524,    -1,    -1,    15,   525,    -1,   369,
     525,    -1,    -1,    15,    -1,   174,    -1,   175,    -1,    20,
      -1,   505,    -1,   518,    -1,    17,    -1,   370,   516,   371,
      -1,   370,   520,   371,    -1,    16,    -1,   523,    -1,   362,
     532,   368,   532,   363,    -1,   362,   512,   368,   532,   368,
     532,   363,    -1,    -1,    19,   362,   537,   363,    -1,    19,
      -1,   101,    -1,   180,    -1,   181,    -1,   183,    -1,   184,
      -1,   185,    -1,   186,    -1,   187,    -1,   362,   532,   363,
      -1,   532,    26,   532,    -1,   532,    27,   532,    -1,   532,
      28,   532,    -1,   532,    29,   532,    -1,   532,    11,   532,
      -1,   532,    12,   532,    -1,   532,    22,   532,    -1,   532,
      10,   532,    -1,   532,    23,   532,    -1,   532,     9,   532,
      -1,   532,    24,   532,    -1,   532,     8,   532,    -1,   532,
      25,   532,    -1,    31,   532,    -1,   189,   362,   532,   363,
      -1,   530,    -1,   526,    -1,   527,    -1,    81,    -1,   528,
     531,    -1,   528,   638,    -1,   532,    32,   159,    -1,   532,
      32,   188,    -1,   532,    32,   182,   362,   532,   363,    -1,
     532,    32,   193,    -1,   532,    32,   194,    -1,    26,   197,
      26,    -1,    27,   197,    27,    -1,    27,    27,   197,    27,
      27,    -1,   192,   362,   532,   368,   532,   363,    -1,   140,
     362,   532,   368,   532,   363,    -1,   141,   362,   532,   368,
     532,   363,    -1,    87,   362,   532,   368,   532,   363,    -1,
     196,   362,    19,   363,    -1,   196,   362,    19,   368,   532,
     368,   532,   363,    -1,    19,   362,   537,   363,    -1,   156,
      -1,   154,    -1,   155,    -1,    46,    -1,   150,    -1,   151,
      -1,   532,    -1,    -1,   534,    -1,   534,   368,   535,    -1,
     532,    -1,   532,   368,   536,    -1,    -1,   536,    -1,   170,
     532,   171,   504,    -1,   170,   532,   171,   504,   172,   504,
      -1,    19,    22,   532,   364,    -1,   153,   532,   364,    -1,
     528,   638,    22,   532,   364,    -1,   528,   531,    22,   532,
     364,    -1,    81,    22,   532,   364,    -1,   152,   362,   528,
     638,   363,   364,    -1,   533,   535,   364,    -1,   529,   364,
      -1,   173,   532,   366,   521,   367,    -1,   528,   638,    32,
     197,   364,    -1,   528,   638,    32,   192,   362,   532,   363,
     364,    -1,   528,   638,    32,   140,   362,   532,   363,   364,
      -1,   528,   638,    32,   141,   362,   532,   363,   364,    -1,
     528,   638,    32,    87,   362,   532,   363,   364,    -1,   418,
     119,    -1,   539,   419,   366,    -1,   540,   420,   364,    -1,
     540,   200,   202,   375,   364,    -1,   540,   200,   378,   202,
     375,   364,    -1,   540,   201,   378,   379,   202,   375,   364,
      -1,   540,   230,   233,    78,   409,   364,    -1,   540,   230,
     232,   364,    -1,   540,   231,   232,   364,    -1,   540,   203,
      67,   375,   364,    -1,   540,   208,   203,    67,   375,   364,
      -1,   540,   204,   205,    67,   375,   364,    -1,   540,   206,
      67,   375,   364,    -1,   540,   207,   364,    -1,   540,   207,
     375,   364,    -1,   540,   210,   211,   212,   364,    -1,   540,
     210,   211,    98,   364,    -1,   540,   240,   241,   212,   364,
      -1,   540,   240,   241,   242,   364,    -1,   540,   240,   241,
     243,   364,    -1,   540,   250,    83,   364,    -1,   540,   250,
     251,   364,    -1,   540,   214,   215,   377,   364,    -1,   540,
     252,   215,   377,   364,    -1,   540,   249,   215,   377,   364,
      -1,   540,   238,   239,   377,   364,    -1,   540,   255,   252,
     377,   364,    -1,   540,   213,   223,   375,   364,    -1,   540,
     213,   222,   375,   364,    -1,   540,   184,   122,   378,   364,
      -1,   540,   216,   217,    67,   375,   364,    -1,   540,    46,
     218,    67,   375,   364,    -1,   540,    46,   219,    67,   375,
     368,   375,   364,    -1,   540,    97,   220,    46,   377,   364,
      -1,   540,   148,   138,   244,   377,   364,    -1,   540,   148,
     234,   377,   364,    -1,   540,   237,   377,   364,    -1,   540,
     235,   236,   377,   364,    -1,   540,   100,    20,   364,    -1,
     540,   138,    92,   375,   364,    -1,   540,   102,   377,   364,
      -1,   540,   245,   246,   377,   364,    -1,   540,   256,   377,
     364,    -1,   540,   249,    74,   424,   364,    -1,   540,   253,
     254,   377,   364,    -1,   418,   257,    -1,   541,   419,   366,
      -1,   542,   543,   364,    -1,   420,    -1,   263,   377,    -1,
     300,   377,    -1,   300,   377,    92,   375,    -1,   265,   375,
      -1,   545,    -1,   258,   409,    -1,   544,   366,   546,   367,
      -1,    -1,   546,   547,   364,    -1,   264,   377,    -1,   302,
      -1,   137,   377,    -1,   213,   302,   377,    -1,   213,   266,
     375,    -1,   213,   267,   375,    -1,   264,   266,   375,    -1,
     303,   377,    -1,   303,   304,   375,    -1,    -1,   288,   548,
     366,   559,   367,    -1,    -1,   298,   549,   366,   559,   367,
      -1,   296,   550,    -1,    84,   570,    -1,   554,    -1,   551,
     366,   552,   367,    -1,   551,    -1,   380,    -1,    -1,   552,
     553,   364,    -1,   289,   377,    -1,   137,   377,    -1,   266,
     375,    -1,   557,   567,   366,   555,   367,    -1,   557,   567,
      -1,    -1,   555,   556,   364,    -1,    -1,   269,   375,    -1,
     268,   375,    -1,   270,   217,   375,    -1,   219,   375,    -1,
     272,   375,    -1,   272,   110,   375,    -1,   283,    88,    -1,
     283,   282,    -1,   283,   285,    -1,   443,    -1,   290,   291,
     409,    -1,   266,   375,    -1,   269,   375,    -1,   287,   375,
      -1,   268,   375,    -1,   219,   375,    -1,   272,   375,    -1,
     272,   110,   375,    -1,   273,   274,    -1,   273,   275,    -1,
     273,   276,    -1,   273,   277,    -1,   273,   278,    -1,   273,
     279,    -1,   273,   280,    -1,   273,   281,    -1,   308,   274,
     377,    -1,   279,   309,   377,    -1,   270,   217,   375,    -1,
     271,   375,    -1,   284,   276,   377,    -1,   264,   377,    -1,
      60,   291,   377,    -1,   300,   301,   375,    -1,   145,   366,
     563,   367,    -1,   283,    88,    -1,   283,   282,    -1,   283,
     285,    -1,   292,   293,   294,    -1,   292,   293,   295,    -1,
     292,   293,   375,    -1,   443,    -1,    -1,   559,   560,    -1,
     561,   562,   364,    -1,   380,    -1,    -1,   289,    -1,   297,
     375,    -1,    -1,   563,   565,    -1,    -1,   286,    -1,    18,
     564,   364,    -1,    -1,    -1,   307,   375,    -1,    -1,   568,
     558,   364,    -1,    -1,   366,   568,   367,    -1,   566,   430,
     567,   569,    -1,    20,    -1,    -1,   135,   257,   452,     3,
      -1,   135,   257,   145,   452,   571,     3,    -1,   135,   257,
      84,   452,   571,     3,    -1,   135,   257,   310,   452,   571,
       3,    -1,   135,   257,   310,    40,   452,   571,     3,    -1,
     135,   257,   311,   452,   571,     3,    -1,   135,   257,   311,
      40,   452,   571,     3,    -1,   135,   257,   299,   580,     3,
      -1,    -1,   580,   305,    -1,   580,   258,   409,    -1,   580,
     291,    -1,   580,   273,    15,    -1,   580,   306,   409,    -1,
     580,   212,    -1,   580,    77,   409,    -1,   580,    19,    -1,
     418,   312,    -1,   581,   419,   366,    -1,   582,   420,   364,
      -1,   582,   313,    74,    19,   364,    -1,   582,   314,   315,
     364,    -1,   582,   314,   316,   364,    -1,   418,   317,    -1,
     420,    -1,    84,   596,    -1,   160,   602,    -1,    -1,   336,
     585,   608,    -1,    -1,   337,   586,   614,    -1,   340,   380,
      -1,    -1,   587,   584,   364,    -1,   583,   419,   366,   587,
     367,    -1,    -1,   318,   319,   320,   375,    -1,   116,   319,
     320,   375,    -1,   318,   217,   375,    -1,   321,   377,    -1,
     322,   323,   377,    -1,   291,   324,   375,    -1,   325,    67,
     375,    -1,   326,   327,   375,    -1,   328,   211,    92,   375,
      -1,   213,   332,   375,   616,    -1,   160,   602,    -1,    -1,
     336,   591,   608,    -1,    -1,   337,   592,   614,    -1,   336,
     200,   377,    -1,   337,   200,   377,    -1,    -1,    -1,   594,
     590,   364,    -1,    -1,   366,   594,   367,    -1,   589,   430,
     595,   593,    -1,   380,    -1,   333,   377,    -1,   334,   377,
      -1,   335,   377,    -1,   329,   332,   375,   616,    -1,   330,
     332,   375,   616,    -1,    -1,    -1,   600,   598,   364,    -1,
      -1,   366,   600,   367,    -1,   597,   601,   599,    -1,   378,
      -1,    -1,    -1,   338,   603,    -1,   332,   615,    -1,    -1,
      -1,   607,   605,   364,    -1,   603,    -1,   366,   604,   607,
     367,   606,    -1,    20,    -1,    -1,    -1,   339,   609,    -1,
     332,   615,    -1,    -1,    -1,   613,   611,   364,    -1,   609,
      -1,   366,   610,   613,   367,   612,    -1,   375,    -1,   331,
     375,    -1,    -1,   341,   377,    -1,   418,   342,    -1,   617,
     419,   366,    -1,   618,   420,   364,    -1,   618,   343,   375,
     364,    -1,   618,   123,   375,   364,    -1,   618,   344,   375,
     364,    -1,   618,   345,    67,   375,   364,    -1,   618,    61,
      67,   375,   364,    -1,   618,   283,   619,   364,    -1,   618,
     443,   364,    -1,   618,   352,   354,   364,    -1,   618,   352,
     201,   364,    -1,   618,   352,   353,   364,    -1,   618,    84,
     625,   364,    -1,   350,    -1,   351,    -1,    88,    -1,   274,
      -1,   346,    -1,   347,    -1,   348,    -1,   349,    -1,    -1,
     215,   375,    -1,   314,   620,    -1,    -1,   622,   621,   364,
      -1,    -1,   366,   622,   367,    -1,    -1,   624,   430,   623,
      -1,   418,   357,    -1,   626,   419,   366,    -1,   627,   420,
     364,    -1,   627,    60,   291,   377,   364,    -1,   627,   249,
      74,   424,   364,    -1,   627,   631,   364,    -1,   138,   380,
      -1,   209,   378,   379,    -1,   629,   301,   375,    -1,   629,
      -1,   630,   629,    -1,   628,   209,   378,   379,    -1,   628,
     209,    20,    -1,   628,   359,   630,    -1,   628,   251,   378,
      -1,   628,   242,    -1,   628,   155,    -1,   628,   360,    -1,
     628,   361,    -1,   628,   358,    -1,   135,   357,   452,     3,
      -1,   364,    -1,   376,    -1,   385,    -1,   391,    -1,   394,
      -1,   408,    -1,   410,    -1,   414,    -1,   417,    -1,   635,
      -1,   425,    -1,   488,    -1,   490,    -1,   500,    -1,   395,
      -1,   396,    -1,   397,    -1,   398,    -1,   399,    -1,   400,
      -1,   448,    -1,   449,    -1,   450,    -1,   451,    -1,   453,
      -1,   454,    -1,   455,    -1,   458,    -1,   461,    -1,   464,
      -1,   465,    -1,   466,    -1,   467,    -1,   468,    -1,   469,
      -1,   470,    -1,   471,    -1,   472,    -1,   473,    -1,   474,
      -1,   477,    -1,   478,    -1,   479,    -1,   480,    -1,   481,
      -1,   482,    -1,   483,    -1,   484,    -1,   485,    -1,   572,
      -1,   573,    -1,   574,    -1,   575,    -1,   576,    -1,   577,
      -1,   578,    -1,   579,    -1,   632,    -1,   636,   367,    -1,
     637,   367,    -1,   434,   367,    -1,   540,   367,    -1,   542,
     367,    -1,   582,   367,    -1,   588,    -1,   618,   367,    -1,
     627,   367,    -1,   403,   419,   366,    -1,   636,   420,   364,
      -1,   636,   404,   364,    -1,   636,   407,   364,    -1,   405,
     419,   366,    -1,   637,   420,   364,    -1,   637,   406,   364,
      -1,    71,    -1,    72,    -1,    75,    -1,    76,    -1,   134,
      -1,     5,    -1,   224,    -1,   221,    -1,   225,    -1,   223,
      -1,   222,    -1,   226,    -1,   227,    -1,   228,    -1,   247,
      -1,   248,    -1,   229,    -1,   259,    -1,   260,    -1,   261,
      -1,   262,    -1,   355,    -1,   356,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   670,   670,   671,   674,   676,   683,   684,   685,   691,
     695,   704,   705,   706,   707,   708,   709,   715,   716,   723,
     724,   728,   735,   736,   740,   744,   751,   759,   760,   766,
     775,   776,   780,   785,   786,   790,   791,   795,   796,   800,
     801,   802,   803,   804,   805,   806,   807,   808,   814,   815,
     824,   825,   826,   827,   830,   831,   832,   833,   837,   844,
     847,   854,   857,   860,   863,   867,   868,   872,   873,   874,
     882,   887,   888,   892,   899,   905,   910,   914,   928,   942,
     943,   947,   948,   949,   960,   962,   964,   968,   969,   970,
     971,   978,   979,   983,   991,   995,   997,  1003,  1004,  1011,
    1012,  1016,  1022,  1026,  1036,  1038,  1042,  1043,  1044,  1045,
    1046,  1047,  1048,  1049,  1050,  1051,  1052,  1053,  1057,  1058,
    1059,  1060,  1064,  1065,  1066,  1067,  1068,  1072,  1078,  1082,
    1090,  1091,  1099,  1107,  1108,  1109,  1113,  1114,  1118,  1123,
    1124,  1127,  1135,  1142,  1149,  1150,  1151,  1155,  1163,  1169,
    1170,  1171,  1175,  1176,  1180,  1181,  1182,  1183,  1184,  1185,
    1191,  1192,  1193,  1197,  1198,  1202,  1203,  1209,  1210,  1213,
    1215,  1219,  1220,  1224,  1242,  1243,  1244,  1245,  1246,  1247,
    1255,  1258,  1261,  1264,  1268,  1269,  1272,  1275,  1279,  1283,
    1288,  1294,  1301,  1306,  1311,  1316,  1320,  1324,  1328,  1338,
    1346,  1350,  1357,  1358,  1363,  1367,  1374,  1381,  1385,  1393,
    1394,  1395,  1400,  1404,  1407,  1408,  1409,  1410,  1411,  1412,
    1413,  1418,  1423,  1431,  1438,  1445,  1453,  1455,  1457,  1459,
    1461,  1463,  1465,  1468,  1474,  1475,  1476,  1480,  1481,  1487,
    1489,  1491,  1493,  1495,  1497,  1501,  1505,  1508,  1512,  1513,
    1514,  1518,  1519,  1520,  1528,  1528,  1538,  1542,  1543,  1544,
    1545,  1546,  1547,  1548,  1549,  1550,  1551,  1552,  1553,  1554,
    1575,  1586,  1587,  1594,  1595,  1602,  1611,  1615,  1619,  1643,
    1644,  1648,  1661,  1661,  1677,  1678,  1681,  1682,  1686,  1689,
    1698,  1711,  1712,  1713,  1714,  1718,  1719,  1720,  1721,  1722,
    1726,  1729,  1730,  1731,  1735,  1738,  1747,  1750,  1751,  1752,
    1753,  1757,  1758,  1759,  1763,  1764,  1765,  1766,  1770,  1771,
    1772,  1773,  1777,  1778,  1782,  1783,  1787,  1794,  1795,  1796,
    1797,  1804,  1805,  1808,  1809,  1816,  1828,  1829,  1833,  1834,
    1838,  1839,  1840,  1841,  1842,  1846,  1847,  1848,  1852,  1853,
    1854,  1855,  1856,  1857,  1858,  1859,  1860,  1861,  1862,  1866,
    1867,  1877,  1881,  1904,  1940,  1942,  1943,  1944,  1945,  1946,
    1947,  1948,  1952,  1953,  1954,  1955,  1956,  1957,  1958,  1959,
    1960,  1961,  1962,  1963,  1964,  1965,  1966,  1967,  1969,  1970,
    1971,  1973,  1975,  1977,  1979,  1980,  1981,  1982,  1983,  1993,
    1994,  1995,  1996,  1997,  1998,  1999,  2001,  2002,  2007,  2030,
    2031,  2032,  2033,  2034,  2035,  2039,  2042,  2043,  2044,  2052,
    2059,  2068,  2069,  2073,  2079,  2089,  2098,  2104,  2109,  2116,
    2121,  2127,  2128,  2129,  2137,  2138,  2139,  2140,  2141,  2147,
    2168,  2169,  2170,  2171,  2172,  2182,  2183,  2184,  2185,  2186,
    2187,  2188,  2189,  2190,  2191,  2192,  2193,  2194,  2195,  2196,
    2197,  2198,  2199,  2200,  2201,  2202,  2203,  2204,  2205,  2206,
    2207,  2208,  2209,  2210,  2211,  2212,  2213,  2214,  2215,  2220,
    2221,  2222,  2223,  2224,  2235,  2245,  2246,  2250,  2251,  2252,
    2253,  2254,  2255,  2258,  2273,  2276,  2278,  2282,  2283,  2284,
    2285,  2286,  2287,  2288,  2289,  2290,  2291,  2291,  2292,  2292,
    2293,  2294,  2295,  2299,  2300,  2304,  2312,  2314,  2318,  2319,
    2320,  2324,  2325,  2328,  2330,  2333,  2334,  2335,  2336,  2337,
    2338,  2339,  2340,  2341,  2342,  2343,  2346,  2368,  2369,  2370,
    2371,  2372,  2373,  2374,  2375,  2376,  2377,  2378,  2379,  2380,
    2381,  2382,  2383,  2384,  2385,  2386,  2387,  2388,  2389,  2390,
    2391,  2392,  2393,  2394,  2395,  2396,  2397,  2398,  2401,  2403,
    2406,  2408,  2417,  2419,  2420,  2423,  2425,  2429,  2430,  2433,
    2443,  2464,  2466,  2469,  2471,  2474,  2476,  2480,  2484,  2485,
    2490,  2493,  2496,  2501,  2504,  2509,  2512,  2516,  2520,  2523,
    2524,  2525,  2526,  2527,  2528,  2529,  2530,  2536,  2543,  2544,
    2545,  2550,  2551,  2557,  2567,  2568,  2569,  2570,  2570,  2571,
    2571,  2572,  2579,  2581,  2585,  2589,  2606,  2607,  2608,  2609,
    2610,  2611,  2612,  2613,  2614,  2615,  2620,  2621,  2621,  2622,
    2622,  2623,  2624,  2628,  2646,  2648,  2651,  2653,  2657,  2660,
    2673,  2674,  2675,  2676,  2681,  2689,  2697,  2699,  2702,  2704,
    2708,  2712,  2722,  2727,  2728,  2729,  2733,  2745,  2747,  2751,
    2752,  2756,  2769,  2774,  2775,  2776,  2780,  2792,  2794,  2798,
    2799,  2804,  2805,  2809,  2810,  2816,  2823,  2824,  2825,  2826,
    2827,  2828,  2829,  2830,  2831,  2832,  2833,  2834,  2835,  2839,
    2840,  2841,  2846,  2847,  2848,  2849,  2850,  2853,  2854,  2855,
    2858,  2860,  2863,  2865,  2869,  2878,  2885,  2892,  2893,  2894,
    2895,  2896,  2899,  2908,  2916,  2923,  2924,  2928,  2933,  2939,
    2942,  2947,  2948,  2949,  2950,  2951,  2954,  2961,  2961,  2961,
    2961,  2961,  2961,  2961,  2961,  2961,  2961,  2961,  2961,  2961,
    2961,  2962,  2962,  2962,  2962,  2962,  2962,  2962,  2962,  2962,
    2962,  2962,  2962,  2962,  2962,  2962,  2962,  2962,  2962,  2962,
    2962,  2962,  2962,  2962,  2962,  2962,  2962,  2962,  2962,  2962,
    2962,  2962,  2962,  2962,  2962,  2962,  2962,  2962,  2962,  2962,
    2962,  2962,  2962,  2962,  2962,  2963,  2963,  2963,  2963,  2963,
    2963,  2963,  2963,  2963,  2964,  2964,  2964,  2964,  2965,  2965,
    2965,  2966,  2966,  2966,  2966,  2966,  2967,  2967,  2968,  2969,
    2970,  2971,  2972,  2973,  2974,  2975,  2976,  2977,  2978,  2978,
    2978,  2978,  2978,  2978
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "END", "CLI_MARKER", "INVALID_TOKEN",
  "ELSECOL", "DDOT", "GEQ", "LEQ", "NEQ", "AND", "OR", "PO", "PC", "NUM",
  "ENUM", "RTRID", "IPA", "SYM", "TEXT", "PREFIX_DUMMY", "'='", "'<'",
  "'>'", "'~'", "'+'", "'-'", "'*'", "'/'", "'%'", "'!'", "'.'", "DEFINE",
  "ON", "OFF", "YES", "NO", "LOG", "SYSLOG", "ALL", "DEBUG", "TRACE",
  "INFO", "REMOTE", "WARNING", "ERROR", "AUTH", "FATAL", "BUG", "STDERR",
  "SOFT", "TIMEFORMAT", "ISO", "SHORT", "LONG", "BASE", "NAME", "CONFIRM",
  "UNDO", "CHECK", "TIMEOUT", "CONFIGURE", "DOWN", "KERNEL", "PERSIST",
  "SCAN", "TIME", "LEARN", "DEVICE", "ROUTES", "KRT_SOURCE", "KRT_METRIC",
  "ASYNC", "TABLE", "KRT_PREFSRC", "KRT_REALM", "ROUTER", "ID", "PROTOCOL",
  "TEMPLATE", "PREFERENCE", "DISABLED", "DIRECT", "INTERFACE", "IMPORT",
  "EXPORT", "FILTER", "NONE", "STATES", "FILTERS", "RECEIVE", "LIMIT",
  "ACTION", "WARN", "BLOCK", "RESTART", "DISABLE", "KEEP", "FILTERED",
  "PASSWORD", "FROM", "PASSIVE", "TO", "EVENTS", "PACKETS", "PROTOCOLS",
  "INTERFACES", "PRIMARY", "STATS", "COUNT", "FOR", "COMMANDS",
  "PREEXPORT", "GENERATE", "ROA", "MAX", "FLUSH", "LISTEN", "BGP",
  "V6ONLY", "DUAL", "ADDRESS", "PORT", "PASSWORDS", "DESCRIPTION",
  "SORTED", "RELOAD", "IN", "OUT", "MRTDUMP", "MESSAGES", "RESTRICT",
  "MEMORY", "IGP_METRIC", "SHOW", "STATUS", "SUMMARY", "ROUTE", "SYMBOLS",
  "ADD", "DELETE", "DUMP", "RESOURCES", "SOCKETS", "NEIGHBORS",
  "ATTRIBUTES", "ECHO", "ENABLE", "FUNCTION", "PRINT", "PRINTN", "UNSET",
  "RETURN", "ACCEPT", "REJECT", "QUITBIRD", "INT", "BOOL", "IP", "PREFIX",
  "PAIR", "QUAD", "EC", "SET", "STRING", "BGPMASK", "BGPPATH", "CLIST",
  "ECLIST", "IF", "THEN", "ELSE", "CASE", "TRUE", "FALSE", "RT", "RO",
  "UNKNOWN", "GENERIC", "GW", "NET", "MASK", "PROTO", "SOURCE", "SCOPE",
  "CAST", "DEST", "LEN", "DEFINED", "CONTAINS", "RESET", "PREPEND",
  "FIRST", "LAST", "MATCH", "ROA_CHECK", "EMPTY", "WHERE", "EVAL", "LOCAL",
  "NEIGHBOR", "AS", "HOLD", "CONNECT", "RETRY", "KEEPALIVE", "MULTIHOP",
  "STARTUP", "VIA", "NEXT", "HOP", "SELF", "DEFAULT", "PATH", "METRIC",
  "START", "DELAY", "FORGET", "WAIT", "AFTER", "BGP_PATH",
  "BGP_LOCAL_PREF", "BGP_MED", "BGP_ORIGIN", "BGP_NEXT_HOP",
  "BGP_ATOMIC_AGGR", "BGP_AGGREGATOR", "BGP_COMMUNITY",
  "BGP_EXT_COMMUNITY", "RR", "RS", "CLIENT", "CLUSTER", "AS4", "ADVERTISE",
  "IPV4", "CAPABILITIES", "PREFER", "OLDER", "MISSING", "LLADDR", "DROP",
  "IGNORE", "REFRESH", "INTERPRET", "COMMUNITIES", "BGP_ORIGINATOR_ID",
  "BGP_CLUSTER_LIST", "IGP", "GATEWAY", "RECURSIVE", "MED", "TTL",
  "SECURITY", "DETERMINISTIC", "SECONDARY", "OSPF", "AREA", "OSPF_METRIC1",
  "OSPF_METRIC2", "OSPF_TAG", "OSPF_ROUTER_ID", "RFC1583COMPAT", "STUB",
  "TICK", "COST", "COST2", "RETRANSMIT", "HELLO", "TRANSMIT", "PRIORITY",
  "DEAD", "TYPE", "BROADCAST", "BCAST", "NONBROADCAST", "NBMA",
  "POINTOPOINT", "PTP", "POINTOMULTIPOINT", "PTMP", "SIMPLE",
  "AUTHENTICATION", "STRICT", "CRYPTOGRAPHIC", "ELIGIBLE", "POLL",
  "NETWORKS", "HIDDEN", "VIRTUAL", "LINK", "RX", "BUFFER", "LARGE",
  "NORMAL", "STUBNET", "TAG", "EXTERNAL", "LSADB", "ECMP", "WEIGHT",
  "NSSA", "TRANSLATOR", "STABILITY", "GLOBAL", "LSID", "INSTANCE", "REAL",
  "NETMASK", "TOPOLOGY", "STATE", "PIPE", "PEER", "MODE", "OPAQUE",
  "TRANSPARENT", "RADV", "MIN", "RA", "INTERVAL", "MANAGED", "OTHER",
  "CONFIG", "MTU", "REACHABLE", "RETRANS", "TIMER", "CURRENT", "VALID",
  "PREFERRED", "MULT", "LIFETIME", "SKIP", "ONLINK", "AUTONOMOUS", "RDNSS",
  "DNSSL", "NS", "DOMAIN", "TRIGGER", "SENSITIVE", "RIP", "INFINITY",
  "PERIOD", "GARBAGE", "MULTICAST", "QUIET", "NOLISTEN", "VERSION1",
  "PLAINTEXT", "MD5", "HONOR", "NEVER", "ALWAYS", "RIP_METRIC", "RIP_TAG",
  "STATIC", "PROHIBIT", "MULTIPATH", "BLACKHOLE", "UNREACHABLE", "'('",
  "')'", "';'", "':'", "'{'", "'}'", "','", "'?'", "'['", "']'", "$accept",
  "config", "conf_entries", "expr", "definition", "bool", "ipa",
  "ipa_scope", "prefix", "prefix_or_ipa", "pxlen", "datetime",
  "text_or_none", "log_config", "syslog_name", "log_file", "log_mask",
  "log_mask_list", "log_cat", "mrtdump_base", "timeformat_which",
  "timeformat_spec", "timeformat_base", "cmd_CONFIGURE",
  "cmd_CONFIGURE_SOFT", "cmd_CONFIGURE_CONFIRM", "cmd_CONFIGURE_UNDO",
  "cmd_CONFIGURE_CHECK", "cmd_DOWN", "cfg_name", "cfg_timeout",
  "kern_proto_start", "kern_item", "kif_proto_start", "kif_item",
  "nl_item", "rtrid", "idval", "listen", "listen_opts", "listen_opt",
  "tab_sorted", "newtab", "roa_table_start", "roa_table_opts", "roa_table",
  "proto_start", "proto_name", "proto_item", "imexport", "limit_action",
  "limit_spec", "rtable", "debug_default", "iface_patt_node_init",
  "iface_patt_node_body", "iface_negate", "iface_patt_node",
  "iface_patt_list", "iface_patt_init", "iface_patt", "dev_proto_start",
  "dev_proto", "dev_iface_init", "dev_iface_patt", "debug_mask",
  "debug_list", "debug_flag", "mrtdump_mask", "mrtdump_list",
  "mrtdump_flag", "password_list", "password_items", "password_item",
  "password_item_begin", "password_item_params", "cmd_SHOW_STATUS",
  "cmd_SHOW_MEMORY", "cmd_SHOW_PROTOCOLS", "cmd_SHOW_PROTOCOLS_ALL",
  "optsym", "cmd_SHOW_INTERFACES", "cmd_SHOW_INTERFACES_SUMMARY",
  "cmd_SHOW_ROUTE", "r_args", "export_or_preexport", "cmd_SHOW_ROA",
  "roa_args", "roa_mode", "cmd_SHOW_SYMBOLS", "sym_args", "roa_table_arg",
  "cmd_ADD_ROA", "cmd_DELETE_ROA", "cmd_FLUSH_ROA", "cmd_DUMP_RESOURCES",
  "cmd_DUMP_SOCKETS", "cmd_DUMP_INTERFACES", "cmd_DUMP_NEIGHBORS",
  "cmd_DUMP_ATTRIBUTES", "cmd_DUMP_ROUTES", "cmd_DUMP_PROTOCOLS",
  "cmd_ECHO", "echo_mask", "echo_size", "cmd_DISABLE", "cmd_ENABLE",
  "cmd_RESTART", "cmd_RELOAD", "cmd_RELOAD_IN", "cmd_RELOAD_OUT",
  "cmd_DEBUG", "cmd_MRTDUMP", "cmd_RESTRICT", "proto_patt", "proto_patt2",
  "filter_def", "$@1", "filter_eval", "type", "one_decl", "decls",
  "declsn", "filter_body", "filter", "where_filter", "function_params",
  "function_body", "function_def", "$@2", "cmds", "cmds_int", "block",
  "fipa", "set_atom", "switch_atom", "pair_expr", "pair_atom", "pair_item",
  "ec_expr", "ec_kind", "ec_item", "set_item", "switch_item", "set_items",
  "switch_items", "fprefix_s", "fprefix", "fprefix_set", "switch_body",
  "bgp_path_expr", "bgp_path", "bgp_path_tail1", "bgp_path_tail2",
  "constant", "constructor", "rtadot", "function_call", "symbol",
  "static_attr", "term", "break_command", "print_one", "print_list",
  "var_listn", "var_list", "cmd", "bgp_proto_start", "bgp_proto",
  "ospf_proto_start", "ospf_proto", "ospf_proto_item", "ospf_area_start",
  "ospf_area", "ospf_area_opts", "ospf_area_item", "$@3", "$@4",
  "ospf_stubnet", "ospf_stubnet_start", "ospf_stubnet_opts",
  "ospf_stubnet_item", "ospf_vlink", "ospf_vlink_opts", "ospf_vlink_item",
  "ospf_vlink_start", "ospf_iface_item", "pref_list", "pref_item",
  "pref_base", "pref_opt", "nbma_list", "nbma_eligible", "nbma_item",
  "ospf_iface_start", "ospf_instance_id", "ospf_iface_opts",
  "ospf_iface_opt_list", "ospf_iface", "opttext", "cmd_SHOW_OSPF",
  "cmd_SHOW_OSPF_NEIGHBORS", "cmd_SHOW_OSPF_INTERFACE",
  "cmd_SHOW_OSPF_TOPOLOGY", "cmd_SHOW_OSPF_TOPOLOGY_ALL",
  "cmd_SHOW_OSPF_STATE", "cmd_SHOW_OSPF_STATE_ALL", "cmd_SHOW_OSPF_LSADB",
  "lsadb_args", "pipe_proto_start", "pipe_proto", "radv_proto_start",
  "radv_proto_item", "$@5", "$@6", "radv_proto_opts", "radv_proto",
  "radv_iface_start", "radv_iface_item", "$@7", "$@8", "radv_iface_finish",
  "radv_iface_opts", "radv_iface_opt_list", "radv_iface",
  "radv_prefix_start", "radv_prefix_item", "radv_prefix_finish",
  "radv_prefix_opts", "radv_prefix_opt_list", "radv_prefix",
  "radv_rdnss_node", "radv_rdnss_start", "radv_rdnss_item",
  "radv_rdnss_finish", "radv_rdnss_opts", "radv_rdnss", "radv_dnssl_node",
  "radv_dnssl_start", "radv_dnssl_item", "radv_dnssl_finish",
  "radv_dnssl_opts", "radv_dnssl", "radv_mult", "radv_sensitive",
  "rip_cfg_start", "rip_cfg", "rip_auth", "rip_mode", "rip_iface_item",
  "rip_iface_opts", "rip_iface_opt_list", "rip_iface_init", "rip_iface",
  "static_proto_start", "static_proto", "stat_route0", "stat_multipath1",
  "stat_multipath", "stat_route", "cmd_SHOW_STATIC", "conf", "cli_cmd",
  "proto", "kern_proto", "kif_proto", "dynamic_attr", YY_NULL
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    61,    60,    62,   126,    43,    45,    42,    47,
      37,    33,    46,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,    40,    41,    59,    58,   123,   125,    44,    63,
      91,    93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   372,   373,   373,   374,   374,   375,   375,   375,   376,
     376,   377,   377,   377,   377,   377,   377,   378,   378,   379,
     379,   380,   381,   381,   382,   382,   383,   384,   384,   385,
     386,   386,   387,   387,   387,   388,   388,   389,   389,   390,
     390,   390,   390,   390,   390,   390,   390,   390,   391,   391,
     392,   392,   392,   392,   393,   393,   393,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   401,   402,   402,   402,
     403,   404,   404,   404,   404,   405,   406,   406,   407,   408,
     408,   409,   409,   409,   410,   411,   411,   412,   412,   412,
     412,   413,   413,   414,   415,   416,   416,   417,   417,   418,
     418,   419,   419,   419,   420,   420,   420,   420,   420,   420,
     420,   420,   420,   420,   420,   420,   420,   420,   421,   421,
     421,   421,   422,   422,   422,   422,   422,   423,   423,   424,
     425,   425,   426,   427,   427,   427,   428,   428,   429,   430,
     430,   431,   432,   433,   434,   434,   434,   435,   436,   437,
     437,   437,   438,   438,   439,   439,   439,   439,   439,   439,
     440,   440,   440,   441,   441,   442,   442,   443,   443,   444,
     444,   445,   445,   446,   447,   447,   447,   447,   447,   447,
     448,   449,   450,   451,   452,   452,   453,   454,   455,   456,
     456,   456,   456,   456,   456,   456,   456,   456,   456,   456,
     456,   456,   457,   457,   458,   459,   459,   459,   459,   460,
     460,   460,   461,   462,   462,   462,   462,   462,   462,   462,
     462,   463,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   475,   475,   476,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   486,
     486,   487,   487,   487,   489,   488,   490,   491,   491,   491,
     491,   491,   491,   491,   491,   491,   491,   491,   491,   491,
     492,   493,   493,   494,   494,   495,   496,   496,   497,   498,
     498,   499,   501,   500,   502,   502,   503,   503,   504,   504,
     505,   506,   506,   506,   506,   507,   507,   507,   507,   507,
     508,   509,   509,   509,   510,   510,   511,   512,   512,   512,
     512,   513,   513,   513,   514,   514,   514,   514,   515,   515,
     515,   515,   516,   516,   517,   517,   518,   519,   519,   519,
     519,   520,   520,   521,   521,   521,   522,   522,   523,   523,
     524,   524,   524,   524,   524,   525,   525,   525,   526,   526,
     526,   526,   526,   526,   526,   526,   526,   526,   526,   527,
     527,   528,   529,   530,   531,   531,   531,   531,   531,   531,
     531,   531,   532,   532,   532,   532,   532,   532,   532,   532,
     532,   532,   532,   532,   532,   532,   532,   532,   532,   532,
     532,   532,   532,   532,   532,   532,   532,   532,   532,   532,
     532,   532,   532,   532,   532,   532,   532,   532,   532,   533,
     533,   533,   533,   533,   533,   534,   535,   535,   535,   536,
     536,   537,   537,   538,   538,   538,   538,   538,   538,   538,
     538,   538,   538,   538,   538,   538,   538,   538,   538,   539,
     540,   540,   540,   540,   540,   540,   540,   540,   540,   540,
     540,   540,   540,   540,   540,   540,   540,   540,   540,   540,
     540,   540,   540,   540,   540,   540,   540,   540,   540,   540,
     540,   540,   540,   540,   540,   540,   540,   540,   540,   540,
     540,   540,   540,   540,   541,   542,   542,   543,   543,   543,
     543,   543,   543,   544,   545,   546,   546,   547,   547,   547,
     547,   547,   547,   547,   547,   547,   548,   547,   549,   547,
     547,   547,   547,   550,   550,   551,   552,   552,   553,   553,
     553,   554,   554,   555,   555,   556,   556,   556,   556,   556,
     556,   556,   556,   556,   556,   556,   557,   558,   558,   558,
     558,   558,   558,   558,   558,   558,   558,   558,   558,   558,
     558,   558,   558,   558,   558,   558,   558,   558,   558,   558,
     558,   558,   558,   558,   558,   558,   558,   558,   559,   559,
     560,   561,   562,   562,   562,   563,   563,   564,   564,   565,
     566,   567,   567,   568,   568,   569,   569,   570,   571,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   580,
     580,   580,   580,   580,   580,   580,   580,   581,   582,   582,
     582,   582,   582,   583,   584,   584,   584,   585,   584,   586,
     584,   584,   587,   587,   588,   589,   590,   590,   590,   590,
     590,   590,   590,   590,   590,   590,   590,   591,   590,   592,
     590,   590,   590,   593,   594,   594,   595,   595,   596,   597,
     598,   598,   598,   598,   598,   599,   600,   600,   601,   601,
     602,   603,   604,   605,   605,   605,   606,   607,   607,   608,
     608,   609,   610,   611,   611,   611,   612,   613,   613,   614,
     614,   615,   615,   616,   616,   617,   618,   618,   618,   618,
     618,   618,   618,   618,   618,   618,   618,   618,   618,   619,
     619,   619,   620,   620,   620,   620,   620,   621,   621,   621,
     622,   622,   623,   623,   624,   625,   626,   627,   627,   627,
     627,   627,   628,   629,   629,   630,   630,   631,   631,   631,
     631,   631,   631,   631,   631,   631,   632,   633,   633,   633,
     633,   633,   633,   633,   633,   633,   633,   633,   633,   633,
     633,   634,   634,   634,   634,   634,   634,   634,   634,   634,
     634,   634,   634,   634,   634,   634,   634,   634,   634,   634,
     634,   634,   634,   634,   634,   634,   634,   634,   634,   634,
     634,   634,   634,   634,   634,   634,   634,   634,   634,   634,
     634,   634,   634,   634,   634,   635,   635,   635,   635,   635,
     635,   635,   635,   635,   636,   636,   636,   636,   637,   637,
     637,   638,   638,   638,   638,   638,   638,   638,   638,   638,
     638,   638,   638,   638,   638,   638,   638,   638,   638,   638,
     638,   638,   638,   638
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     2,     0,     2,     1,     3,     1,     5,
       5,     1,     1,     1,     1,     1,     0,     1,     1,     0,
       2,     2,     1,     1,     2,     2,     1,     1,     0,     4,
       2,     0,     1,     2,     1,     1,     3,     1,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     4,     3,
       1,     1,     1,     1,     2,     4,     3,     3,     3,     4,
       5,     3,     3,     4,     2,     0,     1,     0,     1,     2,
       2,     2,     3,     2,     3,     2,     3,     3,     3,     4,
       5,     1,     1,     1,     4,     0,     2,     2,     2,     1,
       1,     0,     1,     3,     3,     0,     8,     1,     4,     1,
       1,     0,     1,     3,     0,     2,     2,     2,     2,     2,
       2,     3,     3,     3,     4,     2,     3,     2,     2,     1,
       1,     1,     0,     2,     2,     2,     2,     2,     1,     1,
       3,     3,     0,     1,     1,     2,     0,     1,     3,     1,
       3,     0,     2,     2,     3,     3,     3,     0,     3,     1,
       1,     3,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     3,     1,     1,     4,     1,     0,
       3,     4,     1,     2,     0,     5,     5,     5,     5,     4,
       3,     3,     4,     5,     1,     0,     3,     4,     4,     0,
       2,     3,     3,     3,     2,     2,     2,     2,     3,     3,
       2,     2,     1,     1,     4,     0,     3,     3,     3,     0,
       1,     1,     4,     0,     2,     2,     2,     2,     2,     2,
       2,     0,     2,     9,     9,     4,     3,     3,     3,     3,
       3,     3,     3,     4,     1,     1,     1,     0,     1,     3,
       3,     3,     3,     4,     4,     4,     4,     2,     1,     1,
       1,     1,     0,     1,     0,     4,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       2,     0,     3,     1,     3,     1,     1,     1,     2,     3,
       2,     4,     0,     5,     0,     1,     1,     2,     1,     3,
       1,     1,     1,     1,     1,     1,     3,     1,     1,     1,
       1,     1,     3,     1,     5,    11,     1,     1,     1,     2,
       1,     7,     9,     7,     1,     1,     1,     3,     1,     1,
       1,     3,     1,     3,     1,     3,     3,     1,     2,     2,
       6,     1,     3,     0,     4,     3,     1,     3,     3,     3,
       2,     2,     2,     2,     0,     2,     2,     0,     1,     1,
       1,     1,     1,     1,     1,     3,     3,     1,     1,     5,
       7,     0,     4,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     2,     4,     1,     1,
       1,     1,     2,     2,     3,     3,     6,     3,     3,     3,
       3,     5,     6,     6,     6,     6,     4,     8,     4,     1,
       1,     1,     1,     1,     1,     1,     0,     1,     3,     1,
       3,     0,     1,     4,     6,     4,     3,     5,     5,     4,
       6,     3,     2,     5,     5,     8,     8,     8,     8,     2,
       3,     3,     5,     6,     7,     6,     4,     4,     5,     6,
       6,     5,     3,     4,     5,     5,     5,     5,     5,     4,
       4,     5,     5,     5,     5,     5,     5,     5,     5,     6,
       6,     8,     6,     6,     5,     4,     5,     4,     5,     4,
       5,     4,     5,     5,     2,     3,     3,     1,     2,     2,
       4,     2,     1,     2,     4,     0,     3,     2,     1,     2,
       3,     3,     3,     3,     2,     3,     0,     5,     0,     5,
       2,     2,     1,     4,     1,     1,     0,     3,     2,     2,
       2,     5,     2,     0,     3,     0,     2,     2,     3,     2,
       2,     3,     2,     2,     2,     1,     3,     2,     2,     2,
       2,     2,     2,     3,     2,     2,     2,     2,     2,     2,
       2,     2,     3,     3,     3,     2,     3,     2,     3,     3,
       4,     2,     2,     2,     3,     3,     3,     1,     0,     2,
       3,     1,     0,     1,     2,     0,     2,     0,     1,     3,
       0,     0,     2,     0,     3,     0,     3,     4,     1,     0,
       4,     6,     6,     6,     7,     6,     7,     5,     0,     2,
       3,     2,     3,     3,     2,     3,     2,     2,     3,     3,
       5,     4,     4,     2,     1,     2,     2,     0,     3,     0,
       3,     2,     0,     3,     5,     0,     4,     4,     3,     2,
       3,     3,     3,     3,     4,     4,     2,     0,     3,     0,
       3,     3,     3,     0,     0,     3,     0,     3,     4,     1,
       2,     2,     2,     4,     4,     0,     0,     3,     0,     3,
       3,     1,     0,     0,     2,     2,     0,     0,     3,     1,
       5,     1,     0,     0,     2,     2,     0,     0,     3,     1,
       5,     1,     2,     0,     2,     2,     3,     3,     4,     4,
       4,     5,     5,     4,     3,     4,     4,     4,     4,     1,
       1,     1,     1,     1,     1,     1,     1,     0,     2,     2,
       0,     3,     0,     3,     0,     3,     2,     3,     3,     5,
       5,     3,     2,     3,     3,     1,     2,     4,     3,     3,
       3,     2,     2,     2,     2,     2,     4,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     2,     2,     2,     2,
       2,     1,     2,     2,     3,     3,     3,     3,     3,     3,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       4,     0,     0,     0,     0,    65,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   751,
     752,   753,   754,   755,   756,   757,   758,   759,   760,   761,
     762,   763,   764,   765,   766,   767,   768,   769,   770,   771,
     772,   773,   774,   775,   776,   777,   778,   779,   780,   781,
     782,   783,   784,   785,   786,   787,   788,   789,   790,   791,
     792,   793,   794,     3,     1,     2,     0,     0,     0,     0,
       0,     0,    99,   100,     0,     0,     0,     0,     0,   361,
     737,   738,   739,   740,   741,   101,   101,   742,   743,   744,
      97,   745,     0,   747,   101,   104,   748,   749,   750,   101,
     104,   101,   104,   101,   104,   101,   801,   101,   104,   101,
     104,     5,   746,   104,   104,   248,   250,   249,     0,    66,
      65,     0,     0,    65,    67,    64,     0,     0,   221,     0,
       0,     0,     0,   247,   252,     0,   205,     0,     0,   189,
     213,   185,   185,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   235,   234,   237,     0,     0,    32,    31,
      34,     0,     0,     0,    53,    52,    51,    50,     0,     0,
      91,     0,   254,     0,    85,     0,     0,   282,   344,   348,
     357,   354,   290,   363,   351,     0,     0,   347,   361,   391,
       0,     0,     0,   349,   350,     0,     0,     0,   361,     0,
     352,   353,   358,   389,   390,     0,   388,   256,   102,     0,
       0,    95,    70,    75,   143,   439,   484,   607,   613,   685,
     716,     0,     0,     0,     0,     0,    16,   147,     0,     0,
       0,     0,     0,   797,     0,     0,     0,     0,     0,     0,
      16,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    16,     0,
       0,     0,     0,     0,     0,     0,     0,    16,   798,     0,
       0,     0,    16,     0,    16,   799,   487,     0,     0,   492,
       0,     0,     0,   800,     0,     0,     0,     0,   714,     0,
       0,     0,     0,     0,     0,     0,     0,   802,     0,     0,
     168,   172,     0,     0,     0,     0,   803,     0,     0,     0,
       0,    16,     0,    16,     0,   795,     0,     0,     0,     0,
      28,   796,     0,     0,   150,   149,     0,     0,    67,    61,
      62,     0,    68,     0,   241,   239,     0,     0,     0,     0,
     242,   161,   160,     0,     0,   251,   253,   252,     0,   186,
       0,   209,   181,   180,     0,     0,   184,   185,   185,   598,
     185,   185,     0,     0,    17,    18,     0,     0,     0,   231,
     232,   228,   226,   227,   229,   230,   238,     0,   240,     0,
       0,    33,    35,     0,     0,   130,     6,     8,   361,   131,
      54,     0,    58,    92,    93,    81,    82,    83,   141,     0,
     271,    94,     0,    49,     0,     0,   344,   363,   344,   361,
     344,   344,     0,   336,     0,   361,     0,     0,     0,   347,
     347,     0,   386,   361,   361,   361,   361,   361,     0,   307,
     308,     0,   310,     0,     0,   294,   292,   361,   291,   293,
     316,   314,   315,   322,     0,   327,   331,     0,   816,   811,
     812,   813,   814,   364,   815,   365,   366,   367,   368,   369,
     370,   371,   818,   821,   820,   817,   819,   822,   823,   824,
     827,   825,   826,   828,   829,   830,   831,   832,   833,   392,
     393,   361,   361,   361,   361,   361,   361,   361,   361,   361,
     361,   361,   361,   361,     0,     0,   804,   808,     0,   144,
     107,   129,   115,     0,   105,    12,    14,    13,    15,    11,
     106,   132,   120,   271,   121,     0,     0,   361,   109,   119,
       0,   110,     0,   117,   108,   145,   146,   440,     0,     0,
       0,     0,     0,     0,     0,    16,     0,     0,     0,    19,
       0,     0,     0,   452,     0,     0,     0,     0,     0,    16,
       0,     0,     0,     0,    16,     0,    16,     0,    16,     0,
      16,     0,     0,    16,    16,    16,     0,   441,   485,   493,
     488,   491,   489,   486,   495,   608,     0,     0,     0,   609,
     622,   686,     0,   132,     0,   173,     0,   169,   701,   699,
     700,     0,     0,     0,     0,     0,     0,     0,   687,   694,
     174,   717,    16,   722,     0,   718,   732,     0,   731,     0,
     735,     0,   733,   734,   721,     0,    71,     0,    73,    16,
     806,   807,   805,     0,    27,     0,   810,   809,   155,   154,
     156,   158,   159,   157,     0,   152,   245,     0,    63,    69,
      59,   222,   225,   243,   244,   165,   166,     0,   163,   246,
       0,   182,   187,   204,     0,   211,   210,     0,     0,   188,
     195,     0,     0,   203,   271,   197,   196,   200,   201,     0,
     202,   190,     0,   194,   212,   220,   214,   217,   218,   216,
     219,   215,   589,   589,     0,   185,   589,   185,   589,   590,
     736,     0,     0,    21,     0,     0,   233,     0,     0,    30,
      39,    40,    41,    42,    43,    44,    45,    46,    47,     0,
      37,    29,     0,     0,    56,    57,   132,     0,    79,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,     0,     0,     0,   255,   275,    89,    90,     0,     0,
      84,    86,    48,     0,   271,   340,   341,     0,   342,   343,
     338,   326,   419,   422,     0,   399,     0,   400,   345,   346,
     339,     0,     0,     0,     0,     0,     0,   309,   361,   372,
     361,   303,   301,     0,     0,   300,     0,     0,   355,   328,
     329,     0,     0,   356,   384,   382,   380,   377,   378,   379,
     381,   383,   385,   373,   374,   375,   376,   394,     0,   395,
     397,   398,   103,     0,    98,   116,   136,   139,   148,   276,
     277,   118,   128,   122,   112,    16,   278,   113,   111,     0,
       0,    16,   477,   479,     0,    16,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   453,     0,     0,     0,     0,
       0,     0,     0,   446,     0,   447,     0,   475,     0,     0,
       0,     0,     0,     0,     0,   459,   460,     0,     0,     0,
     481,     0,     0,     0,   611,   612,   104,     0,   712,   698,
     689,     0,     0,   693,   688,   690,     0,   696,   697,   695,
       0,     0,     0,     0,     0,     0,   728,    19,   730,     0,
     725,   729,    78,    72,    74,    76,    23,    22,    77,   151,
       0,    60,   162,     0,   183,   208,   207,   206,   192,   199,
     193,   191,   198,   588,     0,     0,   597,   606,     0,   604,
       0,     0,   601,   599,     0,   589,     0,   589,     0,    24,
      25,     0,     0,    10,     9,    36,     0,     7,    55,   142,
      80,   270,   269,   271,   361,    87,    88,   280,   273,     0,
     283,   337,   361,   408,     0,   361,   361,   361,   387,   361,
     406,   361,     0,     0,   361,   361,   361,   290,   317,   323,
       0,     0,   332,   361,     0,   137,     0,   132,     0,   127,
     114,     0,     0,     0,   478,     0,   474,   468,   442,     0,
      20,     0,   448,     0,   451,     0,   455,   454,   467,   466,
     461,     0,     0,   476,   464,   456,   457,   458,   480,   482,
     463,   462,   483,   465,   490,   580,    16,     0,    16,   506,
       0,     0,   508,   498,    16,   494,     0,   512,   581,   610,
     625,     0,   617,   619,     0,   624,   614,     0,   692,   710,
     715,   167,   169,   691,     0,     0,     0,     0,     0,   171,
     719,   720,   727,    19,     0,   726,   153,   164,   592,   591,
     605,   600,   602,   603,     0,   593,     0,   595,     0,     0,
      38,   272,     0,   412,     0,   413,   414,     0,   361,   410,
     411,   409,   361,   361,     0,   361,     0,     0,   361,   286,
       0,   279,   420,   401,     0,     0,     0,     0,     0,   361,
     359,   302,   300,     0,     0,   306,     0,     0,     0,   133,
     134,   138,   140,   123,   124,   125,   126,   470,     0,   472,
     473,   443,     0,   450,   449,   469,   445,   132,   511,   499,
       0,     0,    16,     0,   497,     0,     0,   515,   510,   514,
       0,     0,   504,   496,     0,   522,   132,   615,   649,   658,
     616,     0,     0,   621,   623,   707,   170,   174,    26,     0,
       0,     0,     0,   723,   724,   594,   596,   221,   221,   361,
     361,   361,   361,     0,     0,     0,   281,   287,     0,     0,
     432,   415,   417,     0,   274,   405,   403,   404,   402,   361,
       0,   304,   361,     0,   396,     0,   135,     0,   444,   581,
     501,   502,   500,   503,   568,   536,   516,   568,   505,   582,
     523,   646,   656,   655,   662,   661,   669,   618,   671,   672,
     679,   620,     0,     0,   713,     0,   179,   174,   174,   174,
     174,     0,     0,     0,     0,     0,     0,   426,   361,   333,
     361,   361,     0,   361,   431,     0,   360,     0,     0,     0,
     330,     0,   471,   585,     0,     0,     0,   525,   644,   643,
       0,   660,   667,   677,   708,   702,   703,   704,   705,   706,
     709,   711,   175,   176,   177,   178,   223,   224,   425,   362,
     429,     0,   361,   423,   288,     0,     0,     0,     0,     0,
       0,     0,     0,   418,   407,   361,   313,   361,   311,     0,
     583,   587,   507,   571,   569,   572,    16,     0,    16,   513,
       0,   509,     0,     0,     0,     0,     0,     0,   521,   535,
       0,     0,   648,     0,     0,    16,    16,    16,   659,     0,
     663,   673,     0,     0,   361,   361,   295,   299,   297,   361,
     433,   298,   320,   318,   319,   324,     0,   428,   427,   361,
     361,   361,   361,   434,     0,     0,    96,     0,   573,     0,
       0,   519,   520,   518,   517,   529,   527,   526,     0,     0,
     530,   532,   533,   534,   524,     0,     0,     0,     0,     0,
      16,     0,     0,     0,     0,   637,   639,   647,     0,     0,
       0,   650,   651,   652,   657,     0,     0,   666,     0,     0,
       0,   676,     0,   430,   289,   424,   335,   300,     0,   361,
       0,     0,     0,     0,     0,   361,   312,     0,     0,     0,
      16,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   586,   567,     0,   574,   570,
     528,   531,     0,   636,     0,     0,     0,     0,   629,    16,
       0,     0,     0,    16,     0,    16,     0,   645,   683,   683,
       0,   681,   665,   664,   670,   668,   675,   674,   680,   678,
     296,   361,   321,   334,   325,     0,     0,     0,     0,     0,
      16,   575,   541,   557,   537,   540,   538,     0,   555,     0,
     542,   544,   545,   546,   547,   548,   549,   550,   551,    16,
     561,   562,   563,    16,   539,     0,     0,    16,   584,     0,
     683,   631,   628,     0,   630,   632,   633,     0,   641,   638,
     642,   640,    16,   653,   654,   682,     0,   438,   436,   437,
     435,   305,   558,     0,   554,   543,   553,   556,   564,   565,
     566,   559,   552,   627,   635,   626,   634,   684,   577,   560,
     576,   578,     0,   579
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,   509,    81,   510,   366,   831,   897,   898,
     693,  1159,   625,    82,   381,   161,   384,   709,   710,    83,
     168,   169,    84,    19,    20,    21,    22,    23,    24,   124,
     333,    85,   316,    86,   322,   317,    87,   399,    88,   402,
     741,   394,    89,    90,   498,    91,    92,   209,   234,   518,
     979,   814,   502,    93,   806,  1111,   976,   807,   808,   716,
     717,    94,    95,   511,   235,   327,   634,   635,   344,   647,
     648,   299,   871,   300,   301,   883,    25,    26,    27,    28,
     362,    29,    30,    31,   354,   672,    32,   351,   658,    33,
     355,   337,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,   155,   377,    45,    46,    47,    48,    49,
      50,    51,    52,    53,   118,   348,    96,   400,    97,   731,
     732,   733,   949,   810,   811,   519,   744,   735,    98,   405,
    1084,  1085,  1283,   200,   440,  1342,   772,   773,   441,  1104,
     774,   442,   443,  1345,   444,  1346,   201,   446,   447,  1285,
     411,   202,   412,   421,   203,   204,   205,  1087,   206,   479,
    1102,  1088,  1182,  1183,   753,   754,  1089,    99,   100,   101,
     102,   277,   278,   279,   862,  1026,  1135,  1140,  1138,  1139,
    1255,  1310,  1027,  1257,  1320,  1028,  1437,  1254,  1304,  1305,
    1360,  1533,  1552,  1550,  1127,  1145,  1357,  1301,  1128,   914,
      54,    55,    56,    57,    58,    59,    60,    61,   684,   103,
     104,   105,  1037,  1151,  1152,   866,   106,  1146,  1388,  1454,
    1456,  1322,  1321,  1259,  1147,  1149,  1329,  1261,  1260,  1213,
    1150,  1216,  1262,  1398,  1464,  1330,  1217,  1220,  1263,  1402,
    1468,  1331,  1221,  1462,  1523,   107,   108,   591,  1270,  1225,
    1155,  1040,   583,   584,   109,   110,   308,   890,   891,   309,
      62,   111,    63,   112,   113,   114,   480
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -1325
static const yytype_int16 yypact[] =
{
     113,  2380,    68,   418,   540,   851,   148,   540,   540,    48,
     575,   540,   185,    32,   144,   222,   846,   344,   540, -1325,
   -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325,
   -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325,
   -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325,
   -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325,
   -1325, -1325, -1325, -1325, -1325, -1325,   160,   682,   168,   464,
     184,   277, -1325, -1325,   354,   319,   308,    46,   439,  1406,
   -1325, -1325, -1325, -1325, -1325,   467,   467, -1325, -1325, -1325,
     130, -1325,   388, -1325,   467,  2245, -1325, -1325, -1325,   467,
    2065,   467,  2125,   467,  2203,   467, -1325,   467,  1886,   467,
    1163, -1325, -1325,  1916,  1043, -1325, -1325, -1325,    29, -1325,
     498,   529,   534,   498,   515, -1325,   558,   580,   567,   540,
     540,   586,    80, -1325,   544,   134, -1325,   649,   651, -1325,
   -1325,   417,   627,   485,   485,   683,   687,   703,   721,   728,
     735,   744, -1325, -1325, -1325,   745,   789,   759, -1325,   750,
   -1325,   -12,    29,   131, -1325, -1325, -1325, -1325,   261,   454,
     708,   564, -1325,   825, -1325,   495,    80, -1325,    56, -1325,
   -1325, -1325,   835,   510, -1325,   669,    38,     6,  1406, -1325,
     519,   524,   526, -1325, -1325,   528,   531,   551,   836,   111,
   -1325, -1325, -1325, -1325, -1325,  1841, -1325,  2521,   805,   549,
     555, -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325,
   -1325,   571,    29,   930,   885,   131,   363, -1325,   500,   230,
     874,   948,    80, -1325,   607,   617,   622,   460,   775,   977,
     363,   913,   -30,   886,   114,   485,   940,   812,   952,    26,
     818,   811,   563,   821,   809,   594,   795,   801,   363,   799,
     798,   794,   -26,    -5,   827,   791,   800,   363, -1325,   679,
     680,   843,   363,   131,   363, -1325, -1325,   686,   681, -1325,
     691,   979,   559, -1325,   694,   701,   702,   984, -1325,  1040,
     131,   704,     2,   131,   131,  1002,   112, -1325,   712,   714,
   -1325,   713,   716,   796,   485,  1006, -1325,   722,   537,   724,
    1011,   363,  1022,   363,  1023, -1325,   731,   733,   734,  1032,
    1083, -1325,   741,   747, -1325, -1325,   815,  1103,   515, -1325,
   -1325,  1112,   131,  1113, -1325, -1325,  1099,  1116,  1118,  1120,
   -1325, -1325, -1325,   203,  1127, -1325, -1325,   828,  1132, -1325,
    1133,   532, -1325, -1325,  2305,  1052, -1325,   627,   627, -1325,
     623,   628,  1134,  1135, -1325, -1325,    -2,  1024,  1027, -1325,
   -1325, -1325, -1325, -1325, -1325, -1325, -1325,  1141, -1325,    82,
    1125, -1325, -1325,  1402,   782, -1325, -1325, -1325,  1406, -1325,
     131,   829, -1325, -1325, -1325, -1325, -1325, -1325, -1325,   783,
    1914, -1325,   108, -1325,   784,   788,    56, -1325,    56,  1406,
      56,    56,  1138, -1325,  1139,   967,  1140,   956,  1131,     6,
       6,  1136,  1128,  1406,  1406,  1406,  1406,  1406,  1150, -1325,
   -1325,  1155, -1325,   803,    28, -1325, -1325,   654, -1325, -1325,
    1167, -1325, -1325, -1325,   347,    35, -1325,   355, -1325, -1325,
   -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325,
   -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325,
   -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325,
   -1325,  1406,  1406,  1406,  1406,  1406,  1406,  1406,  1406,  1406,
    1406,  1406,  1406,  1406,   841,  1153, -1325, -1325,   -56, -1325,
   -1325, -1325, -1325,   843, -1325, -1325, -1325, -1325, -1325, -1325,
   -1325, -1325, -1325,  2181, -1325,    83,  1076,  1406, -1325, -1325,
      83, -1325,    83, -1325, -1325, -1325, -1325, -1325,  1109,  1121,
    1143,   826,   833,   131,   935,   363,   485,   131,   991,  1169,
     131,  1142,   131, -1325,   838,  1144,   129,   131,   131,   363,
    1159,   839,  1122,   844,   363,   858,   363,   296,   363,   930,
     363,   863,   865,   363,   363,   363,   867, -1325, -1325, -1325,
   -1325, -1325,  1147, -1325, -1325, -1325,  1186,   868,   869, -1325,
   -1325, -1325,   131, -1325,   872, -1325,   877,  1110, -1325, -1325,
   -1325,   879,   883,   887,   131,   889,   892,   893, -1325, -1325,
     169, -1325,   363, -1325,   930, -1325, -1325,   778, -1325,   485,
   -1325,  1041, -1325, -1325, -1325,   131, -1325,   131, -1325,   363,
   -1325, -1325, -1325,   131, -1325,   485, -1325, -1325, -1325, -1325,
   -1325, -1325, -1325, -1325,   579, -1325, -1325,  1255, -1325, -1325,
   -1325, -1325, -1325, -1325, -1325, -1325, -1325,   588, -1325, -1325,
    1258, -1325, -1325, -1325,  1243, -1325, -1325,  1248,   485, -1325,
   -1325,  1245,  1246, -1325,  2181, -1325, -1325, -1325, -1325,   485,
   -1325, -1325,  1247, -1325, -1325, -1325, -1325, -1325, -1325, -1325,
   -1325, -1325,  1257,  1257,   645,   627,  1257,   627,  1257, -1325,
   -1325,   131,   485, -1325,  1252,  1260, -1325,   915,   917, -1325,
   -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325,   611,
   -1325, -1325,  1456,  1263, -1325, -1325, -1325,   920, -1325, -1325,
   -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325,
   -1325,    27,   921,   925, -1325, -1325, -1325, -1325,   485,   131,
   -1325, -1325, -1325,   643,  1914, -1325, -1325,  1486, -1325, -1325,
   -1325, -1325,   132, -1325,   923, -1325,  1265, -1325, -1325, -1325,
   -1325,   173,   240,   276,  1540,   452,   120, -1325,  1406, -1325,
    1406, -1325,  1280,   926,   928,  1456,   159,   191, -1325, -1325,
   -1325,  1283,  1285, -1325,  1375,  1375,  1375,  2549,  2549,  1375,
    1375,  1375,  1375,   742,   742,  1128,  1128, -1325,   942, -1325,
   -1325, -1325, -1325,   485, -1325, -1325,  1282, -1325,   939, -1325,
   -1325, -1325, -1325,  1218, -1325,   363,  2521, -1325, -1325,   131,
     131,   363, -1325, -1325,   949,   363,   953,   954,   960,   131,
    1293,  1114,   963,   131,   964, -1325,   131,   968,   969,   970,
     971,   972,   131, -1325,   843, -1325,   974, -1325,   978,   983,
     985,   988,   989,   992,   994, -1325, -1325,   995,   999,  1007,
   -1325,   131,  1012,  1008, -1325, -1325,  2097,  1009,   176, -1325,
   -1325,   976,  1010, -1325, -1325, -1325,  1017, -1325, -1325, -1325,
     131,   448,   504,   981,  1018,  1026, -1325,  1169, -1325,   485,
    1019,  1041, -1325, -1325, -1325, -1325,    -2, -1325, -1325, -1325,
     815, -1325, -1325,   203, -1325, -1325, -1325, -1325, -1325, -1325,
   -1325, -1325, -1325, -1325,  1338,  1352, -1325, -1325,   843, -1325,
     843,  1355, -1325, -1325,   843,  1257,  1383,  1257,  1385, -1325,
   -1325,  1189,  1191, -1325, -1325, -1325,  1402, -1325, -1325,   939,
   -1325, -1325, -1325,  1914,   603, -1325, -1325, -1325,  1030,  1033,
   -1325, -1325,  1406, -1325,  1368,  1406,  1406,  1406, -1325,  1406,
   -1325,  1406,   546,  1565,  1406,  1046,  1406, -1325, -1325, -1325,
    1047,   835, -1325,  1406,  1295, -1325,   881, -1325,   720, -1325,
   -1325,  1050,  1059,  1054, -1325,  1056, -1325, -1325, -1325,  1064,
   -1325,   131, -1325,  1065, -1325,  1067, -1325, -1325, -1325, -1325,
   -1325,  1070,  1096, -1325, -1325, -1325, -1325, -1325, -1325, -1325,
   -1325, -1325, -1325, -1325, -1325, -1325,   363,   517,    77, -1325,
    1170,   485, -1325, -1325,   241, -1325,  1137, -1325,  1156, -1325,
   -1325,   485, -1325, -1325,   485, -1325, -1325,  1152, -1325, -1325,
   -1325, -1325,  1110, -1325,  1157,  1457,  1457,  1457,  1457, -1325,
   -1325, -1325, -1325,  1169,   131,  1019, -1325, -1325, -1325, -1325,
   -1325, -1325, -1325, -1325,  1483, -1325,  1488, -1325,  1477,  1484,
   -1325, -1325,    73, -1325,  1478, -1325, -1325,  1145,  1406, -1325,
   -1325, -1325,  1406,  1406,  1158,    64,  1841,  1162,  1165, -1325,
    1914, -1325, -1325, -1325,  1595,  1620,  1645,  1670,   601,  1406,
   -1325, -1325,  2521,  1154,  1151,  2521,  1487,  1698,  1489,   485,
   -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325,   131, -1325,
   -1325, -1325,  1164, -1325, -1325, -1325, -1325, -1325, -1325, -1325,
     131,   131,   363,   131, -1325,  1166,   843, -1325, -1325,  1168,
    1171,   131, -1325, -1325,   131,  1173, -1325, -1325, -1325,  1174,
   -1325,    58,    53, -1325, -1325,  -122, -1325,   169, -1325,  1172,
    1178,  1179,  1180, -1325, -1325, -1325, -1325,   567,   567,  1406,
     967,  1406, -1325,   685,  2027,   502, -1325, -1325,  1481,   329,
   -1325,  2521,  1185,  1190, -1325, -1325, -1325, -1325, -1325,  1406,
    1723,  1498,  1349,  1188, -1325,  1304, -1325,  1192, -1325,    19,
   -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325,
   -1325,   248, -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325,
   -1325, -1325,   131,   272, -1325,  1193, -1325,   169,   169,   169,
     169,  1517,  1519,   740,  1196,   813,  1869, -1325,  1779, -1325,
    1406,  1406,   547,  1165, -1325,  1755, -1325,  1198,  1207,     9,
   -1325,  1516, -1325,  1205,    16,    76,    25,   689, -1325, -1325,
     600, -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325,
   -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325,
   -1325,  1215,   603,  1361, -1325,    14,   916,  1430,  1199,  1217,
    1220,  1221,  1194, -1325, -1325,  1406, -1325,  1406, -1325,  1222,
   -1325, -1325, -1325, -1325, -1325,   152,   363,   131,   363, -1325,
    1232, -1325,   131,   131,   131,  1367,    70,   224, -1325, -1325,
    1235,  2147, -1325,  1253,  1268,   363,   363,   363, -1325,  1237,
      18,   265,  1244,  1242,  1779,    88, -1325, -1325, -1325,   654,
   -1325, -1325,  1603, -1325, -1325, -1325,   375, -1325, -1325,  1406,
    1406,  1406,  1406, -1325,  1266,  1249, -1325,  2187, -1325,   131,
    1250, -1325, -1325, -1325, -1325, -1325, -1325, -1325,   131,   131,
   -1325, -1325, -1325, -1325, -1325,  1292,   485,  1281,  1291,   -64,
     363,  1302,  1549,  1299,  1422,  1435,  1436, -1325,  1273,   131,
     131, -1325, -1325, -1325, -1325,   300,   485, -1325,  1274,   300,
    1619, -1325,  1276, -1325, -1325, -1325, -1325,  1780,   106,    88,
     278,  1805,  1830,  1855,  1882,  1406, -1325,  1350,  1284,   131,
     363,   131,   131,   131,  1434,   131,   313,  1195,  1351,   237,
    1382,   131,  1366,  1360,  1388, -1325, -1325,  1300, -1325, -1325,
   -1325, -1325,  1343, -1325,   131,   131,   131,  1345, -1325,   363,
     131,   131,  1574,   363,    58,   363,    53, -1325,  1334,  1334,
     131, -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325,
   -1325,  1406, -1325, -1325, -1325,  1312,  1319,  1320,  1321,  1323,
     363, -1325, -1325, -1325, -1325, -1325, -1325,   131, -1325,   131,
   -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325,   363,
   -1325, -1325, -1325,   363, -1325,    72,   131,   363, -1325,   131,
    1334, -1325, -1325,   131, -1325, -1325, -1325,   131, -1325, -1325,
   -1325, -1325,   363, -1325, -1325, -1325,  1780, -1325, -1325, -1325,
   -1325, -1325, -1325,     7, -1325, -1325, -1325, -1325, -1325, -1325,
   -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325,  1401, -1325,
   -1325, -1325,  1324, -1325
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1325, -1325, -1325,  -100, -1325,  -225,  -239,  -820,  -142,  -655,
   -1325,   -73, -1325, -1325, -1325, -1325, -1325, -1325,   753, -1325,
   -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325,   667,
    1362, -1325, -1325, -1325, -1325, -1325, -1325,  -267, -1325, -1325,
   -1325, -1325, -1325, -1325, -1325, -1325, -1325,  2054,   -91,  1462,
   -1325,   179,  -277, -1325, -1325, -1325, -1325,   723,  -580, -1325,
   -1325, -1325, -1325, -1325, -1325,   207, -1325,   804,   -45, -1325,
     802, -1185,   659,  -575, -1325,  -592, -1325, -1325, -1325, -1325,
    -135, -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325,
   -1325,  -236, -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325,
   -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325,
   -1325, -1325, -1325, -1325,   648,  1356, -1325, -1325, -1325, -1325,
    -719,   769,   624,  1313,  1051,  1363, -1325,   993, -1325, -1325,
   -1029, -1325,   382,  -191,   962,   310,  -946,   763, -1137, -1076,
    1531, -1119,   959,   330, -1325, -1325,  -189,   957, -1325, -1325,
   -1325, -1325,   554,   582, -1325, -1325,  -918, -1325,    79,   655,
     -79, -1325, -1325,   499,   792,   573, -1027, -1325, -1325, -1325,
   -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325,
   -1325, -1325, -1325, -1325, -1325, -1325, -1325,   550, -1325, -1325,
   -1325, -1325, -1325, -1325, -1325,   557, -1325, -1325, -1325,  -326,
   -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325,
   -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325,
   -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325, -1325,
     377,   358, -1325, -1325, -1325, -1325,   304,   359, -1325, -1325,
   -1325, -1325,   305,   361, -1324, -1325, -1325, -1325, -1325, -1325,
   -1325, -1325, -1325, -1325, -1325, -1325, -1325,   871, -1325, -1325,
   -1325, -1325, -1325, -1325, -1325, -1325, -1012
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -422
static const yytype_int16 yytable[] =
{
     207,   367,   368,   868,   569,   538,   539,   363,   439,   269,
     445,   276,   872,   284,   911,   532,  1297,   298,  1101,   307,
    1335,   419,   318,   323,   948,  1548,  1086,   691,   382,  1336,
    1337,  1338,   967,   555,   364,   365,   481,   482,   483,   484,
     485,   386,   566,   364,   365,   387,   941,   570,   559,   572,
     486,   487,   488,   489,   490,   491,   492,   493,  1177,   803,
     494,   779,   780,   389,   324,   417,   175,  1052,    64,   325,
    -285,   406,  1319,  1218,  1179,   407,   364,   365,   561,  -285,
    -285,  -285,  -285,  1072,   408,   386,   616,   386,   618,   387,
     588,   387,   386,  1222,  -284,  1169,   387,   386,   386,   438,
     697,   387,   387,  -284,  -284,  -284,  -284,  1072,   534,   422,
    1073,   505,   506,   507,   508,   341,  1249,     1,   812,   434,
     342,  1336,  1337,  1338,   967,   504,   386,   435,   436,   182,
     387,   404,   364,   365,  1073,  1524,   939,   349,   134,   135,
     481,   482,   483,   484,   485,  1074,   386,   136,  1343,   544,
     387,   125,   176,  1446,   486,   487,   488,   489,   490,   491,
     492,   493,   603,   128,   494,   137,  1344,  1086,   138,  1074,
     139,   140,  1436,   571,   386,   435,   436,   967,   387,   157,
    1369,   481,   482,   483,   484,   485,  1544,   524,   133,   560,
     586,   942,  1223,   592,   593,   486,   487,   488,   489,   490,
     491,   492,   493,   170,   535,   494,   386,   435,   436,   967,
     387,  1284,   671,  1306,  1075,  1076,  1077,  1078,  1079,  1080,
    1081,  1355,   682,   683,  1281,   686,   688,   837,   736,   737,
     738,   739,   639,  1163,  1082,   418,   805,  1083,  1075,  1076,
    1077,  1078,  1079,  1080,  1081,  1224,   562,   880,   481,   482,
     483,   484,   485,  1333,  1236,  1447,   386,   413,  1082,   143,
     387,  1083,   486,   487,   488,   489,   490,   491,   492,   493,
     512,   350,   494,  1343,   162,   505,   506,   507,   508,   698,
     163,   390,   853,   881,   481,   482,   483,   484,   485,   141,
     713,  1344,   645,  1336,  1337,  1338,   967,   827,   486,   487,
     488,   489,   490,   491,   492,   493,  1406,  1284,   494,   712,
     826,   804,  1371,   595,   391,   386,   537,   513,   514,   387,
    1086,  1110,   520,   882,   841,  1500,  1144,   885,   386,   846,
     747,   848,   387,   852,   646,   854,   752,   144,   857,   858,
     859,   838,  1307,  1133,   761,   762,   763,   764,   765,  1354,
    1395,  1241,   589,   590,   383,   171,  1396,   915,   775,   152,
     926,  1242,   928,   692,  1086,  1308,  1538,  1539,   887,   385,
     888,   948,  1298,   172,  1549,   420,  1339,   884,   386,   153,
    1473,  1340,   387,  1302,   154,  1397,   896,   977,   388,   142,
     543,   769,  1311,   173,   894,   326,   770,   505,   506,   507,
     508,   781,   784,   785,   786,   787,   788,   789,   790,   791,
     792,   793,   794,   795,   796,   813,  1086,  1086,   409,  1219,
     813,    65,   813,  1489,  1214,   410,  -285,   174,   517,   500,
     896,  -285,   388,   824,   388,  1170,   356,   828,   816,   388,
     832,  1358,   834,  1309,   388,   388,   343,   839,   840,  1359,
    -284,    66,   212,   930,  1196,  -284,    67,   213,   177,    68,
     481,   482,   483,   484,   485,   596,   597,   872,  1471,  1479,
      69,   214,   740,   437,   486,   487,   488,   489,   490,   491,
     492,   493,   867,   960,   494,   413,   208,   413,   961,   413,
     413,  1086,    70,   388,   876,    71,   211,    72,    73,   945,
     952,   357,   164,   364,   365,    74,  1372,   215,   849,  1373,
     481,   482,   483,   484,   485,   892,   907,   893,   119,  1501,
     165,   388,  1502,   895,   486,   487,   488,   489,   490,   491,
     492,   493,   329,    75,   494,   653,    76,   330,   850,   851,
     512,   955,  1039,   166,   977,  1141,  1265,  1199,    77,  1045,
     925,  1046,   927,   437,   481,   482,   483,   484,   485,   115,
     116,   334,   358,   345,   346,  1226,  1211,    78,   486,   487,
     488,   489,   490,   491,   492,   493,   332,  1002,   494,   395,
     117,   396,   397,   335,   347,   439,   439,   513,   514,   340,
     980,   929,   515,   445,   115,   116,   983,  1399,   516,  1064,
     985,  1066,   167,   388,  1400,  1047,   654,  1048,   956,   481,
     482,   483,   484,   485,  1258,   117,   977,    79,  1266,  1267,
    1268,  1269,  1072,   486,   487,   488,   489,   490,   491,   492,
     493,  1460,  1401,   494,  1288,  1272,  1273,  1274,  1275,   946,
    1339,   336,   356,   655,   957,   216,   356,   356,   916,  1073,
    1053,  1060,   352,  1061,   353,   126,   127,  1063,   131,   132,
     656,   974,   388,   685,   917,   398,   156,   178,   687,   179,
     180,   181,   182,   183,   184,   388,   438,   438,   528,   529,
     185,   186,   771,   187,  1074,   188,   369,  1289,  1290,   962,
     370,   963,   606,   481,   482,   483,   484,   485,   517,   817,
     217,   818,   158,   129,   130,   218,   371,   486,   487,   488,
     489,   490,   491,   492,   493,   777,   359,   494,   778,   981,
     982,   159,   918,   782,   372,   388,   783,   360,   361,   989,
     219,   373,   160,   993,   657,   189,   995,   896,   374,  1291,
    1409,   190,  1001,  1410,  1292,   220,   607,   375,   481,   482,
     483,   484,   485,  1075,  1076,  1077,  1078,  1079,  1080,  1081,
     376,  1014,   486,   487,   488,   489,   490,   491,   492,   493,
     492,   493,   494,  1082,   494,  1036,  1083,   338,   339,   608,
    1044,   379,    80,  1130,  1131,   547,   548,   328,   609,   289,
     331,  1129,   378,  1134,   191,   192,   364,   365,   886,  1142,
     719,   720,   721,   722,   723,   724,   725,   380,   726,   727,
     728,   729,   730,   291,  1113,  1114,  1115,  1116,   392,  1132,
     959,   481,   482,   483,   484,   485,   551,   552,   193,   194,
     429,   430,   431,   432,   393,   486,   487,   488,   489,   490,
     491,   492,   493,   195,   401,   494,   196,   345,   346,   178,
     197,   179,   180,   181,   182,   183,   184,   919,   395,   403,
     396,   397,   185,   186,   414,   187,   416,   188,  1239,  1205,
     896,   119,   415,   752,   577,   578,  1094,  1095,  1096,  1137,
    1097,   423,  1098,   714,   715,   628,   424,  1105,   425,  1148,
     426,  1122,  1153,   427,  1107,   610,   611,   612,   613,   364,
     365,  1109,   120,   920,   629,   630,   495,  1202,  1312,   121,
     122,   123,  1215,   428,  1099,   496,   145,   189,   921,   631,
     632,   497,   633,   190,   481,   482,   483,   484,   485,  1323,
    1324,  1231,  1232,  1325,  1326,  1327,   922,   499,   486,   487,
     488,   489,   490,   491,   492,   493,   899,   900,   494,   501,
     923,   924,   146,   147,  1164,   902,   903,  1313,  1314,  1315,
     745,  1316,   746,   503,   748,   749,   522,  1328,   523,  1189,
    -284,   525,  1317,  1160,  1161,  1162,   191,   192,   935,   936,
     178,   526,   179,   180,   181,   182,   183,   184,   527,   148,
     149,   150,   151,   185,   186,   530,   187,   531,   188,  1173,
     797,   758,   759,  1174,  1175,   533,   947,   540,   536,  1181,
     193,   194,   429,   430,   431,   432,   198,   541,  1197,   542,
    1190,   545,   546,   798,   199,   195,   550,   553,   196,   799,
    1200,  1201,   197,  1203,   800,   801,   549,   554,   556,   557,
     558,  1208,   563,   567,  1209,   564,   568,   574,   189,  1237,
     573,   582,   565,   576,   190,   674,  1318,   575,   579,   178,
     585,   179,   180,   181,   182,   183,   184,   580,   581,   594,
     587,   675,   185,   186,   771,   187,   598,   188,   599,   600,
     604,  1361,   601,  1363,   222,   615,   605,   602,   614,   617,
    1233,   752,  1235,   619,  1341,   620,  1015,   621,   622,   623,
    1391,  1392,  1393,   624,  1278,   626,   636,   191,   192,   319,
    1245,   627,  1303,  1105,  1303,   638,   640,   223,   641,   642,
     224,   643,  1264,   644,   225,   226,   676,   189,   228,   229,
     649,   677,   678,   190,   230,   651,   652,   689,   690,   679,
     694,   193,   194,   695,   696,   699,   711,   718,   742,  1016,
     743,   320,   750,   756,   751,  1448,   195,  1215,   757,   196,
     494,  1286,  1287,   197,  1181,   760,   755,   680,   231,   766,
     767,   768,   802,   232,   776,   815,   819,  1280,   178,   825,
     179,   180,   181,   182,   183,   184,   191,   192,   820,   821,
     822,   185,   186,   829,   187,  1483,   188,   823,   198,   830,
     844,   681,   835,   843,   222,   863,   199,  1362,   845,   833,
     289,   836,  1365,  1366,  1367,  1215,  1370,  1341,  1105,  1341,
     193,   194,   847,   303,  1514,  1017,   842,   855,  1518,   856,
    1520,   860,   864,   865,  1148,   195,   869,   223,   196,   861,
     224,   870,   197,   873,   225,   226,   189,   874,   228,   229,
     889,   875,   190,   877,   230,  1532,   878,   879,   901,  1438,
    1407,   904,   905,   906,   908,   909,   912,   931,  1440,  1441,
    1411,  1412,  1413,  1414,  1536,   932,  1018,   913,  1537,   933,
    1347,   934,  1542,   938,   940,   943,   953,   964,   231,  1458,
    1459,   944,   954,   232,   965,  1461,   966,  1547,   970,  1461,
    1019,   304,  1020,   971,   973,   191,   192,   977,  1021,   975,
    1022,   978,   990,   984,  1023,  1024,   991,   986,   987,  1482,
    1054,  1484,  1485,  1486,   988,  1488,  1490,   992,   994,   198,
    -421,  1504,   996,   997,   998,   999,  1000,   199,  1003,   193,
     194,  1058,  1004,  1041,  1510,  1511,  1512,  1005,  1049,  1006,
    1515,  1516,  1007,  1008,   195,  1059,  1009,   196,  1010,  1011,
    1525,   197,   178,  1012,   179,   180,   181,   182,   183,   184,
    1062,  1013,  1029,  1038,  1042,   185,   186,  1248,   187,  1025,
     188,  1043,  1050,  -422,  -422,  -422,  1065,  1534,  1067,  1535,
    1051,  1068,  1526,  1069,  1090,  1093,  1091,  -422,  -422,  -422,
    -422,   490,   491,   492,   493,  1540,  1541,   494,   198,  1543,
     321,  1108,   305,  1545,  1117,  1106,   199,  1546,  1119,   178,
    1120,   179,   180,   181,   182,   183,   184,  1118,  1121,  1123,
     189,  1124,   185,   186,  1125,   187,   190,   188,   481,   482,
     483,   484,   485,   700,   701,   702,   703,   704,   705,   706,
     707,   708,   486,   487,   488,   489,   490,   491,   492,   493,
    1126,  1136,   494,  1144,   481,   482,   483,   484,   485,  1491,
    1492,  1493,  1494,  1495,  1496,  1497,  1498,  1158,   486,   487,
     488,   489,   490,   491,   492,   493,  1165,   189,   494,   191,
     192,  1166,  1167,   190,   481,   482,   483,   484,   485,  1168,
    1171,  1143,  1193,  1240,  1195,  1247,  1251,  1172,   486,   487,
     488,   489,   490,   491,   492,   493,  1154,  1191,   494,  1192,
    1276,  1157,  1277,   193,   194,  1176,  1180,   198,  1198,  -416,
     306,  1299,  1204,  1334,  1206,   199,  1227,  1207,   195,  1210,
    1212,   196,  1228,  1229,  1230,   197,   191,   192,   481,   482,
     483,   484,   485,  1243,  1244,  1250,  1252,  1271,  1353,  1279,
    1295,  1349,   486,   487,   488,   489,   490,   491,   492,   493,
    1296,  1300,   494,   481,   482,   483,   484,   485,  1332,  1350,
     193,   194,  1351,  1352,  1368,  1389,  1356,   486,   487,   488,
     489,   490,   491,   492,   493,   195,  1364,   494,   196,  1374,
    1390,  1394,   197,   481,   482,   483,   484,   485,  1403,  1404,
    1408,  1442,  1416,  1444,  1439,  1445,  1450,   486,   487,   488,
     489,   490,   491,   492,   493,  1449,  1451,   494,   481,   482,
     483,   484,   485,  1452,  1415,  1453,  1455,  1457,  1465,  1218,
    1469,  1480,   486,   487,   488,   489,   490,   491,   492,   493,
    1481,  1487,   494,   481,   482,   483,   484,   485,  1503,  1505,
    1499,  1506,  1507,  1509,  1508,  1513,  1517,   486,   487,   488,
     489,   490,   491,   492,   493,  1522,  1527,   494,   481,   482,
     483,   484,   485,  1528,  1529,  1530,  1531,  1551,  1553,  1070,
     637,   521,   486,   487,   488,   489,   490,   491,   492,   493,
    1112,  1156,   494,   650,  1056,  1057,   481,   482,   483,   484,
     485,   198,  1071,   734,  1184,   910,  1405,   673,  1472,   199,
     486,   487,   488,   489,   490,   491,   492,   493,  1103,   433,
     494,   481,   482,   483,   484,   485,   969,   950,   968,   972,
    1474,  1178,  1293,  1234,  1092,   486,   487,   488,   489,   490,
     491,   492,   493,  1443,  1463,   494,  1253,  1256,  1519,  1467,
    1466,  1521,  1055,   481,   482,   483,   484,   485,   198,     0,
       0,     0,     0,     0,     0,     0,   199,   486,   487,   488,
     489,   490,   491,   492,   493,     0,     0,   494,   481,   482,
     483,   484,   485,     0,  1348,     0,     0,     0,  1072,     0,
       0,     0,   486,   487,   488,   489,   490,   491,   492,   493,
       0,     0,   494,   481,   482,   483,   484,   485,     0,   937,
       0,     0,     0,     0,     0,  1073,     0,   486,   487,   488,
     489,   490,   491,   492,   493,     0,     0,   494,   481,   482,
     483,   484,   485,     0,     0,     0,   448,     0,     0,   951,
       0,     0,   486,   487,   488,   489,   490,   491,   492,   493,
    1074,     0,   494,   481,   482,   483,   484,   485,     0,     0,
       0,     0,     0,     0,   448,     0,     0,   486,   487,   488,
     489,   490,   491,   492,   493,     0,     0,   494,     0,     0,
     481,   482,   483,   484,   485,     0,     0,     0,     0,     0,
       0,     0,     0,   958,   486,   487,   488,   489,   490,   491,
     492,   493,   449,   450,   494,     0,   451,   452,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   222,  1100,  1075,
    1076,  1077,  1078,  1079,  1080,  1081,     0,     0,     0,     0,
     449,   450,   453,     0,   451,   452,     0,   287,     0,  1082,
       0,     0,  1083,     0,     0,     0,     0,   222,  1185,     0,
     223,     0,     0,   224,     0,     0,     0,   225,   226,     0,
     288,   228,   229,     0,     0,   454,     0,   230,     0,     0,
     310,   311,   312,  1186,   313,   314,   289,     0,     0,     0,
     223,     0,     0,   224,     0,     0,     0,   225,   226,     0,
       0,   228,   229,   454,     0,     0,     0,   230,  1187,   290,
     291,   231,     0,     0,     0,     0,   232,     0,     0,     0,
       0,   455,   456,     0,   457,   458,   459,   460,   461,     0,
       0,     0,     0,  1188,     0,   481,   482,   483,   484,   485,
       0,   231,     0,     0,     0,     0,   232,     0,     0,   486,
     487,   488,   489,   490,   491,   492,   493,     0,     0,   494,
       0,  1194,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   719,   720,   721,   722,   723,   724,   725,     0,   726,
     727,   728,   729,   730,     0,     0,  1246,     0,   471,   472,
     462,   463,   464,   465,   466,   467,   468,   469,   470,     0,
     473,   474,   475,   476,     0,     0,   222,     0,     0,     0,
       0,   237,     0,     0,     0,     0,   471,   472,  1294,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   473,   474,
     475,   476,     0,     0,     0,     0,     0,     0,   222,   223,
     210,     0,   224,  1470,     0,  1282,   225,   226,   221,     0,
     228,   229,     0,   236,     0,   270,   230,   280,     0,   285,
       0,   286,   238,   302,     0,   239,   222,   240,  1475,   292,
       0,   223,     0,     0,   224,     0,     0,     0,   225,   226,
       0,  1030,   228,   229,     0,     0,     0,     0,   230,     0,
     231,     0,     0,  1476,     0,   232,   477,   478,  1238,   223,
     809,     0,   224,   241,     0,     0,   225,   226,     0,     0,
     228,   229,     0,   242,     0,     0,   230,     0,  1477,     0,
       0,     0,   231,     0,   477,   478,     0,   232,     0,   293,
     294,   295,     0,     0,     0,     0,     0,     0,   296,     0,
       0,     0,     0,     0,   222,  1478,     0,  1417,     0,   243,
     231,     0,     0,   297,     0,   232,     0,  1031,     0,     0,
       0,     0,     0,  1375,     0,   244,   245,     0,   246,   247,
       0,   248,   249,   250,     0,   251,     0,   223,   252,   253,
     224,   254,     0,   315,   225,   226,   222,   289,   228,   229,
       0,     0,     0,     0,   230,   255,   256,     0,     0,     0,
     257,     0,   258,   259,     0,   260,     0,  1376,   659,     0,
     261,   291,     0,     0,   262,   263,     0,   264,   265,   223,
     266,   267,   224,   364,   365,     0,   225,   226,   231,   227,
     228,   229,  1418,   232,     0,     0,   230,     0,   719,   720,
     721,   722,   723,   724,   725,   660,   726,   727,   728,   729,
     730,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1377,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     231,     0,     0,     0,     0,   232,     0,     0,     0,   661,
       0,     0,     0,   271,   662,     0,     0,     0,   272,     0,
     273,   663,   664,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   665,     0,  1419,     0,     0,     0,
       0,     0,     0,   666,   667,   668,   669,     0,   670,     0,
       0,     4,     0,     0,     0,   274,     0,     0,     0,     0,
       0,     0,   268,  1032,  1033,     0,     0,  1034,  1378,     0,
       0,     0,     5,     6,     0,     0,     0,     0,     0,     0,
       0,  1420,     0,  1421,     0,  1422,  1423,  1424,  1425,  1426,
    1427,     0,     0,     0,  1035,  1379,  1428,     0,  1380,  1381,
    1429,  1430,  1382,  1383,  1431,  1384,     7,     8,     0,  1432,
       0,     0,     0,  1385,  1386,     0,     0,  1433,     0,     0,
       0,     0,   275,     0,     0,  1434,     0,     9,     0,     0,
       0,     0,     0,   517,     0,     0,     0,    10,     0,     0,
      11,     0,    12,     0,  1387,    13,   281,   282,     0,     0,
      14,    15,    16,     0,     0,     0,     0,    17,    18,   481,
     482,   483,   484,   485,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   486,   487,   488,   489,   490,   491,   492,
     493,     0,     0,   494,  1435,     0,     0,   481,   482,   483,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     283,   486,   487,   488,   489,   490,   491,   492,   493,     0,
       0,   494,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   233
};

#define yypact_value_is_default(yystate) \
  ((yystate) == (-1325))

#define yytable_value_is_error(yytable_value) \
  ((yytable_value) == (-422))

static const yytype_int16 yycheck[] =
{
      79,   143,   144,   583,   271,   244,   245,   142,   199,   100,
     199,   102,   587,   104,   669,   240,     7,   108,   964,   110,
       6,    15,   113,   114,   743,    18,   944,    29,    40,    15,
      16,    17,    18,   258,    18,    19,     8,     9,    10,    11,
      12,    15,   267,    18,    19,    19,    19,   272,    74,   274,
      22,    23,    24,    25,    26,    27,    28,    29,  1085,   115,
      32,    26,    27,   163,    35,    27,    20,   887,     0,    40,
       6,    15,  1257,    20,  1086,    19,    18,    19,    83,    15,
      16,    17,    18,    19,    28,    15,   311,    15,   313,    19,
      88,    19,    15,   215,     6,    22,    19,    15,    15,   199,
      18,    19,    19,    15,    16,    17,    18,    19,   138,   188,
      46,    34,    35,    36,    37,    35,  1192,     4,    35,   198,
      40,    15,    16,    17,    18,   225,    15,    16,    17,    18,
      19,   176,    18,    19,    46,  1459,   716,     3,   106,   107,
       8,     9,    10,    11,    12,    81,    15,   115,  1285,   249,
      19,     3,   106,   217,    22,    23,    24,    25,    26,    27,
      28,    29,   304,   115,    32,   133,  1285,  1085,   136,    81,
     138,   139,  1357,   273,    15,    16,    17,    18,    19,    19,
     110,     8,     9,    10,    11,    12,  1510,   232,     3,   215,
     290,   164,   314,   293,   294,    22,    23,    24,    25,    26,
      27,    28,    29,    19,   234,    32,    15,    16,    17,    18,
      19,  1238,   354,   137,   150,   151,   152,   153,   154,   155,
     156,  1297,   357,   358,  1236,   360,   361,    98,   120,   121,
     122,   123,   332,  1053,   170,   197,   503,   173,   150,   151,
     152,   153,   154,   155,   156,   367,   251,    78,     8,     9,
      10,    11,    12,  1282,  1172,   319,    15,   178,   170,   115,
      19,   173,    22,    23,    24,    25,    26,    27,    28,    29,
      40,   137,    32,  1410,   106,    34,    35,    36,    37,   379,
     112,    20,   559,   114,     8,     9,    10,    11,    12,   257,
     390,  1410,    89,    15,    16,    17,    18,   536,    22,    23,
      24,    25,    26,    27,    28,    29,  1335,  1334,    32,   388,
     535,   367,    88,   201,    53,    15,   202,    87,    88,    19,
    1238,   976,    92,   154,   549,    88,   307,   604,    15,   554,
     409,   556,    19,   558,   131,   560,   415,   115,   563,   564,
     565,   212,   266,   266,   423,   424,   425,   426,   427,  1295,
     332,    22,   350,   351,   366,    78,   338,   683,   437,    15,
     686,    32,   688,   365,  1282,   289,   294,   295,   607,   162,
     609,  1090,   363,    19,   367,   369,   362,   602,    15,    35,
    1409,   367,    19,   367,    40,   367,   625,   368,   362,   357,
     364,   363,   367,    74,   619,   366,   368,    34,    35,    36,
      37,   366,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   515,  1334,  1335,   362,   366,
     520,     3,   522,   110,   366,   369,   362,   119,   198,   222,
     669,   367,   362,   533,   362,   362,    19,   537,   517,   362,
     540,   289,   542,   367,   362,   362,   366,   547,   548,   297,
     362,    33,    64,   692,  1109,   367,    38,    69,    19,    41,
       8,     9,    10,    11,    12,   353,   354,  1042,   362,  1415,
      52,    83,   364,   362,    22,    23,    24,    25,    26,    27,
      28,    29,   582,   363,    32,   406,    19,   408,   368,   410,
     411,  1409,    74,   362,   594,    77,   366,    79,    80,   738,
     368,    84,    38,    18,    19,    87,   282,   119,   212,   285,
       8,     9,    10,    11,    12,   615,   658,   617,    20,   282,
      56,   362,   285,   623,    22,    23,    24,    25,    26,    27,
      28,    29,     3,   115,    32,     3,   118,     3,   242,   243,
      40,   368,   366,    79,   368,   304,   274,  1127,   130,   101,
     685,   103,   687,   362,     8,     9,    10,    11,    12,    19,
      20,     3,   145,    19,    20,  1157,  1146,   149,    22,    23,
      24,    25,    26,    27,    28,    29,    61,   844,    32,    15,
      40,    17,    18,     3,    40,   776,   777,    87,    88,     3,
     815,   691,    92,   782,    19,    20,   821,   332,    98,   925,
     825,   927,   138,   362,   339,   101,    74,   103,   368,     8,
       9,    10,    11,    12,   366,    40,   368,   199,   346,   347,
     348,   349,    19,    22,    23,    24,    25,    26,    27,    28,
      29,   331,   367,    32,    87,  1227,  1228,  1229,  1230,   739,
     362,    74,    19,   111,   368,   257,    19,    19,     3,    46,
     889,   918,     3,   920,     3,     7,     8,   924,    10,    11,
     128,   803,   362,    40,    19,   101,    18,    13,    40,    15,
      16,    17,    18,    19,    20,   362,   776,   777,   218,   219,
      26,    27,    28,    29,    81,    31,     3,   140,   141,   768,
       3,   770,   155,     8,     9,    10,    11,    12,   198,   520,
     312,   522,    20,   128,   129,   317,     3,    22,    23,    24,
      25,    26,    27,    28,    29,   368,   299,    32,   371,   819,
     820,    39,    77,   368,     3,   362,   371,   310,   311,   829,
     342,     3,    50,   833,   202,    81,   836,   976,     3,   192,
     365,    87,   842,   368,   197,   357,   209,     3,     8,     9,
      10,    11,    12,   150,   151,   152,   153,   154,   155,   156,
      15,   861,    22,    23,    24,    25,    26,    27,    28,    29,
      28,    29,    32,   170,    32,   866,   173,   129,   130,   242,
     880,    22,   364,   266,   267,   222,   223,   120,   251,   100,
     123,  1016,     3,  1018,   140,   141,    18,    19,    20,  1024,
     157,   158,   159,   160,   161,   162,   163,    57,   165,   166,
     167,   168,   169,   124,    94,    95,    96,    97,   364,   302,
     368,     8,     9,    10,    11,    12,   232,   233,   174,   175,
     176,   177,   178,   179,   126,    22,    23,    24,    25,    26,
      27,    28,    29,   189,    19,    32,   192,    19,    20,    13,
     196,    15,    16,    17,    18,    19,    20,   212,    15,   364,
      17,    18,    26,    27,    29,    29,   197,    31,   366,  1136,
    1109,    20,   362,   952,   315,   316,   955,   956,   957,  1021,
     959,   362,   961,    54,    55,    70,   362,   966,   362,  1031,
     362,   991,  1034,   362,   973,   358,   359,   360,   361,    18,
      19,    20,    51,   258,    89,    90,   101,  1132,   219,    58,
      59,    60,  1151,   362,   368,   366,    70,    81,   273,   104,
     105,   366,   107,    87,     8,     9,    10,    11,    12,   329,
     330,  1167,  1168,   333,   334,   335,   291,   366,    22,    23,
      24,    25,    26,    27,    28,    29,   367,   368,    32,    19,
     305,   306,   106,   107,  1054,   367,   368,   268,   269,   270,
     406,   272,   408,    78,   410,   411,    92,   367,    20,   368,
     367,   364,   283,  1046,  1047,  1048,   140,   141,   367,   368,
      13,   364,    15,    16,    17,    18,    19,    20,   366,   143,
     144,   145,   146,    26,    27,   220,    29,    20,    31,  1078,
     159,   419,   420,  1082,  1083,    92,   363,    67,   122,  1088,
     174,   175,   176,   177,   178,   179,   362,   205,  1118,    67,
    1099,   203,   211,   182,   370,   189,   217,   232,   192,   188,
    1130,  1131,   196,  1133,   193,   194,   215,   236,   239,   241,
     246,  1141,   215,   364,  1144,   254,   366,   366,    81,   364,
     364,    67,   252,    74,    87,     3,   367,   366,   364,    13,
      20,    15,    16,    17,    18,    19,    20,   366,   366,    67,
     366,    19,    26,    27,    28,    29,   364,    31,   364,   366,
      74,  1306,   366,  1308,    41,    74,   364,   291,   364,    67,
    1169,  1170,  1171,    70,  1285,   364,    84,   364,   364,    67,
    1325,  1326,  1327,    20,   364,   364,     3,   140,   141,    66,
    1189,   364,  1254,  1192,  1256,     3,     3,    74,    19,     3,
      77,     3,  1222,     3,    81,    82,    74,    81,    85,    86,
       3,    79,    80,    87,    91,     3,     3,     3,     3,    87,
     116,   174,   175,   116,     3,    20,   364,   364,   364,   137,
     362,   108,    14,   197,    15,  1380,   189,  1396,    27,   192,
      32,  1240,  1241,   196,  1243,    29,    26,   115,   125,    19,
      15,   368,    19,   130,     7,    99,    67,   364,    13,   244,
      15,    16,    17,    18,    19,    20,   140,   141,    67,    46,
     364,    26,    27,   202,    29,  1420,    31,   364,   362,    30,
      78,   149,   364,   364,    41,    19,   370,  1307,   364,    67,
     100,    67,  1312,  1313,  1314,  1454,  1316,  1408,  1297,  1410,
     174,   175,   364,    60,  1449,   213,    67,   364,  1453,   364,
    1455,   364,   364,   364,  1376,   189,   364,    74,   192,    92,
      77,   364,   196,   364,    81,    82,    81,   364,    85,    86,
     209,   364,    87,   364,    91,  1480,   364,   364,     3,  1359,
    1339,     3,    19,    15,    19,    19,    19,    15,  1368,  1369,
    1349,  1350,  1351,  1352,  1499,    15,   264,    20,  1503,   364,
     364,   364,  1507,    20,   364,   364,   363,     7,   125,  1389,
    1390,   366,    27,   130,   368,  1395,   368,  1522,    15,  1399,
     288,   138,   290,    18,   362,   140,   141,   368,   296,    27,
     298,    93,    19,   364,   302,   303,   202,   364,   364,  1419,
     301,  1421,  1422,  1423,   364,  1425,  1426,   364,   364,   362,
     363,  1431,   364,   364,   364,   364,   364,   370,   364,   174,
     175,     3,   364,   367,  1444,  1445,  1446,   364,   367,   364,
    1450,  1451,   364,   364,   189,     3,   364,   192,   364,   364,
    1460,   196,    13,   364,    15,    16,    17,    18,    19,    20,
      15,   364,   364,   364,   364,    26,    27,    28,    29,   367,
      31,   364,   364,     8,     9,    10,     3,  1487,     3,  1489,
     364,   202,  1471,   202,   364,    27,   363,    22,    23,    24,
      25,    26,    27,    28,    29,  1505,  1506,    32,   362,  1509,
     367,   116,   249,  1513,   364,   368,   370,  1517,   364,    13,
     364,    15,    16,    17,    18,    19,    20,   368,   364,   364,
      81,   364,    26,    27,   364,    29,    87,    31,     8,     9,
      10,    11,    12,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    22,    23,    24,    25,    26,    27,    28,    29,
     364,   291,    32,   307,     8,     9,    10,    11,    12,   274,
     275,   276,   277,   278,   279,   280,   281,    20,    22,    23,
      24,    25,    26,    27,    28,    29,     3,    81,    32,   140,
     141,     3,    15,    87,     8,     9,    10,    11,    12,    15,
      22,   364,    15,    22,    15,     7,   202,   362,    22,    23,
      24,    25,    26,    27,    28,    29,   364,   363,    32,   368,
       3,   364,     3,   174,   175,   367,   364,   362,   364,   364,
     367,    15,   366,   172,   366,   370,   364,   366,   189,   366,
     366,   192,   364,   364,   364,   196,   140,   141,     8,     9,
      10,    11,    12,   368,   364,   367,   364,   364,   364,   363,
     362,   362,    22,    23,    24,    25,    26,    27,    28,    29,
     363,   366,    32,     8,     9,    10,    11,    12,   363,   362,
     174,   175,   362,   362,   217,   332,   364,    22,    23,    24,
      25,    26,    27,    28,    29,   189,   364,    32,   192,   364,
     332,   364,   196,     8,     9,    10,    11,    12,   364,   367,
       7,   319,   363,   332,   364,   324,    67,    22,    23,    24,
      25,    26,    27,    28,    29,   323,   327,    32,     8,     9,
      10,    11,    12,   211,   368,   200,   200,   364,   364,    20,
     364,   291,    22,    23,    24,    25,    26,    27,    28,    29,
     366,   217,    32,     8,     9,    10,    11,    12,   276,   293,
     309,   301,   274,   320,   364,   320,    92,    22,    23,    24,
      25,    26,    27,    28,    29,   341,   364,    32,     8,     9,
      10,    11,    12,   364,   364,   364,   363,   286,   364,   936,
     328,   229,    22,    23,    24,    25,    26,    27,    28,    29,
     977,  1042,    32,   347,   900,   903,     8,     9,    10,    11,
      12,   362,   943,   400,  1090,   664,  1334,   354,  1408,   370,
      22,    23,    24,    25,    26,    27,    28,    29,   965,   198,
      32,     8,     9,    10,    11,    12,   777,   744,   776,   782,
    1410,  1086,  1243,  1170,   952,    22,    23,    24,    25,    26,
      27,    28,    29,  1376,  1396,    32,  1199,  1207,  1454,  1400,
    1399,  1456,   891,     8,     9,    10,    11,    12,   362,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   370,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    -1,    32,     8,     9,
      10,    11,    12,    -1,   364,    -1,    -1,    -1,    19,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    -1,    32,     8,     9,    10,    11,    12,    -1,   363,
      -1,    -1,    -1,    -1,    -1,    46,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    -1,    32,     8,     9,
      10,    11,    12,    -1,    -1,    -1,     5,    -1,    -1,   363,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      81,    -1,    32,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,     5,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    -1,    32,    -1,    -1,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   363,    22,    23,    24,    25,    26,    27,
      28,    29,    71,    72,    32,    -1,    75,    76,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    41,   363,   150,
     151,   152,   153,   154,   155,   156,    -1,    -1,    -1,    -1,
      71,    72,   101,    -1,    75,    76,    -1,    61,    -1,   170,
      -1,    -1,   173,    -1,    -1,    -1,    -1,    41,   363,    -1,
      74,    -1,    -1,    77,    -1,    -1,    -1,    81,    82,    -1,
      84,    85,    86,    -1,    -1,   134,    -1,    91,    -1,    -1,
      64,    65,    66,   363,    68,    69,   100,    -1,    -1,    -1,
      74,    -1,    -1,    77,    -1,    -1,    -1,    81,    82,    -1,
      -1,    85,    86,   134,    -1,    -1,    -1,    91,   363,   123,
     124,   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,
      -1,   180,   181,    -1,   183,   184,   185,   186,   187,    -1,
      -1,    -1,    -1,   363,    -1,     8,     9,    10,    11,    12,
      -1,   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    -1,    32,
      -1,   363,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   157,   158,   159,   160,   161,   162,   163,    -1,   165,
     166,   167,   168,   169,    -1,    -1,   363,    -1,   247,   248,
     221,   222,   223,   224,   225,   226,   227,   228,   229,    -1,
     259,   260,   261,   262,    -1,    -1,    41,    -1,    -1,    -1,
      -1,    46,    -1,    -1,    -1,    -1,   247,   248,   363,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   259,   260,
     261,   262,    -1,    -1,    -1,    -1,    -1,    -1,    41,    74,
      86,    -1,    77,   363,    -1,   366,    81,    82,    94,    -1,
      85,    86,    -1,    99,    -1,   101,    91,   103,    -1,   105,
      -1,   107,    97,   109,    -1,   100,    41,   102,   363,   283,
      -1,    74,    -1,    -1,    77,    -1,    -1,    -1,    81,    82,
      -1,    84,    85,    86,    -1,    -1,    -1,    -1,    91,    -1,
     125,    -1,    -1,   363,    -1,   130,   355,   356,   171,    74,
      19,    -1,    77,   138,    -1,    -1,    81,    82,    -1,    -1,
      85,    86,    -1,   148,    -1,    -1,    91,    -1,   363,    -1,
      -1,    -1,   125,    -1,   355,   356,    -1,   130,    -1,   343,
     344,   345,    -1,    -1,    -1,    -1,    -1,    -1,   352,    -1,
      -1,    -1,    -1,    -1,    41,   363,    -1,    60,    -1,   184,
     125,    -1,    -1,   367,    -1,   130,    -1,   160,    -1,    -1,
      -1,    -1,    -1,   116,    -1,   200,   201,    -1,   203,   204,
      -1,   206,   207,   208,    -1,   210,    -1,    74,   213,   214,
      77,   216,    -1,   367,    81,    82,    41,   100,    85,    86,
      -1,    -1,    -1,    -1,    91,   230,   231,    -1,    -1,    -1,
     235,    -1,   237,   238,    -1,   240,    -1,   160,     3,    -1,
     245,   124,    -1,    -1,   249,   250,    -1,   252,   253,    74,
     255,   256,    77,    18,    19,    -1,    81,    82,   125,    84,
      85,    86,   145,   130,    -1,    -1,    91,    -1,   157,   158,
     159,   160,   161,   162,   163,    40,   165,   166,   167,   168,
     169,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     213,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     125,    -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,    74,
      -1,    -1,    -1,   258,    79,    -1,    -1,    -1,   263,    -1,
     265,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    99,    -1,   219,    -1,    -1,    -1,
      -1,    -1,    -1,   108,   109,   110,   111,    -1,   113,    -1,
      -1,    41,    -1,    -1,    -1,   300,    -1,    -1,    -1,    -1,
      -1,    -1,   367,   336,   337,    -1,    -1,   340,   291,    -1,
      -1,    -1,    62,    63,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   264,    -1,   266,    -1,   268,   269,   270,   271,   272,
     273,    -1,    -1,    -1,   367,   318,   279,    -1,   321,   322,
     283,   284,   325,   326,   287,   328,    96,    97,    -1,   292,
      -1,    -1,    -1,   336,   337,    -1,    -1,   300,    -1,    -1,
      -1,    -1,   367,    -1,    -1,   308,    -1,   117,    -1,    -1,
      -1,    -1,    -1,   198,    -1,    -1,    -1,   127,    -1,    -1,
     130,    -1,   132,    -1,   367,   135,   313,   314,    -1,    -1,
     140,   141,   142,    -1,    -1,    -1,    -1,   147,   148,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    -1,    32,   367,    -1,    -1,     8,     9,    10,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     367,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      -1,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   367
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     4,   373,   374,    41,    62,    63,    96,    97,   117,
     127,   130,   132,   135,   140,   141,   142,   147,   148,   395,
     396,   397,   398,   399,   400,   448,   449,   450,   451,   453,
     454,   455,   458,   461,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   572,   573,   574,   575,   576,   577,
     578,   579,   632,   634,     0,     3,    33,    38,    41,    52,
      74,    77,    79,    80,    87,   115,   118,   130,   149,   199,
     364,   376,   385,   391,   394,   403,   405,   408,   410,   414,
     415,   417,   418,   425,   433,   434,   488,   490,   500,   539,
     540,   541,   542,   581,   582,   583,   588,   617,   618,   626,
     627,   633,   635,   636,   637,    19,    20,    40,   486,    20,
      51,    58,    59,    60,   401,     3,   486,   486,   115,   128,
     129,   486,   486,     3,   106,   107,   115,   133,   136,   138,
     139,   257,   357,   115,   115,    70,   106,   107,   143,   144,
     145,   146,    15,    35,    40,   475,   486,    19,    20,    39,
      50,   387,   106,   112,    38,    56,    79,   138,   392,   393,
      19,    78,    19,    74,   119,    20,   106,    19,    13,    15,
      16,    17,    18,    19,    20,    26,    27,    29,    31,    81,
      87,   140,   141,   174,   175,   189,   192,   196,   362,   370,
     505,   518,   523,   526,   527,   528,   530,   532,    19,   419,
     419,   366,    64,    69,    83,   119,   257,   312,   317,   342,
     357,   419,    41,    74,    77,    81,    82,    84,    85,    86,
      91,   125,   130,   367,   420,   436,   419,    46,    97,   100,
     102,   138,   148,   184,   200,   201,   203,   204,   206,   207,
     208,   210,   213,   214,   216,   230,   231,   235,   237,   238,
     240,   245,   249,   250,   252,   253,   255,   256,   367,   420,
     419,   258,   263,   265,   300,   367,   420,   543,   544,   545,
     419,   313,   314,   367,   420,   419,   419,    61,    84,   100,
     123,   124,   283,   343,   344,   345,   352,   367,   420,   443,
     445,   446,   419,    60,   138,   249,   367,   420,   628,   631,
      64,    65,    66,    68,    69,   367,   404,   407,   420,    66,
     108,   367,   406,   420,    35,    40,   366,   437,   401,     3,
       3,   401,    61,   402,     3,     3,    74,   463,   486,   486,
       3,    35,    40,   366,   440,    19,    20,    40,   487,     3,
     137,   459,     3,     3,   456,   462,    19,    84,   145,   299,
     310,   311,   452,   452,    18,    19,   378,   380,   380,     3,
       3,     3,     3,     3,     3,     3,    15,   476,     3,    22,
      57,   386,    40,   366,   388,   437,    15,    19,   362,   375,
      20,    53,   364,   126,   413,    15,    17,    18,   101,   409,
     489,    19,   411,   364,   440,   501,    15,    19,    28,   362,
     369,   522,   524,   530,    29,   362,   197,    27,   197,    15,
     369,   525,   532,   362,   362,   362,   362,   362,   362,   176,
     177,   178,   179,   512,   532,    16,    17,   362,   375,   505,
     506,   510,   513,   514,   516,   518,   519,   520,     5,    71,
      72,    75,    76,   101,   134,   180,   181,   183,   184,   185,
     186,   187,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   247,   248,   259,   260,   261,   262,   355,   356,   531,
     638,     8,     9,    10,    11,    12,    22,    23,    24,    25,
      26,    27,    28,    29,    32,   101,   366,   366,   416,   366,
     437,    19,   424,    78,   375,    34,    35,    36,    37,   375,
     377,   435,    40,    87,    88,    92,    98,   198,   421,   497,
      92,   421,    92,    20,   440,   364,   364,   366,   218,   219,
     220,    20,   377,    92,   138,   234,   122,   202,   378,   378,
      67,   205,    67,   364,   375,   203,   211,   222,   223,   215,
     217,   232,   233,   232,   236,   377,   239,   241,   246,    74,
     215,    83,   251,   215,   254,   252,   377,   364,   366,   409,
     377,   375,   377,   364,   366,   366,    74,   315,   316,   364,
     366,   366,    67,   624,   625,    20,   375,   366,    88,   350,
     351,   619,   375,   375,    67,   201,   353,   354,   364,   364,
     366,   366,   291,   380,    74,   364,   155,   209,   242,   251,
     358,   359,   360,   361,   364,    74,   377,    67,   377,    70,
     364,   364,   364,    67,    20,   384,   364,   364,    70,    89,
      90,   104,   105,   107,   438,   439,     3,   402,     3,   375,
       3,    19,     3,     3,     3,    89,   131,   441,   442,     3,
     487,     3,     3,     3,    74,   111,   128,   202,   460,     3,
      40,    74,    79,    86,    87,    99,   108,   109,   110,   111,
     113,   380,   457,   497,     3,    19,    74,    79,    80,    87,
     115,   149,   452,   452,   580,    40,   452,    40,   452,     3,
       3,    29,   365,   382,   116,   116,     3,    18,   375,    20,
      41,    42,    43,    44,    45,    46,    47,    48,    49,   389,
     390,   364,   532,   375,    54,    55,   431,   432,   364,   157,
     158,   159,   160,   161,   162,   163,   165,   166,   167,   168,
     169,   491,   492,   493,   495,   499,   120,   121,   122,   123,
     364,   412,   364,   362,   498,   524,   524,   532,   524,   524,
      14,    15,   532,   536,   537,    26,   197,    27,   525,   525,
      29,   532,   532,   532,   532,   532,    19,    15,   368,   363,
     368,    28,   508,   509,   512,   532,     7,   368,   371,    26,
      27,   366,   368,   371,   532,   532,   532,   532,   532,   532,
     532,   532,   532,   532,   532,   532,   532,   159,   182,   188,
     193,   194,    19,   115,   367,   409,   426,   429,   430,    19,
     495,   496,    35,   375,   423,    99,   532,   423,   423,    67,
      67,    46,   364,   364,   375,   244,   377,   378,   375,   202,
      30,   379,   375,    67,   375,   364,    67,    98,   212,   375,
     375,   377,    67,   364,    78,   364,   377,   364,   377,   212,
     242,   243,   377,   424,   377,   364,   364,   377,   377,   377,
     364,    92,   546,    19,   364,   364,   587,   375,   430,   364,
     364,   444,   445,   364,   364,   364,   375,   364,   364,   364,
      78,   114,   154,   447,   377,   424,    20,   378,   378,   209,
     629,   630,   375,   375,   377,   375,   378,   380,   381,   367,
     368,     3,   367,   368,     3,    19,    15,   380,    19,    19,
     496,   381,    19,    20,   571,   571,     3,    19,    77,   212,
     258,   273,   291,   305,   306,   452,   571,   452,   571,   375,
     378,    15,    15,   364,   364,   367,   368,   363,    20,   430,
     364,    19,   164,   364,   366,   378,   375,   363,   492,   494,
     499,   363,   368,   363,    27,   368,   368,   368,   363,   368,
     363,   368,   532,   532,     7,   368,   368,    18,   506,   514,
      15,    18,   519,   362,   380,    27,   428,   368,    93,   422,
     377,   375,   375,   377,   364,   377,   364,   364,   364,   375,
      19,   202,   364,   375,   364,   375,   364,   364,   364,   364,
     364,   375,   409,   364,   364,   364,   364,   364,   364,   364,
     364,   364,   364,   364,   375,    84,   137,   213,   264,   288,
     290,   296,   298,   302,   303,   367,   547,   554,   557,   364,
      84,   160,   336,   337,   340,   367,   420,   584,   364,   366,
     623,   367,   364,   364,   375,   101,   103,   101,   103,   367,
     364,   364,   379,   378,   301,   629,   439,   442,     3,     3,
     409,   409,    15,   409,   571,     3,   571,     3,   202,   202,
     390,   493,    19,    46,    81,   150,   151,   152,   153,   154,
     155,   156,   170,   173,   502,   503,   528,   529,   533,   538,
     364,   363,   536,    27,   532,   532,   532,   532,   532,   368,
     363,   508,   532,   509,   511,   532,   368,   532,   116,    20,
     381,   427,   429,    94,    95,    96,    97,   364,   368,   364,
     364,   364,   375,   364,   364,   364,   364,   566,   570,   377,
     266,   267,   302,   266,   377,   548,   291,   380,   550,   551,
     549,   304,   377,   364,   307,   567,   589,   596,   380,   597,
     602,   585,   586,   380,   364,   622,   444,   364,    20,   383,
     383,   383,   383,   379,   375,     3,     3,    15,    15,    22,
     362,    22,   362,   532,   532,   532,   367,   538,   531,   638,
     364,   532,   534,   535,   494,   363,   363,   363,   363,   368,
     532,   363,   368,    15,   363,    15,   381,   375,   364,   430,
     375,   375,   377,   375,   366,   409,   366,   366,   375,   375,
     366,   430,   366,   601,   366,   378,   603,   608,    20,   366,
     609,   614,   215,   314,   367,   621,   447,   364,   364,   364,
     364,   463,   463,   532,   537,   532,   528,   364,   171,   366,
      22,    22,    32,   368,   364,   532,   363,     7,    28,   511,
     367,   202,   364,   567,   559,   552,   559,   555,   366,   595,
     600,   599,   604,   610,   375,   274,   346,   347,   348,   349,
     620,   364,   447,   447,   447,   447,     3,     3,   364,   363,
     364,   638,   366,   504,   538,   521,   532,   532,    87,   140,
     141,   192,   197,   535,   363,   362,   363,     7,   363,    15,
     366,   569,   367,   380,   560,   561,   137,   266,   289,   367,
     553,   367,   219,   268,   269,   270,   272,   283,   367,   443,
     556,   594,   593,   329,   330,   333,   334,   335,   367,   598,
     607,   613,   363,   502,   172,     6,    15,    16,    17,   362,
     367,   505,   507,   510,   513,   515,   517,   364,   364,   362,
     362,   362,   362,   364,   508,   511,   364,   568,   289,   297,
     562,   377,   375,   377,   364,   375,   375,   375,   217,   110,
     375,    88,   282,   285,   364,   116,   160,   213,   291,   318,
     321,   322,   325,   326,   328,   336,   337,   367,   590,   332,
     332,   377,   377,   377,   364,   332,   338,   367,   605,   332,
     339,   367,   611,   364,   367,   504,   502,   532,     7,   365,
     368,   532,   532,   532,   532,   368,   363,    60,   145,   219,
     264,   266,   268,   269,   270,   271,   272,   273,   279,   283,
     284,   287,   292,   300,   308,   367,   443,   558,   375,   364,
     375,   375,   319,   602,   332,   324,   217,   319,   377,   323,
      67,   327,   211,   200,   591,   200,   592,   364,   375,   375,
     331,   375,   615,   603,   606,   364,   615,   609,   612,   364,
     363,   362,   507,   502,   515,   363,   363,   363,   363,   508,
     291,   366,   375,   377,   375,   375,   375,   217,   375,   110,
     375,   274,   275,   276,   277,   278,   279,   280,   281,   309,
      88,   282,   285,   276,   375,   293,   301,   274,   364,   320,
     375,   375,   375,   320,   377,   375,   375,    92,   377,   608,
     377,   614,   341,   616,   616,   375,   532,   364,   364,   364,
     364,   363,   377,   563,   375,   375,   377,   377,   294,   295,
     375,   375,   377,   375,   616,   375,   375,   377,    18,   367,
     565,   286,   564,   364
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (YYID (N))                                                     \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (YYID (0))
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])



/* This macro is provided for backward compatibility. */

#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULL, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  YYSIZE_T yysize1;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULL;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                yysize1 = yysize + yytnamerr (YY_NULL, yytname[yyx]);
                if (! (yysize <= yysize1
                       && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                  return 2;
                yysize = yysize1;
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  yysize1 = yysize + yystrlen (yyformat);
  if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
    return 2;
  yysize = yysize1;

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
/* Line 1787 of yacc.c  */
#line 670 "cf-parse.y"
    { return 0; }
    break;

  case 3:
/* Line 1787 of yacc.c  */
#line 671 "cf-parse.y"
    { return 0; }
    break;

  case 7:
/* Line 1787 of yacc.c  */
#line 684 "cf-parse.y"
    { (yyval.i) = f_eval_int((yyvsp[(2) - (3)].x)); }
    break;

  case 8:
/* Line 1787 of yacc.c  */
#line 685 "cf-parse.y"
    { if ((yyvsp[(1) - (1)].s)->class != SYM_NUMBER) cf_error("Number expected"); else (yyval.i) = (yyvsp[(1) - (1)].s)->aux; }
    break;

  case 9:
/* Line 1787 of yacc.c  */
#line 691 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(2) - (5)].s), SYM_NUMBER, NULL);
     (yyvsp[(2) - (5)].s)->aux = (yyvsp[(4) - (5)].i);
   }
    break;

  case 10:
/* Line 1787 of yacc.c  */
#line 695 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(2) - (5)].s), SYM_IPA, cfg_alloc(sizeof(ip_addr)));
     *(ip_addr *)(yyvsp[(2) - (5)].s)->def = (yyvsp[(4) - (5)].a);
   }
    break;

  case 11:
/* Line 1787 of yacc.c  */
#line 704 "cf-parse.y"
    {(yyval.i) = !!(yyvsp[(1) - (1)].i); }
    break;

  case 12:
/* Line 1787 of yacc.c  */
#line 705 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 13:
/* Line 1787 of yacc.c  */
#line 706 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 14:
/* Line 1787 of yacc.c  */
#line 707 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 15:
/* Line 1787 of yacc.c  */
#line 708 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 16:
/* Line 1787 of yacc.c  */
#line 709 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 18:
/* Line 1787 of yacc.c  */
#line 716 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_IPA) cf_error("IP address expected");
     (yyval.a) = *(ip_addr *)(yyvsp[(1) - (1)].s)->def;
   }
    break;

  case 19:
/* Line 1787 of yacc.c  */
#line 723 "cf-parse.y"
    { (yyval.iface) = NULL; }
    break;

  case 20:
/* Line 1787 of yacc.c  */
#line 724 "cf-parse.y"
    { (yyval.iface) = if_get_by_name((yyvsp[(2) - (2)].s)->name); }
    break;

  case 21:
/* Line 1787 of yacc.c  */
#line 728 "cf-parse.y"
    {
     if (!ip_is_prefix((yyvsp[(1) - (2)].a), (yyvsp[(2) - (2)].i))) cf_error("Invalid prefix");
     (yyval.px).addr = (yyvsp[(1) - (2)].a); (yyval.px).len = (yyvsp[(2) - (2)].i);
   }
    break;

  case 23:
/* Line 1787 of yacc.c  */
#line 736 "cf-parse.y"
    { (yyval.px).addr = (yyvsp[(1) - (1)].a); (yyval.px).len = BITS_PER_IP_ADDRESS; }
    break;

  case 24:
/* Line 1787 of yacc.c  */
#line 740 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) < 0 || (yyvsp[(2) - (2)].i) > BITS_PER_IP_ADDRESS) cf_error("Invalid prefix length %d", (yyvsp[(2) - (2)].i));
     (yyval.i) = (yyvsp[(2) - (2)].i);
   }
    break;

  case 25:
/* Line 1787 of yacc.c  */
#line 744 "cf-parse.y"
    {
     (yyval.i) = ipa_mklen((yyvsp[(2) - (2)].a));
     if ((yyval.i) < 0) cf_error("Invalid netmask %I", (yyvsp[(2) - (2)].a));
   }
    break;

  case 26:
/* Line 1787 of yacc.c  */
#line 751 "cf-parse.y"
    {
     (yyval.time) = tm_parse_datetime((yyvsp[(1) - (1)].t));
     if (!(yyval.time))
       cf_error("Invalid date and time");
   }
    break;

  case 27:
/* Line 1787 of yacc.c  */
#line 759 "cf-parse.y"
    { (yyval.t) = (yyvsp[(1) - (1)].t); }
    break;

  case 28:
/* Line 1787 of yacc.c  */
#line 760 "cf-parse.y"
    { (yyval.t) = NULL; }
    break;

  case 29:
/* Line 1787 of yacc.c  */
#line 766 "cf-parse.y"
    {
    struct log_config *c = cfg_allocz(sizeof(struct log_config));
    c->fh = (yyvsp[(2) - (4)].g);
    c->mask = (yyvsp[(3) - (4)].i);
    add_tail(&new_config->logfiles, &c->n);
  }
    break;

  case 30:
/* Line 1787 of yacc.c  */
#line 775 "cf-parse.y"
    { (yyval.t) = (yyvsp[(2) - (2)].t); }
    break;

  case 31:
/* Line 1787 of yacc.c  */
#line 776 "cf-parse.y"
    { (yyval.t) = bird_name; }
    break;

  case 32:
/* Line 1787 of yacc.c  */
#line 780 "cf-parse.y"
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[(1) - (1)].t), "a");
     if (!f) cf_error("Unable to open log file `%s': %m", (yyvsp[(1) - (1)].t));
     (yyval.g) = f;
   }
    break;

  case 33:
/* Line 1787 of yacc.c  */
#line 785 "cf-parse.y"
    { (yyval.g) = NULL; new_config->syslog_name = (yyvsp[(2) - (2)].t); }
    break;

  case 34:
/* Line 1787 of yacc.c  */
#line 786 "cf-parse.y"
    { (yyval.g) = stderr; }
    break;

  case 35:
/* Line 1787 of yacc.c  */
#line 790 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 36:
/* Line 1787 of yacc.c  */
#line 791 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 37:
/* Line 1787 of yacc.c  */
#line 795 "cf-parse.y"
    { (yyval.i) = 1 << (yyvsp[(1) - (1)].i); }
    break;

  case 38:
/* Line 1787 of yacc.c  */
#line 796 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (1 << (yyvsp[(3) - (3)].i)); }
    break;

  case 39:
/* Line 1787 of yacc.c  */
#line 800 "cf-parse.y"
    { (yyval.i) = L_DEBUG[0]; }
    break;

  case 40:
/* Line 1787 of yacc.c  */
#line 801 "cf-parse.y"
    { (yyval.i) = L_TRACE[0]; }
    break;

  case 41:
/* Line 1787 of yacc.c  */
#line 802 "cf-parse.y"
    { (yyval.i) = L_INFO[0]; }
    break;

  case 42:
/* Line 1787 of yacc.c  */
#line 803 "cf-parse.y"
    { (yyval.i) = L_REMOTE[0]; }
    break;

  case 43:
/* Line 1787 of yacc.c  */
#line 804 "cf-parse.y"
    { (yyval.i) = L_WARN[0]; }
    break;

  case 44:
/* Line 1787 of yacc.c  */
#line 805 "cf-parse.y"
    { (yyval.i) = L_ERR[0]; }
    break;

  case 45:
/* Line 1787 of yacc.c  */
#line 806 "cf-parse.y"
    { (yyval.i) = L_AUTH[0]; }
    break;

  case 46:
/* Line 1787 of yacc.c  */
#line 807 "cf-parse.y"
    { (yyval.i) = L_FATAL[0]; }
    break;

  case 47:
/* Line 1787 of yacc.c  */
#line 808 "cf-parse.y"
    { (yyval.i) = L_BUG[0]; }
    break;

  case 48:
/* Line 1787 of yacc.c  */
#line 814 "cf-parse.y"
    { new_config->proto_default_mrtdump = (yyvsp[(3) - (4)].i); }
    break;

  case 49:
/* Line 1787 of yacc.c  */
#line 815 "cf-parse.y"
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[(2) - (3)].t), "a");
     if (!f) cf_error("Unable to open MRTDump file '%s': %m", (yyvsp[(2) - (3)].t));
     new_config->mrtdump_file = fileno(f);
   }
    break;

  case 50:
/* Line 1787 of yacc.c  */
#line 824 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_route; }
    break;

  case 51:
/* Line 1787 of yacc.c  */
#line 825 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_proto; }
    break;

  case 52:
/* Line 1787 of yacc.c  */
#line 826 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_base; }
    break;

  case 53:
/* Line 1787 of yacc.c  */
#line 827 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_log; }
    break;

  case 54:
/* Line 1787 of yacc.c  */
#line 830 "cf-parse.y"
    { *(yyvsp[(1) - (2)].tf) = (struct timeformat){(yyvsp[(2) - (2)].t), NULL, 0}; }
    break;

  case 55:
/* Line 1787 of yacc.c  */
#line 831 "cf-parse.y"
    { *(yyvsp[(1) - (4)].tf) = (struct timeformat){(yyvsp[(2) - (4)].t), (yyvsp[(4) - (4)].t), (yyvsp[(3) - (4)].i)}; }
    break;

  case 56:
/* Line 1787 of yacc.c  */
#line 832 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%T", "%F", 20*3600}; }
    break;

  case 57:
/* Line 1787 of yacc.c  */
#line 833 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%F %T", NULL, 0}; }
    break;

  case 59:
/* Line 1787 of yacc.c  */
#line 845 "cf-parse.y"
    { cmd_reconfig((yyvsp[(2) - (4)].t), RECONFIG_HARD, (yyvsp[(3) - (4)].i)); }
    break;

  case 60:
/* Line 1787 of yacc.c  */
#line 848 "cf-parse.y"
    { cmd_reconfig((yyvsp[(3) - (5)].t), RECONFIG_SOFT, (yyvsp[(4) - (5)].i)); }
    break;

  case 61:
/* Line 1787 of yacc.c  */
#line 855 "cf-parse.y"
    { cmd_reconfig_confirm(); }
    break;

  case 62:
/* Line 1787 of yacc.c  */
#line 858 "cf-parse.y"
    { cmd_reconfig_undo(); }
    break;

  case 63:
/* Line 1787 of yacc.c  */
#line 861 "cf-parse.y"
    { cmd_check_config((yyvsp[(3) - (4)].t)); }
    break;

  case 64:
/* Line 1787 of yacc.c  */
#line 864 "cf-parse.y"
    { cmd_shutdown(); }
    break;

  case 65:
/* Line 1787 of yacc.c  */
#line 867 "cf-parse.y"
    { (yyval.t) = NULL; }
    break;

  case 67:
/* Line 1787 of yacc.c  */
#line 872 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 68:
/* Line 1787 of yacc.c  */
#line 873 "cf-parse.y"
    { (yyval.i) = UNIX_DEFAULT_CONFIGURE_TIMEOUT; }
    break;

  case 69:
/* Line 1787 of yacc.c  */
#line 874 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); }
    break;

  case 70:
/* Line 1787 of yacc.c  */
#line 882 "cf-parse.y"
    { this_proto = krt_init_config((yyvsp[(1) - (2)].i)); }
    break;

  case 71:
/* Line 1787 of yacc.c  */
#line 887 "cf-parse.y"
    { THIS_KRT->persist = (yyvsp[(2) - (2)].i); }
    break;

  case 72:
/* Line 1787 of yacc.c  */
#line 888 "cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KRT->scan_time = (yyvsp[(3) - (3)].i);
   }
    break;

  case 73:
/* Line 1787 of yacc.c  */
#line 892 "cf-parse.y"
    {
      THIS_KRT->learn = (yyvsp[(2) - (2)].i);
#ifndef KRT_ALLOW_LEARN
      if ((yyvsp[(2) - (2)].i))
	cf_error("Learning of kernel routes not supported in this configuration");
#endif
   }
    break;

  case 74:
/* Line 1787 of yacc.c  */
#line 899 "cf-parse.y"
    { THIS_KRT->devroutes = (yyvsp[(3) - (3)].i); }
    break;

  case 75:
/* Line 1787 of yacc.c  */
#line 905 "cf-parse.y"
    { this_proto = kif_init_config((yyvsp[(1) - (2)].i)); }
    break;

  case 76:
/* Line 1787 of yacc.c  */
#line 910 "cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KIF->scan_time = (yyvsp[(3) - (3)].i);
   }
    break;

  case 77:
/* Line 1787 of yacc.c  */
#line 914 "cf-parse.y"
    {
     struct kif_primary_item *kpi = cfg_alloc(sizeof (struct kif_primary_item));
     kpi->pattern = (yyvsp[(2) - (3)].t);
     kpi->prefix = (yyvsp[(3) - (3)].px).addr;
     kpi->pxlen = (yyvsp[(3) - (3)].px).len;
     add_tail(&THIS_KIF->primary, &kpi->n);
   }
    break;

  case 78:
/* Line 1787 of yacc.c  */
#line 928 "cf-parse.y"
    {
	if ((yyvsp[(3) - (3)].i) <= 0 || (yyvsp[(3) - (3)].i) >= NL_NUM_TABLES)
	  cf_error("Kernel routing table number out of range");
	THIS_KRT->sys.table_id = (yyvsp[(3) - (3)].i);
   }
    break;

  case 79:
/* Line 1787 of yacc.c  */
#line 942 "cf-parse.y"
    { new_config->router_id = (yyvsp[(3) - (4)].i32); }
    break;

  case 80:
/* Line 1787 of yacc.c  */
#line 943 "cf-parse.y"
    { new_config->router_id_from = this_ipatt; }
    break;

  case 81:
/* Line 1787 of yacc.c  */
#line 947 "cf-parse.y"
    { (yyval.i32) = (yyvsp[(1) - (1)].i); }
    break;

  case 83:
/* Line 1787 of yacc.c  */
#line 949 "cf-parse.y"
    {
#ifndef IPV6
     (yyval.i32) = ipa_to_u32((yyvsp[(1) - (1)].a));
#else
     cf_error("Router IDs must be entered as hexadecimal numbers or IPv4 addresses in IPv6 version");
#endif
   }
    break;

  case 87:
/* Line 1787 of yacc.c  */
#line 968 "cf-parse.y"
    { new_config->listen_bgp_addr = (yyvsp[(2) - (2)].a); }
    break;

  case 88:
/* Line 1787 of yacc.c  */
#line 969 "cf-parse.y"
    { new_config->listen_bgp_port = (yyvsp[(2) - (2)].i); }
    break;

  case 89:
/* Line 1787 of yacc.c  */
#line 970 "cf-parse.y"
    { new_config->listen_bgp_flags = 0; }
    break;

  case 90:
/* Line 1787 of yacc.c  */
#line 971 "cf-parse.y"
    { new_config->listen_bgp_flags = 1; }
    break;

  case 91:
/* Line 1787 of yacc.c  */
#line 978 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 92:
/* Line 1787 of yacc.c  */
#line 979 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 93:
/* Line 1787 of yacc.c  */
#line 983 "cf-parse.y"
    {
   struct rtable_config *cf;
   cf = rt_new_table((yyvsp[(2) - (3)].s));
   cf->sorted = (yyvsp[(3) - (3)].i);
   }
    break;

  case 94:
/* Line 1787 of yacc.c  */
#line 991 "cf-parse.y"
    {
  this_roa_table = roa_new_table_config((yyvsp[(3) - (3)].s));
}
    break;

  case 96:
/* Line 1787 of yacc.c  */
#line 997 "cf-parse.y"
    {
     roa_add_item_config(this_roa_table, (yyvsp[(3) - (8)].px).addr, (yyvsp[(3) - (8)].px).len, (yyvsp[(5) - (8)].i), (yyvsp[(7) - (8)].i));
   }
    break;

  case 99:
/* Line 1787 of yacc.c  */
#line 1011 "cf-parse.y"
    { (yyval.i) = SYM_PROTO; }
    break;

  case 100:
/* Line 1787 of yacc.c  */
#line 1012 "cf-parse.y"
    { (yyval.i) = SYM_TEMPLATE; }
    break;

  case 101:
/* Line 1787 of yacc.c  */
#line 1016 "cf-parse.y"
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->def = this_proto;
     this_proto->name = s->name;
     }
    break;

  case 102:
/* Line 1787 of yacc.c  */
#line 1022 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(1) - (1)].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[(1) - (1)].s)->name;
   }
    break;

  case 103:
/* Line 1787 of yacc.c  */
#line 1026 "cf-parse.y"
    {
     if (((yyvsp[(3) - (3)].s)->class != SYM_TEMPLATE) && ((yyvsp[(3) - (3)].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");

     cf_define_symbol((yyvsp[(1) - (3)].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[(1) - (3)].s)->name;

     proto_copy_config(this_proto, (yyvsp[(3) - (3)].s)->def);
   }
    break;

  case 105:
/* Line 1787 of yacc.c  */
#line 1038 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) < 0 || (yyvsp[(2) - (2)].i) > 0xFFFF) cf_error("Invalid preference");
     this_proto->preference = (yyvsp[(2) - (2)].i);
   }
    break;

  case 106:
/* Line 1787 of yacc.c  */
#line 1042 "cf-parse.y"
    { this_proto->disabled = (yyvsp[(2) - (2)].i); }
    break;

  case 107:
/* Line 1787 of yacc.c  */
#line 1043 "cf-parse.y"
    { this_proto->debug = (yyvsp[(2) - (2)].i); }
    break;

  case 108:
/* Line 1787 of yacc.c  */
#line 1044 "cf-parse.y"
    { this_proto->mrtdump = (yyvsp[(2) - (2)].i); }
    break;

  case 109:
/* Line 1787 of yacc.c  */
#line 1045 "cf-parse.y"
    { this_proto->in_filter = (yyvsp[(2) - (2)].f); }
    break;

  case 110:
/* Line 1787 of yacc.c  */
#line 1046 "cf-parse.y"
    { this_proto->out_filter = (yyvsp[(2) - (2)].f); }
    break;

  case 111:
/* Line 1787 of yacc.c  */
#line 1047 "cf-parse.y"
    { this_proto->rx_limit = (yyvsp[(3) - (3)].g); }
    break;

  case 112:
/* Line 1787 of yacc.c  */
#line 1048 "cf-parse.y"
    { this_proto->in_limit = (yyvsp[(3) - (3)].g); }
    break;

  case 113:
/* Line 1787 of yacc.c  */
#line 1049 "cf-parse.y"
    { this_proto->out_limit = (yyvsp[(3) - (3)].g); }
    break;

  case 114:
/* Line 1787 of yacc.c  */
#line 1050 "cf-parse.y"
    { this_proto->in_keep_filtered = (yyvsp[(4) - (4)].i); }
    break;

  case 115:
/* Line 1787 of yacc.c  */
#line 1051 "cf-parse.y"
    { this_proto->table = (yyvsp[(2) - (2)].r); }
    break;

  case 116:
/* Line 1787 of yacc.c  */
#line 1052 "cf-parse.y"
    { this_proto->router_id = (yyvsp[(3) - (3)].i32); }
    break;

  case 117:
/* Line 1787 of yacc.c  */
#line 1053 "cf-parse.y"
    { this_proto->dsc = (yyvsp[(2) - (2)].t); }
    break;

  case 118:
/* Line 1787 of yacc.c  */
#line 1057 "cf-parse.y"
    { (yyval.f) = (yyvsp[(2) - (2)].f); }
    break;

  case 120:
/* Line 1787 of yacc.c  */
#line 1059 "cf-parse.y"
    { (yyval.f) = FILTER_ACCEPT; }
    break;

  case 121:
/* Line 1787 of yacc.c  */
#line 1060 "cf-parse.y"
    { (yyval.f) = FILTER_REJECT; }
    break;

  case 122:
/* Line 1787 of yacc.c  */
#line 1064 "cf-parse.y"
    { (yyval.i) = PLA_DISABLE; }
    break;

  case 123:
/* Line 1787 of yacc.c  */
#line 1065 "cf-parse.y"
    { (yyval.i) = PLA_WARN; }
    break;

  case 124:
/* Line 1787 of yacc.c  */
#line 1066 "cf-parse.y"
    { (yyval.i) = PLA_BLOCK; }
    break;

  case 125:
/* Line 1787 of yacc.c  */
#line 1067 "cf-parse.y"
    { (yyval.i) = PLA_RESTART; }
    break;

  case 126:
/* Line 1787 of yacc.c  */
#line 1068 "cf-parse.y"
    { (yyval.i) = PLA_DISABLE; }
    break;

  case 127:
/* Line 1787 of yacc.c  */
#line 1072 "cf-parse.y"
    {
     struct proto_limit *l = cfg_allocz(sizeof(struct proto_limit));
     l->limit = (yyvsp[(1) - (2)].i);
     l->action = (yyvsp[(2) - (2)].i);
     (yyval.g) = l;
   }
    break;

  case 128:
/* Line 1787 of yacc.c  */
#line 1078 "cf-parse.y"
    { (yyval.g) = NULL; }
    break;

  case 129:
/* Line 1787 of yacc.c  */
#line 1082 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_TABLE) cf_error("Table name expected");
     (yyval.r) = (yyvsp[(1) - (1)].s)->def;
   }
    break;

  case 130:
/* Line 1787 of yacc.c  */
#line 1090 "cf-parse.y"
    { new_config->proto_default_debug = (yyvsp[(3) - (3)].i); }
    break;

  case 131:
/* Line 1787 of yacc.c  */
#line 1091 "cf-parse.y"
    { new_config->cli_debug = (yyvsp[(3) - (3)].i); }
    break;

  case 132:
/* Line 1787 of yacc.c  */
#line 1099 "cf-parse.y"
    {
     struct iface_patt_node *ipn = cfg_allocz(sizeof(struct iface_patt_node));
     add_tail(&this_ipatt->ipn_list, NODE ipn);
     this_ipn = ipn;
   }
    break;

  case 133:
/* Line 1787 of yacc.c  */
#line 1107 "cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (1)].t); this_ipn->prefix = IPA_NONE; this_ipn->pxlen = 0; }
    break;

  case 134:
/* Line 1787 of yacc.c  */
#line 1108 "cf-parse.y"
    { this_ipn->pattern = NULL; this_ipn->prefix = (yyvsp[(1) - (1)].px).addr; this_ipn->pxlen = (yyvsp[(1) - (1)].px).len; }
    break;

  case 135:
/* Line 1787 of yacc.c  */
#line 1109 "cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (2)].t); this_ipn->prefix = (yyvsp[(2) - (2)].px).addr; this_ipn->pxlen = (yyvsp[(2) - (2)].px).len; }
    break;

  case 136:
/* Line 1787 of yacc.c  */
#line 1113 "cf-parse.y"
    { this_ipn->positive = 1; }
    break;

  case 137:
/* Line 1787 of yacc.c  */
#line 1114 "cf-parse.y"
    { this_ipn->positive = 0; }
    break;

  case 141:
/* Line 1787 of yacc.c  */
#line 1127 "cf-parse.y"
    {
   /* Generic this_ipatt init */
   this_ipatt = cfg_allocz(sizeof(struct iface_patt));
   init_list(&this_ipatt->ipn_list);
 }
    break;

  case 143:
/* Line 1787 of yacc.c  */
#line 1142 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_device, sizeof(struct rt_dev_config), (yyvsp[(1) - (2)].i));
     init_list(&DIRECT_CFG->iface_list);
   }
    break;

  case 147:
/* Line 1787 of yacc.c  */
#line 1155 "cf-parse.y"
    {
     this_ipatt = cfg_allocz(sizeof(struct iface_patt));
     add_tail(&DIRECT_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
   }
    break;

  case 149:
/* Line 1787 of yacc.c  */
#line 1169 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 150:
/* Line 1787 of yacc.c  */
#line 1170 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 151:
/* Line 1787 of yacc.c  */
#line 1171 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 153:
/* Line 1787 of yacc.c  */
#line 1176 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); }
    break;

  case 154:
/* Line 1787 of yacc.c  */
#line 1180 "cf-parse.y"
    { (yyval.i) = D_STATES; }
    break;

  case 155:
/* Line 1787 of yacc.c  */
#line 1181 "cf-parse.y"
    { (yyval.i) = D_ROUTES; }
    break;

  case 156:
/* Line 1787 of yacc.c  */
#line 1182 "cf-parse.y"
    { (yyval.i) = D_FILTERS; }
    break;

  case 157:
/* Line 1787 of yacc.c  */
#line 1183 "cf-parse.y"
    { (yyval.i) = D_IFACES; }
    break;

  case 158:
/* Line 1787 of yacc.c  */
#line 1184 "cf-parse.y"
    { (yyval.i) = D_EVENTS; }
    break;

  case 159:
/* Line 1787 of yacc.c  */
#line 1185 "cf-parse.y"
    { (yyval.i) = D_PACKETS; }
    break;

  case 160:
/* Line 1787 of yacc.c  */
#line 1191 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 161:
/* Line 1787 of yacc.c  */
#line 1192 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 162:
/* Line 1787 of yacc.c  */
#line 1193 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 164:
/* Line 1787 of yacc.c  */
#line 1198 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); }
    break;

  case 165:
/* Line 1787 of yacc.c  */
#line 1202 "cf-parse.y"
    { (yyval.i) = MD_STATES; }
    break;

  case 166:
/* Line 1787 of yacc.c  */
#line 1203 "cf-parse.y"
    { (yyval.i) = MD_MESSAGES; }
    break;

  case 173:
/* Line 1787 of yacc.c  */
#line 1224 "cf-parse.y"
    {
     if (!this_p_list) {
     	this_p_list = cfg_alloc(sizeof(list));
     	init_list(this_p_list);
        password_id = 1;
     }
     this_p_item = cfg_alloc(sizeof (struct password_item));
     this_p_item->password = (yyvsp[(2) - (2)].t);
     this_p_item->genfrom = 0;
     this_p_item->gento = TIME_INFINITY;
     this_p_item->accfrom = 0;
     this_p_item->accto = TIME_INFINITY;
     this_p_item->id = password_id++;
     add_tail(this_p_list, &this_p_item->n);
   }
    break;

  case 174:
/* Line 1787 of yacc.c  */
#line 1242 "cf-parse.y"
    { }
    break;

  case 175:
/* Line 1787 of yacc.c  */
#line 1243 "cf-parse.y"
    { this_p_item->genfrom = (yyvsp[(3) - (5)].time); }
    break;

  case 176:
/* Line 1787 of yacc.c  */
#line 1244 "cf-parse.y"
    { this_p_item->gento = (yyvsp[(3) - (5)].time); }
    break;

  case 177:
/* Line 1787 of yacc.c  */
#line 1245 "cf-parse.y"
    { this_p_item->accfrom = (yyvsp[(3) - (5)].time); }
    break;

  case 178:
/* Line 1787 of yacc.c  */
#line 1246 "cf-parse.y"
    { this_p_item->accto = (yyvsp[(3) - (5)].time); }
    break;

  case 179:
/* Line 1787 of yacc.c  */
#line 1247 "cf-parse.y"
    { this_p_item->id = (yyvsp[(2) - (4)].i); if ((yyvsp[(2) - (4)].i) <= 0) cf_error("Password ID has to be greated than zero."); }
    break;

  case 180:
/* Line 1787 of yacc.c  */
#line 1256 "cf-parse.y"
    { cmd_show_status(); }
    break;

  case 181:
/* Line 1787 of yacc.c  */
#line 1259 "cf-parse.y"
    { cmd_show_memory(); }
    break;

  case 182:
/* Line 1787 of yacc.c  */
#line 1262 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_show, 0, 0); }
    break;

  case 183:
/* Line 1787 of yacc.c  */
#line 1265 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(4) - (5)].ps), proto_cmd_show, 0, 1); }
    break;

  case 185:
/* Line 1787 of yacc.c  */
#line 1269 "cf-parse.y"
    { (yyval.s) = NULL; }
    break;

  case 186:
/* Line 1787 of yacc.c  */
#line 1273 "cf-parse.y"
    { if_show(); }
    break;

  case 187:
/* Line 1787 of yacc.c  */
#line 1276 "cf-parse.y"
    { if_show_summary(); }
    break;

  case 188:
/* Line 1787 of yacc.c  */
#line 1280 "cf-parse.y"
    { rt_show((yyvsp[(3) - (4)].ra)); }
    break;

  case 189:
/* Line 1787 of yacc.c  */
#line 1283 "cf-parse.y"
    {
     (yyval.ra) = cfg_allocz(sizeof(struct rt_show_data));
     (yyval.ra)->pxlen = 256;
     (yyval.ra)->filter = FILTER_ACCEPT;
   }
    break;

  case 190:
/* Line 1787 of yacc.c  */
#line 1288 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[(2) - (2)].px).addr;
     (yyval.ra)->pxlen = (yyvsp[(2) - (2)].px).len;
   }
    break;

  case 191:
/* Line 1787 of yacc.c  */
#line 1294 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[(3) - (3)].px).addr;
     (yyval.ra)->pxlen = (yyvsp[(3) - (3)].px).len;
     (yyval.ra)->show_for = 1;
   }
    break;

  case 192:
/* Line 1787 of yacc.c  */
#line 1301 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyvsp[(3) - (3)].s)->class != SYM_TABLE) cf_error("%s is not a table", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->table = ((struct rtable_config *)(yyvsp[(3) - (3)].s)->def)->table;
   }
    break;

  case 193:
/* Line 1787 of yacc.c  */
#line 1306 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(3) - (3)].f);
   }
    break;

  case 194:
/* Line 1787 of yacc.c  */
#line 1311 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(2) - (2)].f);
   }
    break;

  case 195:
/* Line 1787 of yacc.c  */
#line 1316 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->verbose = 1;
   }
    break;

  case 196:
/* Line 1787 of yacc.c  */
#line 1320 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->primary_only = 1;
   }
    break;

  case 197:
/* Line 1787 of yacc.c  */
#line 1324 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->filtered = 1;
   }
    break;

  case 198:
/* Line 1787 of yacc.c  */
#line 1328 "cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->export_mode) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->export_mode = (yyvsp[(2) - (3)].i);
     (yyval.ra)->primary_only = 1;
     (yyval.ra)->export_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
    break;

  case 199:
/* Line 1787 of yacc.c  */
#line 1338 "cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->show_protocol) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->show_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
    break;

  case 200:
/* Line 1787 of yacc.c  */
#line 1346 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 1;
   }
    break;

  case 201:
/* Line 1787 of yacc.c  */
#line 1350 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 2;
   }
    break;

  case 202:
/* Line 1787 of yacc.c  */
#line 1357 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 203:
/* Line 1787 of yacc.c  */
#line 1358 "cf-parse.y"
    { (yyval.i) = 2; }
    break;

  case 204:
/* Line 1787 of yacc.c  */
#line 1364 "cf-parse.y"
    { roa_show((yyvsp[(3) - (4)].ro)); }
    break;

  case 205:
/* Line 1787 of yacc.c  */
#line 1367 "cf-parse.y"
    {
     (yyval.ro) = cfg_allocz(sizeof(struct roa_show_data));
     (yyval.ro)->mode = ROA_SHOW_ALL;
     (yyval.ro)->table = roa_table_default;
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
   }
    break;

  case 206:
/* Line 1787 of yacc.c  */
#line 1374 "cf-parse.y"
    {
     (yyval.ro) = (yyvsp[(1) - (3)].ro);
     if ((yyval.ro)->mode != ROA_SHOW_ALL) cf_error("Only one prefix expected");
     (yyval.ro)->prefix = (yyvsp[(3) - (3)].px).addr;
     (yyval.ro)->pxlen = (yyvsp[(3) - (3)].px).len;
     (yyval.ro)->mode = (yyvsp[(2) - (3)].i);
   }
    break;

  case 207:
/* Line 1787 of yacc.c  */
#line 1381 "cf-parse.y"
    {
     (yyval.ro) = (yyvsp[(1) - (3)].ro);
     (yyval.ro)->asn = (yyvsp[(3) - (3)].i);
   }
    break;

  case 208:
/* Line 1787 of yacc.c  */
#line 1385 "cf-parse.y"
    {
     (yyval.ro) = (yyvsp[(1) - (3)].ro);
     if ((yyvsp[(3) - (3)].s)->class != SYM_ROA) cf_error("%s is not a ROA table", (yyvsp[(3) - (3)].s)->name);
     (yyval.ro)->table = ((struct roa_table_config *)(yyvsp[(3) - (3)].s)->def)->table;
   }
    break;

  case 209:
/* Line 1787 of yacc.c  */
#line 1393 "cf-parse.y"
    { (yyval.i) = ROA_SHOW_PX; }
    break;

  case 210:
/* Line 1787 of yacc.c  */
#line 1394 "cf-parse.y"
    { (yyval.i) = ROA_SHOW_IN; }
    break;

  case 211:
/* Line 1787 of yacc.c  */
#line 1395 "cf-parse.y"
    { (yyval.i) = ROA_SHOW_FOR; }
    break;

  case 212:
/* Line 1787 of yacc.c  */
#line 1401 "cf-parse.y"
    { cmd_show_symbols((yyvsp[(3) - (4)].sd)); }
    break;

  case 213:
/* Line 1787 of yacc.c  */
#line 1404 "cf-parse.y"
    {
     (yyval.sd) = cfg_allocz(sizeof(struct sym_show_data));
   }
    break;

  case 214:
/* Line 1787 of yacc.c  */
#line 1407 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_TABLE; }
    break;

  case 215:
/* Line 1787 of yacc.c  */
#line 1408 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_FUNCTION; }
    break;

  case 216:
/* Line 1787 of yacc.c  */
#line 1409 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_FILTER; }
    break;

  case 217:
/* Line 1787 of yacc.c  */
#line 1410 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_PROTO; }
    break;

  case 218:
/* Line 1787 of yacc.c  */
#line 1411 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_TEMPLATE; }
    break;

  case 219:
/* Line 1787 of yacc.c  */
#line 1412 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_ROA; }
    break;

  case 220:
/* Line 1787 of yacc.c  */
#line 1413 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->sym = (yyvsp[(2) - (2)].s); }
    break;

  case 221:
/* Line 1787 of yacc.c  */
#line 1418 "cf-parse.y"
    { 
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
     (yyval.rot) = roa_table_default;
   }
    break;

  case 222:
/* Line 1787 of yacc.c  */
#line 1423 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].s)->class != SYM_ROA)
       cf_error("%s is not a ROA table", (yyvsp[(2) - (2)].s)->name);
     (yyval.rot) = ((struct roa_table_config *)(yyvsp[(2) - (2)].s)->def)->table;
   }
    break;

  case 223:
/* Line 1787 of yacc.c  */
#line 1432 "cf-parse.y"
    {
  if (! cli_access_restricted())
    { roa_add_item((yyvsp[(8) - (9)].rot), (yyvsp[(3) - (9)].px).addr, (yyvsp[(3) - (9)].px).len, (yyvsp[(5) - (9)].i), (yyvsp[(7) - (9)].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
    break;

  case 224:
/* Line 1787 of yacc.c  */
#line 1439 "cf-parse.y"
    {
  if (! cli_access_restricted())
    { roa_delete_item((yyvsp[(8) - (9)].rot), (yyvsp[(3) - (9)].px).addr, (yyvsp[(3) - (9)].px).len, (yyvsp[(5) - (9)].i), (yyvsp[(7) - (9)].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
    break;

  case 225:
/* Line 1787 of yacc.c  */
#line 1446 "cf-parse.y"
    {
  if (! cli_access_restricted())
    { roa_flush((yyvsp[(3) - (4)].rot), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
    break;

  case 226:
/* Line 1787 of yacc.c  */
#line 1454 "cf-parse.y"
    { rdump(&root_pool); cli_msg(0, ""); }
    break;

  case 227:
/* Line 1787 of yacc.c  */
#line 1456 "cf-parse.y"
    { sk_dump_all(); cli_msg(0, ""); }
    break;

  case 228:
/* Line 1787 of yacc.c  */
#line 1458 "cf-parse.y"
    { if_dump_all(); cli_msg(0, ""); }
    break;

  case 229:
/* Line 1787 of yacc.c  */
#line 1460 "cf-parse.y"
    { neigh_dump_all(); cli_msg(0, ""); }
    break;

  case 230:
/* Line 1787 of yacc.c  */
#line 1462 "cf-parse.y"
    { rta_dump_all(); cli_msg(0, ""); }
    break;

  case 231:
/* Line 1787 of yacc.c  */
#line 1464 "cf-parse.y"
    { rt_dump_all(); cli_msg(0, ""); }
    break;

  case 232:
/* Line 1787 of yacc.c  */
#line 1466 "cf-parse.y"
    { protos_dump_all(); cli_msg(0, ""); }
    break;

  case 233:
/* Line 1787 of yacc.c  */
#line 1468 "cf-parse.y"
    {
  cli_set_log_echo(this_cli, (yyvsp[(2) - (4)].i), (yyvsp[(3) - (4)].i));
  cli_msg(0, "");
}
    break;

  case 234:
/* Line 1787 of yacc.c  */
#line 1474 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 235:
/* Line 1787 of yacc.c  */
#line 1475 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 237:
/* Line 1787 of yacc.c  */
#line 1480 "cf-parse.y"
    { (yyval.i) = 4096; }
    break;

  case 238:
/* Line 1787 of yacc.c  */
#line 1481 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].i) < 256 || (yyvsp[(1) - (1)].i) > 65536) cf_error("Invalid log buffer size");
     (yyval.i) = (yyvsp[(1) - (1)].i);
   }
    break;

  case 239:
/* Line 1787 of yacc.c  */
#line 1488 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_disable, 1, 0); }
    break;

  case 240:
/* Line 1787 of yacc.c  */
#line 1490 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_enable, 1, 0); }
    break;

  case 241:
/* Line 1787 of yacc.c  */
#line 1492 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_restart, 1, 0); }
    break;

  case 242:
/* Line 1787 of yacc.c  */
#line 1494 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_reload, 1, CMD_RELOAD); }
    break;

  case 243:
/* Line 1787 of yacc.c  */
#line 1496 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_reload, 1, CMD_RELOAD_IN); }
    break;

  case 244:
/* Line 1787 of yacc.c  */
#line 1498 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_reload, 1, CMD_RELOAD_OUT); }
    break;

  case 245:
/* Line 1787 of yacc.c  */
#line 1502 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_debug, 1, (yyvsp[(3) - (4)].i)); }
    break;

  case 246:
/* Line 1787 of yacc.c  */
#line 1506 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_mrtdump, 1, (yyvsp[(3) - (4)].i)); }
    break;

  case 247:
/* Line 1787 of yacc.c  */
#line 1509 "cf-parse.y"
    { this_cli->restricted = 1; cli_msg(16, "Access restricted"); }
    break;

  case 248:
/* Line 1787 of yacc.c  */
#line 1512 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].s); (yyval.ps).patt = 0; }
    break;

  case 249:
/* Line 1787 of yacc.c  */
#line 1513 "cf-parse.y"
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
    break;

  case 250:
/* Line 1787 of yacc.c  */
#line 1514 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].t); (yyval.ps).patt = 1; }
    break;

  case 251:
/* Line 1787 of yacc.c  */
#line 1518 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].s); (yyval.ps).patt = 0; }
    break;

  case 252:
/* Line 1787 of yacc.c  */
#line 1519 "cf-parse.y"
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
    break;

  case 253:
/* Line 1787 of yacc.c  */
#line 1520 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].t); (yyval.ps).patt = 1; }
    break;

  case 254:
/* Line 1787 of yacc.c  */
#line 1528 "cf-parse.y"
    { (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_FILTER, NULL); cf_push_scope( (yyvsp[(2) - (2)].s) ); }
    break;

  case 255:
/* Line 1787 of yacc.c  */
#line 1529 "cf-parse.y"
    {
     (yyvsp[(2) - (4)].s)->def = (yyvsp[(4) - (4)].f);
     (yyvsp[(4) - (4)].f)->name = (yyvsp[(2) - (4)].s)->name;
     DBG( "We have new filter defined (%s)\n", (yyvsp[(2) - (4)].s)->name );
     cf_pop_scope();
   }
    break;

  case 256:
/* Line 1787 of yacc.c  */
#line 1538 "cf-parse.y"
    { f_eval_int((yyvsp[(2) - (2)].x)); }
    break;

  case 257:
/* Line 1787 of yacc.c  */
#line 1542 "cf-parse.y"
    { (yyval.i) = T_INT; }
    break;

  case 258:
/* Line 1787 of yacc.c  */
#line 1543 "cf-parse.y"
    { (yyval.i) = T_BOOL; }
    break;

  case 259:
/* Line 1787 of yacc.c  */
#line 1544 "cf-parse.y"
    { (yyval.i) = T_IP; }
    break;

  case 260:
/* Line 1787 of yacc.c  */
#line 1545 "cf-parse.y"
    { (yyval.i) = T_PREFIX; }
    break;

  case 261:
/* Line 1787 of yacc.c  */
#line 1546 "cf-parse.y"
    { (yyval.i) = T_PAIR; }
    break;

  case 262:
/* Line 1787 of yacc.c  */
#line 1547 "cf-parse.y"
    { (yyval.i) = T_QUAD; }
    break;

  case 263:
/* Line 1787 of yacc.c  */
#line 1548 "cf-parse.y"
    { (yyval.i) = T_EC; }
    break;

  case 264:
/* Line 1787 of yacc.c  */
#line 1549 "cf-parse.y"
    { (yyval.i) = T_STRING; }
    break;

  case 265:
/* Line 1787 of yacc.c  */
#line 1550 "cf-parse.y"
    { (yyval.i) = T_PATH_MASK; }
    break;

  case 266:
/* Line 1787 of yacc.c  */
#line 1551 "cf-parse.y"
    { (yyval.i) = T_PATH; }
    break;

  case 267:
/* Line 1787 of yacc.c  */
#line 1552 "cf-parse.y"
    { (yyval.i) = T_CLIST; }
    break;

  case 268:
/* Line 1787 of yacc.c  */
#line 1553 "cf-parse.y"
    { (yyval.i) = T_ECLIST; }
    break;

  case 269:
/* Line 1787 of yacc.c  */
#line 1554 "cf-parse.y"
    { 
	switch ((yyvsp[(1) - (2)].i)) {
	  case T_INT:
	  case T_PAIR:
	  case T_QUAD:
	  case T_EC:
	  case T_IP:
	       (yyval.i) = T_SET;
	       break;

	  case T_PREFIX:
	       (yyval.i) = T_PREFIX_SET;
	    break;

	  default:
		cf_error( "You can't create sets of this type." );
	}
   }
    break;

  case 270:
/* Line 1787 of yacc.c  */
#line 1575 "cf-parse.y"
    {
     struct f_val * val = cfg_alloc(sizeof(struct f_val)); 
     val->type = (yyvsp[(1) - (2)].i); 
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_VARIABLE | (yyvsp[(1) - (2)].i), val);
     DBG( "New variable %s type %x\n", (yyvsp[(2) - (2)].s)->name, (yyvsp[(1) - (2)].i) );
     (yyvsp[(2) - (2)].s)->aux2 = NULL;
     (yyval.s)=(yyvsp[(2) - (2)].s);
   }
    break;

  case 271:
/* Line 1787 of yacc.c  */
#line 1586 "cf-parse.y"
    { (yyval.s) = NULL; }
    break;

  case 272:
/* Line 1787 of yacc.c  */
#line 1587 "cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   }
    break;

  case 273:
/* Line 1787 of yacc.c  */
#line 1594 "cf-parse.y"
    { (yyval.s) = (yyvsp[(1) - (1)].s); }
    break;

  case 274:
/* Line 1787 of yacc.c  */
#line 1595 "cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   }
    break;

  case 275:
/* Line 1787 of yacc.c  */
#line 1602 "cf-parse.y"
    {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     f->name = NULL;
     f->root = (yyvsp[(1) - (1)].x);
     (yyval.f) = f;
   }
    break;

  case 276:
/* Line 1787 of yacc.c  */
#line 1611 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_FILTER) cf_error("No such filter.");
     (yyval.f) = (yyvsp[(1) - (1)].s)->def;
   }
    break;

  case 278:
/* Line 1787 of yacc.c  */
#line 1619 "cf-parse.y"
    {
     /* Construct 'IF term THEN ACCEPT; REJECT;' */
     struct filter *f = cfg_alloc(sizeof(struct filter));
     struct f_inst *i, *acc, *rej;
     acc = f_new_inst();		/* ACCEPT */
     acc->code = P('p',',');
     acc->a1.p = NULL;
     acc->a2.i = F_ACCEPT;
     rej = f_new_inst();		/* REJECT */
     rej->code = P('p',',');
     rej->a1.p = NULL;
     rej->a2.i = F_REJECT;
     i = f_new_inst();			/* IF */
     i->code = '?';
     i->a1.p = (yyvsp[(2) - (2)].x);
     i->a2.p = acc;
     i->next = rej;
     f->name = NULL;
     f->root = i;
     (yyval.f) = f;
  }
    break;

  case 279:
/* Line 1787 of yacc.c  */
#line 1643 "cf-parse.y"
    { DBG( "Have function parameters\n" ); (yyval.s)=(yyvsp[(2) - (3)].s); }
    break;

  case 280:
/* Line 1787 of yacc.c  */
#line 1644 "cf-parse.y"
    { (yyval.s)=NULL; }
    break;

  case 281:
/* Line 1787 of yacc.c  */
#line 1648 "cf-parse.y"
    {
     if ((yyvsp[(1) - (4)].s)) {
       /* Prepend instruction to clear local variables */
       (yyval.x) = f_new_inst();
       (yyval.x)->code = P('c','v');
       (yyval.x)->a1.p = (yyvsp[(1) - (4)].s);
       (yyval.x)->next = (yyvsp[(3) - (4)].x);
     } else
       (yyval.x) = (yyvsp[(3) - (4)].x);
   }
    break;

  case 282:
/* Line 1787 of yacc.c  */
#line 1661 "cf-parse.y"
    { DBG( "Beginning of function %s\n", (yyvsp[(2) - (2)].s)->name );
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_FUNCTION, NULL);
     cf_push_scope((yyvsp[(2) - (2)].s));
   }
    break;

  case 283:
/* Line 1787 of yacc.c  */
#line 1664 "cf-parse.y"
    {
     (yyvsp[(2) - (5)].s)->def = (yyvsp[(5) - (5)].x);
     (yyvsp[(2) - (5)].s)->aux2 = (yyvsp[(4) - (5)].s);
     DBG("Hmm, we've got one function here - %s\n", (yyvsp[(2) - (5)].s)->name); 
     cf_pop_scope();
   }
    break;

  case 284:
/* Line 1787 of yacc.c  */
#line 1677 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 285:
/* Line 1787 of yacc.c  */
#line 1678 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x)->next; (yyvsp[(1) - (1)].x)->next = NULL; }
    break;

  case 286:
/* Line 1787 of yacc.c  */
#line 1681 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); (yyvsp[(1) - (1)].x)->next = (yyvsp[(1) - (1)].x); }
    break;

  case 287:
/* Line 1787 of yacc.c  */
#line 1682 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyvsp[(2) - (2)].x)->next = (yyvsp[(1) - (2)].x)->next ; (yyvsp[(1) - (2)].x)->next = (yyvsp[(2) - (2)].x); }
    break;

  case 288:
/* Line 1787 of yacc.c  */
#line 1686 "cf-parse.y"
    {
     (yyval.x)=(yyvsp[(1) - (1)].x);
   }
    break;

  case 289:
/* Line 1787 of yacc.c  */
#line 1689 "cf-parse.y"
    {
     (yyval.x)=(yyvsp[(2) - (3)].x);
   }
    break;

  case 290:
/* Line 1787 of yacc.c  */
#line 1698 "cf-parse.y"
    { (yyval.v).type = T_IP; (yyval.v).val.px.ip = (yyvsp[(1) - (1)].a); }
    break;

  case 291:
/* Line 1787 of yacc.c  */
#line 1711 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[(1) - (1)].i); }
    break;

  case 292:
/* Line 1787 of yacc.c  */
#line 1712 "cf-parse.y"
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[(1) - (1)].i32); }
    break;

  case 293:
/* Line 1787 of yacc.c  */
#line 1713 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); }
    break;

  case 294:
/* Line 1787 of yacc.c  */
#line 1714 "cf-parse.y"
    { (yyval.v).type = pair_a((yyvsp[(1) - (1)].i)); (yyval.v).val.i = pair_b((yyvsp[(1) - (1)].i)); }
    break;

  case 295:
/* Line 1787 of yacc.c  */
#line 1718 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[(1) - (1)].i); }
    break;

  case 296:
/* Line 1787 of yacc.c  */
#line 1719 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = f_eval_int((yyvsp[(2) - (3)].x)); }
    break;

  case 297:
/* Line 1787 of yacc.c  */
#line 1720 "cf-parse.y"
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[(1) - (1)].i32); }
    break;

  case 298:
/* Line 1787 of yacc.c  */
#line 1721 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); }
    break;

  case 299:
/* Line 1787 of yacc.c  */
#line 1722 "cf-parse.y"
    { (yyval.v).type = pair_a((yyvsp[(1) - (1)].i)); (yyval.v).val.i = pair_b((yyvsp[(1) - (1)].i)); }
    break;

  case 300:
/* Line 1787 of yacc.c  */
#line 1726 "cf-parse.y"
    { (yyval.i) = f_eval_int((yyvsp[(1) - (1)].x)); check_u16((yyval.i)); }
    break;

  case 301:
/* Line 1787 of yacc.c  */
#line 1729 "cf-parse.y"
    { (yyval.i32) = pair((yyvsp[(1) - (1)].i), (yyvsp[(1) - (1)].i)); }
    break;

  case 302:
/* Line 1787 of yacc.c  */
#line 1730 "cf-parse.y"
    { (yyval.i32) = pair((yyvsp[(1) - (3)].i), (yyvsp[(3) - (3)].i)); }
    break;

  case 303:
/* Line 1787 of yacc.c  */
#line 1731 "cf-parse.y"
    { (yyval.i32) = 0xFFFF; }
    break;

  case 304:
/* Line 1787 of yacc.c  */
#line 1735 "cf-parse.y"
    {
     (yyval.e) = f_new_pair_set(pair_a((yyvsp[(2) - (5)].i32)), pair_b((yyvsp[(2) - (5)].i32)), pair_a((yyvsp[(4) - (5)].i32)), pair_b((yyvsp[(4) - (5)].i32)));
   }
    break;

  case 305:
/* Line 1787 of yacc.c  */
#line 1738 "cf-parse.y"
    {
     /* Hack: $2 and $4 should be pair_expr, but that would cause shift/reduce conflict */
     if ((pair_a((yyvsp[(2) - (11)].i32)) != pair_b((yyvsp[(2) - (11)].i32))) || (pair_a((yyvsp[(4) - (11)].i32)) != pair_b((yyvsp[(4) - (11)].i32))))
       cf_error("syntax error");
     (yyval.e) = f_new_pair_item(pair_b((yyvsp[(2) - (11)].i32)), (yyvsp[(8) - (11)].i), pair_b((yyvsp[(4) - (11)].i32)), (yyvsp[(10) - (11)].i)); 
   }
    break;

  case 306:
/* Line 1787 of yacc.c  */
#line 1747 "cf-parse.y"
    { (yyval.i32) = f_eval_int((yyvsp[(1) - (1)].x)); }
    break;

  case 307:
/* Line 1787 of yacc.c  */
#line 1750 "cf-parse.y"
    { (yyval.i) = EC_RT; }
    break;

  case 308:
/* Line 1787 of yacc.c  */
#line 1751 "cf-parse.y"
    { (yyval.i) = EC_RO; }
    break;

  case 309:
/* Line 1787 of yacc.c  */
#line 1752 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); }
    break;

  case 310:
/* Line 1787 of yacc.c  */
#line 1753 "cf-parse.y"
    { (yyval.i) = EC_GENERIC; }
    break;

  case 311:
/* Line 1787 of yacc.c  */
#line 1757 "cf-parse.y"
    { (yyval.e) = f_new_ec_item((yyvsp[(2) - (7)].i), 0, (yyvsp[(4) - (7)].i32), (yyvsp[(6) - (7)].i32), (yyvsp[(6) - (7)].i32)); }
    break;

  case 312:
/* Line 1787 of yacc.c  */
#line 1758 "cf-parse.y"
    { (yyval.e) = f_new_ec_item((yyvsp[(2) - (9)].i), 0, (yyvsp[(4) - (9)].i32), (yyvsp[(6) - (9)].i32), (yyvsp[(8) - (9)].i32)); }
    break;

  case 313:
/* Line 1787 of yacc.c  */
#line 1759 "cf-parse.y"
    {  (yyval.e) = f_new_ec_item((yyvsp[(2) - (7)].i), 0, (yyvsp[(4) - (7)].i32), 0, EC_ALL); }
    break;

  case 316:
/* Line 1787 of yacc.c  */
#line 1765 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (1)].v), (yyvsp[(1) - (1)].v)); }
    break;

  case 317:
/* Line 1787 of yacc.c  */
#line 1766 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (3)].v), (yyvsp[(3) - (3)].v)); }
    break;

  case 320:
/* Line 1787 of yacc.c  */
#line 1772 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (1)].v), (yyvsp[(1) - (1)].v)); }
    break;

  case 321:
/* Line 1787 of yacc.c  */
#line 1773 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (3)].v), (yyvsp[(3) - (3)].v)); }
    break;

  case 323:
/* Line 1787 of yacc.c  */
#line 1778 "cf-parse.y"
    { (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), (yyvsp[(3) - (3)].e)); }
    break;

  case 325:
/* Line 1787 of yacc.c  */
#line 1783 "cf-parse.y"
    { (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), (yyvsp[(3) - (3)].e)); }
    break;

  case 326:
/* Line 1787 of yacc.c  */
#line 1787 "cf-parse.y"
    {
     if (((yyvsp[(3) - (3)].i) < 0) || ((yyvsp[(3) - (3)].i) > MAX_PREFIX_LENGTH) || !ip_is_prefix((yyvsp[(1) - (3)].a), (yyvsp[(3) - (3)].i))) cf_error("Invalid network prefix: %I/%d.", (yyvsp[(1) - (3)].a), (yyvsp[(3) - (3)].i));
     (yyval.v).type = T_PREFIX; (yyval.v).val.px.ip = (yyvsp[(1) - (3)].a); (yyval.v).val.px.len = (yyvsp[(3) - (3)].i);
   }
    break;

  case 327:
/* Line 1787 of yacc.c  */
#line 1794 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); }
    break;

  case 328:
/* Line 1787 of yacc.c  */
#line 1795 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (2)].v); (yyval.v).val.px.len |= LEN_PLUS; }
    break;

  case 329:
/* Line 1787 of yacc.c  */
#line 1796 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (2)].v); (yyval.v).val.px.len |= LEN_MINUS; }
    break;

  case 330:
/* Line 1787 of yacc.c  */
#line 1797 "cf-parse.y"
    { 
     if (! ((0 <= (yyvsp[(3) - (6)].i)) && ((yyvsp[(3) - (6)].i) <= (yyvsp[(5) - (6)].i)) && ((yyvsp[(5) - (6)].i) <= MAX_PREFIX_LENGTH))) cf_error("Invalid prefix pattern range: {%d, %d}.", (yyvsp[(3) - (6)].i), (yyvsp[(5) - (6)].i));
     (yyval.v) = (yyvsp[(1) - (6)].v); (yyval.v).val.px.len |= LEN_RANGE | ((yyvsp[(3) - (6)].i) << 16) | ((yyvsp[(5) - (6)].i) << 8);
   }
    break;

  case 331:
/* Line 1787 of yacc.c  */
#line 1804 "cf-parse.y"
    { (yyval.trie) = f_new_trie(cfg_mem); trie_add_fprefix((yyval.trie), &((yyvsp[(1) - (1)].v).val.px)); }
    break;

  case 332:
/* Line 1787 of yacc.c  */
#line 1805 "cf-parse.y"
    { (yyval.trie) = (yyvsp[(1) - (3)].trie); trie_add_fprefix((yyval.trie), &((yyvsp[(3) - (3)].v).val.px)); }
    break;

  case 333:
/* Line 1787 of yacc.c  */
#line 1808 "cf-parse.y"
    { (yyval.e) = NULL; }
    break;

  case 334:
/* Line 1787 of yacc.c  */
#line 1809 "cf-parse.y"
    {
     /* Fill data fields */
     struct f_tree *t;
     for (t = (yyvsp[(2) - (4)].e); t; t = t->left)
       t->data = (yyvsp[(4) - (4)].x);
     (yyval.e) = f_merge_items((yyvsp[(1) - (4)].e), (yyvsp[(2) - (4)].e));
   }
    break;

  case 335:
/* Line 1787 of yacc.c  */
#line 1816 "cf-parse.y"
    { 
     struct f_tree *t = f_new_tree();
     t->from.type = t->to.type = T_VOID;
     t->right = t;
     t->data = (yyvsp[(3) - (3)].x);
     (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), t);
 }
    break;

  case 336:
/* Line 1787 of yacc.c  */
#line 1828 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 337:
/* Line 1787 of yacc.c  */
#line 1829 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); }
    break;

  case 338:
/* Line 1787 of yacc.c  */
#line 1833 "cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); }
    break;

  case 339:
/* Line 1787 of yacc.c  */
#line 1834 "cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); }
    break;

  case 340:
/* Line 1787 of yacc.c  */
#line 1838 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[(1) - (2)].i); }
    break;

  case 341:
/* Line 1787 of yacc.c  */
#line 1839 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; }
    break;

  case 342:
/* Line 1787 of yacc.c  */
#line 1840 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_QUESTION; (yyval.h)->val  = 0; }
    break;

  case 343:
/* Line 1787 of yacc.c  */
#line 1841 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN_EXPR; (yyval.h)->val = (uintptr_t) (yyvsp[(1) - (2)].x); }
    break;

  case 344:
/* Line 1787 of yacc.c  */
#line 1842 "cf-parse.y"
    { (yyval.h) = NULL; }
    break;

  case 345:
/* Line 1787 of yacc.c  */
#line 1846 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[(1) - (2)].i); }
    break;

  case 346:
/* Line 1787 of yacc.c  */
#line 1847 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; }
    break;

  case 347:
/* Line 1787 of yacc.c  */
#line 1848 "cf-parse.y"
    { (yyval.h) = NULL; }
    break;

  case 348:
/* Line 1787 of yacc.c  */
#line 1852 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_INT;  (yyval.x)->a2.i = (yyvsp[(1) - (1)].i); }
    break;

  case 349:
/* Line 1787 of yacc.c  */
#line 1853 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 1;  }
    break;

  case 350:
/* Line 1787 of yacc.c  */
#line 1854 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 0;  }
    break;

  case 351:
/* Line 1787 of yacc.c  */
#line 1855 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_STRING; (yyval.x)->a2.p = (yyvsp[(1) - (1)].t); }
    break;

  case 352:
/* Line 1787 of yacc.c  */
#line 1856 "cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); }
    break;

  case 353:
/* Line 1787 of yacc.c  */
#line 1857 "cf-parse.y"
    {NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); }
    break;

  case 354:
/* Line 1787 of yacc.c  */
#line 1858 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_QUAD;  (yyval.x)->a2.i = (yyvsp[(1) - (1)].i32); }
    break;

  case 355:
/* Line 1787 of yacc.c  */
#line 1859 "cf-parse.y"
    { DBG( "We've got a set here..." ); (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_SET; (yyval.x)->a2.p = build_tree((yyvsp[(2) - (3)].e)); DBG( "ook\n" ); }
    break;

  case 356:
/* Line 1787 of yacc.c  */
#line 1860 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_PREFIX_SET;  (yyval.x)->a2.p = (yyvsp[(2) - (3)].trie); }
    break;

  case 357:
/* Line 1787 of yacc.c  */
#line 1861 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = (yyvsp[(1) - (1)].i) >> 16; (yyval.x)->a2.i = (yyvsp[(1) - (1)].i) & 0xffff; }
    break;

  case 358:
/* Line 1787 of yacc.c  */
#line 1862 "cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; val->type = T_PATH_MASK; val->val.path_mask = (yyvsp[(1) - (1)].h); (yyval.x)->a1.p = val; }
    break;

  case 359:
/* Line 1787 of yacc.c  */
#line 1866 "cf-parse.y"
    { (yyval.x) = f_generate_dpair((yyvsp[(2) - (5)].x), (yyvsp[(4) - (5)].x)); }
    break;

  case 360:
/* Line 1787 of yacc.c  */
#line 1867 "cf-parse.y"
    { (yyval.x) = f_generate_ec((yyvsp[(2) - (7)].i), (yyvsp[(4) - (7)].x), (yyvsp[(6) - (7)].x)); }
    break;

  case 362:
/* Line 1787 of yacc.c  */
#line 1881 "cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
    break;

  case 363:
/* Line 1787 of yacc.c  */
#line 1904 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     switch ((yyvsp[(1) - (1)].s)->class) {
       case SYM_NUMBER:
	(yyval.x) = f_new_inst();
	(yyval.x)->code = 'c'; 
	(yyval.x)->aux = T_INT; 
	(yyval.x)->a2.i = (yyvsp[(1) - (1)].s)->aux;
	break;
       case SYM_IPA:
	{ NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; val->type = T_IP; val->val.px.ip = * (ip_addr *) ((yyvsp[(1) - (1)].s)->def); }
	break;
       case SYM_VARIABLE | T_BOOL:
       case SYM_VARIABLE | T_INT:
       case SYM_VARIABLE | T_PAIR:
       case SYM_VARIABLE | T_QUAD:
       case SYM_VARIABLE | T_EC:
       case SYM_VARIABLE | T_STRING:
       case SYM_VARIABLE | T_IP:
       case SYM_VARIABLE | T_PREFIX:
       case SYM_VARIABLE | T_PREFIX_SET:
       case SYM_VARIABLE | T_SET:
       case SYM_VARIABLE | T_PATH:
       case SYM_VARIABLE | T_PATH_MASK:
       case SYM_VARIABLE | T_CLIST:
       case SYM_VARIABLE | T_ECLIST:
	 (yyval.x)->code = 'V';
	 (yyval.x)->a1.p = (yyvsp[(1) - (1)].s)->def;
	 (yyval.x)->a2.p = (yyvsp[(1) - (1)].s)->name;
	 break;
       default:
	 cf_error("%s: variable expected.", (yyvsp[(1) - (1)].s)->name );
     }
   }
    break;

  case 364:
/* Line 1787 of yacc.c  */
#line 1940 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = OFFSETOF(struct rta, from);   (yyval.x)->a1.i = 1; }
    break;

  case 365:
/* Line 1787 of yacc.c  */
#line 1942 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = OFFSETOF(struct rta, gw);     (yyval.x)->a1.i = 1; }
    break;

  case 366:
/* Line 1787 of yacc.c  */
#line 1943 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_PREFIX;     (yyval.x)->a2.i = 0x12345678; /* This is actually ok - T_PREFIX is special-cased. */ }
    break;

  case 367:
/* Line 1787 of yacc.c  */
#line 1944 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_STRING;     (yyval.x)->a2.i = 0x12345678; /* T_STRING is also special-cased. */ }
    break;

  case 368:
/* Line 1787 of yacc.c  */
#line 1945 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTS;   (yyval.x)->a2.i = OFFSETOF(struct rta, source); }
    break;

  case 369:
/* Line 1787 of yacc.c  */
#line 1946 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_SCOPE; (yyval.x)->a2.i = OFFSETOF(struct rta, scope);  (yyval.x)->a1.i = 1; }
    break;

  case 370:
/* Line 1787 of yacc.c  */
#line 1947 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTC;   (yyval.x)->a2.i = OFFSETOF(struct rta, cast); }
    break;

  case 371:
/* Line 1787 of yacc.c  */
#line 1948 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTD;   (yyval.x)->a2.i = OFFSETOF(struct rta, dest);   (yyval.x)->a1.i = 1; }
    break;

  case 372:
/* Line 1787 of yacc.c  */
#line 1952 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); }
    break;

  case 373:
/* Line 1787 of yacc.c  */
#line 1953 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '+';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 374:
/* Line 1787 of yacc.c  */
#line 1954 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '-';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 375:
/* Line 1787 of yacc.c  */
#line 1955 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '*';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 376:
/* Line 1787 of yacc.c  */
#line 1956 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '/';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 377:
/* Line 1787 of yacc.c  */
#line 1957 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '&';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 378:
/* Line 1787 of yacc.c  */
#line 1958 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '|';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 379:
/* Line 1787 of yacc.c  */
#line 1959 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('=','='); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 380:
/* Line 1787 of yacc.c  */
#line 1960 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('!','=');     (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 381:
/* Line 1787 of yacc.c  */
#line 1961 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 382:
/* Line 1787 of yacc.c  */
#line 1962 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 383:
/* Line 1787 of yacc.c  */
#line 1963 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); }
    break;

  case 384:
/* Line 1787 of yacc.c  */
#line 1964 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); }
    break;

  case 385:
/* Line 1787 of yacc.c  */
#line 1965 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '~';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 386:
/* Line 1787 of yacc.c  */
#line 1966 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '!'; (yyval.x)->a1.p = (yyvsp[(2) - (2)].x); }
    break;

  case 387:
/* Line 1787 of yacc.c  */
#line 1967 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('d','e');  (yyval.x)->a1.p = (yyvsp[(3) - (4)].x); }
    break;

  case 388:
/* Line 1787 of yacc.c  */
#line 1969 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 389:
/* Line 1787 of yacc.c  */
#line 1970 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 390:
/* Line 1787 of yacc.c  */
#line 1971 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 391:
/* Line 1787 of yacc.c  */
#line 1973 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'P'; }
    break;

  case 392:
/* Line 1787 of yacc.c  */
#line 1975 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyval.x)->code = 'a'; }
    break;

  case 393:
/* Line 1787 of yacc.c  */
#line 1977 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyval.x)->code = P('e','a'); }
    break;

  case 394:
/* Line 1787 of yacc.c  */
#line 1979 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('c','p'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->aux = T_IP; }
    break;

  case 395:
/* Line 1787 of yacc.c  */
#line 1980 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'L'; (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 396:
/* Line 1787 of yacc.c  */
#line 1981 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('i','M'); (yyval.x)->a1.p = (yyvsp[(1) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); }
    break;

  case 397:
/* Line 1787 of yacc.c  */
#line 1982 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','f'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 398:
/* Line 1787 of yacc.c  */
#line 1983 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','l'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 399:
/* Line 1787 of yacc.c  */
#line 1993 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_PATH; }
    break;

  case 400:
/* Line 1787 of yacc.c  */
#line 1994 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_CLIST; }
    break;

  case 401:
/* Line 1787 of yacc.c  */
#line 1995 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_ECLIST; }
    break;

  case 402:
/* Line 1787 of yacc.c  */
#line 1996 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('A','p'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); }
    break;

  case 403:
/* Line 1787 of yacc.c  */
#line 1997 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'a'; }
    break;

  case 404:
/* Line 1787 of yacc.c  */
#line 1998 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'd'; }
    break;

  case 405:
/* Line 1787 of yacc.c  */
#line 1999 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'f'; }
    break;

  case 406:
/* Line 1787 of yacc.c  */
#line 2001 "cf-parse.y"
    { (yyval.x) = f_generate_roa_check((yyvsp[(3) - (4)].s), NULL, NULL); }
    break;

  case 407:
/* Line 1787 of yacc.c  */
#line 2002 "cf-parse.y"
    { (yyval.x) = f_generate_roa_check((yyvsp[(3) - (8)].s), (yyvsp[(5) - (8)].x), (yyvsp[(7) - (8)].x)); }
    break;

  case 408:
/* Line 1787 of yacc.c  */
#line 2007 "cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
    break;

  case 409:
/* Line 1787 of yacc.c  */
#line 2030 "cf-parse.y"
    { (yyval.i) = F_QUITBIRD; }
    break;

  case 410:
/* Line 1787 of yacc.c  */
#line 2031 "cf-parse.y"
    { (yyval.i) = F_ACCEPT; }
    break;

  case 411:
/* Line 1787 of yacc.c  */
#line 2032 "cf-parse.y"
    { (yyval.i) = F_REJECT; }
    break;

  case 412:
/* Line 1787 of yacc.c  */
#line 2033 "cf-parse.y"
    { (yyval.i) = F_ERROR; }
    break;

  case 413:
/* Line 1787 of yacc.c  */
#line 2034 "cf-parse.y"
    { (yyval.i) = F_NOP; }
    break;

  case 414:
/* Line 1787 of yacc.c  */
#line 2035 "cf-parse.y"
    { (yyval.i) = F_NONL; }
    break;

  case 415:
/* Line 1787 of yacc.c  */
#line 2039 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'p'; (yyval.x)->a1.p = (yyvsp[(1) - (1)].x); (yyval.x)->a2.p = NULL; }
    break;

  case 416:
/* Line 1787 of yacc.c  */
#line 2042 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 417:
/* Line 1787 of yacc.c  */
#line 2043 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 418:
/* Line 1787 of yacc.c  */
#line 2044 "cf-parse.y"
    {
     if ((yyvsp[(1) - (3)].x)) {
       (yyvsp[(1) - (3)].x)->next = (yyvsp[(3) - (3)].x);
       (yyval.x) = (yyvsp[(1) - (3)].x);
     } else (yyval.x) = (yyvsp[(3) - (3)].x);
   }
    break;

  case 419:
/* Line 1787 of yacc.c  */
#line 2052 "cf-parse.y"
    { 
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (1)].x);
     (yyval.x)->next = NULL;
   }
    break;

  case 420:
/* Line 1787 of yacc.c  */
#line 2059 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (3)].x);
     (yyval.x)->next = (yyvsp[(3) - (3)].x);
   }
    break;

  case 421:
/* Line 1787 of yacc.c  */
#line 2068 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 422:
/* Line 1787 of yacc.c  */
#line 2069 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 423:
/* Line 1787 of yacc.c  */
#line 2073 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = (yyvsp[(2) - (4)].x);
     (yyval.x)->a2.p = (yyvsp[(4) - (4)].x);
   }
    break;

  case 424:
/* Line 1787 of yacc.c  */
#line 2079 "cf-parse.y"
    {
     struct f_inst *i = f_new_inst();
     i->code = '?';
     i->a1.p = (yyvsp[(2) - (6)].x);
     i->a2.p = (yyvsp[(4) - (6)].x);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = i;
     (yyval.x)->a2.p = (yyvsp[(6) - (6)].x);
   }
    break;

  case 425:
/* Line 1787 of yacc.c  */
#line 2089 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll set value\n" );
     if (((yyvsp[(1) - (4)].s)->class & ~T_MASK) != SYM_VARIABLE)
       cf_error( "You may set only variables." );
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = (yyvsp[(1) - (4)].s);
     (yyval.x)->a2.p = (yyvsp[(3) - (4)].x);
   }
    break;

  case 426:
/* Line 1787 of yacc.c  */
#line 2098 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll return the value\n" );
     (yyval.x)->code = 'r';
     (yyval.x)->a1.p = (yyvsp[(2) - (3)].x);
   }
    break;

  case 427:
/* Line 1787 of yacc.c  */
#line 2104 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(2) - (5)].x);
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   }
    break;

  case 428:
/* Line 1787 of yacc.c  */
#line 2109 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(2) - (5)].x);
     if (!(yyval.x)->a1.i)
       cf_error( "This static attribute is read-only.");
     (yyval.x)->code = P('a','S');
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   }
    break;

  case 429:
/* Line 1787 of yacc.c  */
#line 2116 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('P','S');
     (yyval.x)->a1.p = (yyvsp[(3) - (4)].x);
   }
    break;

  case 430:
/* Line 1787 of yacc.c  */
#line 2121 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(4) - (6)].x);
     (yyval.x)->aux = EAF_TYPE_UNDEF | EAF_TEMP;
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = NULL;
   }
    break;

  case 431:
/* Line 1787 of yacc.c  */
#line 2127 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('p',','); (yyval.x)->a1.p = (yyvsp[(2) - (3)].x); (yyval.x)->a2.i = (yyvsp[(1) - (3)].i); }
    break;

  case 432:
/* Line 1787 of yacc.c  */
#line 2128 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (2)].x); }
    break;

  case 433:
/* Line 1787 of yacc.c  */
#line 2129 "cf-parse.y"
    {
      (yyval.x) = f_new_inst();
      (yyval.x)->code = P('S','W');
      (yyval.x)->a1.p = (yyvsp[(2) - (5)].x);
      (yyval.x)->a2.p = build_tree( (yyvsp[(4) - (5)].e) );
   }
    break;

  case 434:
/* Line 1787 of yacc.c  */
#line 2137 "cf-parse.y"
    { (yyval.x) = f_generate_empty((yyvsp[(2) - (5)].x)); }
    break;

  case 435:
/* Line 1787 of yacc.c  */
#line 2138 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('A','p'), 'x', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 436:
/* Line 1787 of yacc.c  */
#line 2139 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'a', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 437:
/* Line 1787 of yacc.c  */
#line 2140 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'd', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 438:
/* Line 1787 of yacc.c  */
#line 2141 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'f', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 439:
/* Line 1787 of yacc.c  */
#line 2147 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_bgp, sizeof(struct bgp_config), (yyvsp[(1) - (2)].i));
     BGP_CFG->hold_time = 240;
     BGP_CFG->connect_retry_time = 120;
     BGP_CFG->initial_hold_time = 240;
     BGP_CFG->compare_path_lengths = 1;
     BGP_CFG->igp_metric = 1;
     BGP_CFG->start_delay_time = 5;
     BGP_CFG->error_amnesia_time = 300;
     BGP_CFG->error_delay_time_min = 60;
     BGP_CFG->error_delay_time_max = 300;
     BGP_CFG->enable_refresh = 1;
     BGP_CFG->enable_as4 = 1;
     BGP_CFG->capabilities = 2;
     BGP_CFG->advertise_ipv4 = 1;
     BGP_CFG->interpret_communities = 1;
     BGP_CFG->default_local_pref = 100;
 }
    break;

  case 442:
/* Line 1787 of yacc.c  */
#line 2170 "cf-parse.y"
    { BGP_CFG->local_as = (yyvsp[(4) - (5)].i); }
    break;

  case 443:
/* Line 1787 of yacc.c  */
#line 2171 "cf-parse.y"
    { BGP_CFG->source_addr = (yyvsp[(3) - (6)].a); BGP_CFG->local_as = (yyvsp[(5) - (6)].i); }
    break;

  case 444:
/* Line 1787 of yacc.c  */
#line 2172 "cf-parse.y"
    {
     if (ipa_nonzero(BGP_CFG->remote_ip))
       cf_error("Only one neighbor per BGP instance is allowed");
     if (!ipa_has_link_scope((yyvsp[(3) - (7)].a)) != !(yyvsp[(4) - (7)].iface))
       cf_error("Link-local address and interface scope must be used together");

     BGP_CFG->remote_ip = (yyvsp[(3) - (7)].a);
     BGP_CFG->iface = (yyvsp[(4) - (7)].iface);
     BGP_CFG->remote_as = (yyvsp[(6) - (7)].i);
   }
    break;

  case 445:
/* Line 1787 of yacc.c  */
#line 2182 "cf-parse.y"
    { BGP_CFG->rr_cluster_id = (yyvsp[(5) - (6)].i32); }
    break;

  case 446:
/* Line 1787 of yacc.c  */
#line 2183 "cf-parse.y"
    { BGP_CFG->rr_client = 1; }
    break;

  case 447:
/* Line 1787 of yacc.c  */
#line 2184 "cf-parse.y"
    { BGP_CFG->rs_client = 1; }
    break;

  case 448:
/* Line 1787 of yacc.c  */
#line 2185 "cf-parse.y"
    { BGP_CFG->hold_time = (yyvsp[(4) - (5)].i); }
    break;

  case 449:
/* Line 1787 of yacc.c  */
#line 2186 "cf-parse.y"
    { BGP_CFG->initial_hold_time = (yyvsp[(5) - (6)].i); }
    break;

  case 450:
/* Line 1787 of yacc.c  */
#line 2187 "cf-parse.y"
    { BGP_CFG->connect_retry_time = (yyvsp[(5) - (6)].i); }
    break;

  case 451:
/* Line 1787 of yacc.c  */
#line 2188 "cf-parse.y"
    { BGP_CFG->keepalive_time = (yyvsp[(4) - (5)].i); }
    break;

  case 452:
/* Line 1787 of yacc.c  */
#line 2189 "cf-parse.y"
    { BGP_CFG->multihop = 64; }
    break;

  case 453:
/* Line 1787 of yacc.c  */
#line 2190 "cf-parse.y"
    { BGP_CFG->multihop = (yyvsp[(3) - (4)].i); if (((yyvsp[(3) - (4)].i)<1) || ((yyvsp[(3) - (4)].i)>255)) cf_error("Multihop must be in range 1-255"); }
    break;

  case 454:
/* Line 1787 of yacc.c  */
#line 2191 "cf-parse.y"
    { BGP_CFG->next_hop_self = 1; BGP_CFG->next_hop_keep = 0; }
    break;

  case 455:
/* Line 1787 of yacc.c  */
#line 2192 "cf-parse.y"
    { BGP_CFG->next_hop_keep = 1; BGP_CFG->next_hop_self = 0; }
    break;

  case 456:
/* Line 1787 of yacc.c  */
#line 2193 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_SELF; }
    break;

  case 457:
/* Line 1787 of yacc.c  */
#line 2194 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_DROP; }
    break;

  case 458:
/* Line 1787 of yacc.c  */
#line 2195 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_IGNORE; }
    break;

  case 459:
/* Line 1787 of yacc.c  */
#line 2196 "cf-parse.y"
    { BGP_CFG->gw_mode = GW_DIRECT; }
    break;

  case 460:
/* Line 1787 of yacc.c  */
#line 2197 "cf-parse.y"
    { BGP_CFG->gw_mode = GW_RECURSIVE; }
    break;

  case 461:
/* Line 1787 of yacc.c  */
#line 2198 "cf-parse.y"
    { BGP_CFG->compare_path_lengths = (yyvsp[(4) - (5)].i); }
    break;

  case 462:
/* Line 1787 of yacc.c  */
#line 2199 "cf-parse.y"
    { BGP_CFG->med_metric = (yyvsp[(4) - (5)].i); }
    break;

  case 463:
/* Line 1787 of yacc.c  */
#line 2200 "cf-parse.y"
    { BGP_CFG->igp_metric = (yyvsp[(4) - (5)].i); }
    break;

  case 464:
/* Line 1787 of yacc.c  */
#line 2201 "cf-parse.y"
    { BGP_CFG->prefer_older = (yyvsp[(4) - (5)].i); }
    break;

  case 465:
/* Line 1787 of yacc.c  */
#line 2202 "cf-parse.y"
    { BGP_CFG->deterministic_med = (yyvsp[(4) - (5)].i); }
    break;

  case 466:
/* Line 1787 of yacc.c  */
#line 2203 "cf-parse.y"
    { BGP_CFG->default_med = (yyvsp[(4) - (5)].i); }
    break;

  case 467:
/* Line 1787 of yacc.c  */
#line 2204 "cf-parse.y"
    { BGP_CFG->default_local_pref = (yyvsp[(4) - (5)].i); }
    break;

  case 468:
/* Line 1787 of yacc.c  */
#line 2205 "cf-parse.y"
    { BGP_CFG->source_addr = (yyvsp[(4) - (5)].a); }
    break;

  case 469:
/* Line 1787 of yacc.c  */
#line 2206 "cf-parse.y"
    { BGP_CFG->start_delay_time = (yyvsp[(5) - (6)].i); }
    break;

  case 470:
/* Line 1787 of yacc.c  */
#line 2207 "cf-parse.y"
    { BGP_CFG->error_amnesia_time = (yyvsp[(5) - (6)].i); }
    break;

  case 471:
/* Line 1787 of yacc.c  */
#line 2208 "cf-parse.y"
    { BGP_CFG->error_delay_time_min = (yyvsp[(5) - (8)].i); BGP_CFG->error_delay_time_max = (yyvsp[(7) - (8)].i); }
    break;

  case 472:
/* Line 1787 of yacc.c  */
#line 2209 "cf-parse.y"
    { BGP_CFG->disable_after_error = (yyvsp[(5) - (6)].i); }
    break;

  case 473:
/* Line 1787 of yacc.c  */
#line 2210 "cf-parse.y"
    { BGP_CFG->enable_refresh = (yyvsp[(5) - (6)].i); }
    break;

  case 474:
/* Line 1787 of yacc.c  */
#line 2211 "cf-parse.y"
    { BGP_CFG->enable_as4 = (yyvsp[(4) - (5)].i); }
    break;

  case 475:
/* Line 1787 of yacc.c  */
#line 2212 "cf-parse.y"
    { BGP_CFG->capabilities = (yyvsp[(3) - (4)].i); }
    break;

  case 476:
/* Line 1787 of yacc.c  */
#line 2213 "cf-parse.y"
    { BGP_CFG->advertise_ipv4 = (yyvsp[(4) - (5)].i); }
    break;

  case 477:
/* Line 1787 of yacc.c  */
#line 2214 "cf-parse.y"
    { BGP_CFG->password = (yyvsp[(3) - (4)].t); }
    break;

  case 478:
/* Line 1787 of yacc.c  */
#line 2215 "cf-parse.y"
    {
     this_proto->in_limit = cfg_allocz(sizeof(struct proto_limit));
     this_proto->in_limit->limit = (yyvsp[(4) - (5)].i);
     this_proto->in_limit->action = PLA_RESTART;
   }
    break;

  case 479:
/* Line 1787 of yacc.c  */
#line 2220 "cf-parse.y"
    { BGP_CFG->passive = (yyvsp[(3) - (4)].i); }
    break;

  case 480:
/* Line 1787 of yacc.c  */
#line 2221 "cf-parse.y"
    { BGP_CFG->interpret_communities = (yyvsp[(4) - (5)].i); }
    break;

  case 481:
/* Line 1787 of yacc.c  */
#line 2222 "cf-parse.y"
    { BGP_CFG->secondary = (yyvsp[(3) - (4)].i); }
    break;

  case 482:
/* Line 1787 of yacc.c  */
#line 2223 "cf-parse.y"
    { BGP_CFG->igp_table = (yyvsp[(4) - (5)].r); }
    break;

  case 483:
/* Line 1787 of yacc.c  */
#line 2224 "cf-parse.y"
    { BGP_CFG->ttl_security = (yyvsp[(4) - (5)].i); }
    break;

  case 484:
/* Line 1787 of yacc.c  */
#line 2235 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_ospf, sizeof(struct ospf_config), (yyvsp[(1) - (2)].i));
     init_list(&OSPF_CFG->area_list);
     init_list(&OSPF_CFG->vlink_list);
     OSPF_CFG->rfc1583 = DEFAULT_RFC1583;
     OSPF_CFG->tick = DEFAULT_OSPFTICK;
  }
    break;

  case 488:
/* Line 1787 of yacc.c  */
#line 2251 "cf-parse.y"
    { OSPF_CFG->rfc1583 = (yyvsp[(2) - (2)].i); }
    break;

  case 489:
/* Line 1787 of yacc.c  */
#line 2252 "cf-parse.y"
    { OSPF_CFG->ecmp = (yyvsp[(2) - (2)].i) ? DEFAULT_ECMP_LIMIT : 0; }
    break;

  case 490:
/* Line 1787 of yacc.c  */
#line 2253 "cf-parse.y"
    { OSPF_CFG->ecmp = (yyvsp[(2) - (4)].i) ? (yyvsp[(4) - (4)].i) : 0; if ((yyvsp[(4) - (4)].i) < 0) cf_error("ECMP limit cannot be negative"); }
    break;

  case 491:
/* Line 1787 of yacc.c  */
#line 2254 "cf-parse.y"
    { OSPF_CFG->tick = (yyvsp[(2) - (2)].i); if((yyvsp[(2) - (2)].i)<=0) cf_error("Tick must be greater than zero"); }
    break;

  case 493:
/* Line 1787 of yacc.c  */
#line 2258 "cf-parse.y"
    {
  this_area = cfg_allocz(sizeof(struct ospf_area_config));
  add_tail(&OSPF_CFG->area_list, NODE this_area);
  this_area->areaid = (yyvsp[(2) - (2)].i32);
  this_area->default_cost = DEFAULT_STUB_COST;
  this_area->type = OPT_E;
  this_area->transint = DEFAULT_TRANSINT;

  init_list(&this_area->patt_list);
  init_list(&this_area->net_list);
  init_list(&this_area->enet_list);
  init_list(&this_area->stubnet_list);
 }
    break;

  case 494:
/* Line 1787 of yacc.c  */
#line 2273 "cf-parse.y"
    { ospf_area_finish(); }
    break;

  case 497:
/* Line 1787 of yacc.c  */
#line 2282 "cf-parse.y"
    { this_area->type = (yyvsp[(2) - (2)].i) ? 0 : OPT_E; /* We should remove the option */ }
    break;

  case 498:
/* Line 1787 of yacc.c  */
#line 2283 "cf-parse.y"
    { this_area->type = OPT_N; }
    break;

  case 499:
/* Line 1787 of yacc.c  */
#line 2284 "cf-parse.y"
    { this_area->summary = (yyvsp[(2) - (2)].i); }
    break;

  case 500:
/* Line 1787 of yacc.c  */
#line 2285 "cf-parse.y"
    { this_area->default_nssa = (yyvsp[(3) - (3)].i); }
    break;

  case 501:
/* Line 1787 of yacc.c  */
#line 2286 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i); check_defcost((yyvsp[(3) - (3)].i)); }
    break;

  case 502:
/* Line 1787 of yacc.c  */
#line 2287 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i) | LSA_EXT_EBIT; check_defcost((yyvsp[(3) - (3)].i)); }
    break;

  case 503:
/* Line 1787 of yacc.c  */
#line 2288 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i);  check_defcost((yyvsp[(3) - (3)].i)); }
    break;

  case 504:
/* Line 1787 of yacc.c  */
#line 2289 "cf-parse.y"
    { this_area->translator = (yyvsp[(2) - (2)].i); }
    break;

  case 505:
/* Line 1787 of yacc.c  */
#line 2290 "cf-parse.y"
    { this_area->transint = (yyvsp[(3) - (3)].i); }
    break;

  case 506:
/* Line 1787 of yacc.c  */
#line 2291 "cf-parse.y"
    { this_nets = &this_area->net_list; }
    break;

  case 508:
/* Line 1787 of yacc.c  */
#line 2292 "cf-parse.y"
    { this_nets = &this_area->enet_list; }
    break;

  case 515:
/* Line 1787 of yacc.c  */
#line 2304 "cf-parse.y"
    {
     this_stubnet = cfg_allocz(sizeof(struct ospf_stubnet_config));
     add_tail(&this_area->stubnet_list, NODE this_stubnet);
     this_stubnet->px = (yyvsp[(1) - (1)].px);
     this_stubnet->cost = COST_D;
   }
    break;

  case 518:
/* Line 1787 of yacc.c  */
#line 2318 "cf-parse.y"
    { this_stubnet->hidden = (yyvsp[(2) - (2)].i); }
    break;

  case 519:
/* Line 1787 of yacc.c  */
#line 2319 "cf-parse.y"
    { this_stubnet->summary = (yyvsp[(2) - (2)].i); }
    break;

  case 520:
/* Line 1787 of yacc.c  */
#line 2320 "cf-parse.y"
    { this_stubnet->cost = (yyvsp[(2) - (2)].i); }
    break;

  case 521:
/* Line 1787 of yacc.c  */
#line 2324 "cf-parse.y"
    { ospf_iface_finish(); }
    break;

  case 522:
/* Line 1787 of yacc.c  */
#line 2325 "cf-parse.y"
    { ospf_iface_finish(); }
    break;

  case 526:
/* Line 1787 of yacc.c  */
#line 2334 "cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
    break;

  case 527:
/* Line 1787 of yacc.c  */
#line 2335 "cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Retransmit int must be greater than zero"); }
    break;

  case 528:
/* Line 1787 of yacc.c  */
#line 2336 "cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
    break;

  case 529:
/* Line 1787 of yacc.c  */
#line 2337 "cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; }
    break;

  case 530:
/* Line 1787 of yacc.c  */
#line 2338 "cf-parse.y"
    { OSPF_PATT->deadint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); }
    break;

  case 531:
/* Line 1787 of yacc.c  */
#line 2339 "cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); }
    break;

  case 532:
/* Line 1787 of yacc.c  */
#line 2340 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE ; }
    break;

  case 533:
/* Line 1787 of yacc.c  */
#line 2341 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE ; }
    break;

  case 534:
/* Line 1787 of yacc.c  */
#line 2342 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT ; }
    break;

  case 536:
/* Line 1787 of yacc.c  */
#line 2347 "cf-parse.y"
    {
  if (this_area->areaid == 0) cf_error("Virtual link cannot be in backbone");
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&OSPF_CFG->vlink_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->voa = this_area->areaid;
  OSPF_PATT->vid = (yyvsp[(3) - (3)].i32);
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->waitint = WAIT_DMH*HELLOINT_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->deadint = 0;
  OSPF_PATT->type = OSPF_IT_VLINK;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->autype = OSPF_AUTH_NONE;
  reset_passwords();
 }
    break;

  case 537:
/* Line 1787 of yacc.c  */
#line 2368 "cf-parse.y"
    { OSPF_PATT->cost = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Cost must be in range 1-65535"); }
    break;

  case 538:
/* Line 1787 of yacc.c  */
#line 2369 "cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
    break;

  case 539:
/* Line 1787 of yacc.c  */
#line 2370 "cf-parse.y"
    { OSPF_PATT->pollint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Poll int must be greater than zero"); }
    break;

  case 540:
/* Line 1787 of yacc.c  */
#line 2371 "cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Retransmit int must be greater than zero"); }
    break;

  case 541:
/* Line 1787 of yacc.c  */
#line 2372 "cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; }
    break;

  case 542:
/* Line 1787 of yacc.c  */
#line 2373 "cf-parse.y"
    { OSPF_PATT->deadint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); }
    break;

  case 543:
/* Line 1787 of yacc.c  */
#line 2374 "cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); }
    break;

  case 544:
/* Line 1787 of yacc.c  */
#line 2375 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
    break;

  case 545:
/* Line 1787 of yacc.c  */
#line 2376 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
    break;

  case 546:
/* Line 1787 of yacc.c  */
#line 2377 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
    break;

  case 547:
/* Line 1787 of yacc.c  */
#line 2378 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
    break;

  case 548:
/* Line 1787 of yacc.c  */
#line 2379 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTP ; }
    break;

  case 549:
/* Line 1787 of yacc.c  */
#line 2380 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTP ; }
    break;

  case 550:
/* Line 1787 of yacc.c  */
#line 2381 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
    break;

  case 551:
/* Line 1787 of yacc.c  */
#line 2382 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
    break;

  case 552:
/* Line 1787 of yacc.c  */
#line 2383 "cf-parse.y"
    { OSPF_PATT->real_bcast = (yyvsp[(3) - (3)].i); if (OSPF_VERSION != 2) cf_error("Real broadcast option requires OSPFv2"); }
    break;

  case 553:
/* Line 1787 of yacc.c  */
#line 2384 "cf-parse.y"
    { OSPF_PATT->ptp_netmask = (yyvsp[(3) - (3)].i); if (OSPF_VERSION != 2) cf_error("Real netmask option requires OSPFv2"); }
    break;

  case 554:
/* Line 1787 of yacc.c  */
#line 2385 "cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
    break;

  case 555:
/* Line 1787 of yacc.c  */
#line 2386 "cf-parse.y"
    { OSPF_PATT->priority = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<0) || ((yyvsp[(2) - (2)].i)>255)) cf_error("Priority must be in range 0-255"); }
    break;

  case 556:
/* Line 1787 of yacc.c  */
#line 2387 "cf-parse.y"
    { OSPF_PATT->strictnbma = (yyvsp[(3) - (3)].i) ; }
    break;

  case 557:
/* Line 1787 of yacc.c  */
#line 2388 "cf-parse.y"
    { OSPF_PATT->stub = (yyvsp[(2) - (2)].i) ; }
    break;

  case 558:
/* Line 1787 of yacc.c  */
#line 2389 "cf-parse.y"
    { OSPF_PATT->check_link = (yyvsp[(3) - (3)].i); }
    break;

  case 559:
/* Line 1787 of yacc.c  */
#line 2390 "cf-parse.y"
    { OSPF_PATT->ecmp_weight = (yyvsp[(3) - (3)].i) - 1; if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
    break;

  case 561:
/* Line 1787 of yacc.c  */
#line 2392 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE ; }
    break;

  case 562:
/* Line 1787 of yacc.c  */
#line 2393 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE ; }
    break;

  case 563:
/* Line 1787 of yacc.c  */
#line 2394 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT ; }
    break;

  case 564:
/* Line 1787 of yacc.c  */
#line 2395 "cf-parse.y"
    { OSPF_PATT->rxbuf = OSPF_RXBUF_LARGE ; }
    break;

  case 565:
/* Line 1787 of yacc.c  */
#line 2396 "cf-parse.y"
    { OSPF_PATT->rxbuf = OSPF_RXBUF_NORMAL ; }
    break;

  case 566:
/* Line 1787 of yacc.c  */
#line 2397 "cf-parse.y"
    { OSPF_PATT->rxbuf = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i) < OSPF_RXBUF_MINSIZE) || ((yyvsp[(3) - (3)].i) > OSPF_MAX_PKT_SIZE)) cf_error("Buffer size must be in range 256-65535"); }
    break;

  case 571:
/* Line 1787 of yacc.c  */
#line 2409 "cf-parse.y"
    {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(this_nets, NODE this_pref);
   this_pref->px.addr = (yyvsp[(1) - (1)].px).addr;
   this_pref->px.len = (yyvsp[(1) - (1)].px).len;
 }
    break;

  case 573:
/* Line 1787 of yacc.c  */
#line 2419 "cf-parse.y"
    { this_pref->hidden = 1; }
    break;

  case 574:
/* Line 1787 of yacc.c  */
#line 2420 "cf-parse.y"
    { this_pref->tag = (yyvsp[(2) - (2)].i); }
    break;

  case 577:
/* Line 1787 of yacc.c  */
#line 2429 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 578:
/* Line 1787 of yacc.c  */
#line 2430 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 579:
/* Line 1787 of yacc.c  */
#line 2434 "cf-parse.y"
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[(1) - (3)].a);
   this_nbma->eligible=(yyvsp[(2) - (3)].i);
 }
    break;

  case 580:
/* Line 1787 of yacc.c  */
#line 2443 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->pollint = POLLINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->priority = PRIORITY_D;
  OSPF_PATT->waitint = WAIT_DMH*HELLOINT_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->deadint = 0;
  OSPF_PATT->type = OSPF_IT_UNDEF;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->autype = OSPF_AUTH_NONE;
  OSPF_PATT->ptp_netmask = 2; /* not specified */
  reset_passwords();
 }
    break;

  case 582:
/* Line 1787 of yacc.c  */
#line 2466 "cf-parse.y"
    { set_instance_id((yyvsp[(2) - (2)].i)); }
    break;

  case 587:
/* Line 1787 of yacc.c  */
#line 2480 "cf-parse.y"
    { ospf_iface_finish(); }
    break;

  case 589:
/* Line 1787 of yacc.c  */
#line 2485 "cf-parse.y"
    { (yyval.t) = NULL; }
    break;

  case 590:
/* Line 1787 of yacc.c  */
#line 2491 "cf-parse.y"
    { ospf_sh(proto_get_named((yyvsp[(3) - (4)].s), &proto_ospf)); }
    break;

  case 591:
/* Line 1787 of yacc.c  */
#line 2494 "cf-parse.y"
    { ospf_sh_neigh(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); }
    break;

  case 592:
/* Line 1787 of yacc.c  */
#line 2497 "cf-parse.y"
    { ospf_sh_iface(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); }
    break;

  case 593:
/* Line 1787 of yacc.c  */
#line 2502 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 0, 1); }
    break;

  case 594:
/* Line 1787 of yacc.c  */
#line 2505 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(5) - (7)].s), &proto_ospf), 0, 0); }
    break;

  case 595:
/* Line 1787 of yacc.c  */
#line 2510 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 1, 1); }
    break;

  case 596:
/* Line 1787 of yacc.c  */
#line 2513 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(5) - (7)].s), &proto_ospf), 1, 0); }
    break;

  case 597:
/* Line 1787 of yacc.c  */
#line 2517 "cf-parse.y"
    { ospf_sh_lsadb((yyvsp[(4) - (5)].ld)); }
    break;

  case 598:
/* Line 1787 of yacc.c  */
#line 2520 "cf-parse.y"
    {
     (yyval.ld) = cfg_allocz(sizeof(struct lsadb_show_data));
   }
    break;

  case 599:
/* Line 1787 of yacc.c  */
#line 2523 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->scope = LSA_SCOPE_AS; }
    break;

  case 600:
/* Line 1787 of yacc.c  */
#line 2524 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->scope = LSA_SCOPE_AREA; (yyval.ld)->area = (yyvsp[(3) - (3)].i32); }
    break;

  case 601:
/* Line 1787 of yacc.c  */
#line 2525 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->scope = 1; /* hack, 0 is no filter */ }
    break;

  case 602:
/* Line 1787 of yacc.c  */
#line 2526 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->type = (yyvsp[(3) - (3)].i); }
    break;

  case 603:
/* Line 1787 of yacc.c  */
#line 2527 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->lsid = (yyvsp[(3) - (3)].i32); }
    break;

  case 604:
/* Line 1787 of yacc.c  */
#line 2528 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->router = SH_ROUTER_SELF; }
    break;

  case 605:
/* Line 1787 of yacc.c  */
#line 2529 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->router = (yyvsp[(3) - (3)].i32); }
    break;

  case 606:
/* Line 1787 of yacc.c  */
#line 2530 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->name = (yyvsp[(2) - (2)].s); }
    break;

  case 607:
/* Line 1787 of yacc.c  */
#line 2536 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_pipe, sizeof(struct pipe_config), (yyvsp[(1) - (2)].i));
     PIPE_CFG->mode = PIPE_TRANSPARENT;
  }
    break;

  case 610:
/* Line 1787 of yacc.c  */
#line 2545 "cf-parse.y"
    {
     if ((yyvsp[(4) - (5)].s)->class != SYM_TABLE)
       cf_error("Routing table name expected");
     PIPE_CFG->peer = (yyvsp[(4) - (5)].s)->def;
   }
    break;

  case 611:
/* Line 1787 of yacc.c  */
#line 2550 "cf-parse.y"
    { PIPE_CFG->mode = PIPE_OPAQUE; }
    break;

  case 612:
/* Line 1787 of yacc.c  */
#line 2551 "cf-parse.y"
    { PIPE_CFG->mode = PIPE_TRANSPARENT; }
    break;

  case 613:
/* Line 1787 of yacc.c  */
#line 2558 "cf-parse.y"
    {
  this_proto = proto_config_new(&proto_radv, sizeof(struct radv_config), (yyvsp[(1) - (2)].i));
  init_list(&RADV_CFG->patt_list);
  init_list(&RADV_CFG->pref_list);
  init_list(&RADV_CFG->rdnss_list);
  init_list(&RADV_CFG->dnssl_list);
}
    break;

  case 616:
/* Line 1787 of yacc.c  */
#line 2569 "cf-parse.y"
    { add_tail(&RADV_CFG->pref_list, NODE this_radv_prefix); }
    break;

  case 617:
/* Line 1787 of yacc.c  */
#line 2570 "cf-parse.y"
    { init_list(&radv_dns_list); }
    break;

  case 618:
/* Line 1787 of yacc.c  */
#line 2570 "cf-parse.y"
    { add_tail_list(&RADV_CFG->rdnss_list, &radv_dns_list); }
    break;

  case 619:
/* Line 1787 of yacc.c  */
#line 2571 "cf-parse.y"
    { init_list(&radv_dns_list); }
    break;

  case 620:
/* Line 1787 of yacc.c  */
#line 2571 "cf-parse.y"
    { add_tail_list(&RADV_CFG->dnssl_list, &radv_dns_list); }
    break;

  case 621:
/* Line 1787 of yacc.c  */
#line 2572 "cf-parse.y"
    {
     RADV_CFG->trigger_prefix = (yyvsp[(2) - (2)].px).addr;
     RADV_CFG->trigger_pxlen = (yyvsp[(2) - (2)].px).len;
     RADV_CFG->trigger_valid = 1;
   }
    break;

  case 625:
/* Line 1787 of yacc.c  */
#line 2589 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct radv_iface_config));
  add_tail(&RADV_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  init_list(&RADV_IFACE->pref_list);
  init_list(&RADV_IFACE->rdnss_list);
  init_list(&RADV_IFACE->dnssl_list);

  RADV_IFACE->min_ra_int = -1; /* undefined */
  RADV_IFACE->max_ra_int = DEFAULT_MAX_RA_INT;
  RADV_IFACE->min_delay = DEFAULT_MIN_DELAY;
  RADV_IFACE->current_hop_limit = DEFAULT_CURRENT_HOP_LIMIT;
  RADV_IFACE->default_lifetime = -1;
  RADV_IFACE->default_lifetime_sensitive = 1;
}
    break;

  case 626:
/* Line 1787 of yacc.c  */
#line 2606 "cf-parse.y"
    { RADV_IFACE->min_ra_int = (yyvsp[(4) - (4)].i); if ((yyvsp[(4) - (4)].i) < 3) cf_error("Min RA interval must be at least 3"); }
    break;

  case 627:
/* Line 1787 of yacc.c  */
#line 2607 "cf-parse.y"
    { RADV_IFACE->max_ra_int = (yyvsp[(4) - (4)].i); if (((yyvsp[(4) - (4)].i) < 4) || ((yyvsp[(4) - (4)].i) > 1800)) cf_error("Max RA interval must be in range 4-1800"); }
    break;

  case 628:
/* Line 1787 of yacc.c  */
#line 2608 "cf-parse.y"
    { RADV_IFACE->min_delay = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i) <= 0) cf_error("Min delay must be positive"); }
    break;

  case 629:
/* Line 1787 of yacc.c  */
#line 2609 "cf-parse.y"
    { RADV_IFACE->managed = (yyvsp[(2) - (2)].i); }
    break;

  case 630:
/* Line 1787 of yacc.c  */
#line 2610 "cf-parse.y"
    { RADV_IFACE->other_config = (yyvsp[(3) - (3)].i); }
    break;

  case 631:
/* Line 1787 of yacc.c  */
#line 2611 "cf-parse.y"
    { RADV_IFACE->link_mtu = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i) < 0) cf_error("Link MTU must be 0 or positive"); }
    break;

  case 632:
/* Line 1787 of yacc.c  */
#line 2612 "cf-parse.y"
    { RADV_IFACE->reachable_time = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i) < 0) || ((yyvsp[(3) - (3)].i) > 3600000)) cf_error("Reachable time must be in range 0-3600000"); }
    break;

  case 633:
/* Line 1787 of yacc.c  */
#line 2613 "cf-parse.y"
    { RADV_IFACE->retrans_timer = (yyvsp[(3) - (3)].i); if ((yyvsp[(3) - (3)].i) < 0) cf_error("Retrans timer must be 0 or positive"); }
    break;

  case 634:
/* Line 1787 of yacc.c  */
#line 2614 "cf-parse.y"
    { RADV_IFACE->current_hop_limit = (yyvsp[(4) - (4)].i); if (((yyvsp[(4) - (4)].i) < 0) || ((yyvsp[(4) - (4)].i) > 255))  cf_error("Current hop limit must be in range 0-255"); }
    break;

  case 635:
/* Line 1787 of yacc.c  */
#line 2615 "cf-parse.y"
    {
     RADV_IFACE->default_lifetime = (yyvsp[(3) - (4)].i);
     if (((yyvsp[(3) - (4)].i) < 0) || ((yyvsp[(3) - (4)].i) > 9000))  cf_error("Default lifetime must be in range 0-9000");
     if ((yyvsp[(4) - (4)].i) != -1) RADV_IFACE->default_lifetime_sensitive = (yyvsp[(4) - (4)].i);
   }
    break;

  case 636:
/* Line 1787 of yacc.c  */
#line 2620 "cf-parse.y"
    { add_tail(&RADV_IFACE->pref_list, NODE this_radv_prefix); }
    break;

  case 637:
/* Line 1787 of yacc.c  */
#line 2621 "cf-parse.y"
    { init_list(&radv_dns_list); }
    break;

  case 638:
/* Line 1787 of yacc.c  */
#line 2621 "cf-parse.y"
    { add_tail_list(&RADV_IFACE->rdnss_list, &radv_dns_list); }
    break;

  case 639:
/* Line 1787 of yacc.c  */
#line 2622 "cf-parse.y"
    { init_list(&radv_dns_list); }
    break;

  case 640:
/* Line 1787 of yacc.c  */
#line 2622 "cf-parse.y"
    { add_tail_list(&RADV_IFACE->dnssl_list, &radv_dns_list); }
    break;

  case 641:
/* Line 1787 of yacc.c  */
#line 2623 "cf-parse.y"
    { RADV_IFACE->rdnss_local = (yyvsp[(3) - (3)].i); }
    break;

  case 642:
/* Line 1787 of yacc.c  */
#line 2624 "cf-parse.y"
    { RADV_IFACE->dnssl_local = (yyvsp[(3) - (3)].i); }
    break;

  case 643:
/* Line 1787 of yacc.c  */
#line 2628 "cf-parse.y"
    {
  struct radv_iface_config *ic = RADV_IFACE;

  if (ic->min_ra_int == (u32) -1)
    ic->min_ra_int = _MAX(ic->max_ra_int / 3, 3);

  if (ic->default_lifetime == (u32) -1)
    ic->default_lifetime = 3 * ic->max_ra_int;

  if ((ic->min_ra_int > 3) &&
      (ic->min_ra_int > (ic->max_ra_int * 3 / 4)))
    cf_error("Min RA interval must be at most 3/4 * Max RA interval %d %d", ic->min_ra_int, ic->max_ra_int);

  if ((ic->default_lifetime > 0) && (ic->default_lifetime < ic->max_ra_int))
    cf_error("Default lifetime must be either 0 or at least Max RA interval");
}
    break;

  case 649:
/* Line 1787 of yacc.c  */
#line 2661 "cf-parse.y"
    {
  this_radv_prefix = cfg_allocz(sizeof(struct radv_prefix_config));
  RADV_PREFIX->prefix = (yyvsp[(1) - (1)].px).addr;
  RADV_PREFIX->pxlen = (yyvsp[(1) - (1)].px).len;

  RADV_PREFIX->onlink = 1;
  RADV_PREFIX->autonomous = 1;
  RADV_PREFIX->valid_lifetime = DEFAULT_VALID_LIFETIME;
  RADV_PREFIX->preferred_lifetime = DEFAULT_PREFERRED_LIFETIME;
}
    break;

  case 650:
/* Line 1787 of yacc.c  */
#line 2673 "cf-parse.y"
    { RADV_PREFIX->skip = (yyvsp[(2) - (2)].i); }
    break;

  case 651:
/* Line 1787 of yacc.c  */
#line 2674 "cf-parse.y"
    { RADV_PREFIX->onlink = (yyvsp[(2) - (2)].i); }
    break;

  case 652:
/* Line 1787 of yacc.c  */
#line 2675 "cf-parse.y"
    { RADV_PREFIX->autonomous = (yyvsp[(2) - (2)].i); }
    break;

  case 653:
/* Line 1787 of yacc.c  */
#line 2676 "cf-parse.y"
    {
     RADV_PREFIX->valid_lifetime = (yyvsp[(3) - (4)].i);
     if ((yyvsp[(3) - (4)].i) < 0) cf_error("Valid lifetime must be 0 or positive");
     if ((yyvsp[(4) - (4)].i) != -1) RADV_PREFIX->valid_lifetime_sensitive = (yyvsp[(4) - (4)].i);
   }
    break;

  case 654:
/* Line 1787 of yacc.c  */
#line 2681 "cf-parse.y"
    {
     RADV_PREFIX->preferred_lifetime = (yyvsp[(3) - (4)].i);
     if ((yyvsp[(3) - (4)].i) < 0) cf_error("Preferred lifetime must be 0 or positive");
     if ((yyvsp[(4) - (4)].i) != -1) RADV_PREFIX->preferred_lifetime_sensitive = (yyvsp[(4) - (4)].i);
   }
    break;

  case 655:
/* Line 1787 of yacc.c  */
#line 2689 "cf-parse.y"
    {
  if (RADV_PREFIX->preferred_lifetime > RADV_PREFIX->valid_lifetime)
    cf_error("Preferred lifetime must be at most Valid lifetime");

  if (RADV_PREFIX->valid_lifetime_sensitive > RADV_PREFIX->preferred_lifetime_sensitive)
    cf_error("Valid lifetime sensitive requires that Preferred lifetime is sensitive too");
}
    break;

  case 661:
/* Line 1787 of yacc.c  */
#line 2713 "cf-parse.y"
    {
  struct radv_rdnss_config *cf = cfg_allocz(sizeof(struct radv_rdnss_config));
  add_tail(&radv_dns_list, NODE cf);

  cf->server = (yyvsp[(1) - (1)].a);
  cf->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
    break;

  case 662:
/* Line 1787 of yacc.c  */
#line 2722 "cf-parse.y"
    {
  RADV_RDNSS->lifetime = 0;
  RADV_RDNSS->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
    break;

  case 665:
/* Line 1787 of yacc.c  */
#line 2729 "cf-parse.y"
    { RADV_RDNSS->lifetime = (yyvsp[(2) - (2)].i); RADV_RDNSS->lifetime_mult = radv_mult_val; }
    break;

  case 666:
/* Line 1787 of yacc.c  */
#line 2733 "cf-parse.y"
    {
  if (EMPTY_LIST(radv_dns_list))
    cf_error("No nameserver in RDNSS section");

  struct radv_rdnss_config *cf;
  WALK_LIST(cf, radv_dns_list)
  {
    cf->lifetime = RADV_RDNSS->lifetime;
    cf->lifetime_mult = RADV_RDNSS->lifetime_mult;
  }
}
    break;

  case 671:
/* Line 1787 of yacc.c  */
#line 2757 "cf-parse.y"
    {
  struct radv_dnssl_config *cf = cfg_allocz(sizeof(struct radv_dnssl_config));
  add_tail(&radv_dns_list, NODE cf);

  cf->domain = (yyvsp[(1) - (1)].t);
  cf->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;

  if (radv_process_domain(cf) < 0)
    cf_error("Invalid domain dame");
}
    break;

  case 672:
/* Line 1787 of yacc.c  */
#line 2769 "cf-parse.y"
    {
  RADV_DNSSL->lifetime = 0;
  RADV_DNSSL->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
    break;

  case 675:
/* Line 1787 of yacc.c  */
#line 2776 "cf-parse.y"
    { RADV_DNSSL->lifetime = (yyvsp[(2) - (2)].i); RADV_DNSSL->lifetime_mult = radv_mult_val; }
    break;

  case 676:
/* Line 1787 of yacc.c  */
#line 2780 "cf-parse.y"
    {
  if (EMPTY_LIST(radv_dns_list))
    cf_error("No domain in DNSSL section");

  struct radv_dnssl_config *cf;
  WALK_LIST(cf, radv_dns_list)
  {
    cf->lifetime = RADV_DNSSL->lifetime;
    cf->lifetime_mult = RADV_DNSSL->lifetime_mult;
  }
}
    break;

  case 681:
/* Line 1787 of yacc.c  */
#line 2804 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (1)].i); radv_mult_val = 0; }
    break;

  case 682:
/* Line 1787 of yacc.c  */
#line 2805 "cf-parse.y"
    { (yyval.i) = 0; radv_mult_val = (yyvsp[(2) - (2)].i); if (((yyvsp[(2) - (2)].i) < 1) || ((yyvsp[(2) - (2)].i) > 254)) cf_error("Multiplier must be in range 1-254"); }
    break;

  case 683:
/* Line 1787 of yacc.c  */
#line 2809 "cf-parse.y"
    { (yyval.i) = -1; }
    break;

  case 684:
/* Line 1787 of yacc.c  */
#line 2810 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); }
    break;

  case 685:
/* Line 1787 of yacc.c  */
#line 2816 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_rip, sizeof(struct rip_proto_config), (yyvsp[(1) - (2)].i));
     rip_init_config(RIP_CFG);
   }
    break;

  case 688:
/* Line 1787 of yacc.c  */
#line 2825 "cf-parse.y"
    { RIP_CFG->infinity = (yyvsp[(3) - (4)].i); }
    break;

  case 689:
/* Line 1787 of yacc.c  */
#line 2826 "cf-parse.y"
    { RIP_CFG->port = (yyvsp[(3) - (4)].i); }
    break;

  case 690:
/* Line 1787 of yacc.c  */
#line 2827 "cf-parse.y"
    { RIP_CFG->period = (yyvsp[(3) - (4)].i); }
    break;

  case 691:
/* Line 1787 of yacc.c  */
#line 2828 "cf-parse.y"
    { RIP_CFG->garbage_time = (yyvsp[(4) - (5)].i); }
    break;

  case 692:
/* Line 1787 of yacc.c  */
#line 2829 "cf-parse.y"
    { RIP_CFG->timeout_time = (yyvsp[(4) - (5)].i); }
    break;

  case 693:
/* Line 1787 of yacc.c  */
#line 2830 "cf-parse.y"
    {RIP_CFG->authtype = (yyvsp[(3) - (4)].i); }
    break;

  case 695:
/* Line 1787 of yacc.c  */
#line 2832 "cf-parse.y"
    { RIP_CFG->honor = HO_ALWAYS; }
    break;

  case 696:
/* Line 1787 of yacc.c  */
#line 2833 "cf-parse.y"
    { RIP_CFG->honor = HO_NEIGHBOR; }
    break;

  case 697:
/* Line 1787 of yacc.c  */
#line 2834 "cf-parse.y"
    { RIP_CFG->honor = HO_NEVER; }
    break;

  case 699:
/* Line 1787 of yacc.c  */
#line 2839 "cf-parse.y"
    { (yyval.i)=AT_PLAINTEXT; }
    break;

  case 700:
/* Line 1787 of yacc.c  */
#line 2840 "cf-parse.y"
    { (yyval.i)=AT_MD5; }
    break;

  case 701:
/* Line 1787 of yacc.c  */
#line 2841 "cf-parse.y"
    { (yyval.i)=AT_NONE; }
    break;

  case 702:
/* Line 1787 of yacc.c  */
#line 2846 "cf-parse.y"
    { (yyval.i)=IM_BROADCAST; }
    break;

  case 703:
/* Line 1787 of yacc.c  */
#line 2847 "cf-parse.y"
    { (yyval.i)=0; }
    break;

  case 704:
/* Line 1787 of yacc.c  */
#line 2848 "cf-parse.y"
    { (yyval.i)=IM_QUIET; }
    break;

  case 705:
/* Line 1787 of yacc.c  */
#line 2849 "cf-parse.y"
    { (yyval.i)=IM_NOLISTEN; }
    break;

  case 706:
/* Line 1787 of yacc.c  */
#line 2850 "cf-parse.y"
    { (yyval.i)=IM_VERSION1 | IM_BROADCAST; }
    break;

  case 708:
/* Line 1787 of yacc.c  */
#line 2854 "cf-parse.y"
    { RIP_IPATT->metric = (yyvsp[(2) - (2)].i); }
    break;

  case 709:
/* Line 1787 of yacc.c  */
#line 2855 "cf-parse.y"
    { RIP_IPATT->mode |= (yyvsp[(2) - (2)].i); }
    break;

  case 714:
/* Line 1787 of yacc.c  */
#line 2869 "cf-parse.y"
    {
     this_ipatt = cfg_allocz(sizeof(struct rip_patt));
     add_tail(&RIP_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
     RIP_IPATT->metric = 1;
   }
    break;

  case 716:
/* Line 1787 of yacc.c  */
#line 2885 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_static, sizeof(struct static_config), (yyvsp[(1) - (2)].i));
     static_init_config((struct static_config *) this_proto);
  }
    break;

  case 719:
/* Line 1787 of yacc.c  */
#line 2894 "cf-parse.y"
    { STATIC_CFG->check_link = (yyvsp[(4) - (5)].i); }
    break;

  case 720:
/* Line 1787 of yacc.c  */
#line 2895 "cf-parse.y"
    { STATIC_CFG->igp_table = (yyvsp[(4) - (5)].r); }
    break;

  case 722:
/* Line 1787 of yacc.c  */
#line 2899 "cf-parse.y"
    {
     this_srt = cfg_allocz(sizeof(struct static_route));
     add_tail(&STATIC_CFG->other_routes, &this_srt->n);
     this_srt->net = (yyvsp[(2) - (2)].px).addr;
     this_srt->masklen = (yyvsp[(2) - (2)].px).len;
  }
    break;

  case 723:
/* Line 1787 of yacc.c  */
#line 2908 "cf-parse.y"
    {
     last_srt_nh = this_srt_nh;
     this_srt_nh = cfg_allocz(sizeof(struct static_route));
     this_srt_nh->dest = RTD_NONE;
     this_srt_nh->via = (yyvsp[(2) - (3)].a);
     this_srt_nh->via_if = (yyvsp[(3) - (3)].iface);
     this_srt_nh->if_name = (void *) this_srt; /* really */
   }
    break;

  case 724:
/* Line 1787 of yacc.c  */
#line 2916 "cf-parse.y"
    {
     this_srt_nh->masklen = (yyvsp[(3) - (3)].i) - 1; /* really */
     if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>256)) cf_error("Weight must be in range 1-256"); 
   }
    break;

  case 725:
/* Line 1787 of yacc.c  */
#line 2923 "cf-parse.y"
    { this_srt->mp_next = this_srt_nh; }
    break;

  case 726:
/* Line 1787 of yacc.c  */
#line 2924 "cf-parse.y"
    { last_srt_nh->mp_next = this_srt_nh; }
    break;

  case 727:
/* Line 1787 of yacc.c  */
#line 2928 "cf-parse.y"
    {
      this_srt->dest = RTD_ROUTER;
      this_srt->via = (yyvsp[(3) - (4)].a);
      this_srt->via_if = (yyvsp[(4) - (4)].iface);
   }
    break;

  case 728:
/* Line 1787 of yacc.c  */
#line 2933 "cf-parse.y"
    {
      this_srt->dest = RTD_DEVICE;
      this_srt->if_name = (yyvsp[(3) - (3)].t);
      rem_node(&this_srt->n);
      add_tail(&STATIC_CFG->iface_routes, &this_srt->n);
   }
    break;

  case 729:
/* Line 1787 of yacc.c  */
#line 2939 "cf-parse.y"
    {
      this_srt->dest = RTD_MULTIPATH;
   }
    break;

  case 730:
/* Line 1787 of yacc.c  */
#line 2942 "cf-parse.y"
    {
      this_srt->dest = RTDX_RECURSIVE;
      this_srt->via = (yyvsp[(3) - (3)].a);
   }
    break;

  case 731:
/* Line 1787 of yacc.c  */
#line 2947 "cf-parse.y"
    { this_srt->dest = RTD_BLACKHOLE; }
    break;

  case 732:
/* Line 1787 of yacc.c  */
#line 2948 "cf-parse.y"
    { this_srt->dest = RTD_UNREACHABLE; }
    break;

  case 733:
/* Line 1787 of yacc.c  */
#line 2949 "cf-parse.y"
    { this_srt->dest = RTD_BLACKHOLE; }
    break;

  case 734:
/* Line 1787 of yacc.c  */
#line 2950 "cf-parse.y"
    { this_srt->dest = RTD_UNREACHABLE; }
    break;

  case 735:
/* Line 1787 of yacc.c  */
#line 2951 "cf-parse.y"
    { this_srt->dest = RTD_PROHIBIT; }
    break;

  case 736:
/* Line 1787 of yacc.c  */
#line 2955 "cf-parse.y"
    { static_show(proto_get_named((yyvsp[(3) - (4)].s), &proto_static)); }
    break;

  case 798:
/* Line 1787 of yacc.c  */
#line 2963 "cf-parse.y"
    { bgp_check_config(BGP_CFG); }
    break;

  case 799:
/* Line 1787 of yacc.c  */
#line 2963 "cf-parse.y"
    { ospf_proto_finish(); }
    break;

  case 802:
/* Line 1787 of yacc.c  */
#line 2963 "cf-parse.y"
    { RIP_CFG->passwords = get_passwords(); }
    break;

  case 811:
/* Line 1787 of yacc.c  */
#line 2966 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_SOURCE); }
    break;

  case 812:
/* Line 1787 of yacc.c  */
#line 2966 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_METRIC); }
    break;

  case 813:
/* Line 1787 of yacc.c  */
#line 2966 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_KRT_PREFSRC); }
    break;

  case 814:
/* Line 1787 of yacc.c  */
#line 2966 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REALM); }
    break;

  case 815:
/* Line 1787 of yacc.c  */
#line 2967 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_GEN_IGP_METRIC); }
    break;

  case 816:
/* Line 1787 of yacc.c  */
#line 2967 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 817:
/* Line 1787 of yacc.c  */
#line 2968 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_BGP_ORIGIN, EA_CODE(EAP_BGP, BA_ORIGIN)); }
    break;

  case 818:
/* Line 1787 of yacc.c  */
#line 2969 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_AS_PATH, T_PATH, EA_CODE(EAP_BGP, BA_AS_PATH)); }
    break;

  case 819:
/* Line 1787 of yacc.c  */
#line 2970 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_CODE(EAP_BGP, BA_NEXT_HOP)); }
    break;

  case 820:
/* Line 1787 of yacc.c  */
#line 2971 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_MULTI_EXIT_DISC)); }
    break;

  case 821:
/* Line 1787 of yacc.c  */
#line 2972 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_LOCAL_PREF)); }
    break;

  case 822:
/* Line 1787 of yacc.c  */
#line 2973 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(EAP_BGP, BA_ATOMIC_AGGR)); }
    break;

  case 823:
/* Line 1787 of yacc.c  */
#line 2974 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_AGGREGATOR)); }
    break;

  case 824:
/* Line 1787 of yacc.c  */
#line 2975 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_COMMUNITY)); }
    break;

  case 825:
/* Line 1787 of yacc.c  */
#line 2976 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID, T_QUAD, EA_CODE(EAP_BGP, BA_ORIGINATOR_ID)); }
    break;

  case 826:
/* Line 1787 of yacc.c  */
#line 2977 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_CLUSTER_LIST)); }
    break;

  case 827:
/* Line 1787 of yacc.c  */
#line 2978 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_EC_SET, T_ECLIST, EA_CODE(EAP_BGP, BA_EXT_COMMUNITY)); }
    break;

  case 828:
/* Line 1787 of yacc.c  */
#line 2978 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC1); }
    break;

  case 829:
/* Line 1787 of yacc.c  */
#line 2978 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC2); }
    break;

  case 830:
/* Line 1787 of yacc.c  */
#line 2978 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_TAG); }
    break;

  case 831:
/* Line 1787 of yacc.c  */
#line 2978 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID | EAF_TEMP, T_QUAD, EA_OSPF_ROUTER_ID); }
    break;

  case 832:
/* Line 1787 of yacc.c  */
#line 2978 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_METRIC); }
    break;

  case 833:
/* Line 1787 of yacc.c  */
#line 2978 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_TAG); }
    break;


/* Line 1787 of yacc.c  */
#line 8620 "cf-parse.tab.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


/* Line 2048 of yacc.c  */
#line 2980 "cf-parse.y"

/* C Code from ../../conf/confbase.Y */

/* C Code from ../../sysdep/unix/config.Y */

/* C Code from ../../sysdep/unix/krt.Y */

/* C Code from ../../sysdep/linux/netlink.Y */

/* C Code from ../../nest/config.Y */

/* C Code from ../../proto/bgp/config.Y */

/* C Code from ../../proto/ospf/config.Y */

/* C Code from ../../proto/pipe/config.Y */

/* C Code from ../../proto/radv/config.Y */

/* C Code from ../../proto/rip/config.Y */

/* C Code from ../../proto/static/config.Y */


