/* A Bison parser, made by GNU Bison 2.6.1.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2012 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.6.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         cf_parse
#define yylex           cf_lex
#define yyerror         cf_error
#define yylval          cf_lval
#define yychar          cf_char
#define yydebug         cf_debug
#define yynerrs         cf_nerrs

/* Copy the first part of user declarations.  */
/* Line 336 of yacc.c  */
#line 1 "cf-parse.y"

/* Headers from ../../conf/confbase.Y */

#define PARSER 1

#include "nest/bird.h"
#include "conf/conf.h"
#include "lib/resource.h"
#include "lib/socket.h"
#include "lib/timer.h"
#include "lib/string.h"
#include "nest/protocol.h"
#include "nest/iface.h"
#include "nest/route.h"
#include "nest/cli.h"
#include "filter/filter.h"

/* FIXME: Turn on YYERROR_VERBOSE and work around lots of bison bugs? */

/* Defines from ../../conf/confbase.Y */

static void
check_u16(unsigned val)
{
  if (val > 0xFFFF)
    cf_error("Value %d out of range (0-65535)", val);
}

/* Headers from ../../sysdep/unix/config.Y */

#include "lib/unix.h"
#include <stdio.h>

/* Headers from ../../sysdep/unix/krt.Y */

#include "lib/krt.h"

/* Defines from ../../sysdep/unix/krt.Y */

#define THIS_KRT ((struct krt_config *) this_proto)
#define THIS_KIF ((struct kif_config *) this_proto)

/* Headers from ../../sysdep/linux/netlink.Y */

/* Headers from ../../nest/config.Y */

#include "nest/rt-dev.h"
#include "nest/password.h"
#include "nest/cmds.h"
#include "lib/lists.h"

/* Defines from ../../nest/config.Y */

static struct proto_config *this_proto;
static struct iface_patt *this_ipatt;
static struct iface_patt_node *this_ipn;
static struct roa_table_config *this_roa_table;
static list *this_p_list;
static struct password_item *this_p_item;
static int password_id;

static inline void
reset_passwords(void)
{
  this_p_list = NULL;
}

static inline list *
get_passwords(void)
{
  list *rv = this_p_list;
  this_p_list = NULL;
  return rv;
}

#define DIRECT_CFG ((struct rt_dev_config *) this_proto)

/* Headers from ../../filter/config.Y */

/* Defines from ../../filter/config.Y */

#define P(a,b) ((a << 8) | b)

static inline u32 pair(u32 a, u32 b) { return (a << 16) | b; }
static inline u32 pair_a(u32 p) { return p >> 16; }
static inline u32 pair_b(u32 p) { return p & 0xFFFF; }


/*
 * Sets and their items are during parsing handled as lists, linked
 * through left ptr. The first item in a list also contains a pointer
 * to the last item in a list (right ptr). For convenience, even items
 * are handled as one-item lists. Lists are merged by f_merge_items().
 */

static inline struct f_tree *
f_new_item(struct f_val from, struct f_val to)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from = from;
  t->to = to;
  return t;
}

static inline struct f_tree *
f_merge_items(struct f_tree *a, struct f_tree *b)
{
  if (!a) return b;
  a->right->left = b;
  a->right = b->right;
  b->right = NULL;
  return a;
}

static inline struct f_tree *
f_new_pair_item(int fa, int ta, int fb, int tb)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_PAIR;
  t->from.val.i = pair(fa, fb);
  t->to.val.i = pair(ta, tb);
  return t;
}

static inline struct f_tree *
f_new_pair_set(int fa, int ta, int fb, int tb)
{
  struct f_tree *lst = NULL;
  int i;

  if ((fa == ta) || ((fb == 0) && (tb == 0xFFFF)))
    return f_new_pair_item(fa, ta, fb, tb);
  
  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  for (i = fa; i <= ta; i++)
    lst = f_merge_items(lst, f_new_pair_item(i, i, fb, tb));

  return lst;
}

#define EC_ALL 0xFFFFFFFF

static struct f_tree *
f_new_ec_item(u32 kind, u32 ipv4_used, u32 key, u32 vf, u32 vt)
{
  u64 fm, to;

  if (ipv4_used || (key >= 0x10000)) {
    check_u16(vf);
    if (vt == EC_ALL)
      vt = 0xFFFF;
    else
      check_u16(vt);
  }

  if (kind == EC_GENERIC) {
    fm = ec_generic(key, vf);
    to = ec_generic(key, vt);
  }
  else if (ipv4_used) {
    fm = ec_ip4(kind, key, vf);
    to = ec_ip4(kind, key, vt);
  }
  else if (key < 0x10000) {
    fm = ec_as2(kind, key, vf);
    to = ec_as2(kind, key, vt);
  }
  else {
    fm = ec_as4(kind, key, vf);
    to = ec_as4(kind, key, vt);
  }

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_EC;
  t->from.val.ec = fm;
  t->to.val.ec = to;
  return t;
}

static inline struct f_inst *
f_generate_empty(struct f_inst *dyn)
{ 
  struct f_inst *e = f_new_inst();
  e->code = 'E';

  switch (dyn->aux & EAF_TYPE_MASK) {
    case EAF_TYPE_AS_PATH:
      e->aux = T_PATH;
      break;
    case EAF_TYPE_INT_SET:
      e->aux = T_CLIST;
      break;
    case EAF_TYPE_EC_SET:
      e->aux = T_ECLIST;
      break;
    default:
      cf_error("Can't empty that attribute");
  }

  dyn->code = P('e','S');
  dyn->a1.p = e;
  return dyn;
}


static inline struct f_inst *
f_generate_dpair(struct f_inst *t1, struct f_inst *t2)
{
  struct f_inst *rv;

  if ((t1->code == 'c') && (t2->code == 'c')) {
    if ((t1->aux != T_INT) || (t2->aux != T_INT))
      cf_error( "Can't operate with value of non-integer type in pair constructor");

    check_u16(t1->a2.i);
    check_u16(t2->a2.i);

    rv = f_new_inst();
    rv->code = 'c';
    rv->aux = T_PAIR;
    rv->a2.i = pair(t1->a2.i, t2->a2.i);
  }
  else {
    rv = f_new_inst();
    rv->code = P('m', 'p');
    rv->a1.p = t1;
    rv->a2.p = t2;
  }

  return rv;
}

static inline struct f_inst *
f_generate_ec(u16 kind, struct f_inst *tk, struct f_inst *tv)
{
  struct f_inst *rv;
  int c1 = 0, c2 = 0, ipv4_used = 0;
  u32 key = 0, val2 = 0;

  if (tk->code == 'c') {
    c1 = 1;

    if (tk->aux == T_INT) {
      ipv4_used = 0; key = tk->a2.i;
    }
    else if (tk->aux == T_QUAD) {
      ipv4_used = 1; key = tk->a2.i;
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }

#ifndef IPV6
  /* IP->Quad implicit conversion */
  else if (tk->code == 'C') {
    c1 = 1;
    struct f_val *val = tk->a1.p;
    if (val->type == T_IP) {
      ipv4_used = 1; key = ipa_to_u32(val->val.px.ip);
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }
#endif

  if (tv->code == 'c') {
    if (tv->aux != T_INT)
      cf_error("Can't operate with value of non-integer type in EC constructor");
    c2 = 1;
    val2 = tv->a2.i;
  }

  if (c1 && c2) {
    u64 ec;
  
    if (kind == EC_GENERIC) {
      ec = ec_generic(key, val2);
    }
    else if (ipv4_used) {
      check_u16(val2);
      ec = ec_ip4(kind, key, val2);
    }
    else if (key < 0x10000) {
      ec = ec_as2(kind, key, val2);
    }
    else {
      check_u16(val2);
      ec = ec_as4(kind, key, val2);
    }

    NEW_F_VAL;
    rv = f_new_inst();
    rv->code = 'C';
    rv->a1.p = val;    
    val->type = T_EC;
    val->val.ec = ec;
  }
  else {
    rv = f_new_inst();
    rv->code = P('m','c');
    rv->aux = kind;
    rv->a1.p = tk;
    rv->a2.p = tv;
  }

  return rv;
}



/* Headers from ../../proto/bgp/config.Y */

#include "proto/bgp/bgp.h"

/* Defines from ../../proto/bgp/config.Y */

#define BGP_CFG ((struct bgp_config *) this_proto)

/* Headers from ../../proto/ospf/config.Y */

#include "proto/ospf/ospf.h"

/* Defines from ../../proto/ospf/config.Y */

#define OSPF_CFG ((struct ospf_config *) this_proto)
#define OSPF_PATT ((struct ospf_iface_patt *) this_ipatt)

static struct ospf_area_config *this_area;
static struct nbma_node *this_nbma;
static list *this_nets;
static struct area_net_config *this_pref;
static struct ospf_stubnet_config *this_stubnet; 

#ifdef OSPFv2
static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  ip->passwords = get_passwords();

  if ((ip->autype == OSPF_AUTH_CRYPT) && (ip->helloint < 5))
    log(L_WARN "Hello or poll interval less that 5 makes cryptographic authenication prone to replay attacks");

  if ((ip->autype == OSPF_AUTH_NONE) && (ip->passwords != NULL))
    log(L_WARN "Password option without authentication option does not make sense");
}
#endif

#ifdef OSPFv3
static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  if ((ip->autype != OSPF_AUTH_NONE) || (get_passwords() != NULL))
    cf_error("Authentication not supported in OSPFv3");
}
#endif

static void
ospf_area_finish(void)
{
  if ((this_area->areaid == 0) && (this_area->type != OPT_E))
    cf_error("Backbone area cannot be stub/NSSA");

  if (this_area->summary && (this_area->type == OPT_E))
    cf_error("Only Stub/NSSA areas can use summary propagation");

  if (this_area->default_nssa && ((this_area->type != OPT_N) || ! this_area->summary))
    cf_error("Only NSSA areas with summary propagation can use NSSA default route");

  if ((this_area->default_cost & LSA_EXT_EBIT) && ! this_area->default_nssa)
    cf_error("Only NSSA default route can use type 2 metric");
}

static void
ospf_proto_finish(void)
{
  struct ospf_config *cf = OSPF_CFG;

  if (EMPTY_LIST(cf->area_list))
    cf_error( "No configured areas in OSPF");

  int areano = 0;
  int backbone = 0;
  struct ospf_area_config *ac;
  WALK_LIST(ac, cf->area_list)
  {
    areano++;
    if (ac->areaid == 0)
     backbone = 1;
  }
  cf->abr = areano > 1;

  if (cf->abr && !backbone)
  {
    struct ospf_area_config *ac = cfg_allocz(sizeof(struct ospf_area_config));
    ac->type = OPT_E; /* Backbone is non-stub */
    add_head(&cf->area_list, NODE ac);
    init_list(&ac->patt_list);
    init_list(&ac->net_list);
    init_list(&ac->enet_list);
    init_list(&ac->stubnet_list);
  }

  if (!cf->abr && !EMPTY_LIST(cf->vlink_list))
    cf_error( "Vlinks cannot be used on single area router");
}

static inline void
check_defcost(int cost)
{
  if ((cost <= 0) || (cost >= LSINFINITY))
   cf_error("Default cost must be in range 1-%d", LSINFINITY-1);
}

static inline void
set_instance_id(unsigned id)
{
#ifdef OSPFv3
  OSPF_PATT->instance_id = id;
#else
  cf_error("Instance ID requires OSPFv3");
#endif
}

/* Headers from ../../proto/pipe/config.Y */

#include "proto/pipe/pipe.h"

/* Defines from ../../proto/pipe/config.Y */

#define PIPE_CFG ((struct pipe_config *) this_proto)

/* Headers from ../../proto/rip/config.Y */

#include "proto/rip/rip.h"
#include "nest/iface.h"

/* Defines from ../../proto/rip/config.Y */

#define RIP_CFG ((struct rip_proto_config *) this_proto)
#define RIP_IPATT ((struct rip_patt *) this_ipatt)

/* Headers from ../../proto/static/config.Y */

#include "proto/static/static.h"

/* Defines from ../../proto/static/config.Y */

#define STATIC_CFG ((struct static_config *) this_proto)
static struct static_route *this_srt, *this_srt_nh, *last_srt_nh;


/* Line 336 of yacc.c  */
#line 542 "cf-parse.tab.c"

# ifndef YY_NULL
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULL nullptr
#  else
#   define YY_NULL 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "cf-parse.tab.h".  */
#ifndef CF_CF_PARSE_TAB_H
# define CF_CF_PARSE_TAB_H
/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int cf_debug;
#endif

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     END = 258,
     CLI_MARKER = 259,
     INVALID_TOKEN = 260,
     ELSECOL = 261,
     DDOT = 262,
     GEQ = 263,
     LEQ = 264,
     NEQ = 265,
     AND = 266,
     OR = 267,
     PO = 268,
     PC = 269,
     NUM = 270,
     ENUM = 271,
     RTRID = 272,
     IPA = 273,
     SYM = 274,
     TEXT = 275,
     PREFIX_DUMMY = 276,
     DEFINE = 277,
     ON = 278,
     OFF = 279,
     YES = 280,
     NO = 281,
     LOG = 282,
     SYSLOG = 283,
     ALL = 284,
     DEBUG = 285,
     TRACE = 286,
     INFO = 287,
     REMOTE = 288,
     WARNING = 289,
     ERROR = 290,
     AUTH = 291,
     FATAL = 292,
     BUG = 293,
     STDERR = 294,
     SOFT = 295,
     TIMEFORMAT = 296,
     ISO = 297,
     SHORT = 298,
     LONG = 299,
     BASE = 300,
     NAME = 301,
     CONFIRM = 302,
     UNDO = 303,
     CHECK = 304,
     TIMEOUT = 305,
     CONFIGURE = 306,
     DOWN = 307,
     KERNEL = 308,
     PERSIST = 309,
     SCAN = 310,
     TIME = 311,
     LEARN = 312,
     DEVICE = 313,
     ROUTES = 314,
     KRT_SOURCE = 315,
     KRT_METRIC = 316,
     ASYNC = 317,
     TABLE = 318,
     KRT_PREFSRC = 319,
     KRT_REALM = 320,
     ROUTER = 321,
     ID = 322,
     PROTOCOL = 323,
     TEMPLATE = 324,
     PREFERENCE = 325,
     DISABLED = 326,
     DIRECT = 327,
     INTERFACE = 328,
     IMPORT = 329,
     EXPORT = 330,
     FILTER = 331,
     NONE = 332,
     STATES = 333,
     FILTERS = 334,
     RECEIVE = 335,
     LIMIT = 336,
     ACTION = 337,
     WARN = 338,
     BLOCK = 339,
     RESTART = 340,
     DISABLE = 341,
     KEEP = 342,
     FILTERED = 343,
     PASSWORD = 344,
     FROM = 345,
     PASSIVE = 346,
     TO = 347,
     EVENTS = 348,
     PACKETS = 349,
     PROTOCOLS = 350,
     INTERFACES = 351,
     PRIMARY = 352,
     STATS = 353,
     COUNT = 354,
     FOR = 355,
     COMMANDS = 356,
     PREEXPORT = 357,
     GENERATE = 358,
     ROA = 359,
     MAX = 360,
     FLUSH = 361,
     LISTEN = 362,
     BGP = 363,
     V6ONLY = 364,
     DUAL = 365,
     ADDRESS = 366,
     PORT = 367,
     PASSWORDS = 368,
     DESCRIPTION = 369,
     SORTED = 370,
     RELOAD = 371,
     IN = 372,
     OUT = 373,
     MRTDUMP = 374,
     MESSAGES = 375,
     RESTRICT = 376,
     MEMORY = 377,
     IGP_METRIC = 378,
     SHOW = 379,
     STATUS = 380,
     SUMMARY = 381,
     ROUTE = 382,
     SYMBOLS = 383,
     ADD = 384,
     DELETE = 385,
     DUMP = 386,
     RESOURCES = 387,
     SOCKETS = 388,
     NEIGHBORS = 389,
     ATTRIBUTES = 390,
     ECHO = 391,
     ENABLE = 392,
     FUNCTION = 393,
     PRINT = 394,
     PRINTN = 395,
     UNSET = 396,
     RETURN = 397,
     ACCEPT = 398,
     REJECT = 399,
     QUITBIRD = 400,
     INT = 401,
     BOOL = 402,
     IP = 403,
     PREFIX = 404,
     PAIR = 405,
     QUAD = 406,
     EC = 407,
     SET = 408,
     STRING = 409,
     BGPMASK = 410,
     BGPPATH = 411,
     CLIST = 412,
     ECLIST = 413,
     IF = 414,
     THEN = 415,
     ELSE = 416,
     CASE = 417,
     TRUE = 418,
     FALSE = 419,
     RT = 420,
     RO = 421,
     UNKNOWN = 422,
     GENERIC = 423,
     GW = 424,
     NET = 425,
     MASK = 426,
     PROTO = 427,
     SOURCE = 428,
     SCOPE = 429,
     CAST = 430,
     DEST = 431,
     LEN = 432,
     DEFINED = 433,
     CONTAINS = 434,
     RESET = 435,
     PREPEND = 436,
     FIRST = 437,
     LAST = 438,
     MATCH = 439,
     ROA_CHECK = 440,
     EMPTY = 441,
     WHERE = 442,
     EVAL = 443,
     LOCAL = 444,
     NEIGHBOR = 445,
     AS = 446,
     HOLD = 447,
     CONNECT = 448,
     RETRY = 449,
     KEEPALIVE = 450,
     MULTIHOP = 451,
     STARTUP = 452,
     VIA = 453,
     NEXT = 454,
     HOP = 455,
     SELF = 456,
     DEFAULT = 457,
     PATH = 458,
     METRIC = 459,
     START = 460,
     DELAY = 461,
     FORGET = 462,
     WAIT = 463,
     AFTER = 464,
     BGP_PATH = 465,
     BGP_LOCAL_PREF = 466,
     BGP_MED = 467,
     BGP_ORIGIN = 468,
     BGP_NEXT_HOP = 469,
     BGP_ATOMIC_AGGR = 470,
     BGP_AGGREGATOR = 471,
     BGP_COMMUNITY = 472,
     BGP_EXT_COMMUNITY = 473,
     RR = 474,
     RS = 475,
     CLIENT = 476,
     CLUSTER = 477,
     AS4 = 478,
     ADVERTISE = 479,
     IPV4 = 480,
     CAPABILITIES = 481,
     PREFER = 482,
     OLDER = 483,
     MISSING = 484,
     LLADDR = 485,
     DROP = 486,
     IGNORE = 487,
     REFRESH = 488,
     INTERPRET = 489,
     COMMUNITIES = 490,
     BGP_ORIGINATOR_ID = 491,
     BGP_CLUSTER_LIST = 492,
     IGP = 493,
     GATEWAY = 494,
     RECURSIVE = 495,
     MED = 496,
     TTL = 497,
     SECURITY = 498,
     DETERMINISTIC = 499,
     SECONDARY = 500,
     OSPF = 501,
     AREA = 502,
     OSPF_METRIC1 = 503,
     OSPF_METRIC2 = 504,
     OSPF_TAG = 505,
     OSPF_ROUTER_ID = 506,
     RFC1583COMPAT = 507,
     STUB = 508,
     TICK = 509,
     COST = 510,
     COST2 = 511,
     RETRANSMIT = 512,
     HELLO = 513,
     TRANSMIT = 514,
     PRIORITY = 515,
     DEAD = 516,
     TYPE = 517,
     BROADCAST = 518,
     BCAST = 519,
     NONBROADCAST = 520,
     NBMA = 521,
     POINTOPOINT = 522,
     PTP = 523,
     POINTOMULTIPOINT = 524,
     PTMP = 525,
     SIMPLE = 526,
     AUTHENTICATION = 527,
     STRICT = 528,
     CRYPTOGRAPHIC = 529,
     ELIGIBLE = 530,
     POLL = 531,
     NETWORKS = 532,
     HIDDEN = 533,
     VIRTUAL = 534,
     LINK = 535,
     RX = 536,
     BUFFER = 537,
     LARGE = 538,
     NORMAL = 539,
     STUBNET = 540,
     TAG = 541,
     EXTERNAL = 542,
     LSADB = 543,
     ECMP = 544,
     WEIGHT = 545,
     NSSA = 546,
     TRANSLATOR = 547,
     STABILITY = 548,
     GLOBAL = 549,
     LSID = 550,
     INSTANCE = 551,
     REAL = 552,
     NETMASK = 553,
     TOPOLOGY = 554,
     STATE = 555,
     PIPE = 556,
     PEER = 557,
     MODE = 558,
     OPAQUE = 559,
     TRANSPARENT = 560,
     RIP = 561,
     INFINITY = 562,
     PERIOD = 563,
     GARBAGE = 564,
     MULTICAST = 565,
     QUIET = 566,
     NOLISTEN = 567,
     VERSION1 = 568,
     PLAINTEXT = 569,
     MD5 = 570,
     HONOR = 571,
     NEVER = 572,
     ALWAYS = 573,
     RIP_METRIC = 574,
     RIP_TAG = 575,
     STATIC = 576,
     PROHIBIT = 577,
     MULTIPATH = 578,
     BLACKHOLE = 579,
     UNREACHABLE = 580
   };
#endif


#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{
/* Line 350 of yacc.c  */
#line 470 "cf-parse.y"

  int i;
  u32 i32;
  ip_addr a;
  struct symbol *s;
  char *t;
  struct rtable_config *r;
  struct f_inst *x;
  struct filter *f;
  struct f_tree *e;
  struct f_trie *trie;
  struct f_val v;
  struct f_path_mask *h;
  struct password_item *p;
  struct rt_show_data *ra;
  struct roa_show_data *ro;
  struct sym_show_data *sd;
  struct lsadb_show_data *ld;
  struct iface *iface;
  struct roa_table *rot;
  void *g;
  bird_clock_t time;
  struct prefix px;
  struct proto_spec ps;
  struct timeformat *tf;


/* Line 350 of yacc.c  */
#line 938 "cf-parse.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

extern YYSTYPE cf_lval;

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int cf_parse (void *YYPARSE_PARAM);
#else
int cf_parse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int cf_parse (void);
#else
int cf_parse ();
#endif
#endif /* ! YYPARSE_PARAM */

#endif /* !CF_CF_PARSE_TAB_H  */

/* Copy the second part of user declarations.  */

/* Line 353 of yacc.c  */
#line 966 "cf-parse.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  64
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2634

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  347
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  233
/* YYNRULES -- Number of rules.  */
#define YYNRULES  760
/* YYNRULES -- Number of states.  */
#define YYNSTATES  1425

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   580

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    31,     2,     2,     2,    30,     2,     2,
     337,   338,    28,    26,   343,    27,    32,    29,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   340,   339,
      23,    22,    24,   344,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   345,     2,   346,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   341,     2,   342,    25,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     6,     9,    10,    13,    15,    19,    21,
      27,    33,    35,    37,    39,    41,    43,    44,    46,    48,
      49,    52,    55,    57,    59,    62,    65,    67,    69,    70,
      75,    78,    79,    81,    84,    86,    88,    92,    94,    98,
     100,   102,   104,   106,   108,   110,   112,   114,   116,   121,
     125,   127,   129,   131,   133,   136,   141,   145,   149,   153,
     158,   164,   168,   172,   177,   180,   181,   183,   184,   186,
     189,   192,   195,   199,   202,   206,   209,   213,   217,   221,
     226,   232,   234,   236,   238,   243,   244,   247,   250,   253,
     255,   257,   258,   260,   264,   268,   269,   278,   280,   285,
     287,   289,   290,   292,   296,   297,   300,   303,   306,   309,
     312,   315,   319,   323,   327,   332,   335,   339,   342,   345,
     347,   349,   351,   352,   355,   358,   361,   364,   367,   369,
     371,   375,   379,   380,   382,   384,   387,   388,   390,   394,
     396,   400,   401,   404,   407,   411,   415,   419,   420,   424,
     426,   428,   432,   434,   438,   440,   442,   444,   446,   448,
     450,   452,   454,   458,   460,   464,   466,   468,   473,   475,
     476,   480,   485,   487,   490,   491,   497,   503,   509,   515,
     520,   524,   528,   533,   539,   541,   542,   546,   551,   556,
     557,   560,   564,   568,   572,   575,   578,   581,   584,   588,
     592,   595,   598,   600,   602,   607,   608,   612,   616,   620,
     621,   623,   625,   630,   631,   634,   637,   640,   643,   646,
     649,   652,   653,   656,   666,   676,   681,   685,   689,   693,
     697,   701,   705,   709,   714,   716,   718,   720,   721,   723,
     727,   731,   735,   739,   744,   749,   754,   759,   762,   764,
     766,   768,   770,   771,   773,   774,   779,   782,   784,   786,
     788,   790,   792,   794,   796,   798,   800,   802,   804,   806,
     809,   812,   813,   817,   819,   823,   825,   827,   829,   832,
     836,   839,   844,   845,   851,   852,   854,   856,   859,   861,
     865,   867,   869,   871,   873,   875,   877,   881,   883,   885,
     887,   889,   891,   895,   897,   903,   915,   917,   919,   921,
     924,   926,   934,   944,   952,   954,   956,   958,   962,   964,
     966,   968,   972,   974,   978,   980,   984,   988,   990,   993,
     996,  1003,  1005,  1009,  1010,  1015,  1019,  1021,  1025,  1029,
    1033,  1036,  1039,  1042,  1045,  1046,  1049,  1052,  1053,  1055,
    1057,  1059,  1061,  1063,  1065,  1067,  1071,  1075,  1077,  1079,
    1085,  1093,  1094,  1099,  1101,  1103,  1105,  1107,  1109,  1111,
    1113,  1115,  1117,  1121,  1125,  1129,  1133,  1137,  1141,  1145,
    1149,  1153,  1157,  1161,  1165,  1169,  1173,  1176,  1181,  1183,
    1185,  1187,  1189,  1192,  1195,  1199,  1203,  1210,  1214,  1218,
    1222,  1226,  1232,  1239,  1246,  1253,  1260,  1265,  1274,  1279,
    1281,  1283,  1285,  1287,  1289,  1291,  1293,  1294,  1296,  1300,
    1302,  1306,  1307,  1309,  1314,  1321,  1326,  1330,  1336,  1342,
    1347,  1354,  1358,  1361,  1367,  1373,  1382,  1391,  1400,  1409,
    1412,  1416,  1420,  1426,  1433,  1441,  1448,  1453,  1458,  1464,
    1471,  1478,  1484,  1488,  1493,  1499,  1505,  1511,  1517,  1523,
    1528,  1533,  1539,  1545,  1551,  1557,  1563,  1569,  1575,  1581,
    1588,  1595,  1604,  1611,  1618,  1624,  1629,  1635,  1640,  1646,
    1651,  1657,  1662,  1668,  1674,  1677,  1681,  1685,  1687,  1690,
    1693,  1698,  1701,  1703,  1706,  1711,  1712,  1716,  1719,  1721,
    1724,  1728,  1732,  1736,  1740,  1743,  1747,  1748,  1754,  1755,
    1761,  1764,  1767,  1769,  1774,  1776,  1778,  1779,  1783,  1786,
    1789,  1792,  1798,  1801,  1802,  1806,  1807,  1810,  1813,  1817,
    1820,  1823,  1827,  1830,  1833,  1836,  1838,  1842,  1845,  1848,
    1851,  1854,  1857,  1860,  1864,  1867,  1870,  1873,  1876,  1879,
    1882,  1885,  1888,  1892,  1896,  1900,  1903,  1907,  1910,  1914,
    1918,  1923,  1926,  1929,  1932,  1936,  1940,  1944,  1946,  1947,
    1950,  1954,  1956,  1957,  1959,  1962,  1963,  1966,  1967,  1969,
    1973,  1974,  1975,  1978,  1979,  1983,  1984,  1988,  1993,  1995,
    1996,  2001,  2008,  2015,  2022,  2030,  2037,  2045,  2051,  2052,
    2055,  2059,  2062,  2066,  2070,  2073,  2077,  2080,  2083,  2087,
    2091,  2097,  2102,  2107,  2110,  2114,  2118,  2123,  2128,  2133,
    2139,  2145,  2150,  2154,  2159,  2164,  2169,  2174,  2176,  2178,
    2180,  2182,  2184,  2186,  2188,  2190,  2191,  2194,  2197,  2198,
    2202,  2203,  2207,  2208,  2212,  2215,  2219,  2223,  2229,  2235,
    2239,  2242,  2246,  2250,  2252,  2255,  2260,  2264,  2268,  2272,
    2275,  2278,  2281,  2284,  2287,  2292,  2294,  2296,  2298,  2300,
    2302,  2304,  2306,  2308,  2310,  2312,  2314,  2316,  2318,  2320,
    2322,  2324,  2326,  2328,  2330,  2332,  2334,  2336,  2338,  2340,
    2342,  2344,  2346,  2348,  2350,  2352,  2354,  2356,  2358,  2360,
    2362,  2364,  2366,  2368,  2370,  2372,  2374,  2376,  2378,  2380,
    2382,  2384,  2386,  2388,  2390,  2392,  2394,  2396,  2398,  2400,
    2402,  2404,  2406,  2408,  2411,  2414,  2417,  2420,  2423,  2426,
    2429,  2432,  2436,  2440,  2444,  2448,  2452,  2456,  2460,  2462,
    2464,  2466,  2468,  2470,  2472,  2474,  2476,  2478,  2480,  2482,
    2484,  2486,  2488,  2490,  2492,  2494,  2496,  2498,  2500,  2502,
    2504
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     348,     0,    -1,   349,     3,    -1,     4,   575,    -1,    -1,
     349,   574,    -1,    15,    -1,   337,   507,   338,    -1,    19,
      -1,    33,    19,    22,   350,   339,    -1,    33,    19,    22,
      18,   339,    -1,   350,    -1,    34,    -1,    36,    -1,    35,
      -1,    37,    -1,    -1,    18,    -1,    19,    -1,    -1,    30,
      19,    -1,   353,   357,    -1,   355,    -1,   353,    -1,    29,
     350,    -1,   340,   353,    -1,    20,    -1,    20,    -1,    -1,
      38,   362,   363,   339,    -1,    57,    20,    -1,    -1,    20,
      -1,    39,   361,    -1,    50,    -1,    40,    -1,   341,   364,
     342,    -1,   365,    -1,   364,   343,   365,    -1,    41,    -1,
      42,    -1,    43,    -1,    44,    -1,    45,    -1,    46,    -1,
      47,    -1,    48,    -1,    49,    -1,   130,   106,   415,   339,
      -1,   130,    20,   339,    -1,   138,    -1,    79,    -1,    56,
      -1,    38,    -1,   367,    20,    -1,   367,    20,   350,    20,
      -1,   367,    53,    54,    -1,   367,    53,    55,    -1,    52,
     368,   339,    -1,    62,   376,   377,     3,    -1,    62,    51,
     376,   377,     3,    -1,    62,    58,     3,    -1,    62,    59,
       3,    -1,    62,    60,   376,     3,    -1,    63,     3,    -1,
      -1,    20,    -1,    -1,    61,    -1,    61,   350,    -1,   393,
      64,    -1,    65,   352,    -1,    66,    67,   350,    -1,    68,
     352,    -1,    69,    70,   352,    -1,   393,    69,    -1,    66,
      67,   350,    -1,   108,   359,   356,    -1,    64,    74,   350,
      -1,    77,    78,   384,   339,    -1,    77,    78,   101,   407,
     339,    -1,    15,    -1,    17,    -1,    18,    -1,   118,   119,
     386,   339,    -1,    -1,   386,   387,    -1,   122,   353,    -1,
     123,   350,    -1,   120,    -1,   121,    -1,    -1,   126,    -1,
      74,    19,   388,    -1,   115,    74,    19,    -1,    -1,   391,
     115,   355,   116,    15,   202,    15,   339,    -1,   390,    -1,
     390,   341,   391,   342,    -1,    79,    -1,    80,    -1,    -1,
      19,    -1,    19,   101,    19,    -1,    -1,    81,   350,    -1,
      82,   352,    -1,    41,   412,    -1,   130,   415,    -1,    85,
     396,    -1,    86,   396,    -1,    91,    92,   398,    -1,    85,
      92,   398,    -1,    86,    92,   398,    -1,    85,    98,    99,
     352,    -1,    74,   399,    -1,    77,    78,   384,    -1,   125,
      20,    -1,    87,   471,    -1,   472,    -1,    40,    -1,    88,
      -1,    -1,    93,    94,    -1,    93,    95,    -1,    93,    96,
      -1,    93,    97,    -1,   350,   397,    -1,    35,    -1,    19,
      -1,    41,   106,   412,    -1,    41,   112,   350,    -1,    -1,
      20,    -1,   356,    -1,    20,   356,    -1,    -1,    27,    -1,
     401,   403,   402,    -1,   404,    -1,   405,   343,   404,    -1,
      -1,   406,   405,    -1,   393,    83,    -1,   408,   394,   341,
      -1,   409,   395,   339,    -1,   409,   411,   339,    -1,    -1,
      84,   410,   405,    -1,    40,    -1,    35,    -1,   341,   413,
     342,    -1,   414,    -1,   413,   343,   414,    -1,    89,    -1,
      70,    -1,    90,    -1,   107,    -1,   104,    -1,   105,    -1,
      40,    -1,    35,    -1,   341,   416,   342,    -1,   417,    -1,
     416,   343,   417,    -1,    89,    -1,   131,    -1,   124,   341,
     419,   342,    -1,   420,    -1,    -1,   420,   339,   419,    -1,
     421,   341,   422,   342,    -1,   421,    -1,   100,    20,    -1,
      -1,   114,   101,   358,   339,   422,    -1,   114,   103,   358,
     339,   422,    -1,   154,   101,   358,   339,   422,    -1,   154,
     103,   358,   339,   422,    -1,    78,   350,   339,   422,    -1,
     135,   136,     3,    -1,   135,   133,     3,    -1,   135,   106,
     462,     3,    -1,   135,   106,    40,   462,     3,    -1,    19,
      -1,    -1,   135,   107,     3,    -1,   135,   107,   137,     3,
      -1,   135,   138,   431,     3,    -1,    -1,   431,   355,    -1,
     431,   111,   356,    -1,   431,    74,    19,    -1,   431,    87,
     471,    -1,   431,   472,    -1,   431,    40,    -1,   431,   108,
      -1,   431,    99,    -1,   431,   432,    19,    -1,   431,    79,
      19,    -1,   431,   109,    -1,   431,   110,    -1,   113,    -1,
      86,    -1,   135,   115,   434,     3,    -1,    -1,   434,   435,
     355,    -1,   434,   202,    15,    -1,   434,    74,    19,    -1,
      -1,   128,    -1,   111,    -1,   135,   139,   437,     3,    -1,
      -1,   437,    74,    -1,   437,   149,    -1,   437,    87,    -1,
     437,    79,    -1,   437,    80,    -1,   437,   115,    -1,   437,
      19,    -1,    -1,    74,    19,    -1,   140,   115,   355,   116,
      15,   202,    15,   438,     3,    -1,   141,   115,   355,   116,
      15,   202,    15,   438,     3,    -1,   117,   115,   438,     3,
      -1,   142,   143,     3,    -1,   142,   144,     3,    -1,   142,
     107,     3,    -1,   142,   145,     3,    -1,   142,   146,     3,
      -1,   142,    70,     3,    -1,   142,   106,     3,    -1,   147,
     450,   451,     3,    -1,    40,    -1,    35,    -1,    15,    -1,
      -1,    15,    -1,    97,   461,     3,    -1,   148,   461,     3,
      -1,    96,   461,     3,    -1,   127,   461,     3,    -1,   127,
     128,   461,     3,    -1,   127,   129,   461,     3,    -1,    41,
     461,   412,     3,    -1,   130,   461,   415,     3,    -1,   132,
       3,    -1,    19,    -1,    40,    -1,    20,    -1,    19,    -1,
      -1,    20,    -1,    -1,    87,    19,   464,   470,    -1,   199,
     507,    -1,   157,    -1,   158,    -1,   159,    -1,   160,    -1,
     161,    -1,   162,    -1,   163,    -1,   165,    -1,   166,    -1,
     167,    -1,   168,    -1,   169,    -1,   466,   164,    -1,   466,
      19,    -1,    -1,   467,   339,   468,    -1,   467,    -1,   467,
     339,   469,    -1,   474,    -1,    19,    -1,   470,    -1,   198,
     507,    -1,   337,   469,   338,    -1,   337,   338,    -1,   468,
     341,   477,   342,    -1,    -1,   149,    19,   476,   473,   474,
      -1,    -1,   478,    -1,   513,    -1,   478,   513,    -1,   513,
      -1,   341,   477,   342,    -1,    18,    -1,   350,    -1,    17,
      -1,   480,    -1,    16,    -1,    15,    -1,   337,   507,   338,
      -1,    17,    -1,   480,    -1,    16,    -1,   507,    -1,   483,
      -1,   483,     7,   483,    -1,    28,    -1,   337,   484,   343,
     484,   338,    -1,   337,   484,   343,   484,   338,     7,   337,
     483,   343,   483,   338,    -1,   507,    -1,   176,    -1,   177,
      -1,   178,    15,    -1,   179,    -1,   337,   487,   343,   486,
     343,   486,   338,    -1,   337,   487,   343,   486,   343,   486,
       7,   486,   338,    -1,   337,   487,   343,   486,   343,    28,
     338,    -1,   485,    -1,   488,    -1,   481,    -1,   481,     7,
     481,    -1,   485,    -1,   488,    -1,   482,    -1,   482,     7,
     482,    -1,   489,    -1,   491,   343,   489,    -1,   490,    -1,
     492,   343,   490,    -1,    18,    29,    15,    -1,   493,    -1,
     493,    26,    -1,   493,    27,    -1,   493,   341,    15,   343,
      15,   342,    -1,   494,    -1,   495,   343,   494,    -1,    -1,
     496,   492,   340,   477,    -1,   496,     6,   477,    -1,   505,
      -1,   337,   507,   338,    -1,    13,   499,    14,    -1,    29,
     500,    29,    -1,    15,   499,    -1,    28,   499,    -1,   344,
     499,    -1,   497,   499,    -1,    -1,    15,   500,    -1,   344,
     500,    -1,    -1,    15,    -1,   174,    -1,   175,    -1,    20,
      -1,   480,    -1,   493,    -1,    17,    -1,   345,   491,   346,
      -1,   345,   495,   346,    -1,    16,    -1,   498,    -1,   337,
     507,   343,   507,   338,    -1,   337,   487,   343,   507,   343,
     507,   338,    -1,    -1,    19,   337,   512,   338,    -1,    19,
      -1,   101,    -1,   180,    -1,   181,    -1,   183,    -1,   184,
      -1,   185,    -1,   186,    -1,   187,    -1,   337,   507,   338,
      -1,   507,    26,   507,    -1,   507,    27,   507,    -1,   507,
      28,   507,    -1,   507,    29,   507,    -1,   507,    11,   507,
      -1,   507,    12,   507,    -1,   507,    22,   507,    -1,   507,
      10,   507,    -1,   507,    23,   507,    -1,   507,     9,   507,
      -1,   507,    24,   507,    -1,   507,     8,   507,    -1,   507,
      25,   507,    -1,    31,   507,    -1,   189,   337,   507,   338,
      -1,   505,    -1,   501,    -1,   502,    -1,    81,    -1,   503,
     506,    -1,   503,   579,    -1,   507,    32,   159,    -1,   507,
      32,   188,    -1,   507,    32,   182,   337,   507,   338,    -1,
     507,    32,   193,    -1,   507,    32,   194,    -1,    26,   197,
      26,    -1,    27,   197,    27,    -1,    27,    27,   197,    27,
      27,    -1,   192,   337,   507,   343,   507,   338,    -1,   140,
     337,   507,   343,   507,   338,    -1,   141,   337,   507,   343,
     507,   338,    -1,    87,   337,   507,   343,   507,   338,    -1,
     196,   337,    19,   338,    -1,   196,   337,    19,   343,   507,
     343,   507,   338,    -1,    19,   337,   512,   338,    -1,   156,
      -1,   154,    -1,   155,    -1,    46,    -1,   150,    -1,   151,
      -1,   507,    -1,    -1,   509,    -1,   509,   343,   510,    -1,
     507,    -1,   507,   343,   511,    -1,    -1,   511,    -1,   170,
     507,   171,   479,    -1,   170,   507,   171,   479,   172,   479,
      -1,    19,    22,   507,   339,    -1,   153,   507,   339,    -1,
     503,   579,    22,   507,   339,    -1,   503,   506,    22,   507,
     339,    -1,    81,    22,   507,   339,    -1,   152,   337,   503,
     579,   338,   339,    -1,   508,   510,   339,    -1,   504,   339,
      -1,   173,   507,   341,   496,   342,    -1,   503,   579,    32,
     197,   339,    -1,   503,   579,    32,   192,   337,   507,   338,
     339,    -1,   503,   579,    32,   140,   337,   507,   338,   339,
      -1,   503,   579,    32,   141,   337,   507,   338,   339,    -1,
     503,   579,    32,    87,   337,   507,   338,   339,    -1,   393,
     119,    -1,   514,   394,   341,    -1,   515,   395,   339,    -1,
     515,   200,   202,   350,   339,    -1,   515,   200,   353,   202,
     350,   339,    -1,   515,   201,   353,   354,   202,   350,   339,
      -1,   515,   230,   233,    78,   384,   339,    -1,   515,   230,
     232,   339,    -1,   515,   231,   232,   339,    -1,   515,   203,
      67,   350,   339,    -1,   515,   208,   203,    67,   350,   339,
      -1,   515,   204,   205,    67,   350,   339,    -1,   515,   206,
      67,   350,   339,    -1,   515,   207,   339,    -1,   515,   207,
     350,   339,    -1,   515,   210,   211,   212,   339,    -1,   515,
     210,   211,    98,   339,    -1,   515,   240,   241,   212,   339,
      -1,   515,   240,   241,   242,   339,    -1,   515,   240,   241,
     243,   339,    -1,   515,   250,    83,   339,    -1,   515,   250,
     251,   339,    -1,   515,   214,   215,   352,   339,    -1,   515,
     252,   215,   352,   339,    -1,   515,   249,   215,   352,   339,
      -1,   515,   238,   239,   352,   339,    -1,   515,   255,   252,
     352,   339,    -1,   515,   213,   223,   350,   339,    -1,   515,
     213,   222,   350,   339,    -1,   515,   184,   122,   353,   339,
      -1,   515,   216,   217,    67,   350,   339,    -1,   515,    46,
     218,    67,   350,   339,    -1,   515,    46,   219,    67,   350,
     343,   350,   339,    -1,   515,    97,   220,    46,   352,   339,
      -1,   515,   148,   138,   244,   352,   339,    -1,   515,   148,
     234,   352,   339,    -1,   515,   237,   352,   339,    -1,   515,
     235,   236,   352,   339,    -1,   515,   100,    20,   339,    -1,
     515,   138,    92,   350,   339,    -1,   515,   102,   352,   339,
      -1,   515,   245,   246,   352,   339,    -1,   515,   256,   352,
     339,    -1,   515,   249,    74,   399,   339,    -1,   515,   253,
     254,   352,   339,    -1,   393,   257,    -1,   516,   394,   341,
      -1,   517,   518,   339,    -1,   395,    -1,   263,   352,    -1,
     300,   352,    -1,   300,   352,    92,   350,    -1,   265,   350,
      -1,   520,    -1,   258,   384,    -1,   519,   341,   521,   342,
      -1,    -1,   521,   522,   339,    -1,   264,   352,    -1,   302,
      -1,   137,   352,    -1,   213,   302,   352,    -1,   213,   266,
     350,    -1,   213,   267,   350,    -1,   264,   266,   350,    -1,
     303,   352,    -1,   303,   304,   350,    -1,    -1,   288,   523,
     341,   534,   342,    -1,    -1,   298,   524,   341,   534,   342,
      -1,   296,   525,    -1,    84,   545,    -1,   529,    -1,   526,
     341,   527,   342,    -1,   526,    -1,   355,    -1,    -1,   527,
     528,   339,    -1,   289,   352,    -1,   137,   352,    -1,   266,
     350,    -1,   532,   542,   341,   530,   342,    -1,   532,   542,
      -1,    -1,   530,   531,   339,    -1,    -1,   269,   350,    -1,
     268,   350,    -1,   270,   217,   350,    -1,   219,   350,    -1,
     272,   350,    -1,   272,   110,   350,    -1,   283,    88,    -1,
     283,   282,    -1,   283,   285,    -1,   418,    -1,   290,   291,
     384,    -1,   266,   350,    -1,   269,   350,    -1,   287,   350,
      -1,   268,   350,    -1,   219,   350,    -1,   272,   350,    -1,
     272,   110,   350,    -1,   273,   274,    -1,   273,   275,    -1,
     273,   276,    -1,   273,   277,    -1,   273,   278,    -1,   273,
     279,    -1,   273,   280,    -1,   273,   281,    -1,   308,   274,
     352,    -1,   279,   309,   352,    -1,   270,   217,   350,    -1,
     271,   350,    -1,   284,   276,   352,    -1,   264,   352,    -1,
      60,   291,   352,    -1,   300,   301,   350,    -1,   145,   341,
     538,   342,    -1,   283,    88,    -1,   283,   282,    -1,   283,
     285,    -1,   292,   293,   294,    -1,   292,   293,   295,    -1,
     292,   293,   350,    -1,   418,    -1,    -1,   534,   535,    -1,
     536,   537,   339,    -1,   355,    -1,    -1,   289,    -1,   297,
     350,    -1,    -1,   538,   540,    -1,    -1,   286,    -1,    18,
     539,   339,    -1,    -1,    -1,   307,   350,    -1,    -1,   543,
     533,   339,    -1,    -1,   341,   543,   342,    -1,   541,   405,
     542,   544,    -1,    20,    -1,    -1,   135,   257,   427,     3,
      -1,   135,   257,   145,   427,   546,     3,    -1,   135,   257,
      84,   427,   546,     3,    -1,   135,   257,   310,   427,   546,
       3,    -1,   135,   257,   310,    40,   427,   546,     3,    -1,
     135,   257,   311,   427,   546,     3,    -1,   135,   257,   311,
      40,   427,   546,     3,    -1,   135,   257,   299,   555,     3,
      -1,    -1,   555,   305,    -1,   555,   258,   384,    -1,   555,
     291,    -1,   555,   273,    15,    -1,   555,   306,   384,    -1,
     555,   212,    -1,   555,    77,   384,    -1,   555,    19,    -1,
     393,   312,    -1,   556,   394,   341,    -1,   557,   395,   339,
      -1,   557,   313,    74,    19,   339,    -1,   557,   314,   315,
     339,    -1,   557,   314,   316,   339,    -1,   393,   317,    -1,
     558,   394,   341,    -1,   559,   395,   339,    -1,   559,   318,
     350,   339,    -1,   559,   123,   350,   339,    -1,   559,   319,
     350,   339,    -1,   559,   320,    67,   350,   339,    -1,   559,
      61,    67,   350,   339,    -1,   559,   283,   560,   339,    -1,
     559,   418,   339,    -1,   559,   327,   329,   339,    -1,   559,
     327,   201,   339,    -1,   559,   327,   328,   339,    -1,   559,
      84,   566,   339,    -1,   325,    -1,   326,    -1,    88,    -1,
     274,    -1,   321,    -1,   322,    -1,   323,    -1,   324,    -1,
      -1,   215,   350,    -1,   314,   561,    -1,    -1,   563,   562,
     339,    -1,    -1,   341,   563,   342,    -1,    -1,   565,   405,
     564,    -1,   393,   332,    -1,   567,   394,   341,    -1,   568,
     395,   339,    -1,   568,    60,   291,   352,   339,    -1,   568,
     249,    74,   399,   339,    -1,   568,   572,   339,    -1,   138,
     355,    -1,   209,   353,   354,    -1,   570,   301,   350,    -1,
     570,    -1,   571,   570,    -1,   569,   209,   353,   354,    -1,
     569,   209,    20,    -1,   569,   334,   571,    -1,   569,   251,
     353,    -1,   569,   242,    -1,   569,   155,    -1,   569,   335,
      -1,   569,   336,    -1,   569,   333,    -1,   135,   332,   427,
       3,    -1,   339,    -1,   351,    -1,   360,    -1,   366,    -1,
     369,    -1,   383,    -1,   385,    -1,   389,    -1,   392,    -1,
     576,    -1,   400,    -1,   463,    -1,   465,    -1,   475,    -1,
     370,    -1,   371,    -1,   372,    -1,   373,    -1,   374,    -1,
     375,    -1,   423,    -1,   424,    -1,   425,    -1,   426,    -1,
     428,    -1,   429,    -1,   430,    -1,   433,    -1,   436,    -1,
     439,    -1,   440,    -1,   441,    -1,   442,    -1,   443,    -1,
     444,    -1,   445,    -1,   446,    -1,   447,    -1,   448,    -1,
     449,    -1,   452,    -1,   453,    -1,   454,    -1,   455,    -1,
     456,    -1,   457,    -1,   458,    -1,   459,    -1,   460,    -1,
     547,    -1,   548,    -1,   549,    -1,   550,    -1,   551,    -1,
     552,    -1,   553,    -1,   554,    -1,   573,    -1,   577,   342,
      -1,   578,   342,    -1,   409,   342,    -1,   515,   342,    -1,
     517,   342,    -1,   557,   342,    -1,   559,   342,    -1,   568,
     342,    -1,   378,   394,   341,    -1,   577,   395,   339,    -1,
     577,   379,   339,    -1,   577,   382,   339,    -1,   380,   394,
     341,    -1,   578,   395,   339,    -1,   578,   381,   339,    -1,
      71,    -1,    72,    -1,    75,    -1,    76,    -1,   134,    -1,
       5,    -1,   224,    -1,   221,    -1,   225,    -1,   223,    -1,
     222,    -1,   226,    -1,   227,    -1,   228,    -1,   247,    -1,
     248,    -1,   229,    -1,   259,    -1,   260,    -1,   261,    -1,
     262,    -1,   330,    -1,   331,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   645,   645,   646,   649,   651,   658,   659,   660,   666,
     670,   679,   680,   681,   682,   683,   684,   690,   691,   698,
     699,   703,   710,   711,   715,   719,   726,   734,   735,   741,
     750,   751,   755,   760,   761,   765,   766,   770,   771,   775,
     776,   777,   778,   779,   780,   781,   782,   783,   789,   790,
     799,   800,   801,   802,   805,   806,   807,   808,   812,   819,
     822,   829,   832,   835,   838,   842,   843,   847,   848,   849,
     857,   862,   863,   867,   874,   880,   885,   889,   903,   917,
     918,   922,   923,   924,   935,   937,   939,   943,   944,   945,
     946,   953,   954,   958,   966,   970,   972,   978,   979,   986,
     987,   991,   997,  1001,  1011,  1013,  1017,  1018,  1019,  1020,
    1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,  1032,  1033,
    1034,  1035,  1039,  1040,  1041,  1042,  1043,  1047,  1053,  1057,
    1065,  1066,  1074,  1082,  1083,  1084,  1088,  1089,  1093,  1098,
    1099,  1102,  1110,  1117,  1124,  1125,  1126,  1130,  1138,  1144,
    1145,  1146,  1150,  1151,  1155,  1156,  1157,  1158,  1159,  1160,
    1166,  1167,  1168,  1172,  1173,  1177,  1178,  1184,  1185,  1188,
    1190,  1194,  1195,  1199,  1217,  1218,  1219,  1220,  1221,  1222,
    1230,  1233,  1236,  1239,  1243,  1244,  1247,  1250,  1254,  1258,
    1263,  1269,  1276,  1281,  1286,  1291,  1295,  1299,  1303,  1313,
    1321,  1325,  1332,  1333,  1338,  1342,  1349,  1356,  1360,  1368,
    1369,  1370,  1375,  1379,  1382,  1383,  1384,  1385,  1386,  1387,
    1388,  1393,  1398,  1406,  1413,  1420,  1428,  1430,  1432,  1434,
    1436,  1438,  1440,  1443,  1449,  1450,  1451,  1455,  1456,  1462,
    1464,  1466,  1468,  1470,  1472,  1476,  1480,  1483,  1487,  1488,
    1489,  1493,  1494,  1495,  1503,  1503,  1513,  1517,  1518,  1519,
    1520,  1521,  1522,  1523,  1524,  1525,  1526,  1527,  1528,  1529,
    1550,  1561,  1562,  1569,  1570,  1577,  1586,  1590,  1594,  1618,
    1619,  1623,  1636,  1636,  1652,  1653,  1656,  1657,  1661,  1664,
    1673,  1686,  1687,  1688,  1689,  1693,  1694,  1695,  1696,  1697,
    1701,  1704,  1705,  1706,  1710,  1713,  1722,  1725,  1726,  1727,
    1728,  1732,  1733,  1734,  1738,  1739,  1740,  1741,  1745,  1746,
    1747,  1748,  1752,  1753,  1757,  1758,  1762,  1769,  1770,  1771,
    1772,  1779,  1780,  1783,  1784,  1791,  1803,  1804,  1808,  1809,
    1813,  1814,  1815,  1816,  1817,  1821,  1822,  1823,  1827,  1828,
    1829,  1830,  1831,  1832,  1833,  1834,  1835,  1836,  1837,  1841,
    1842,  1852,  1856,  1879,  1915,  1917,  1918,  1919,  1920,  1921,
    1922,  1923,  1927,  1928,  1929,  1930,  1931,  1932,  1933,  1934,
    1935,  1936,  1937,  1938,  1939,  1940,  1941,  1942,  1944,  1945,
    1946,  1948,  1950,  1952,  1954,  1955,  1956,  1957,  1958,  1968,
    1969,  1970,  1971,  1972,  1973,  1974,  1976,  1977,  1982,  2005,
    2006,  2007,  2008,  2009,  2010,  2014,  2017,  2018,  2019,  2027,
    2034,  2043,  2044,  2048,  2054,  2064,  2073,  2079,  2084,  2091,
    2096,  2102,  2103,  2104,  2112,  2113,  2114,  2115,  2116,  2122,
    2143,  2144,  2145,  2146,  2147,  2157,  2158,  2159,  2160,  2161,
    2162,  2163,  2164,  2165,  2166,  2167,  2168,  2169,  2170,  2171,
    2172,  2173,  2174,  2175,  2176,  2177,  2178,  2179,  2180,  2181,
    2182,  2183,  2184,  2185,  2186,  2187,  2188,  2189,  2190,  2195,
    2196,  2197,  2198,  2199,  2210,  2220,  2221,  2225,  2226,  2227,
    2228,  2229,  2230,  2233,  2248,  2251,  2253,  2257,  2258,  2259,
    2260,  2261,  2262,  2263,  2264,  2265,  2266,  2266,  2267,  2267,
    2268,  2269,  2270,  2274,  2275,  2279,  2287,  2289,  2293,  2294,
    2295,  2299,  2300,  2303,  2305,  2308,  2309,  2310,  2311,  2312,
    2313,  2314,  2315,  2316,  2317,  2318,  2321,  2343,  2344,  2345,
    2346,  2347,  2348,  2349,  2350,  2351,  2352,  2353,  2354,  2355,
    2356,  2357,  2358,  2359,  2360,  2361,  2362,  2363,  2364,  2365,
    2366,  2367,  2368,  2369,  2370,  2371,  2372,  2373,  2376,  2378,
    2381,  2383,  2392,  2394,  2395,  2398,  2400,  2404,  2405,  2408,
    2418,  2439,  2441,  2444,  2446,  2449,  2451,  2455,  2459,  2460,
    2465,  2468,  2471,  2476,  2479,  2484,  2487,  2491,  2495,  2498,
    2499,  2500,  2501,  2502,  2503,  2504,  2505,  2511,  2518,  2519,
    2520,  2525,  2526,  2532,  2539,  2540,  2541,  2542,  2543,  2544,
    2545,  2546,  2547,  2548,  2549,  2550,  2551,  2555,  2556,  2557,
    2562,  2563,  2564,  2565,  2566,  2569,  2570,  2571,  2574,  2576,
    2579,  2581,  2585,  2594,  2601,  2608,  2609,  2610,  2611,  2612,
    2615,  2624,  2632,  2639,  2640,  2644,  2649,  2655,  2658,  2663,
    2664,  2665,  2666,  2667,  2670,  2677,  2677,  2677,  2677,  2677,
    2677,  2677,  2677,  2677,  2677,  2677,  2677,  2677,  2677,  2678,
    2678,  2678,  2678,  2678,  2678,  2678,  2678,  2678,  2678,  2678,
    2678,  2678,  2678,  2678,  2678,  2678,  2678,  2678,  2678,  2678,
    2678,  2678,  2678,  2678,  2678,  2678,  2678,  2678,  2678,  2678,
    2678,  2678,  2678,  2678,  2678,  2678,  2678,  2678,  2678,  2678,
    2678,  2678,  2678,  2679,  2679,  2679,  2679,  2679,  2679,  2679,
    2679,  2680,  2680,  2680,  2680,  2681,  2681,  2681,  2682,  2682,
    2682,  2682,  2682,  2683,  2683,  2684,  2685,  2686,  2687,  2688,
    2689,  2690,  2691,  2692,  2693,  2694,  2694,  2694,  2694,  2694,
    2694
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "END", "CLI_MARKER", "INVALID_TOKEN",
  "ELSECOL", "DDOT", "GEQ", "LEQ", "NEQ", "AND", "OR", "PO", "PC", "NUM",
  "ENUM", "RTRID", "IPA", "SYM", "TEXT", "PREFIX_DUMMY", "'='", "'<'",
  "'>'", "'~'", "'+'", "'-'", "'*'", "'/'", "'%'", "'!'", "'.'", "DEFINE",
  "ON", "OFF", "YES", "NO", "LOG", "SYSLOG", "ALL", "DEBUG", "TRACE",
  "INFO", "REMOTE", "WARNING", "ERROR", "AUTH", "FATAL", "BUG", "STDERR",
  "SOFT", "TIMEFORMAT", "ISO", "SHORT", "LONG", "BASE", "NAME", "CONFIRM",
  "UNDO", "CHECK", "TIMEOUT", "CONFIGURE", "DOWN", "KERNEL", "PERSIST",
  "SCAN", "TIME", "LEARN", "DEVICE", "ROUTES", "KRT_SOURCE", "KRT_METRIC",
  "ASYNC", "TABLE", "KRT_PREFSRC", "KRT_REALM", "ROUTER", "ID", "PROTOCOL",
  "TEMPLATE", "PREFERENCE", "DISABLED", "DIRECT", "INTERFACE", "IMPORT",
  "EXPORT", "FILTER", "NONE", "STATES", "FILTERS", "RECEIVE", "LIMIT",
  "ACTION", "WARN", "BLOCK", "RESTART", "DISABLE", "KEEP", "FILTERED",
  "PASSWORD", "FROM", "PASSIVE", "TO", "EVENTS", "PACKETS", "PROTOCOLS",
  "INTERFACES", "PRIMARY", "STATS", "COUNT", "FOR", "COMMANDS",
  "PREEXPORT", "GENERATE", "ROA", "MAX", "FLUSH", "LISTEN", "BGP",
  "V6ONLY", "DUAL", "ADDRESS", "PORT", "PASSWORDS", "DESCRIPTION",
  "SORTED", "RELOAD", "IN", "OUT", "MRTDUMP", "MESSAGES", "RESTRICT",
  "MEMORY", "IGP_METRIC", "SHOW", "STATUS", "SUMMARY", "ROUTE", "SYMBOLS",
  "ADD", "DELETE", "DUMP", "RESOURCES", "SOCKETS", "NEIGHBORS",
  "ATTRIBUTES", "ECHO", "ENABLE", "FUNCTION", "PRINT", "PRINTN", "UNSET",
  "RETURN", "ACCEPT", "REJECT", "QUITBIRD", "INT", "BOOL", "IP", "PREFIX",
  "PAIR", "QUAD", "EC", "SET", "STRING", "BGPMASK", "BGPPATH", "CLIST",
  "ECLIST", "IF", "THEN", "ELSE", "CASE", "TRUE", "FALSE", "RT", "RO",
  "UNKNOWN", "GENERIC", "GW", "NET", "MASK", "PROTO", "SOURCE", "SCOPE",
  "CAST", "DEST", "LEN", "DEFINED", "CONTAINS", "RESET", "PREPEND",
  "FIRST", "LAST", "MATCH", "ROA_CHECK", "EMPTY", "WHERE", "EVAL", "LOCAL",
  "NEIGHBOR", "AS", "HOLD", "CONNECT", "RETRY", "KEEPALIVE", "MULTIHOP",
  "STARTUP", "VIA", "NEXT", "HOP", "SELF", "DEFAULT", "PATH", "METRIC",
  "START", "DELAY", "FORGET", "WAIT", "AFTER", "BGP_PATH",
  "BGP_LOCAL_PREF", "BGP_MED", "BGP_ORIGIN", "BGP_NEXT_HOP",
  "BGP_ATOMIC_AGGR", "BGP_AGGREGATOR", "BGP_COMMUNITY",
  "BGP_EXT_COMMUNITY", "RR", "RS", "CLIENT", "CLUSTER", "AS4", "ADVERTISE",
  "IPV4", "CAPABILITIES", "PREFER", "OLDER", "MISSING", "LLADDR", "DROP",
  "IGNORE", "REFRESH", "INTERPRET", "COMMUNITIES", "BGP_ORIGINATOR_ID",
  "BGP_CLUSTER_LIST", "IGP", "GATEWAY", "RECURSIVE", "MED", "TTL",
  "SECURITY", "DETERMINISTIC", "SECONDARY", "OSPF", "AREA", "OSPF_METRIC1",
  "OSPF_METRIC2", "OSPF_TAG", "OSPF_ROUTER_ID", "RFC1583COMPAT", "STUB",
  "TICK", "COST", "COST2", "RETRANSMIT", "HELLO", "TRANSMIT", "PRIORITY",
  "DEAD", "TYPE", "BROADCAST", "BCAST", "NONBROADCAST", "NBMA",
  "POINTOPOINT", "PTP", "POINTOMULTIPOINT", "PTMP", "SIMPLE",
  "AUTHENTICATION", "STRICT", "CRYPTOGRAPHIC", "ELIGIBLE", "POLL",
  "NETWORKS", "HIDDEN", "VIRTUAL", "LINK", "RX", "BUFFER", "LARGE",
  "NORMAL", "STUBNET", "TAG", "EXTERNAL", "LSADB", "ECMP", "WEIGHT",
  "NSSA", "TRANSLATOR", "STABILITY", "GLOBAL", "LSID", "INSTANCE", "REAL",
  "NETMASK", "TOPOLOGY", "STATE", "PIPE", "PEER", "MODE", "OPAQUE",
  "TRANSPARENT", "RIP", "INFINITY", "PERIOD", "GARBAGE", "MULTICAST",
  "QUIET", "NOLISTEN", "VERSION1", "PLAINTEXT", "MD5", "HONOR", "NEVER",
  "ALWAYS", "RIP_METRIC", "RIP_TAG", "STATIC", "PROHIBIT", "MULTIPATH",
  "BLACKHOLE", "UNREACHABLE", "'('", "')'", "';'", "':'", "'{'", "'}'",
  "','", "'?'", "'['", "']'", "$accept", "config", "conf_entries", "expr",
  "definition", "bool", "ipa", "ipa_scope", "prefix", "prefix_or_ipa",
  "pxlen", "datetime", "text_or_none", "log_config", "syslog_name",
  "log_file", "log_mask", "log_mask_list", "log_cat", "mrtdump_base",
  "timeformat_which", "timeformat_spec", "timeformat_base",
  "cmd_CONFIGURE", "cmd_CONFIGURE_SOFT", "cmd_CONFIGURE_CONFIRM",
  "cmd_CONFIGURE_UNDO", "cmd_CONFIGURE_CHECK", "cmd_DOWN", "cfg_name",
  "cfg_timeout", "kern_proto_start", "kern_item", "kif_proto_start",
  "kif_item", "nl_item", "rtrid", "idval", "listen", "listen_opts",
  "listen_opt", "tab_sorted", "newtab", "roa_table_start",
  "roa_table_opts", "roa_table", "proto_start", "proto_name", "proto_item",
  "imexport", "limit_action", "limit_spec", "rtable", "debug_default",
  "iface_patt_node_init", "iface_patt_node_body", "iface_negate",
  "iface_patt_node", "iface_patt_list", "iface_patt_init", "iface_patt",
  "dev_proto_start", "dev_proto", "dev_iface_init", "dev_iface_patt",
  "debug_mask", "debug_list", "debug_flag", "mrtdump_mask", "mrtdump_list",
  "mrtdump_flag", "password_list", "password_items", "password_item",
  "password_item_begin", "password_item_params", "cmd_SHOW_STATUS",
  "cmd_SHOW_MEMORY", "cmd_SHOW_PROTOCOLS", "cmd_SHOW_PROTOCOLS_ALL",
  "optsym", "cmd_SHOW_INTERFACES", "cmd_SHOW_INTERFACES_SUMMARY",
  "cmd_SHOW_ROUTE", "r_args", "export_or_preexport", "cmd_SHOW_ROA",
  "roa_args", "roa_mode", "cmd_SHOW_SYMBOLS", "sym_args", "roa_table_arg",
  "cmd_ADD_ROA", "cmd_DELETE_ROA", "cmd_FLUSH_ROA", "cmd_DUMP_RESOURCES",
  "cmd_DUMP_SOCKETS", "cmd_DUMP_INTERFACES", "cmd_DUMP_NEIGHBORS",
  "cmd_DUMP_ATTRIBUTES", "cmd_DUMP_ROUTES", "cmd_DUMP_PROTOCOLS",
  "cmd_ECHO", "echo_mask", "echo_size", "cmd_DISABLE", "cmd_ENABLE",
  "cmd_RESTART", "cmd_RELOAD", "cmd_RELOAD_IN", "cmd_RELOAD_OUT",
  "cmd_DEBUG", "cmd_MRTDUMP", "cmd_RESTRICT", "proto_patt", "proto_patt2",
  "filter_def", "$@1", "filter_eval", "type", "one_decl", "decls",
  "declsn", "filter_body", "filter", "where_filter", "function_params",
  "function_body", "function_def", "$@2", "cmds", "cmds_int", "block",
  "fipa", "set_atom", "switch_atom", "pair_expr", "pair_atom", "pair_item",
  "ec_expr", "ec_kind", "ec_item", "set_item", "switch_item", "set_items",
  "switch_items", "fprefix_s", "fprefix", "fprefix_set", "switch_body",
  "bgp_path_expr", "bgp_path", "bgp_path_tail1", "bgp_path_tail2",
  "constant", "constructor", "rtadot", "function_call", "symbol",
  "static_attr", "term", "break_command", "print_one", "print_list",
  "var_listn", "var_list", "cmd", "bgp_proto_start", "bgp_proto",
  "ospf_proto_start", "ospf_proto", "ospf_proto_item", "ospf_area_start",
  "ospf_area", "ospf_area_opts", "ospf_area_item", "$@3", "$@4",
  "ospf_stubnet", "ospf_stubnet_start", "ospf_stubnet_opts",
  "ospf_stubnet_item", "ospf_vlink", "ospf_vlink_opts", "ospf_vlink_item",
  "ospf_vlink_start", "ospf_iface_item", "pref_list", "pref_item",
  "pref_base", "pref_opt", "nbma_list", "nbma_eligible", "nbma_item",
  "ospf_iface_start", "ospf_instance_id", "ospf_iface_opts",
  "ospf_iface_opt_list", "ospf_iface", "opttext", "cmd_SHOW_OSPF",
  "cmd_SHOW_OSPF_NEIGHBORS", "cmd_SHOW_OSPF_INTERFACE",
  "cmd_SHOW_OSPF_TOPOLOGY", "cmd_SHOW_OSPF_TOPOLOGY_ALL",
  "cmd_SHOW_OSPF_STATE", "cmd_SHOW_OSPF_STATE_ALL", "cmd_SHOW_OSPF_LSADB",
  "lsadb_args", "pipe_proto_start", "pipe_proto", "rip_cfg_start",
  "rip_cfg", "rip_auth", "rip_mode", "rip_iface_item", "rip_iface_opts",
  "rip_iface_opt_list", "rip_iface_init", "rip_iface",
  "static_proto_start", "static_proto", "stat_route0", "stat_multipath1",
  "stat_multipath", "stat_route", "cmd_SHOW_STATIC", "conf", "cli_cmd",
  "proto", "kern_proto", "kif_proto", "dynamic_attr", YY_NULL
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    61,    60,    62,   126,    43,    45,    42,    47,
      37,    33,    46,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,    40,    41,    59,
      58,   123,   125,    44,    63,    91,    93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   347,   348,   348,   349,   349,   350,   350,   350,   351,
     351,   352,   352,   352,   352,   352,   352,   353,   353,   354,
     354,   355,   356,   356,   357,   357,   358,   359,   359,   360,
     361,   361,   362,   362,   362,   363,   363,   364,   364,   365,
     365,   365,   365,   365,   365,   365,   365,   365,   366,   366,
     367,   367,   367,   367,   368,   368,   368,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   376,   377,   377,   377,
     378,   379,   379,   379,   379,   380,   381,   381,   382,   383,
     383,   384,   384,   384,   385,   386,   386,   387,   387,   387,
     387,   388,   388,   389,   390,   391,   391,   392,   392,   393,
     393,   394,   394,   394,   395,   395,   395,   395,   395,   395,
     395,   395,   395,   395,   395,   395,   395,   395,   396,   396,
     396,   396,   397,   397,   397,   397,   397,   398,   398,   399,
     400,   400,   401,   402,   402,   402,   403,   403,   404,   405,
     405,   406,   407,   408,   409,   409,   409,   410,   411,   412,
     412,   412,   413,   413,   414,   414,   414,   414,   414,   414,
     415,   415,   415,   416,   416,   417,   417,   418,   418,   419,
     419,   420,   420,   421,   422,   422,   422,   422,   422,   422,
     423,   424,   425,   426,   427,   427,   428,   429,   430,   431,
     431,   431,   431,   431,   431,   431,   431,   431,   431,   431,
     431,   431,   432,   432,   433,   434,   434,   434,   434,   435,
     435,   435,   436,   437,   437,   437,   437,   437,   437,   437,
     437,   438,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   450,   450,   451,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   461,
     461,   462,   462,   462,   464,   463,   465,   466,   466,   466,
     466,   466,   466,   466,   466,   466,   466,   466,   466,   466,
     467,   468,   468,   469,   469,   470,   471,   471,   472,   473,
     473,   474,   476,   475,   477,   477,   478,   478,   479,   479,
     480,   481,   481,   481,   481,   482,   482,   482,   482,   482,
     483,   484,   484,   484,   485,   485,   486,   487,   487,   487,
     487,   488,   488,   488,   489,   489,   489,   489,   490,   490,
     490,   490,   491,   491,   492,   492,   493,   494,   494,   494,
     494,   495,   495,   496,   496,   496,   497,   497,   498,   498,
     499,   499,   499,   499,   499,   500,   500,   500,   501,   501,
     501,   501,   501,   501,   501,   501,   501,   501,   501,   502,
     502,   503,   504,   505,   506,   506,   506,   506,   506,   506,
     506,   506,   507,   507,   507,   507,   507,   507,   507,   507,
     507,   507,   507,   507,   507,   507,   507,   507,   507,   507,
     507,   507,   507,   507,   507,   507,   507,   507,   507,   507,
     507,   507,   507,   507,   507,   507,   507,   507,   507,   508,
     508,   508,   508,   508,   508,   509,   510,   510,   510,   511,
     511,   512,   512,   513,   513,   513,   513,   513,   513,   513,
     513,   513,   513,   513,   513,   513,   513,   513,   513,   514,
     515,   515,   515,   515,   515,   515,   515,   515,   515,   515,
     515,   515,   515,   515,   515,   515,   515,   515,   515,   515,
     515,   515,   515,   515,   515,   515,   515,   515,   515,   515,
     515,   515,   515,   515,   515,   515,   515,   515,   515,   515,
     515,   515,   515,   515,   516,   517,   517,   518,   518,   518,
     518,   518,   518,   519,   520,   521,   521,   522,   522,   522,
     522,   522,   522,   522,   522,   522,   523,   522,   524,   522,
     522,   522,   522,   525,   525,   526,   527,   527,   528,   528,
     528,   529,   529,   530,   530,   531,   531,   531,   531,   531,
     531,   531,   531,   531,   531,   531,   532,   533,   533,   533,
     533,   533,   533,   533,   533,   533,   533,   533,   533,   533,
     533,   533,   533,   533,   533,   533,   533,   533,   533,   533,
     533,   533,   533,   533,   533,   533,   533,   533,   534,   534,
     535,   536,   537,   537,   537,   538,   538,   539,   539,   540,
     541,   542,   542,   543,   543,   544,   544,   545,   546,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   555,
     555,   555,   555,   555,   555,   555,   555,   556,   557,   557,
     557,   557,   557,   558,   559,   559,   559,   559,   559,   559,
     559,   559,   559,   559,   559,   559,   559,   560,   560,   560,
     561,   561,   561,   561,   561,   562,   562,   562,   563,   563,
     564,   564,   565,   566,   567,   568,   568,   568,   568,   568,
     569,   570,   570,   571,   571,   572,   572,   572,   572,   572,
     572,   572,   572,   572,   573,   574,   574,   574,   574,   574,
     574,   574,   574,   574,   574,   574,   574,   574,   574,   575,
     575,   575,   575,   575,   575,   575,   575,   575,   575,   575,
     575,   575,   575,   575,   575,   575,   575,   575,   575,   575,
     575,   575,   575,   575,   575,   575,   575,   575,   575,   575,
     575,   575,   575,   575,   575,   575,   575,   575,   575,   575,
     575,   575,   575,   576,   576,   576,   576,   576,   576,   576,
     576,   577,   577,   577,   577,   578,   578,   578,   579,   579,
     579,   579,   579,   579,   579,   579,   579,   579,   579,   579,
     579,   579,   579,   579,   579,   579,   579,   579,   579,   579,
     579
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     2,     0,     2,     1,     3,     1,     5,
       5,     1,     1,     1,     1,     1,     0,     1,     1,     0,
       2,     2,     1,     1,     2,     2,     1,     1,     0,     4,
       2,     0,     1,     2,     1,     1,     3,     1,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     4,     3,
       1,     1,     1,     1,     2,     4,     3,     3,     3,     4,
       5,     3,     3,     4,     2,     0,     1,     0,     1,     2,
       2,     2,     3,     2,     3,     2,     3,     3,     3,     4,
       5,     1,     1,     1,     4,     0,     2,     2,     2,     1,
       1,     0,     1,     3,     3,     0,     8,     1,     4,     1,
       1,     0,     1,     3,     0,     2,     2,     2,     2,     2,
       2,     3,     3,     3,     4,     2,     3,     2,     2,     1,
       1,     1,     0,     2,     2,     2,     2,     2,     1,     1,
       3,     3,     0,     1,     1,     2,     0,     1,     3,     1,
       3,     0,     2,     2,     3,     3,     3,     0,     3,     1,
       1,     3,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     3,     1,     1,     4,     1,     0,
       3,     4,     1,     2,     0,     5,     5,     5,     5,     4,
       3,     3,     4,     5,     1,     0,     3,     4,     4,     0,
       2,     3,     3,     3,     2,     2,     2,     2,     3,     3,
       2,     2,     1,     1,     4,     0,     3,     3,     3,     0,
       1,     1,     4,     0,     2,     2,     2,     2,     2,     2,
       2,     0,     2,     9,     9,     4,     3,     3,     3,     3,
       3,     3,     3,     4,     1,     1,     1,     0,     1,     3,
       3,     3,     3,     4,     4,     4,     4,     2,     1,     1,
       1,     1,     0,     1,     0,     4,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       2,     0,     3,     1,     3,     1,     1,     1,     2,     3,
       2,     4,     0,     5,     0,     1,     1,     2,     1,     3,
       1,     1,     1,     1,     1,     1,     3,     1,     1,     1,
       1,     1,     3,     1,     5,    11,     1,     1,     1,     2,
       1,     7,     9,     7,     1,     1,     1,     3,     1,     1,
       1,     3,     1,     3,     1,     3,     3,     1,     2,     2,
       6,     1,     3,     0,     4,     3,     1,     3,     3,     3,
       2,     2,     2,     2,     0,     2,     2,     0,     1,     1,
       1,     1,     1,     1,     1,     3,     3,     1,     1,     5,
       7,     0,     4,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     2,     4,     1,     1,
       1,     1,     2,     2,     3,     3,     6,     3,     3,     3,
       3,     5,     6,     6,     6,     6,     4,     8,     4,     1,
       1,     1,     1,     1,     1,     1,     0,     1,     3,     1,
       3,     0,     1,     4,     6,     4,     3,     5,     5,     4,
       6,     3,     2,     5,     5,     8,     8,     8,     8,     2,
       3,     3,     5,     6,     7,     6,     4,     4,     5,     6,
       6,     5,     3,     4,     5,     5,     5,     5,     5,     4,
       4,     5,     5,     5,     5,     5,     5,     5,     5,     6,
       6,     8,     6,     6,     5,     4,     5,     4,     5,     4,
       5,     4,     5,     5,     2,     3,     3,     1,     2,     2,
       4,     2,     1,     2,     4,     0,     3,     2,     1,     2,
       3,     3,     3,     3,     2,     3,     0,     5,     0,     5,
       2,     2,     1,     4,     1,     1,     0,     3,     2,     2,
       2,     5,     2,     0,     3,     0,     2,     2,     3,     2,
       2,     3,     2,     2,     2,     1,     3,     2,     2,     2,
       2,     2,     2,     3,     2,     2,     2,     2,     2,     2,
       2,     2,     3,     3,     3,     2,     3,     2,     3,     3,
       4,     2,     2,     2,     3,     3,     3,     1,     0,     2,
       3,     1,     0,     1,     2,     0,     2,     0,     1,     3,
       0,     0,     2,     0,     3,     0,     3,     4,     1,     0,
       4,     6,     6,     6,     7,     6,     7,     5,     0,     2,
       3,     2,     3,     3,     2,     3,     2,     2,     3,     3,
       5,     4,     4,     2,     3,     3,     4,     4,     4,     5,
       5,     4,     3,     4,     4,     4,     4,     1,     1,     1,
       1,     1,     1,     1,     1,     0,     2,     2,     0,     3,
       0,     3,     0,     3,     2,     3,     3,     5,     5,     3,
       2,     3,     3,     1,     2,     4,     3,     3,     3,     2,
       2,     2,     2,     2,     4,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     2,     2,     2,     2,     2,     2,
       2,     3,     3,     3,     3,     3,     3,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       4,     0,     0,     0,     0,    65,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,     3,     1,     2,     0,     0,     0,     0,
       0,     0,    99,   100,     0,     0,     0,     0,     0,   361,
     665,   666,   667,   668,   669,   101,   101,   670,   671,   672,
      97,   673,     0,   675,   101,   104,   676,   677,   678,   101,
     104,   101,   104,   101,   104,   101,   104,   101,   104,     5,
     674,   104,   104,   248,   250,   249,     0,    66,    65,     0,
       0,    65,    67,    64,     0,     0,   221,     0,     0,     0,
       0,   247,   252,     0,   205,     0,     0,   189,   213,   185,
     185,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   235,   234,   237,     0,     0,    32,    31,    34,     0,
       0,     0,    53,    52,    51,    50,     0,     0,    91,     0,
     254,     0,    85,     0,     0,   282,   344,   348,   357,   354,
     290,   363,   351,     0,     0,   347,   361,   391,     0,     0,
       0,   349,   350,     0,     0,     0,   361,     0,   352,   353,
     358,   389,   390,     0,   388,   256,   102,     0,     0,    95,
      70,    75,   143,   439,   484,   607,   613,   644,     0,     0,
       0,     0,     0,    16,   147,     0,     0,     0,     0,     0,
     725,     0,     0,     0,     0,     0,     0,    16,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    16,     0,     0,     0,     0,
       0,     0,     0,     0,    16,   726,     0,     0,     0,    16,
       0,    16,   727,   487,     0,     0,   492,     0,     0,     0,
     728,     0,     0,     0,   642,     0,     0,     0,     0,     0,
       0,     0,     0,   729,     0,     0,   168,   172,     0,     0,
       0,     0,   730,     0,     0,     0,     0,    16,     0,    16,
       0,   723,     0,     0,     0,     0,    28,   724,     0,     0,
     150,   149,     0,     0,    67,    61,    62,     0,    68,     0,
     241,   239,     0,     0,     0,     0,   242,   161,   160,     0,
       0,   251,   253,   252,     0,   186,     0,   209,   181,   180,
       0,     0,   184,   185,   185,   598,   185,   185,     0,     0,
      17,    18,     0,     0,     0,   231,   232,   228,   226,   227,
     229,   230,   238,     0,   240,     0,     0,    33,    35,     0,
       0,   130,     6,     8,   361,   131,    54,     0,    58,    92,
      93,    81,    82,    83,   141,     0,   271,    94,     0,    49,
       0,     0,   344,   363,   344,   361,   344,   344,     0,   336,
       0,   361,     0,     0,     0,   347,   347,     0,   386,   361,
     361,   361,   361,   361,     0,   307,   308,     0,   310,     0,
       0,   294,   292,   361,   291,   293,   316,   314,   315,   322,
       0,   327,   331,     0,   743,   738,   739,   740,   741,   364,
     742,   365,   366,   367,   368,   369,   370,   371,   745,   748,
     747,   744,   746,   749,   750,   751,   754,   752,   753,   755,
     756,   757,   758,   759,   760,   392,   393,   361,   361,   361,
     361,   361,   361,   361,   361,   361,   361,   361,   361,   361,
       0,     0,   731,   735,     0,   144,   107,   129,   115,     0,
     105,    12,    14,    13,    15,    11,   106,   132,   120,   271,
     121,     0,     0,   361,   109,   119,     0,   110,     0,   117,
     108,   145,   146,   440,     0,     0,     0,     0,     0,     0,
       0,    16,     0,     0,     0,    19,     0,     0,     0,   452,
       0,     0,     0,     0,     0,    16,     0,     0,     0,     0,
      16,     0,    16,     0,    16,     0,    16,     0,     0,    16,
      16,    16,     0,   441,   485,   493,   488,   491,   489,   486,
     495,   608,     0,     0,     0,   609,   614,     0,   132,     0,
     173,     0,   169,   629,   627,   628,     0,     0,     0,     0,
       0,     0,     0,   615,   622,   174,   645,    16,   650,     0,
     646,   660,     0,   659,     0,   663,     0,   661,   662,   649,
       0,    71,     0,    73,    16,   733,   734,   732,     0,    27,
       0,   737,   736,   155,   154,   156,   158,   159,   157,     0,
     152,   245,     0,    63,    69,    59,   222,   225,   243,   244,
     165,   166,     0,   163,   246,     0,   182,   187,   204,     0,
     211,   210,     0,     0,   188,   195,     0,     0,   203,   271,
     197,   196,   200,   201,     0,   202,   190,     0,   194,   212,
     220,   214,   217,   218,   216,   219,   215,   589,   589,     0,
     185,   589,   185,   589,   590,   664,     0,     0,    21,     0,
       0,   233,     0,     0,    30,    39,    40,    41,    42,    43,
      44,    45,    46,    47,     0,    37,    29,     0,     0,    56,
      57,   132,     0,    79,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,     0,     0,     0,   255,
     275,    89,    90,     0,     0,    84,    86,    48,     0,   271,
     340,   341,     0,   342,   343,   338,   326,   419,   422,     0,
     399,     0,   400,   345,   346,   339,     0,     0,     0,     0,
       0,     0,   309,   361,   372,   361,   303,   301,     0,     0,
     300,     0,     0,   355,   328,   329,     0,     0,   356,   384,
     382,   380,   377,   378,   379,   381,   383,   385,   373,   374,
     375,   376,   394,     0,   395,   397,   398,   103,     0,    98,
     116,   136,   139,   148,   276,   277,   118,   128,   122,   112,
      16,   278,   113,   111,     0,     0,    16,   477,   479,     0,
      16,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     453,     0,     0,     0,     0,     0,     0,     0,   446,     0,
     447,     0,   475,     0,     0,     0,     0,     0,     0,     0,
     459,   460,     0,     0,     0,   481,     0,     0,     0,   611,
     612,     0,   640,   626,   617,     0,     0,   621,   616,   618,
       0,   624,   625,   623,     0,     0,     0,     0,     0,     0,
     656,    19,   658,     0,   653,   657,    78,    72,    74,    76,
      23,    22,    77,   151,     0,    60,   162,     0,   183,   208,
     207,   206,   192,   199,   193,   191,   198,   588,     0,     0,
     597,   606,     0,   604,     0,     0,   601,   599,     0,   589,
       0,   589,     0,    24,    25,     0,     0,    10,     9,    36,
       0,     7,    55,   142,    80,   270,   269,   271,   361,    87,
      88,   280,   273,     0,   283,   337,   361,   408,     0,   361,
     361,   361,   387,   361,   406,   361,     0,     0,   361,   361,
     361,   290,   317,   323,     0,     0,   332,   361,     0,   137,
       0,   132,     0,   127,   114,     0,     0,     0,   478,     0,
     474,   468,   442,     0,    20,     0,   448,     0,   451,     0,
     455,   454,   467,   466,   461,     0,     0,   476,   464,   456,
     457,   458,   480,   482,   463,   462,   483,   465,   490,   580,
      16,     0,    16,   506,     0,     0,   508,   498,    16,   494,
       0,   512,   581,   610,   620,   638,   643,   167,   169,   619,
       0,     0,     0,     0,     0,   171,   647,   648,   655,    19,
       0,   654,   153,   164,   592,   591,   605,   600,   602,   603,
       0,   593,     0,   595,     0,     0,    38,   272,     0,   412,
       0,   413,   414,     0,   361,   410,   411,   409,   361,   361,
       0,   361,     0,     0,   361,   286,     0,   279,   420,   401,
       0,     0,     0,     0,     0,   361,   359,   302,   300,     0,
       0,   306,     0,     0,     0,   133,   134,   138,   140,   123,
     124,   125,   126,   470,     0,   472,   473,   443,     0,   450,
     449,   469,   445,   132,   511,   499,     0,     0,    16,     0,
     497,     0,     0,   515,   510,   514,     0,     0,   504,   496,
       0,   522,   635,   170,   174,    26,     0,     0,     0,     0,
     651,   652,   594,   596,   221,   221,   361,   361,   361,   361,
       0,     0,     0,   281,   287,     0,     0,   432,   415,   417,
       0,   274,   405,   403,   404,   402,   361,     0,   304,   361,
       0,   396,     0,   135,     0,   444,   581,   501,   502,   500,
     503,   568,   536,   516,   568,   505,   582,   523,     0,     0,
     641,     0,   179,   174,   174,   174,   174,     0,     0,     0,
       0,     0,     0,   426,   361,   333,   361,   361,     0,   361,
     431,     0,   360,     0,     0,     0,   330,     0,   471,   585,
       0,     0,     0,   525,   636,   630,   631,   632,   633,   634,
     637,   639,   175,   176,   177,   178,   223,   224,   425,   362,
     429,     0,   361,   423,   288,     0,     0,     0,     0,     0,
       0,     0,     0,   418,   407,   361,   313,   361,   311,     0,
     583,   587,   507,   571,   569,   572,    16,     0,    16,   513,
       0,   509,     0,     0,     0,     0,     0,     0,   521,   535,
       0,     0,     0,   361,   361,   295,   299,   297,   361,   433,
     298,   320,   318,   319,   324,     0,   428,   427,   361,   361,
     361,   361,   434,     0,     0,    96,     0,   573,     0,     0,
     519,   520,   518,   517,   529,   527,   526,     0,     0,   530,
     532,   533,   534,   524,   430,   289,   424,   335,   300,     0,
     361,     0,     0,     0,     0,     0,   361,   312,     0,     0,
       0,    16,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   586,   567,     0,   574,
     570,   528,   531,   296,   361,   321,   334,   325,     0,     0,
       0,     0,     0,    16,   575,   541,   557,   537,   540,   538,
       0,   555,     0,   542,   544,   545,   546,   547,   548,   549,
     550,   551,    16,   561,   562,   563,    16,   539,     0,     0,
      16,   584,     0,   438,   436,   437,   435,   305,   558,     0,
     554,   543,   553,   556,   564,   565,   566,   559,   552,   577,
     560,   576,   578,     0,   579
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,   505,    81,   506,   362,   826,   891,   892,
     688,  1136,   620,    82,   377,   159,   380,   704,   705,    83,
     166,   167,    84,    19,    20,    21,    22,    23,    24,   122,
     329,    85,   312,    86,   318,   313,    87,   395,    88,   398,
     736,   390,    89,    90,   494,    91,    92,   207,   231,   514,
     973,   809,   498,    93,   801,  1097,   970,   802,   803,   711,
     712,    94,    95,   507,   232,   323,   629,   630,   340,   642,
     643,   295,   865,   296,   297,   877,    25,    26,    27,    28,
     358,    29,    30,    31,   350,   667,    32,   347,   653,    33,
     351,   333,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,   153,   373,    45,    46,    47,    48,    49,
      50,    51,    52,    53,   116,   344,    96,   396,    97,   726,
     727,   728,   943,   805,   806,   515,   739,   730,    98,   401,
    1070,  1071,  1243,   198,   436,  1291,   767,   768,   437,  1090,
     769,   438,   439,  1294,   440,  1295,   199,   442,   443,  1245,
     407,   200,   408,   417,   201,   202,   203,  1073,   204,   475,
    1088,  1074,  1159,  1160,   748,   749,  1075,    99,   100,   101,
     102,   274,   275,   276,   857,  1020,  1121,  1126,  1124,  1125,
    1221,  1270,  1021,  1223,  1280,  1022,  1358,  1220,  1264,  1265,
    1309,  1409,  1423,  1421,  1113,  1131,  1306,  1261,  1114,   908,
      54,    55,    56,    57,    58,    59,    60,    61,   679,   103,
     104,   105,   106,   586,  1230,  1191,  1132,  1026,   578,   579,
     107,   108,   304,   884,   885,   305,    62,   109,    63,   110,
     111,   112,   476
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -1164
static const yytype_int16 yypact[] =
{
      63,  2384,   115,   215,   516,   886,   184,   516,   516,    30,
     411,   516,   211,   435,   126,   154,   709,   273,   516, -1164,
   -1164, -1164, -1164, -1164, -1164, -1164, -1164, -1164, -1164, -1164,
   -1164, -1164, -1164, -1164, -1164, -1164, -1164, -1164, -1164, -1164,
   -1164, -1164, -1164, -1164, -1164, -1164, -1164, -1164, -1164, -1164,
   -1164, -1164, -1164, -1164, -1164, -1164, -1164, -1164, -1164, -1164,
   -1164, -1164, -1164, -1164, -1164, -1164,   208,   444,   330,   455,
     302,   298, -1164, -1164,   344,   364,   271,    96,   426,  1275,
   -1164, -1164, -1164, -1164, -1164,   431,   431, -1164, -1164, -1164,
     116, -1164,   602, -1164,   431,  2157, -1164, -1164, -1164,   431,
    2126,   431,  2128,   431,  2216,   431,  1950,   431,  1980, -1164,
   -1164,  2038,   565, -1164, -1164, -1164,    45, -1164,   441,   462,
     467,   441,   436, -1164,   478,   496,   457,   516,   516,   511,
      52, -1164,   550,    80, -1164,   522,   526, -1164, -1164,   117,
     529,   576,   576,   552,   563,   586,   588,   611,   627,   634,
   -1164, -1164, -1164,   538,   640,   583, -1164,   592, -1164,   -18,
      45,   142, -1164, -1164, -1164, -1164,   250,   306,   527,   451,
   -1164,   655, -1164,   337,    52, -1164,    24, -1164, -1164, -1164,
     649,   343, -1164,   491,    23,    14,  1275, -1164,   357,   359,
     380, -1164, -1164,   402,   406,   423,   776,   103, -1164, -1164,
   -1164, -1164, -1164,  1914, -1164,  1971,   677,   445,   447, -1164,
   -1164, -1164, -1164, -1164, -1164, -1164, -1164, -1164,   449,    45,
     762,   721,   142,    74, -1164,   440,   420,   708,   781,    52,
   -1164,   465,   471,   476,   422,   593,   798,    74,   729,   -13,
     706,    26,   576,   755,   625,   764,    44,   629,   623,   460,
     620,   619,   430,   613,   615,    74,   617,   621,   612,   -34,
     -35,   646,   610,   614,    74, -1164,   530,   532,   562,    74,
     142,    74, -1164, -1164,   536,   541, -1164,   542,   794,   386,
   -1164,   540,   544,   813, -1164,   876,   142,   557,   -46,   142,
     142,   833,   -28, -1164,   564,   569, -1164,   560,   561,   622,
     576,   830, -1164,   572,  1068,   591,   841,    74,   860,    74,
     861, -1164,   594,   597,   608,   865,   919, -1164,   628,   630,
   -1164, -1164,   887,   938,   436, -1164, -1164,   946,   142,   953,
   -1164, -1164,   940,   959,   961,   963, -1164, -1164, -1164,    13,
     967, -1164, -1164,   685,   970, -1164,   972,   578, -1164, -1164,
    2350,  1090, -1164,   529,   529, -1164,   285,   316,   975,   976,
   -1164, -1164,    -1,   864,   866, -1164, -1164, -1164, -1164, -1164,
   -1164, -1164, -1164,   978, -1164,    76,   966, -1164, -1164,  1030,
     644, -1164, -1164, -1164,  1275, -1164,   142,   665, -1164, -1164,
   -1164, -1164, -1164, -1164, -1164,   648,  1437, -1164,   274, -1164,
     654,   651,    24, -1164,    24,  1275,    24,    24,   990, -1164,
     982,   983,   981,   811,   984,    14,    14,   986,   985,  1275,
    1275,  1275,  1275,  1275,   994, -1164, -1164,  1001, -1164,   675,
      46, -1164, -1164,   746, -1164, -1164,  1013, -1164, -1164, -1164,
    -217,   -10, -1164,   -50, -1164, -1164, -1164, -1164, -1164, -1164,
   -1164, -1164, -1164, -1164, -1164, -1164, -1164, -1164, -1164, -1164,
   -1164, -1164, -1164, -1164, -1164, -1164, -1164, -1164, -1164, -1164,
   -1164, -1164, -1164, -1164, -1164, -1164, -1164,  1275,  1275,  1275,
    1275,  1275,  1275,  1275,  1275,  1275,  1275,  1275,  1275,  1275,
     505,  1003, -1164, -1164,   -78, -1164, -1164, -1164, -1164,   562,
   -1164, -1164, -1164, -1164, -1164, -1164, -1164, -1164, -1164,   939,
   -1164,   145,   930,  1275, -1164, -1164,   145, -1164,   145, -1164,
   -1164, -1164, -1164, -1164,   964,   971,   987,   691,   701,   142,
     803,    74,   576,   142,   846,  1020,   142,   988,   142, -1164,
     712,   998,    54,   142,   142,    74,  1014,   713,  1007,   714,
      74,   715,    74,    42,    74,   762,    74,   747,   749,    74,
      74,    74,   753, -1164, -1164, -1164, -1164, -1164,  1002, -1164,
   -1164, -1164,  1084,   771,   773, -1164, -1164,   142, -1164,   775,
   -1164,   783,  1015, -1164, -1164, -1164,   786,   790,   792,   142,
     797,   799,   805, -1164, -1164,   173, -1164,    74, -1164,   762,
   -1164, -1164,   601, -1164,   576, -1164,   928, -1164, -1164, -1164,
     142, -1164,   142, -1164,    74, -1164, -1164, -1164,   142, -1164,
     576, -1164, -1164, -1164, -1164, -1164, -1164, -1164, -1164,   391,
   -1164, -1164,  1137, -1164, -1164, -1164, -1164, -1164, -1164, -1164,
   -1164, -1164,   414, -1164, -1164,  1139, -1164, -1164, -1164,  1127,
   -1164, -1164,  1135,   576, -1164, -1164,  1132,  1140, -1164,   939,
   -1164, -1164, -1164, -1164,   576, -1164, -1164,  1141, -1164, -1164,
   -1164, -1164, -1164, -1164, -1164, -1164, -1164,  1134,  1134,   907,
     529,  1134,   529,  1134, -1164, -1164,   142,   576, -1164,  1148,
    1151, -1164,   817,   828, -1164, -1164, -1164, -1164, -1164, -1164,
   -1164, -1164, -1164, -1164,   427, -1164, -1164,  1500,  1153, -1164,
   -1164, -1164,   829, -1164, -1164, -1164, -1164, -1164, -1164, -1164,
   -1164, -1164, -1164, -1164, -1164, -1164,    19,   832,   835, -1164,
   -1164, -1164, -1164,   576,   142, -1164, -1164, -1164,   681,  1437,
   -1164, -1164,  1561, -1164, -1164, -1164, -1164,   181, -1164,   836,
   -1164,  1154, -1164, -1164, -1164, -1164,   249,   463,   494,  1599,
     535,    36, -1164,  1275, -1164,  1275, -1164,  1182,   849,   850,
    1500,   122,   228, -1164, -1164, -1164,  1179,  1177, -1164,  1511,
    1511,  1511,  2512,  2512,  1511,  1511,  1511,  1511,   481,   481,
     985,   985, -1164,   862, -1164, -1164, -1164, -1164,   576, -1164,
   -1164,  1174, -1164,   859, -1164, -1164, -1164, -1164,  1110, -1164,
      74,  1971, -1164, -1164,   142,   142,    74, -1164, -1164,   867,
      74,   868,   869,   871,   142,  1192,  1012,   877,   142,   878,
   -1164,   142,   879,   888,   890,   891,   893,   142, -1164,   562,
   -1164,   901, -1164,   902,   909,   912,   920,   923,   932,   934,
   -1164, -1164,   936,   941,   945, -1164,   142,  1048,   947, -1164,
   -1164,   950,    79, -1164, -1164,   873,   957, -1164, -1164, -1164,
     958, -1164, -1164, -1164,   142,   314,   352,   883,   968,   969,
   -1164,  1020, -1164,   576,   997,   928, -1164, -1164, -1164, -1164,
      -1, -1164, -1164, -1164,   887, -1164, -1164,    13, -1164, -1164,
   -1164, -1164, -1164, -1164, -1164, -1164, -1164, -1164,  1243,  1255,
   -1164, -1164,   562, -1164,   562,  1252, -1164, -1164,   562,  1134,
    1266,  1134,  1297, -1164, -1164,  1101,  1107, -1164, -1164, -1164,
    1030, -1164, -1164,   859, -1164, -1164, -1164,  1437,   598, -1164,
   -1164, -1164,   974,   973, -1164, -1164,  1275, -1164,  1287,  1275,
    1275,  1275, -1164,  1275, -1164,  1275,   575,  1624,  1275,  1008,
    1275, -1164, -1164, -1164,   979,   649, -1164,  1275,  1199, -1164,
     718, -1164,   539, -1164, -1164,   977,   980,   991, -1164,   992,
   -1164, -1164, -1164,   993, -1164,   142, -1164,   995, -1164,   996,
   -1164, -1164, -1164, -1164, -1164,  1000,  1004, -1164, -1164, -1164,
   -1164, -1164, -1164, -1164, -1164, -1164, -1164, -1164, -1164, -1164,
      74,    16,   112, -1164,  1026,   576, -1164, -1164,   163, -1164,
    1009, -1164,  1018, -1164, -1164, -1164, -1164, -1164,  1015, -1164,
    1010,  1306,  1306,  1306,  1306, -1164, -1164, -1164, -1164,  1020,
     142,   997, -1164, -1164, -1164, -1164, -1164, -1164, -1164, -1164,
    1324, -1164,  1326, -1164,  1318,  1322, -1164, -1164,    -3, -1164,
    1319, -1164, -1164,  1005,  1275, -1164, -1164, -1164,  1275,  1275,
    1019,    15,  1914,  1016,  1218, -1164,  1437, -1164, -1164, -1164,
    1649,  1675,  1700,  1730,   600,  1275, -1164, -1164,  1971,  1022,
    1011,  1971,  1325,  1755,  1332,   576, -1164, -1164, -1164, -1164,
   -1164, -1164, -1164, -1164,   142, -1164, -1164, -1164,  1024, -1164,
   -1164, -1164, -1164, -1164, -1164, -1164,   142,   142,    74,   142,
   -1164,  1023,   562, -1164, -1164,  1029,  1031,   142, -1164, -1164,
     142,  1033,   121, -1164,   173, -1164,  1032,  1036,  1037,  1049,
   -1164, -1164, -1164, -1164,   457,   457,  1275,   983,  1275, -1164,
    1034,  2463,   700, -1164, -1164,  1330,   277, -1164,  1971,  1044,
    1052, -1164, -1164, -1164, -1164, -1164,  1275,  1783,  1350,  1237,
    1053, -1164,  1194, -1164,  1055, -1164,  -231, -1164, -1164, -1164,
   -1164, -1164, -1164, -1164, -1164, -1164, -1164, -1164,   142,   502,
   -1164,  1058, -1164,   173,   173,   173,   173,  1395,  1396,  1357,
    1062,  1412,  1930, -1164,   739, -1164,  1275,  1275,   590,  1218,
   -1164,  1808, -1164,  1069,  1067,    11, -1164,  1393, -1164,  1072,
      17,    49,    28,   472, -1164, -1164, -1164, -1164, -1164, -1164,
   -1164, -1164, -1164, -1164, -1164, -1164, -1164, -1164, -1164, -1164,
   -1164,  1071,   598,  1245, -1164,     9,  1450,  1475,  1081,  1082,
    1088,  1091,  1092, -1164, -1164,  1275, -1164,  1275, -1164,  1093,
   -1164, -1164, -1164, -1164, -1164,     1,    74,   142,    74, -1164,
    1103, -1164,   142,   142,   142,  1210,   140,    25, -1164, -1164,
    1104,  1106,  1105,   739,    82, -1164, -1164, -1164,   746, -1164,
   -1164,  1423, -1164, -1164, -1164,    10, -1164, -1164,  1275,  1275,
    1275,  1275, -1164,  1108,  1114, -1164,  2135, -1164,   142,  1109,
   -1164, -1164, -1164, -1164, -1164, -1164, -1164,   142,   142, -1164,
   -1164, -1164, -1164, -1164, -1164, -1164, -1164, -1164,  1833,    88,
      82,   159,  1858,  1883,  1916,  1941,  1275, -1164,  1155,  1112,
     142,    74,   142,   142,   142,  1238,   142,   196,  1214,  1145,
     141,  1180,   142,  1164,  1162,  1191, -1164, -1164,  1129, -1164,
   -1164, -1164, -1164, -1164,  1275, -1164, -1164, -1164,  1130,  1131,
    1142,  1157,  1128,    74, -1164, -1164, -1164, -1164, -1164, -1164,
     142, -1164,   142, -1164, -1164, -1164, -1164, -1164, -1164, -1164,
   -1164, -1164,    74, -1164, -1164, -1164,    74, -1164,    34,   142,
      74, -1164,  1833, -1164, -1164, -1164, -1164, -1164, -1164,     5,
   -1164, -1164, -1164, -1164, -1164, -1164, -1164, -1164, -1164,  1219,
   -1164, -1164, -1164,  1167, -1164
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1164, -1164, -1164,  -156, -1164,  -113,  -235,  -800,  -138,  -651,
   -1164,  -287, -1164, -1164, -1164, -1164, -1164, -1164,   584, -1164,
   -1164, -1164, -1164, -1164, -1164, -1164, -1164, -1164, -1164,   254,
    1156, -1164, -1164, -1164, -1164, -1164, -1164,  -257, -1164, -1164,
   -1164, -1164, -1164, -1164, -1164, -1164, -1164,  1040,  1170,  1289,
   -1164,   -40,  -331, -1164, -1164, -1164, -1164,   545,  -576, -1164,
   -1164, -1164, -1164, -1164, -1164,   -96, -1164,   624,   -97, -1164,
     616, -1163,   489,  -570, -1164,  -480, -1164, -1164, -1164, -1164,
    -131, -1164, -1164, -1164, -1164, -1164, -1164, -1164, -1164, -1164,
   -1164,  -361, -1164, -1164, -1164, -1164, -1164, -1164, -1164, -1164,
   -1164, -1164, -1164, -1164, -1164, -1164, -1164, -1164, -1164, -1164,
   -1164, -1164, -1164, -1164,   801,  1187, -1164, -1164, -1164, -1164,
    -728,   604,   466,  1149,   872,  1196, -1164,   808, -1164, -1164,
    -993, -1164,   261,  -196,   777,   220,  -944,   595, -1091, -1107,
    1354, -1066,   779,   221, -1164, -1164,  -189,   782, -1164, -1164,
   -1164, -1164,   263,   382, -1164, -1164,  -918, -1164,   -90,   484,
     -79, -1164, -1164,   349,   607,   413, -1020, -1164, -1164, -1164,
   -1164, -1164, -1164, -1164, -1164, -1164, -1164, -1164, -1164, -1164,
   -1164, -1164, -1164, -1164, -1164, -1164, -1164,   377, -1164, -1164,
   -1164, -1164, -1164, -1164, -1164,   388, -1164, -1164, -1164,  -599,
   -1164, -1164, -1164, -1164, -1164, -1164, -1164, -1164, -1164, -1164,
   -1164, -1164, -1164, -1164, -1164, -1164, -1164, -1164, -1164, -1164,
   -1164, -1164, -1164,   680, -1164, -1164, -1164, -1164, -1164, -1164,
   -1164, -1164, -1007
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -422
static const yytype_int16 yytable[] =
{
     205,   435,   862,   363,   364,   385,   534,   535,   441,   359,
     942,   565,   866,   905,  1087,  1284,   774,   775,  1257,  1146,
    1072,  -285,   378,  1419,  1285,  1286,  1287,   961,   686,   415,
    -285,  -285,  -285,  -285,  1058,   360,   361,   798,   935,   402,
     555,   434,   583,   403,   360,   361,   360,   361,   557,   382,
     413,  1154,   404,   383,   477,   478,   479,   480,   481,   382,
    1279,  1059,  1215,   383,   381,  1156,   500,     1,   482,   483,
     484,   485,   486,   487,   488,   489,  1130,   400,   490,   909,
     320,  1038,   920,   345,   922,   321,   409,   337,  -284,   382,
     540,   382,   338,   383,   692,   383,  1060,  -284,  -284,  -284,
    -284,  1058,   640,  1285,  1286,  1287,   961,   418,   501,   502,
     503,   504,   971,  1320,   567,    64,   173,   430,   382,   431,
     432,   180,   383,   496,   528,   530,   772,   382,  1059,   773,
     581,   383,   520,   587,   588,   933,   352,   382,   431,   432,
     961,   383,   551,  1357,   641,   126,   501,   502,   503,   504,
    1304,   562,   832,  1072,  1292,   382,   566,   382,   568,   383,
     382,   383,   598,  1060,   383,  1061,  1062,  1063,  1064,  1065,
    1066,  1067,   634,   590,  1285,  1286,  1287,   961,   382,  1293,
     807,   556,   383,   936,  1244,  1068,  1266,   123,  1069,   477,
     478,   479,   480,   481,   611,  1241,   613,   501,   502,   503,
     504,   353,   174,   482,   483,   484,   485,   486,   487,   488,
     489,   382,   666,   490,   131,   383,   558,   346,    65,   693,
     414,   531,   677,   678,   848,   681,   683,   155,   533,  1393,
     708,  1202,  1061,  1062,  1063,  1064,  1065,  1066,  1067,  1140,
    1292,   141,   800,   382,   431,   432,   961,   383,    66,  1282,
    1318,   874,  1068,    67,   844,  1069,    68,   477,   478,   479,
     480,   481,   354,  1244,   799,  1293,   833,    69,   879,   142,
     386,   482,   483,   484,   485,   486,   487,   488,   489,   584,
     585,   490,  1116,  1117,   845,   846,  1072,   875,   150,    70,
    1307,  1327,    71,   777,    72,    73,   778,   822,  1308,  1207,
     591,   592,    74,   387,   352,   707,  1382,  1321,   151,  1208,
    1322,  1303,   409,   152,   409,  1267,   409,   409,  1118,  1096,
    1050,   168,  1052,   379,  1072,   680,   742,   876,  1414,  1415,
      75,   776,   747,    76,  1147,   352,  1188,  1366,  1268,   687,
     756,   757,   758,   759,   760,    77,  1288,  1420,   942,  1258,
    1330,  1289,  -285,  1331,   770,   808,   682,  -285,   416,  1262,
     808,   405,   808,   170,    78,  1072,  1072,   881,   406,   882,
    1271,   384,   324,   819,   954,   327,   169,   823,  1119,   955,
     827,   384,   829,   539,   764,   890,   322,   834,   835,   765,
     172,  1269,  1372,   339,   731,   732,   733,   734,   779,   780,
     781,   782,   783,   784,   785,   786,   787,   788,   789,   790,
     791,   384,  1072,   384,    79,  1031,   355,  1032,   821,  -284,
    1025,   861,   971,  1394,  -284,  1364,  1395,   356,   357,   890,
     113,   114,   836,   870,   811,  1189,   160,   841,   171,   843,
     433,   847,   161,   849,  1173,   175,   852,   853,   854,   384,
     206,   115,   924,  1033,   886,  1034,   887,   209,   866,   384,
     508,   117,   889,  1190,   156,   325,   391,  1127,   392,   393,
     326,   477,   478,   479,   480,   481,   812,   384,   813,   384,
     508,   330,   384,   157,   878,   482,   483,   484,   485,   486,
     487,   488,   489,   162,   158,   490,  1288,   328,   939,   331,
     384,   888,   477,   478,   479,   480,   481,   509,   510,   488,
     489,   163,   516,   490,   336,   901,   482,   483,   484,   485,
     486,   487,   488,   489,   946,   348,   490,   509,   510,   349,
     923,   332,   511,   384,   164,   113,   114,  1176,   512,   127,
     128,   132,   133,   477,   478,   479,   480,   481,   352,   919,
     134,   921,   394,   372,    80,   365,   115,   482,   483,   484,
     485,   486,   487,   488,   489,   433,   366,   490,   135,   341,
     342,   136,   285,   137,   138,   435,   435,   391,   940,   392,
     393,   648,   996,   477,   478,   479,   480,   481,   441,   367,
     343,   368,   949,   165,   360,   361,   287,   482,   483,   484,
     485,   486,   487,   488,   489,   375,   219,   490,   477,   478,
     479,   480,   481,   735,   369,   434,   434,  1058,   513,   360,
     361,   880,   482,   483,   484,   485,   486,   487,   488,   489,
     370,   315,   490,  1099,  1100,  1101,  1102,   371,   513,   220,
     524,   525,   221,   374,  1059,   388,   222,   223,  1039,   376,
     225,   226,   649,   389,  1192,  1046,   227,  1047,   975,   976,
     968,  1049,   547,   548,   792,   740,   210,   741,   983,   743,
     744,   211,   987,   316,   397,   989,   399,  1248,   410,  1060,
     411,   995,   543,   544,   956,   212,   957,   793,   412,   650,
     228,  1272,   139,   794,   419,   229,   420,   974,   795,   796,
    1008,   573,   574,   977,   341,   342,   651,   979,   477,   478,
     479,   480,   481,  1232,  1233,  1234,  1235,   421,  1030,   709,
     710,   213,   482,   483,   484,   485,   486,   487,   488,   489,
    1249,  1250,   490,   893,   894,   890,   360,   361,  1095,   422,
    1273,  1274,  1275,   423,  1276,  1137,  1138,  1139,  1061,  1062,
    1063,  1064,  1065,  1066,  1067,  1277,   896,   897,  1058,   176,
     424,   177,   178,   179,   180,   181,   182,   140,  1068,   929,
     930,  1069,   183,   184,   766,   185,  1225,   186,   491,   143,
     652,   497,  1251,  1197,  1198,  1059,   492,  1252,   493,   176,
     495,   177,   178,   179,   180,   181,   182,   753,   754,   499,
     518,   519,   183,   184,   521,   185,   950,   186,   124,   125,
     522,   129,   130,   526,  1278,   144,   145,   523,   527,   154,
    1060,   529,   536,  1226,  1227,  1228,  1229,   187,   532,  1108,
     537,   538,   541,   188,   542,   545,   546,   951,   714,   715,
     716,   717,   718,   719,   720,   549,   721,   722,   723,   724,
     725,   550,   146,   147,   148,   149,   552,   187,   554,   214,
     890,   559,   553,   188,   560,  1182,   561,   747,   572,   563,
    1080,  1081,  1082,   564,  1083,   569,  1084,  1123,   953,   575,
     577,  1091,   570,   571,  1141,   576,   189,   190,  1093,  1061,
    1062,  1063,  1064,  1065,  1066,  1067,   580,  1115,   582,  1120,
     589,   595,   596,   593,   599,  1128,   117,   317,   594,  1068,
     910,   600,  1069,   597,   215,   610,   189,   190,  1085,   216,
     191,   192,   425,   426,   427,   428,   911,   612,   334,   335,
     609,   614,   618,   615,   217,   193,   616,   118,   194,   619,
    -284,   631,   195,  1166,   119,   120,   121,   617,  1174,   633,
     191,   192,   425,   426,   427,   428,   635,   623,   804,   636,
    1177,  1178,   637,  1180,   638,   193,   639,   621,   194,   622,
     644,  1185,   195,   646,  1186,   647,   624,   625,   684,   685,
     689,   691,   690,   706,   912,  1150,   694,   713,   738,  1151,
    1152,   626,   627,   737,   628,  1158,   176,   746,   177,   178,
     179,   180,   181,   182,   745,  1179,  1167,   750,   751,   183,
     184,   752,   185,   761,   186,   755,   762,   490,   763,   941,
     771,   176,   797,   177,   178,   179,   180,   181,   182,   810,
     817,   814,  1224,   816,   183,   184,   766,   185,   815,   186,
     818,  1205,   477,   478,   479,   480,   481,   820,   824,  1290,
     825,   830,   838,   840,   842,   828,   482,   483,   484,   485,
     486,   487,   488,   489,   187,   831,   490,  1199,   747,  1201,
     188,   695,   696,   697,   698,   699,   700,   701,   702,   703,
    1242,   837,  1263,   196,  1263,   839,   850,  1211,   851,   187,
    1091,   197,   855,   669,   856,   188,   714,   715,   716,   717,
     718,   719,   720,   858,   721,   722,   723,   724,   725,   670,
     859,  1311,   860,   196,   863,   285,  1314,  1315,  1316,   913,
    1319,   197,   864,   189,   190,   867,   208,  1246,  1247,   868,
    1158,   869,  1009,  1290,   218,  1290,   871,   883,   872,   233,
     895,   267,   898,   277,   873,   282,   899,   298,   189,   190,
     900,   902,  1359,  1310,   907,  1312,   927,   191,   192,   903,
     906,  1361,  1362,   925,   671,   914,   926,   928,   934,   672,
     673,   937,   193,   932,   947,   194,   938,   674,  1091,   195,
     915,   948,   191,   192,  1375,  1010,  1377,  1378,  1379,   958,
    1381,  1383,   959,   960,   964,   965,  1397,   193,   916,   967,
     194,   969,   971,   972,   195,   675,   978,   980,   981,  1328,
     982,   984,   917,   918,   985,  1027,   986,   988,   990,  1332,
    1333,  1334,  1335,   601,  1410,  1035,  1411,   991,  1376,   992,
     993,   176,   994,   177,   178,   179,   180,   181,   182,   676,
     997,   998,  1416,  1417,   183,   184,  1044,   185,   999,   186,
     176,  1000,   177,   178,   179,   180,   181,   182,  1045,  1001,
    1408,  1011,  1002,   183,   184,  1214,   185,  1048,   186,  1051,
     266,  1003,   273,  1004,   281,  1005,   294,   602,   303,  1412,
    1006,   314,   319,  1413,  1007,  1402,  1023,  1418,   176,  1024,
     177,   178,   179,   180,   181,   182,  1028,  1029,  1040,   187,
    1053,   183,   184,  1054,   185,   188,   186,  1036,  1037,  1055,
     603,  1077,  1012,  1076,  1079,  1094,  1103,  1122,   187,   604,
     196,  -421,  1092,  1104,   188,  1130,  1135,  1142,   197,  1143,
    1105,  1106,  1107,  1144,  1109,  1110,  1013,  1145,  1014,  1111,
    1170,  1148,  1149,  1112,  1015,   196,  1016,  1172,  1129,  1134,
    1017,  1018,  1206,   197,  1169,  1157,   187,  1213,   189,   190,
    1168,  1153,   188,  1175,  1181,   477,   478,   479,   480,   481,
    1183,  1193,  1184,  1203,  1187,  1194,  1195,   189,   190,   482,
     483,   484,   485,   486,   487,   488,   489,  1209,  1196,   490,
    1019,  1210,   191,   192,  1218,  1216,  1217,  1231,  1236,  1237,
    1239,   605,   606,   607,   608,  1256,  1255,   193,  1259,  1281,
     194,   191,   192,  1260,   195,   189,   190,  1283,  1298,  1299,
     477,   478,   479,   480,   481,  1300,   193,  1317,  1301,   194,
    1329,  1302,  1305,   195,   482,   483,   484,   485,   486,   487,
     488,   489,  1313,  1323,   490,  1324,  1373,  1325,  1360,   191,
     192,  1336,  1337,  1374,  1392,  1380,  1396,  1398,   477,   478,
     479,   480,   481,  1399,   193,  1400,  1407,   194,  1401,  1403,
    1404,   195,   482,   483,   484,   485,   486,   487,   488,   489,
     632,  1405,   490,   477,   478,   479,   480,   481,  1384,  1385,
    1386,  1387,  1388,  1389,  1390,  1391,  1406,   482,   483,   484,
     485,   486,   487,   488,   489,  1422,  1424,   490,   477,   478,
     479,   480,   481,  1043,  1056,   517,  1098,  1133,  1042,  -422,
    -422,  -422,   482,   483,   484,   485,   486,   487,   488,   489,
     645,   904,   490,  -422,  -422,  -422,  -422,   486,   487,   488,
     489,  1057,  1161,   490,  1326,   729,   668,   944,   962,  1365,
     429,   963,  1367,  1078,  1089,   196,  1155,  -416,  1253,   966,
    1200,  1222,     0,   197,  1219,  1041,     0,     0,     0,   477,
     478,   479,   480,   481,   196,     0,     0,     0,     0,     0,
       0,     0,   197,   482,   483,   484,   485,   486,   487,   488,
     489,     0,     0,   490,   714,   715,   716,   717,   718,   719,
     720,     0,   721,   722,   723,   724,   725,   477,   478,   479,
     480,   481,   196,     0,     0,     0,     0,     0,     0,     0,
     197,   482,   483,   484,   485,   486,   487,   488,   489,     0,
       0,   490,   477,   478,   479,   480,   481,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   482,   483,   484,   485,
     486,   487,   488,   489,     0,     0,   490,   477,   478,   479,
     480,   481,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   482,   483,   484,   485,   486,   487,   488,   489,     0,
       0,   490,     0,   477,   478,   479,   480,   481,     0,     0,
       0,     0,     0,     0,     0,     0,  1238,   482,   483,   484,
     485,   486,   487,   488,   489,     0,     0,   490,   477,   478,
     479,   480,   481,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   482,   483,   484,   485,   486,   487,   488,   489,
       0,     0,   490,     0,     0,     0,     0,     0,   477,   478,
     479,   480,   481,     0,     0,     0,     0,     0,     0,     0,
       0,  1240,   482,   483,   484,   485,   486,   487,   488,   489,
       0,     0,   490,   477,   478,   479,   480,   481,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   482,   483,   484,
     485,   486,   487,   488,   489,     0,     0,   490,     0,  1296,
       0,   477,   478,   479,   480,   481,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   482,   483,   484,   485,   486,
     487,   488,   489,     0,  1297,   490,   477,   478,   479,   480,
     481,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     482,   483,   484,   485,   486,   487,   488,   489,   931,     0,
     490,   477,   478,   479,   480,   481,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   482,   483,   484,   485,   486,
     487,   488,   489,     0,     0,   490,   477,   478,   479,   480,
     481,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     482,   483,   484,   485,   486,   487,   488,   489,     0,     0,
     490,   477,   478,   479,   480,   481,     0,     0,     0,   945,
       0,     0,     0,     0,     0,   482,   483,   484,   485,   486,
     487,   488,   489,     0,     0,   490,     0,     0,     0,   444,
       0,     0,     0,     0,   477,   478,   479,   480,   481,     0,
       0,     0,     0,     0,     0,   444,     0,   952,   482,   483,
     484,   485,   486,   487,   488,   489,     0,     0,   490,   477,
     478,   479,   480,   481,     0,     0,     0,     0,     0,     0,
       0,     0,  1086,   482,   483,   484,   485,   486,   487,   488,
     489,     0,     0,   490,     0,     0,     0,     0,     0,   477,
     478,   479,   480,   481,     0,   445,   446,  1162,     0,   447,
     448,   219,     0,   482,   483,   484,   485,   486,   487,   488,
     489,   445,   446,   490,     0,   447,   448,     0,     0,     0,
       0,   283,     0,  1163,     0,   449,     0,     0,     0,     0,
       0,   219,     0,     0,   220,     0,     0,   221,     0,     0,
       0,   222,   223,     0,   284,   225,   226,     0,  1164,     0,
     299,   227,     0,     0,     0,     0,     0,     0,   450,     0,
     285,     0,     0,     0,   220,     0,     0,   221,     0,     0,
       0,   222,   223,     0,   450,   225,   226,     0,  1165,     0,
       0,   227,     0,   286,   287,   228,     0,     0,     0,   219,
     229,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1171,   451,   452,     0,   453,   454,   455,
     456,   457,   306,   307,   308,   228,   309,   310,     0,     0,
     229,     0,   220,     0,     0,   221,     0,     0,   300,   222,
     223,  1212,     0,   225,   226,     0,     0,     0,     0,   227,
       0,     0,     0,     0,     0,   458,   459,   460,   461,   462,
     463,   464,   465,   466,     0,     0,  1254,     0,     0,     0,
       0,   458,   459,   460,   461,   462,   463,   464,   465,   466,
       0,   467,   468,   228,     0,     0,     0,   219,   229,   219,
       0,  1363,   234,   469,   470,   471,   472,   467,   468,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   469,
     470,   471,   472,     0,     0,  1338,  1368,     0,   219,     0,
     220,     0,   220,   221,     0,   221,     0,   222,   223,   222,
     223,   225,   226,   225,   226,     0,     0,   227,     0,   227,
       0,  1369,     0,   235,     0,     0,   236,     0,   237,   301,
       0,   220,     0,   288,   221,   285,     0,     0,   222,   223,
       0,   224,   225,   226,   473,   474,     0,     0,   227,     0,
       0,   228,     0,   228,  1370,     0,   229,   219,   229,   287,
     473,   474,     0,     0,   238,     0,     0,     0,   289,   290,
     291,     0,     0,     0,   239,     0,     0,   292,     0,  1371,
    1339,     0,   228,     0,     0,     0,     0,   229,     0,     0,
     220,     0,   293,   221,     0,     0,     0,   222,   223,     0,
       0,   225,   226,     0,     0,     0,     0,   227,     0,     0,
     240,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   302,     0,     0,     0,   241,   242,     0,   243,
     244,     0,   245,   246,   247,     0,   248,     0,     0,   249,
     250,   228,   251,     0,     0,     0,   229,     0,     0,     0,
       0,     0,     0,   654,  1340,     0,   252,   253,     0,     0,
       0,   254,     0,   255,   256,     0,   257,     0,   360,   361,
       0,   258,     0,     0,     0,   259,   260,     0,   261,   262,
     311,   263,   264,     0,     0,     0,   268,     0,     0,     0,
     655,   269,     0,   270,     0,     0,     0,     0,     0,  1341,
       0,  1342,     0,  1343,  1344,  1345,  1346,  1347,  1348,     0,
       0,     0,     0,     0,  1349,     0,     0,     0,  1350,  1351,
       0,     0,  1352,     0,   656,     4,     0,  1353,   271,   657,
       0,     0,     0,     0,     0,  1354,   658,   659,     0,     0,
       0,     0,     0,  1355,     0,     0,     5,     6,     0,   660,
       0,     0,     0,     0,     0,     0,     0,     0,   661,   662,
     663,   664,     0,   665,     0,     0,     0,     0,   265,     0,
     272,   477,   478,   479,   480,   481,     0,  1356,     0,     0,
       7,     8,     0,     0,     0,   482,   483,   484,   485,   486,
     487,   488,   489,     0,     0,   490,     0,     0,     0,   230,
       0,     9,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    10,     0,     0,    11,     0,    12,     0,     0,    13,
     477,   478,   479,     0,    14,    15,    16,     0,     0,   278,
     279,    17,    18,     0,   482,   483,   484,   485,   486,   487,
     488,   489,     0,     0,   490,     0,     0,     0,   513,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   280,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1204
};

#define yypact_value_is_default(yystate) \
  ((yystate) == (-1164))

#define yytable_value_is_error(yytable_value) \
  ((yytable_value) == (-422))

static const yytype_int16 yycheck[] =
{
      79,   197,   578,   141,   142,   161,   241,   242,   197,   140,
     738,   268,   582,   664,   958,     6,    26,    27,     7,    22,
     938,     6,    40,    18,    15,    16,    17,    18,    29,    15,
      15,    16,    17,    18,    19,    18,    19,   115,    19,    15,
      74,   197,    88,    19,    18,    19,    18,    19,    83,    15,
      27,  1071,    28,    19,     8,     9,    10,    11,    12,    15,
    1223,    46,  1169,    19,   160,  1072,   222,     4,    22,    23,
      24,    25,    26,    27,    28,    29,   307,   174,    32,   678,
      35,   881,   681,     3,   683,    40,   176,    35,     6,    15,
     246,    15,    40,    19,    18,    19,    81,    15,    16,    17,
      18,    19,    89,    15,    16,    17,    18,   186,    34,    35,
      36,    37,   343,    88,   270,     0,    20,   196,    15,    16,
      17,    18,    19,   219,   237,   138,   343,    15,    46,   346,
     286,    19,   229,   289,   290,   711,    19,    15,    16,    17,
      18,    19,   255,  1306,   131,   115,    34,    35,    36,    37,
    1257,   264,    98,  1071,  1245,    15,   269,    15,   271,    19,
      15,    19,   300,    81,    19,   150,   151,   152,   153,   154,
     155,   156,   328,   201,    15,    16,    17,    18,    15,  1245,
      35,   215,    19,   164,  1204,   170,   137,     3,   173,     8,
       9,    10,    11,    12,   307,  1202,   309,    34,    35,    36,
      37,    84,   106,    22,    23,    24,    25,    26,    27,    28,
      29,    15,   350,    32,     3,    19,   251,   137,     3,   375,
     197,   234,   353,   354,   555,   356,   357,    19,   202,    88,
     386,  1149,   150,   151,   152,   153,   154,   155,   156,  1039,
    1331,   115,   499,    15,    16,    17,    18,    19,    33,  1242,
     110,    78,   170,    38,   212,   173,    41,     8,     9,    10,
      11,    12,   145,  1283,   342,  1331,   212,    52,   599,   115,
      20,    22,    23,    24,    25,    26,    27,    28,    29,   325,
     326,    32,   266,   267,   242,   243,  1204,   114,    15,    74,
     289,  1284,    77,   343,    79,    80,   346,   532,   297,    22,
     328,   329,    87,    53,    19,   384,   110,   282,    35,    32,
     285,  1255,   402,    40,   404,   266,   406,   407,   302,   970,
     919,    19,   921,   341,  1242,    40,   405,   154,   294,   295,
     115,   341,   411,   118,   337,    19,   215,  1330,   289,   340,
     419,   420,   421,   422,   423,   130,   337,   342,  1076,   338,
     340,   342,   337,   343,   433,   511,    40,   342,   344,   342,
     516,   337,   518,    19,   149,  1283,  1284,   602,   344,   604,
     342,   337,   118,   529,   338,   121,    78,   533,   266,   343,
     536,   337,   538,   339,   338,   620,   341,   543,   544,   343,
     119,   342,  1336,   341,   120,   121,   122,   123,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   337,  1330,   337,   199,   101,   299,   103,   531,   337,
     341,   577,   343,   282,   342,   337,   285,   310,   311,   664,
      19,    20,   545,   589,   513,   314,   106,   550,    74,   552,
     337,   554,   112,   556,  1095,    19,   559,   560,   561,   337,
      19,    40,   687,   101,   610,   103,   612,   341,  1028,   337,
      40,    20,   618,   342,    20,     3,    15,   304,    17,    18,
       3,     8,     9,    10,    11,    12,   516,   337,   518,   337,
      40,     3,   337,    39,   597,    22,    23,    24,    25,    26,
      27,    28,    29,    38,    50,    32,   337,    61,   733,     3,
     337,   614,     8,     9,    10,    11,    12,    87,    88,    28,
      29,    56,    92,    32,     3,   653,    22,    23,    24,    25,
      26,    27,    28,    29,   343,     3,    32,    87,    88,     3,
     686,    74,    92,   337,    79,    19,    20,  1113,    98,   128,
     129,   106,   107,     8,     9,    10,    11,    12,    19,   680,
     115,   682,   101,    15,   339,     3,    40,    22,    23,    24,
      25,    26,    27,    28,    29,   337,     3,    32,   133,    19,
      20,   136,   100,   138,   139,   771,   772,    15,   734,    17,
      18,     3,   839,     8,     9,    10,    11,    12,   777,     3,
      40,     3,   343,   138,    18,    19,   124,    22,    23,    24,
      25,    26,    27,    28,    29,    22,    41,    32,     8,     9,
      10,    11,    12,   339,     3,   771,   772,    19,   198,    18,
      19,    20,    22,    23,    24,    25,    26,    27,    28,    29,
       3,    66,    32,    94,    95,    96,    97,     3,   198,    74,
     218,   219,    77,     3,    46,   339,    81,    82,   883,    57,
      85,    86,    74,   126,  1134,   912,    91,   914,   814,   815,
     798,   918,   232,   233,   159,   402,    64,   404,   824,   406,
     407,    69,   828,   108,    19,   831,   339,    87,    29,    81,
     337,   837,   222,   223,   763,    83,   765,   182,   197,   111,
     125,   219,   257,   188,   337,   130,   337,   810,   193,   194,
     856,   315,   316,   816,    19,    20,   128,   820,     8,     9,
      10,    11,    12,  1193,  1194,  1195,  1196,   337,   874,    54,
      55,   119,    22,    23,    24,    25,    26,    27,    28,    29,
     140,   141,    32,   342,   343,   970,    18,    19,    20,   337,
     268,   269,   270,   337,   272,  1032,  1033,  1034,   150,   151,
     152,   153,   154,   155,   156,   283,   342,   343,    19,    13,
     337,    15,    16,    17,    18,    19,    20,   332,   170,   342,
     343,   173,    26,    27,    28,    29,   274,    31,   101,    70,
     202,    19,   192,  1144,  1145,    46,   341,   197,   341,    13,
     341,    15,    16,    17,    18,    19,    20,   415,   416,    78,
      92,    20,    26,    27,   339,    29,   343,    31,     7,     8,
     339,    10,    11,   220,   342,   106,   107,   341,    20,    18,
      81,    92,    67,   321,   322,   323,   324,    81,   122,   985,
     205,    67,   203,    87,   211,   215,   217,   343,   157,   158,
     159,   160,   161,   162,   163,   232,   165,   166,   167,   168,
     169,   236,   143,   144,   145,   146,   239,    81,   246,   257,
    1095,   215,   241,    87,   254,  1122,   252,   946,    74,   339,
     949,   950,   951,   341,   953,   339,   955,  1015,   343,   339,
      67,   960,   341,   341,  1040,   341,   140,   141,   967,   150,
     151,   152,   153,   154,   155,   156,    20,  1010,   341,  1012,
      67,   341,   341,   339,    74,  1018,    20,   342,   339,   170,
       3,   339,   173,   291,   312,    74,   140,   141,   343,   317,
     174,   175,   176,   177,   178,   179,    19,    67,   127,   128,
     339,    70,    67,   339,   332,   189,   339,    51,   192,    20,
     342,     3,   196,   343,    58,    59,    60,   339,  1104,     3,
     174,   175,   176,   177,   178,   179,     3,    70,    19,    19,
    1116,  1117,     3,  1119,     3,   189,     3,   339,   192,   339,
       3,  1127,   196,     3,  1130,     3,    89,    90,     3,     3,
     116,     3,   116,   339,    77,  1064,    20,   339,   337,  1068,
    1069,   104,   105,   339,   107,  1074,    13,    15,    15,    16,
      17,    18,    19,    20,    14,  1118,  1085,    26,   197,    26,
      27,    27,    29,    19,    31,    29,    15,    32,   343,   338,
       7,    13,    19,    15,    16,    17,    18,    19,    20,    99,
     339,    67,  1188,    46,    26,    27,    28,    29,    67,    31,
     339,   341,     8,     9,    10,    11,    12,   244,   202,  1245,
      30,   339,   339,   339,   339,    67,    22,    23,    24,    25,
      26,    27,    28,    29,    81,    67,    32,  1146,  1147,  1148,
      87,    41,    42,    43,    44,    45,    46,    47,    48,    49,
     341,    67,  1220,   337,  1222,    78,   339,  1166,   339,    81,
    1169,   345,   339,     3,    92,    87,   157,   158,   159,   160,
     161,   162,   163,    19,   165,   166,   167,   168,   169,    19,
     339,  1267,   339,   337,   339,   100,  1272,  1273,  1274,   212,
    1276,   345,   339,   140,   141,   339,    86,  1206,  1207,   339,
    1209,   339,    84,  1329,    94,  1331,   339,   209,   339,    99,
       3,   101,     3,   103,   339,   105,    19,   107,   140,   141,
      15,    19,  1308,  1266,    20,  1268,   339,   174,   175,    19,
      19,  1317,  1318,    15,    74,   258,    15,   339,   339,    79,
      80,   339,   189,    20,   338,   192,   341,    87,  1257,   196,
     273,    27,   174,   175,  1340,   137,  1342,  1343,  1344,     7,
    1346,  1347,   343,   343,    15,    18,  1352,   189,   291,   337,
     192,    27,   343,    93,   196,   115,   339,   339,   339,  1288,
     339,    19,   305,   306,   202,   342,   339,   339,   339,  1298,
    1299,  1300,  1301,   155,  1380,   342,  1382,   339,  1341,   339,
     339,    13,   339,    15,    16,    17,    18,    19,    20,   149,
     339,   339,  1398,  1399,    26,    27,     3,    29,   339,    31,
      13,   339,    15,    16,    17,    18,    19,    20,     3,   339,
    1373,   213,   339,    26,    27,    28,    29,    15,    31,     3,
     100,   339,   102,   339,   104,   339,   106,   209,   108,  1392,
     339,   111,   112,  1396,   339,  1364,   339,  1400,    13,   339,
      15,    16,    17,    18,    19,    20,   339,   339,   301,    81,
       3,    26,    27,   202,    29,    87,    31,   339,   339,   202,
     242,   338,   264,   339,    27,   116,   339,   291,    81,   251,
     337,   338,   343,   343,    87,   307,    20,     3,   345,     3,
     339,   339,   339,    15,   339,   339,   288,    15,   290,   339,
      15,    22,   337,   339,   296,   337,   298,    15,   339,   339,
     302,   303,    22,   345,   343,   339,    81,     7,   140,   141,
     338,   342,    87,   339,   341,     8,     9,    10,    11,    12,
     341,   339,   341,   339,   341,   339,   339,   140,   141,    22,
      23,    24,    25,    26,    27,    28,    29,   343,   339,    32,
     342,   339,   174,   175,   339,   342,   202,   339,     3,     3,
     338,   333,   334,   335,   336,   338,   337,   189,    15,   338,
     192,   174,   175,   341,   196,   140,   141,   172,   337,   337,
       8,     9,    10,    11,    12,   337,   189,   217,   337,   192,
       7,   339,   339,   196,    22,    23,    24,    25,    26,    27,
      28,    29,   339,   339,    32,   339,   291,   342,   339,   174,
     175,   343,   338,   341,   309,   217,   276,   293,     8,     9,
      10,    11,    12,   301,   189,   274,   338,   192,   339,   339,
     339,   196,    22,    23,    24,    25,    26,    27,    28,    29,
     324,   339,    32,     8,     9,    10,    11,    12,   274,   275,
     276,   277,   278,   279,   280,   281,   339,    22,    23,    24,
      25,    26,    27,    28,    29,   286,   339,    32,     8,     9,
      10,    11,    12,   897,   930,   226,   971,  1028,   894,     8,
       9,    10,    22,    23,    24,    25,    26,    27,    28,    29,
     343,   659,    32,    22,    23,    24,    25,    26,    27,    28,
      29,   937,  1076,    32,  1283,   396,   350,   739,   771,  1329,
     196,   772,  1331,   946,   959,   337,  1072,   339,  1209,   777,
    1147,  1184,    -1,   345,  1176,   885,    -1,    -1,    -1,     8,
       9,    10,    11,    12,   337,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   345,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    -1,    32,   157,   158,   159,   160,   161,   162,
     163,    -1,   165,   166,   167,   168,   169,     8,     9,    10,
      11,    12,   337,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     345,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      -1,    32,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    -1,    32,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      -1,    32,    -1,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   339,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    -1,    32,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    -1,    32,    -1,    -1,    -1,    -1,    -1,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   339,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    -1,    32,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    -1,    32,    -1,   339,
      -1,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,   339,    32,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,   338,    -1,
      32,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    -1,    32,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    -1,
      32,     8,     9,    10,    11,    12,    -1,    -1,    -1,   338,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    -1,    32,    -1,    -1,    -1,     5,
      -1,    -1,    -1,    -1,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,     5,    -1,   338,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    -1,    32,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   338,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    -1,    32,    -1,    -1,    -1,    -1,    -1,     8,
       9,    10,    11,    12,    -1,    71,    72,   338,    -1,    75,
      76,    41,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    71,    72,    32,    -1,    75,    76,    -1,    -1,    -1,
      -1,    61,    -1,   338,    -1,   101,    -1,    -1,    -1,    -1,
      -1,    41,    -1,    -1,    74,    -1,    -1,    77,    -1,    -1,
      -1,    81,    82,    -1,    84,    85,    86,    -1,   338,    -1,
      60,    91,    -1,    -1,    -1,    -1,    -1,    -1,   134,    -1,
     100,    -1,    -1,    -1,    74,    -1,    -1,    77,    -1,    -1,
      -1,    81,    82,    -1,   134,    85,    86,    -1,   338,    -1,
      -1,    91,    -1,   123,   124,   125,    -1,    -1,    -1,    41,
     130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   338,   180,   181,    -1,   183,   184,   185,
     186,   187,    64,    65,    66,   125,    68,    69,    -1,    -1,
     130,    -1,    74,    -1,    -1,    77,    -1,    -1,   138,    81,
      82,   338,    -1,    85,    86,    -1,    -1,    -1,    -1,    91,
      -1,    -1,    -1,    -1,    -1,   221,   222,   223,   224,   225,
     226,   227,   228,   229,    -1,    -1,   338,    -1,    -1,    -1,
      -1,   221,   222,   223,   224,   225,   226,   227,   228,   229,
      -1,   247,   248,   125,    -1,    -1,    -1,    41,   130,    41,
      -1,   338,    46,   259,   260,   261,   262,   247,   248,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   259,
     260,   261,   262,    -1,    -1,    60,   338,    -1,    41,    -1,
      74,    -1,    74,    77,    -1,    77,    -1,    81,    82,    81,
      82,    85,    86,    85,    86,    -1,    -1,    91,    -1,    91,
      -1,   338,    -1,    97,    -1,    -1,   100,    -1,   102,   249,
      -1,    74,    -1,   283,    77,   100,    -1,    -1,    81,    82,
      -1,    84,    85,    86,   330,   331,    -1,    -1,    91,    -1,
      -1,   125,    -1,   125,   338,    -1,   130,    41,   130,   124,
     330,   331,    -1,    -1,   138,    -1,    -1,    -1,   318,   319,
     320,    -1,    -1,    -1,   148,    -1,    -1,   327,    -1,   338,
     145,    -1,   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,
      74,    -1,   342,    77,    -1,    -1,    -1,    81,    82,    -1,
      -1,    85,    86,    -1,    -1,    -1,    -1,    91,    -1,    -1,
     184,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   342,    -1,    -1,    -1,   200,   201,    -1,   203,
     204,    -1,   206,   207,   208,    -1,   210,    -1,    -1,   213,
     214,   125,   216,    -1,    -1,    -1,   130,    -1,    -1,    -1,
      -1,    -1,    -1,     3,   219,    -1,   230,   231,    -1,    -1,
      -1,   235,    -1,   237,   238,    -1,   240,    -1,    18,    19,
      -1,   245,    -1,    -1,    -1,   249,   250,    -1,   252,   253,
     342,   255,   256,    -1,    -1,    -1,   258,    -1,    -1,    -1,
      40,   263,    -1,   265,    -1,    -1,    -1,    -1,    -1,   264,
      -1,   266,    -1,   268,   269,   270,   271,   272,   273,    -1,
      -1,    -1,    -1,    -1,   279,    -1,    -1,    -1,   283,   284,
      -1,    -1,   287,    -1,    74,    41,    -1,   292,   300,    79,
      -1,    -1,    -1,    -1,    -1,   300,    86,    87,    -1,    -1,
      -1,    -1,    -1,   308,    -1,    -1,    62,    63,    -1,    99,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   108,   109,
     110,   111,    -1,   113,    -1,    -1,    -1,    -1,   342,    -1,
     342,     8,     9,    10,    11,    12,    -1,   342,    -1,    -1,
      96,    97,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    -1,    32,    -1,    -1,    -1,   342,
      -1,   117,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   127,    -1,    -1,   130,    -1,   132,    -1,    -1,   135,
       8,     9,    10,    -1,   140,   141,   142,    -1,    -1,   313,
     314,   147,   148,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    32,    -1,    -1,    -1,   198,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   342,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   171
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     4,   348,   349,    41,    62,    63,    96,    97,   117,
     127,   130,   132,   135,   140,   141,   142,   147,   148,   370,
     371,   372,   373,   374,   375,   423,   424,   425,   426,   428,
     429,   430,   433,   436,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   547,   548,   549,   550,   551,   552,
     553,   554,   573,   575,     0,     3,    33,    38,    41,    52,
      74,    77,    79,    80,    87,   115,   118,   130,   149,   199,
     339,   351,   360,   366,   369,   378,   380,   383,   385,   389,
     390,   392,   393,   400,   408,   409,   463,   465,   475,   514,
     515,   516,   517,   556,   557,   558,   559,   567,   568,   574,
     576,   577,   578,    19,    20,    40,   461,    20,    51,    58,
      59,    60,   376,     3,   461,   461,   115,   128,   129,   461,
     461,     3,   106,   107,   115,   133,   136,   138,   139,   257,
     332,   115,   115,    70,   106,   107,   143,   144,   145,   146,
      15,    35,    40,   450,   461,    19,    20,    39,    50,   362,
     106,   112,    38,    56,    79,   138,   367,   368,    19,    78,
      19,    74,   119,    20,   106,    19,    13,    15,    16,    17,
      18,    19,    20,    26,    27,    29,    31,    81,    87,   140,
     141,   174,   175,   189,   192,   196,   337,   345,   480,   493,
     498,   501,   502,   503,   505,   507,    19,   394,   394,   341,
      64,    69,    83,   119,   257,   312,   317,   332,   394,    41,
      74,    77,    81,    82,    84,    85,    86,    91,   125,   130,
     342,   395,   411,   394,    46,    97,   100,   102,   138,   148,
     184,   200,   201,   203,   204,   206,   207,   208,   210,   213,
     214,   216,   230,   231,   235,   237,   238,   240,   245,   249,
     250,   252,   253,   255,   256,   342,   395,   394,   258,   263,
     265,   300,   342,   395,   518,   519,   520,   394,   313,   314,
     342,   395,   394,    61,    84,   100,   123,   124,   283,   318,
     319,   320,   327,   342,   395,   418,   420,   421,   394,    60,
     138,   249,   342,   395,   569,   572,    64,    65,    66,    68,
      69,   342,   379,   382,   395,    66,   108,   342,   381,   395,
      35,    40,   341,   412,   376,     3,     3,   376,    61,   377,
       3,     3,    74,   438,   461,   461,     3,    35,    40,   341,
     415,    19,    20,    40,   462,     3,   137,   434,     3,     3,
     431,   437,    19,    84,   145,   299,   310,   311,   427,   427,
      18,    19,   353,   355,   355,     3,     3,     3,     3,     3,
       3,     3,    15,   451,     3,    22,    57,   361,    40,   341,
     363,   412,    15,    19,   337,   350,    20,    53,   339,   126,
     388,    15,    17,    18,   101,   384,   464,    19,   386,   339,
     415,   476,    15,    19,    28,   337,   344,   497,   499,   505,
      29,   337,   197,    27,   197,    15,   344,   500,   507,   337,
     337,   337,   337,   337,   337,   176,   177,   178,   179,   487,
     507,    16,    17,   337,   350,   480,   481,   485,   488,   489,
     491,   493,   494,   495,     5,    71,    72,    75,    76,   101,
     134,   180,   181,   183,   184,   185,   186,   187,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   247,   248,   259,
     260,   261,   262,   330,   331,   506,   579,     8,     9,    10,
      11,    12,    22,    23,    24,    25,    26,    27,    28,    29,
      32,   101,   341,   341,   391,   341,   412,    19,   399,    78,
     350,    34,    35,    36,    37,   350,   352,   410,    40,    87,
      88,    92,    98,   198,   396,   472,    92,   396,    92,    20,
     415,   339,   339,   341,   218,   219,   220,    20,   352,    92,
     138,   234,   122,   202,   353,   353,    67,   205,    67,   339,
     350,   203,   211,   222,   223,   215,   217,   232,   233,   232,
     236,   352,   239,   241,   246,    74,   215,    83,   251,   215,
     254,   252,   352,   339,   341,   384,   352,   350,   352,   339,
     341,   341,    74,   315,   316,   339,   341,    67,   565,   566,
      20,   350,   341,    88,   325,   326,   560,   350,   350,    67,
     201,   328,   329,   339,   339,   341,   341,   291,   355,    74,
     339,   155,   209,   242,   251,   333,   334,   335,   336,   339,
      74,   352,    67,   352,    70,   339,   339,   339,    67,    20,
     359,   339,   339,    70,    89,    90,   104,   105,   107,   413,
     414,     3,   377,     3,   350,     3,    19,     3,     3,     3,
      89,   131,   416,   417,     3,   462,     3,     3,     3,    74,
     111,   128,   202,   435,     3,    40,    74,    79,    86,    87,
      99,   108,   109,   110,   111,   113,   355,   432,   472,     3,
      19,    74,    79,    80,    87,   115,   149,   427,   427,   555,
      40,   427,    40,   427,     3,     3,    29,   340,   357,   116,
     116,     3,    18,   350,    20,    41,    42,    43,    44,    45,
      46,    47,    48,    49,   364,   365,   339,   507,   350,    54,
      55,   406,   407,   339,   157,   158,   159,   160,   161,   162,
     163,   165,   166,   167,   168,   169,   466,   467,   468,   470,
     474,   120,   121,   122,   123,   339,   387,   339,   337,   473,
     499,   499,   507,   499,   499,    14,    15,   507,   511,   512,
      26,   197,    27,   500,   500,    29,   507,   507,   507,   507,
     507,    19,    15,   343,   338,   343,    28,   483,   484,   487,
     507,     7,   343,   346,    26,    27,   341,   343,   346,   507,
     507,   507,   507,   507,   507,   507,   507,   507,   507,   507,
     507,   507,   159,   182,   188,   193,   194,    19,   115,   342,
     384,   401,   404,   405,    19,   470,   471,    35,   350,   398,
      99,   507,   398,   398,    67,    67,    46,   339,   339,   350,
     244,   352,   353,   350,   202,    30,   354,   350,    67,   350,
     339,    67,    98,   212,   350,   350,   352,    67,   339,    78,
     339,   352,   339,   352,   212,   242,   243,   352,   399,   352,
     339,   339,   352,   352,   352,   339,    92,   521,    19,   339,
     339,   350,   405,   339,   339,   419,   420,   339,   339,   339,
     350,   339,   339,   339,    78,   114,   154,   422,   352,   399,
      20,   353,   353,   209,   570,   571,   350,   350,   352,   350,
     353,   355,   356,   342,   343,     3,   342,   343,     3,    19,
      15,   355,    19,    19,   471,   356,    19,    20,   546,   546,
       3,    19,    77,   212,   258,   273,   291,   305,   306,   427,
     546,   427,   546,   350,   353,    15,    15,   339,   339,   342,
     343,   338,    20,   405,   339,    19,   164,   339,   341,   353,
     350,   338,   467,   469,   474,   338,   343,   338,    27,   343,
     343,   343,   338,   343,   338,   343,   507,   507,     7,   343,
     343,    18,   481,   489,    15,    18,   494,   337,   355,    27,
     403,   343,    93,   397,   352,   350,   350,   352,   339,   352,
     339,   339,   339,   350,    19,   202,   339,   350,   339,   350,
     339,   339,   339,   339,   339,   350,   384,   339,   339,   339,
     339,   339,   339,   339,   339,   339,   339,   339,   350,    84,
     137,   213,   264,   288,   290,   296,   298,   302,   303,   342,
     522,   529,   532,   339,   339,   341,   564,   342,   339,   339,
     350,   101,   103,   101,   103,   342,   339,   339,   354,   353,
     301,   570,   414,   417,     3,     3,   384,   384,    15,   384,
     546,     3,   546,     3,   202,   202,   365,   468,    19,    46,
      81,   150,   151,   152,   153,   154,   155,   156,   170,   173,
     477,   478,   503,   504,   508,   513,   339,   338,   511,    27,
     507,   507,   507,   507,   507,   343,   338,   483,   507,   484,
     486,   507,   343,   507,   116,    20,   356,   402,   404,    94,
      95,    96,    97,   339,   343,   339,   339,   339,   350,   339,
     339,   339,   339,   541,   545,   352,   266,   267,   302,   266,
     352,   523,   291,   355,   525,   526,   524,   304,   352,   339,
     307,   542,   563,   419,   339,    20,   358,   358,   358,   358,
     354,   350,     3,     3,    15,    15,    22,   337,    22,   337,
     507,   507,   507,   342,   513,   506,   579,   339,   507,   509,
     510,   469,   338,   338,   338,   338,   343,   507,   338,   343,
      15,   338,    15,   356,   350,   339,   405,   350,   350,   352,
     350,   341,   384,   341,   341,   350,   350,   341,   215,   314,
     342,   562,   422,   339,   339,   339,   339,   438,   438,   507,
     512,   507,   503,   339,   171,   341,    22,    22,    32,   343,
     339,   507,   338,     7,    28,   486,   342,   202,   339,   542,
     534,   527,   534,   530,   350,   274,   321,   322,   323,   324,
     561,   339,   422,   422,   422,   422,     3,     3,   339,   338,
     339,   579,   341,   479,   513,   496,   507,   507,    87,   140,
     141,   192,   197,   510,   338,   337,   338,     7,   338,    15,
     341,   544,   342,   355,   535,   536,   137,   266,   289,   342,
     528,   342,   219,   268,   269,   270,   272,   283,   342,   418,
     531,   338,   477,   172,     6,    15,    16,    17,   337,   342,
     480,   482,   485,   488,   490,   492,   339,   339,   337,   337,
     337,   337,   339,   483,   486,   339,   543,   289,   297,   537,
     352,   350,   352,   339,   350,   350,   350,   217,   110,   350,
      88,   282,   285,   339,   339,   342,   479,   477,   507,     7,
     340,   343,   507,   507,   507,   507,   343,   338,    60,   145,
     219,   264,   266,   268,   269,   270,   271,   272,   273,   279,
     283,   284,   287,   292,   300,   308,   342,   418,   533,   350,
     339,   350,   350,   338,   337,   482,   477,   490,   338,   338,
     338,   338,   483,   291,   341,   350,   352,   350,   350,   350,
     217,   350,   110,   350,   274,   275,   276,   277,   278,   279,
     280,   281,   309,    88,   282,   285,   276,   350,   293,   301,
     274,   339,   507,   339,   339,   339,   339,   338,   352,   538,
     350,   350,   352,   352,   294,   295,   350,   350,   352,    18,
     342,   540,   286,   539,   339
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (YYID (N))                                                     \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (YYID (0))
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])



/* This macro is provided for backward compatibility. */

#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULL, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  YYSIZE_T yysize1;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULL;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                yysize1 = yysize + yytnamerr (YY_NULL, yytname[yyx]);
                if (! (yysize <= yysize1
                       && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                  return 2;
                yysize = yysize1;
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  yysize1 = yysize + yystrlen (yyformat);
  if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
    return 2;
  yysize = yysize1;

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
/* Line 1787 of yacc.c  */
#line 645 "cf-parse.y"
    { return 0; }
    break;

  case 3:
/* Line 1787 of yacc.c  */
#line 646 "cf-parse.y"
    { return 0; }
    break;

  case 7:
/* Line 1787 of yacc.c  */
#line 659 "cf-parse.y"
    { (yyval.i) = f_eval_int((yyvsp[(2) - (3)].x)); }
    break;

  case 8:
/* Line 1787 of yacc.c  */
#line 660 "cf-parse.y"
    { if ((yyvsp[(1) - (1)].s)->class != SYM_NUMBER) cf_error("Number expected"); else (yyval.i) = (yyvsp[(1) - (1)].s)->aux; }
    break;

  case 9:
/* Line 1787 of yacc.c  */
#line 666 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(2) - (5)].s), SYM_NUMBER, NULL);
     (yyvsp[(2) - (5)].s)->aux = (yyvsp[(4) - (5)].i);
   }
    break;

  case 10:
/* Line 1787 of yacc.c  */
#line 670 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(2) - (5)].s), SYM_IPA, cfg_alloc(sizeof(ip_addr)));
     *(ip_addr *)(yyvsp[(2) - (5)].s)->def = (yyvsp[(4) - (5)].a);
   }
    break;

  case 11:
/* Line 1787 of yacc.c  */
#line 679 "cf-parse.y"
    {(yyval.i) = !!(yyvsp[(1) - (1)].i); }
    break;

  case 12:
/* Line 1787 of yacc.c  */
#line 680 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 13:
/* Line 1787 of yacc.c  */
#line 681 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 14:
/* Line 1787 of yacc.c  */
#line 682 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 15:
/* Line 1787 of yacc.c  */
#line 683 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 16:
/* Line 1787 of yacc.c  */
#line 684 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 18:
/* Line 1787 of yacc.c  */
#line 691 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_IPA) cf_error("IP address expected");
     (yyval.a) = *(ip_addr *)(yyvsp[(1) - (1)].s)->def;
   }
    break;

  case 19:
/* Line 1787 of yacc.c  */
#line 698 "cf-parse.y"
    { (yyval.iface) = NULL; }
    break;

  case 20:
/* Line 1787 of yacc.c  */
#line 699 "cf-parse.y"
    { (yyval.iface) = if_get_by_name((yyvsp[(2) - (2)].s)->name); }
    break;

  case 21:
/* Line 1787 of yacc.c  */
#line 703 "cf-parse.y"
    {
     if (!ip_is_prefix((yyvsp[(1) - (2)].a), (yyvsp[(2) - (2)].i))) cf_error("Invalid prefix");
     (yyval.px).addr = (yyvsp[(1) - (2)].a); (yyval.px).len = (yyvsp[(2) - (2)].i);
   }
    break;

  case 23:
/* Line 1787 of yacc.c  */
#line 711 "cf-parse.y"
    { (yyval.px).addr = (yyvsp[(1) - (1)].a); (yyval.px).len = BITS_PER_IP_ADDRESS; }
    break;

  case 24:
/* Line 1787 of yacc.c  */
#line 715 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) < 0 || (yyvsp[(2) - (2)].i) > BITS_PER_IP_ADDRESS) cf_error("Invalid prefix length %d", (yyvsp[(2) - (2)].i));
     (yyval.i) = (yyvsp[(2) - (2)].i);
   }
    break;

  case 25:
/* Line 1787 of yacc.c  */
#line 719 "cf-parse.y"
    {
     (yyval.i) = ipa_mklen((yyvsp[(2) - (2)].a));
     if ((yyval.i) < 0) cf_error("Invalid netmask %I", (yyvsp[(2) - (2)].a));
   }
    break;

  case 26:
/* Line 1787 of yacc.c  */
#line 726 "cf-parse.y"
    {
     (yyval.time) = tm_parse_datetime((yyvsp[(1) - (1)].t));
     if (!(yyval.time))
       cf_error("Invalid date and time");
   }
    break;

  case 27:
/* Line 1787 of yacc.c  */
#line 734 "cf-parse.y"
    { (yyval.t) = (yyvsp[(1) - (1)].t); }
    break;

  case 28:
/* Line 1787 of yacc.c  */
#line 735 "cf-parse.y"
    { (yyval.t) = NULL; }
    break;

  case 29:
/* Line 1787 of yacc.c  */
#line 741 "cf-parse.y"
    {
    struct log_config *c = cfg_allocz(sizeof(struct log_config));
    c->fh = (yyvsp[(2) - (4)].g);
    c->mask = (yyvsp[(3) - (4)].i);
    add_tail(&new_config->logfiles, &c->n);
  }
    break;

  case 30:
/* Line 1787 of yacc.c  */
#line 750 "cf-parse.y"
    { (yyval.t) = (yyvsp[(2) - (2)].t); }
    break;

  case 31:
/* Line 1787 of yacc.c  */
#line 751 "cf-parse.y"
    { (yyval.t) = bird_name; }
    break;

  case 32:
/* Line 1787 of yacc.c  */
#line 755 "cf-parse.y"
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[(1) - (1)].t), "a");
     if (!f) cf_error("Unable to open log file `%s': %m", (yyvsp[(1) - (1)].t));
     (yyval.g) = f;
   }
    break;

  case 33:
/* Line 1787 of yacc.c  */
#line 760 "cf-parse.y"
    { (yyval.g) = NULL; new_config->syslog_name = (yyvsp[(2) - (2)].t); }
    break;

  case 34:
/* Line 1787 of yacc.c  */
#line 761 "cf-parse.y"
    { (yyval.g) = stderr; }
    break;

  case 35:
/* Line 1787 of yacc.c  */
#line 765 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 36:
/* Line 1787 of yacc.c  */
#line 766 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 37:
/* Line 1787 of yacc.c  */
#line 770 "cf-parse.y"
    { (yyval.i) = 1 << (yyvsp[(1) - (1)].i); }
    break;

  case 38:
/* Line 1787 of yacc.c  */
#line 771 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (1 << (yyvsp[(3) - (3)].i)); }
    break;

  case 39:
/* Line 1787 of yacc.c  */
#line 775 "cf-parse.y"
    { (yyval.i) = L_DEBUG[0]; }
    break;

  case 40:
/* Line 1787 of yacc.c  */
#line 776 "cf-parse.y"
    { (yyval.i) = L_TRACE[0]; }
    break;

  case 41:
/* Line 1787 of yacc.c  */
#line 777 "cf-parse.y"
    { (yyval.i) = L_INFO[0]; }
    break;

  case 42:
/* Line 1787 of yacc.c  */
#line 778 "cf-parse.y"
    { (yyval.i) = L_REMOTE[0]; }
    break;

  case 43:
/* Line 1787 of yacc.c  */
#line 779 "cf-parse.y"
    { (yyval.i) = L_WARN[0]; }
    break;

  case 44:
/* Line 1787 of yacc.c  */
#line 780 "cf-parse.y"
    { (yyval.i) = L_ERR[0]; }
    break;

  case 45:
/* Line 1787 of yacc.c  */
#line 781 "cf-parse.y"
    { (yyval.i) = L_AUTH[0]; }
    break;

  case 46:
/* Line 1787 of yacc.c  */
#line 782 "cf-parse.y"
    { (yyval.i) = L_FATAL[0]; }
    break;

  case 47:
/* Line 1787 of yacc.c  */
#line 783 "cf-parse.y"
    { (yyval.i) = L_BUG[0]; }
    break;

  case 48:
/* Line 1787 of yacc.c  */
#line 789 "cf-parse.y"
    { new_config->proto_default_mrtdump = (yyvsp[(3) - (4)].i); }
    break;

  case 49:
/* Line 1787 of yacc.c  */
#line 790 "cf-parse.y"
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[(2) - (3)].t), "a");
     if (!f) cf_error("Unable to open MRTDump file '%s': %m", (yyvsp[(2) - (3)].t));
     new_config->mrtdump_file = fileno(f);
   }
    break;

  case 50:
/* Line 1787 of yacc.c  */
#line 799 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_route; }
    break;

  case 51:
/* Line 1787 of yacc.c  */
#line 800 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_proto; }
    break;

  case 52:
/* Line 1787 of yacc.c  */
#line 801 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_base; }
    break;

  case 53:
/* Line 1787 of yacc.c  */
#line 802 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_log; }
    break;

  case 54:
/* Line 1787 of yacc.c  */
#line 805 "cf-parse.y"
    { *(yyvsp[(1) - (2)].tf) = (struct timeformat){(yyvsp[(2) - (2)].t), NULL, 0}; }
    break;

  case 55:
/* Line 1787 of yacc.c  */
#line 806 "cf-parse.y"
    { *(yyvsp[(1) - (4)].tf) = (struct timeformat){(yyvsp[(2) - (4)].t), (yyvsp[(4) - (4)].t), (yyvsp[(3) - (4)].i)}; }
    break;

  case 56:
/* Line 1787 of yacc.c  */
#line 807 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%T", "%F", 20*3600}; }
    break;

  case 57:
/* Line 1787 of yacc.c  */
#line 808 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%F %T", NULL, 0}; }
    break;

  case 59:
/* Line 1787 of yacc.c  */
#line 820 "cf-parse.y"
    { cmd_reconfig((yyvsp[(2) - (4)].t), RECONFIG_HARD, (yyvsp[(3) - (4)].i)); }
    break;

  case 60:
/* Line 1787 of yacc.c  */
#line 823 "cf-parse.y"
    { cmd_reconfig((yyvsp[(3) - (5)].t), RECONFIG_SOFT, (yyvsp[(4) - (5)].i)); }
    break;

  case 61:
/* Line 1787 of yacc.c  */
#line 830 "cf-parse.y"
    { cmd_reconfig_confirm(); }
    break;

  case 62:
/* Line 1787 of yacc.c  */
#line 833 "cf-parse.y"
    { cmd_reconfig_undo(); }
    break;

  case 63:
/* Line 1787 of yacc.c  */
#line 836 "cf-parse.y"
    { cmd_check_config((yyvsp[(3) - (4)].t)); }
    break;

  case 64:
/* Line 1787 of yacc.c  */
#line 839 "cf-parse.y"
    { cmd_shutdown(); }
    break;

  case 65:
/* Line 1787 of yacc.c  */
#line 842 "cf-parse.y"
    { (yyval.t) = NULL; }
    break;

  case 67:
/* Line 1787 of yacc.c  */
#line 847 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 68:
/* Line 1787 of yacc.c  */
#line 848 "cf-parse.y"
    { (yyval.i) = UNIX_DEFAULT_CONFIGURE_TIMEOUT; }
    break;

  case 69:
/* Line 1787 of yacc.c  */
#line 849 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); }
    break;

  case 70:
/* Line 1787 of yacc.c  */
#line 857 "cf-parse.y"
    { this_proto = krt_init_config((yyvsp[(1) - (2)].i)); }
    break;

  case 71:
/* Line 1787 of yacc.c  */
#line 862 "cf-parse.y"
    { THIS_KRT->persist = (yyvsp[(2) - (2)].i); }
    break;

  case 72:
/* Line 1787 of yacc.c  */
#line 863 "cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KRT->scan_time = (yyvsp[(3) - (3)].i);
   }
    break;

  case 73:
/* Line 1787 of yacc.c  */
#line 867 "cf-parse.y"
    {
      THIS_KRT->learn = (yyvsp[(2) - (2)].i);
#ifndef KRT_ALLOW_LEARN
      if ((yyvsp[(2) - (2)].i))
	cf_error("Learning of kernel routes not supported in this configuration");
#endif
   }
    break;

  case 74:
/* Line 1787 of yacc.c  */
#line 874 "cf-parse.y"
    { THIS_KRT->devroutes = (yyvsp[(3) - (3)].i); }
    break;

  case 75:
/* Line 1787 of yacc.c  */
#line 880 "cf-parse.y"
    { this_proto = kif_init_config((yyvsp[(1) - (2)].i)); }
    break;

  case 76:
/* Line 1787 of yacc.c  */
#line 885 "cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KIF->scan_time = (yyvsp[(3) - (3)].i);
   }
    break;

  case 77:
/* Line 1787 of yacc.c  */
#line 889 "cf-parse.y"
    {
     struct kif_primary_item *kpi = cfg_alloc(sizeof (struct kif_primary_item));
     kpi->pattern = (yyvsp[(2) - (3)].t);
     kpi->prefix = (yyvsp[(3) - (3)].px).addr;
     kpi->pxlen = (yyvsp[(3) - (3)].px).len;
     add_tail(&THIS_KIF->primary, &kpi->n);
   }
    break;

  case 78:
/* Line 1787 of yacc.c  */
#line 903 "cf-parse.y"
    {
	if ((yyvsp[(3) - (3)].i) <= 0 || (yyvsp[(3) - (3)].i) >= NL_NUM_TABLES)
	  cf_error("Kernel routing table number out of range");
	THIS_KRT->sys.table_id = (yyvsp[(3) - (3)].i);
   }
    break;

  case 79:
/* Line 1787 of yacc.c  */
#line 917 "cf-parse.y"
    { new_config->router_id = (yyvsp[(3) - (4)].i32); }
    break;

  case 80:
/* Line 1787 of yacc.c  */
#line 918 "cf-parse.y"
    { new_config->router_id_from = this_ipatt; }
    break;

  case 81:
/* Line 1787 of yacc.c  */
#line 922 "cf-parse.y"
    { (yyval.i32) = (yyvsp[(1) - (1)].i); }
    break;

  case 83:
/* Line 1787 of yacc.c  */
#line 924 "cf-parse.y"
    {
#ifndef IPV6
     (yyval.i32) = ipa_to_u32((yyvsp[(1) - (1)].a));
#else
     cf_error("Router IDs must be entered as hexadecimal numbers or IPv4 addresses in IPv6 version");
#endif
   }
    break;

  case 87:
/* Line 1787 of yacc.c  */
#line 943 "cf-parse.y"
    { new_config->listen_bgp_addr = (yyvsp[(2) - (2)].a); }
    break;

  case 88:
/* Line 1787 of yacc.c  */
#line 944 "cf-parse.y"
    { new_config->listen_bgp_port = (yyvsp[(2) - (2)].i); }
    break;

  case 89:
/* Line 1787 of yacc.c  */
#line 945 "cf-parse.y"
    { new_config->listen_bgp_flags = 0; }
    break;

  case 90:
/* Line 1787 of yacc.c  */
#line 946 "cf-parse.y"
    { new_config->listen_bgp_flags = 1; }
    break;

  case 91:
/* Line 1787 of yacc.c  */
#line 953 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 92:
/* Line 1787 of yacc.c  */
#line 954 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 93:
/* Line 1787 of yacc.c  */
#line 958 "cf-parse.y"
    {
   struct rtable_config *cf;
   cf = rt_new_table((yyvsp[(2) - (3)].s));
   cf->sorted = (yyvsp[(3) - (3)].i);
   }
    break;

  case 94:
/* Line 1787 of yacc.c  */
#line 966 "cf-parse.y"
    {
  this_roa_table = roa_new_table_config((yyvsp[(3) - (3)].s));
}
    break;

  case 96:
/* Line 1787 of yacc.c  */
#line 972 "cf-parse.y"
    {
     roa_add_item_config(this_roa_table, (yyvsp[(3) - (8)].px).addr, (yyvsp[(3) - (8)].px).len, (yyvsp[(5) - (8)].i), (yyvsp[(7) - (8)].i));
   }
    break;

  case 99:
/* Line 1787 of yacc.c  */
#line 986 "cf-parse.y"
    { (yyval.i) = SYM_PROTO; }
    break;

  case 100:
/* Line 1787 of yacc.c  */
#line 987 "cf-parse.y"
    { (yyval.i) = SYM_TEMPLATE; }
    break;

  case 101:
/* Line 1787 of yacc.c  */
#line 991 "cf-parse.y"
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->def = this_proto;
     this_proto->name = s->name;
     }
    break;

  case 102:
/* Line 1787 of yacc.c  */
#line 997 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(1) - (1)].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[(1) - (1)].s)->name;
   }
    break;

  case 103:
/* Line 1787 of yacc.c  */
#line 1001 "cf-parse.y"
    {
     if (((yyvsp[(3) - (3)].s)->class != SYM_TEMPLATE) && ((yyvsp[(3) - (3)].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");

     cf_define_symbol((yyvsp[(1) - (3)].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[(1) - (3)].s)->name;

     proto_copy_config(this_proto, (yyvsp[(3) - (3)].s)->def);
   }
    break;

  case 105:
/* Line 1787 of yacc.c  */
#line 1013 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) < 0 || (yyvsp[(2) - (2)].i) > 0xFFFF) cf_error("Invalid preference");
     this_proto->preference = (yyvsp[(2) - (2)].i);
   }
    break;

  case 106:
/* Line 1787 of yacc.c  */
#line 1017 "cf-parse.y"
    { this_proto->disabled = (yyvsp[(2) - (2)].i); }
    break;

  case 107:
/* Line 1787 of yacc.c  */
#line 1018 "cf-parse.y"
    { this_proto->debug = (yyvsp[(2) - (2)].i); }
    break;

  case 108:
/* Line 1787 of yacc.c  */
#line 1019 "cf-parse.y"
    { this_proto->mrtdump = (yyvsp[(2) - (2)].i); }
    break;

  case 109:
/* Line 1787 of yacc.c  */
#line 1020 "cf-parse.y"
    { this_proto->in_filter = (yyvsp[(2) - (2)].f); }
    break;

  case 110:
/* Line 1787 of yacc.c  */
#line 1021 "cf-parse.y"
    { this_proto->out_filter = (yyvsp[(2) - (2)].f); }
    break;

  case 111:
/* Line 1787 of yacc.c  */
#line 1022 "cf-parse.y"
    { this_proto->rx_limit = (yyvsp[(3) - (3)].g); }
    break;

  case 112:
/* Line 1787 of yacc.c  */
#line 1023 "cf-parse.y"
    { this_proto->in_limit = (yyvsp[(3) - (3)].g); }
    break;

  case 113:
/* Line 1787 of yacc.c  */
#line 1024 "cf-parse.y"
    { this_proto->out_limit = (yyvsp[(3) - (3)].g); }
    break;

  case 114:
/* Line 1787 of yacc.c  */
#line 1025 "cf-parse.y"
    { this_proto->in_keep_filtered = (yyvsp[(4) - (4)].i); }
    break;

  case 115:
/* Line 1787 of yacc.c  */
#line 1026 "cf-parse.y"
    { this_proto->table = (yyvsp[(2) - (2)].r); }
    break;

  case 116:
/* Line 1787 of yacc.c  */
#line 1027 "cf-parse.y"
    { this_proto->router_id = (yyvsp[(3) - (3)].i32); }
    break;

  case 117:
/* Line 1787 of yacc.c  */
#line 1028 "cf-parse.y"
    { this_proto->dsc = (yyvsp[(2) - (2)].t); }
    break;

  case 118:
/* Line 1787 of yacc.c  */
#line 1032 "cf-parse.y"
    { (yyval.f) = (yyvsp[(2) - (2)].f); }
    break;

  case 120:
/* Line 1787 of yacc.c  */
#line 1034 "cf-parse.y"
    { (yyval.f) = FILTER_ACCEPT; }
    break;

  case 121:
/* Line 1787 of yacc.c  */
#line 1035 "cf-parse.y"
    { (yyval.f) = FILTER_REJECT; }
    break;

  case 122:
/* Line 1787 of yacc.c  */
#line 1039 "cf-parse.y"
    { (yyval.i) = PLA_DISABLE; }
    break;

  case 123:
/* Line 1787 of yacc.c  */
#line 1040 "cf-parse.y"
    { (yyval.i) = PLA_WARN; }
    break;

  case 124:
/* Line 1787 of yacc.c  */
#line 1041 "cf-parse.y"
    { (yyval.i) = PLA_BLOCK; }
    break;

  case 125:
/* Line 1787 of yacc.c  */
#line 1042 "cf-parse.y"
    { (yyval.i) = PLA_RESTART; }
    break;

  case 126:
/* Line 1787 of yacc.c  */
#line 1043 "cf-parse.y"
    { (yyval.i) = PLA_DISABLE; }
    break;

  case 127:
/* Line 1787 of yacc.c  */
#line 1047 "cf-parse.y"
    {
     struct proto_limit *l = cfg_allocz(sizeof(struct proto_limit));
     l->limit = (yyvsp[(1) - (2)].i);
     l->action = (yyvsp[(2) - (2)].i);
     (yyval.g) = l;
   }
    break;

  case 128:
/* Line 1787 of yacc.c  */
#line 1053 "cf-parse.y"
    { (yyval.g) = NULL; }
    break;

  case 129:
/* Line 1787 of yacc.c  */
#line 1057 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_TABLE) cf_error("Table name expected");
     (yyval.r) = (yyvsp[(1) - (1)].s)->def;
   }
    break;

  case 130:
/* Line 1787 of yacc.c  */
#line 1065 "cf-parse.y"
    { new_config->proto_default_debug = (yyvsp[(3) - (3)].i); }
    break;

  case 131:
/* Line 1787 of yacc.c  */
#line 1066 "cf-parse.y"
    { new_config->cli_debug = (yyvsp[(3) - (3)].i); }
    break;

  case 132:
/* Line 1787 of yacc.c  */
#line 1074 "cf-parse.y"
    {
     struct iface_patt_node *ipn = cfg_allocz(sizeof(struct iface_patt_node));
     add_tail(&this_ipatt->ipn_list, NODE ipn);
     this_ipn = ipn;
   }
    break;

  case 133:
/* Line 1787 of yacc.c  */
#line 1082 "cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (1)].t); this_ipn->prefix = IPA_NONE; this_ipn->pxlen = 0; }
    break;

  case 134:
/* Line 1787 of yacc.c  */
#line 1083 "cf-parse.y"
    { this_ipn->pattern = NULL; this_ipn->prefix = (yyvsp[(1) - (1)].px).addr; this_ipn->pxlen = (yyvsp[(1) - (1)].px).len; }
    break;

  case 135:
/* Line 1787 of yacc.c  */
#line 1084 "cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (2)].t); this_ipn->prefix = (yyvsp[(2) - (2)].px).addr; this_ipn->pxlen = (yyvsp[(2) - (2)].px).len; }
    break;

  case 136:
/* Line 1787 of yacc.c  */
#line 1088 "cf-parse.y"
    { this_ipn->positive = 1; }
    break;

  case 137:
/* Line 1787 of yacc.c  */
#line 1089 "cf-parse.y"
    { this_ipn->positive = 0; }
    break;

  case 141:
/* Line 1787 of yacc.c  */
#line 1102 "cf-parse.y"
    {
   /* Generic this_ipatt init */
   this_ipatt = cfg_allocz(sizeof(struct iface_patt));
   init_list(&this_ipatt->ipn_list);
 }
    break;

  case 143:
/* Line 1787 of yacc.c  */
#line 1117 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_device, sizeof(struct rt_dev_config), (yyvsp[(1) - (2)].i));
     init_list(&DIRECT_CFG->iface_list);
   }
    break;

  case 147:
/* Line 1787 of yacc.c  */
#line 1130 "cf-parse.y"
    {
     this_ipatt = cfg_allocz(sizeof(struct iface_patt));
     add_tail(&DIRECT_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
   }
    break;

  case 149:
/* Line 1787 of yacc.c  */
#line 1144 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 150:
/* Line 1787 of yacc.c  */
#line 1145 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 151:
/* Line 1787 of yacc.c  */
#line 1146 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 153:
/* Line 1787 of yacc.c  */
#line 1151 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); }
    break;

  case 154:
/* Line 1787 of yacc.c  */
#line 1155 "cf-parse.y"
    { (yyval.i) = D_STATES; }
    break;

  case 155:
/* Line 1787 of yacc.c  */
#line 1156 "cf-parse.y"
    { (yyval.i) = D_ROUTES; }
    break;

  case 156:
/* Line 1787 of yacc.c  */
#line 1157 "cf-parse.y"
    { (yyval.i) = D_FILTERS; }
    break;

  case 157:
/* Line 1787 of yacc.c  */
#line 1158 "cf-parse.y"
    { (yyval.i) = D_IFACES; }
    break;

  case 158:
/* Line 1787 of yacc.c  */
#line 1159 "cf-parse.y"
    { (yyval.i) = D_EVENTS; }
    break;

  case 159:
/* Line 1787 of yacc.c  */
#line 1160 "cf-parse.y"
    { (yyval.i) = D_PACKETS; }
    break;

  case 160:
/* Line 1787 of yacc.c  */
#line 1166 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 161:
/* Line 1787 of yacc.c  */
#line 1167 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 162:
/* Line 1787 of yacc.c  */
#line 1168 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 164:
/* Line 1787 of yacc.c  */
#line 1173 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); }
    break;

  case 165:
/* Line 1787 of yacc.c  */
#line 1177 "cf-parse.y"
    { (yyval.i) = MD_STATES; }
    break;

  case 166:
/* Line 1787 of yacc.c  */
#line 1178 "cf-parse.y"
    { (yyval.i) = MD_MESSAGES; }
    break;

  case 173:
/* Line 1787 of yacc.c  */
#line 1199 "cf-parse.y"
    {
     if (!this_p_list) {
     	this_p_list = cfg_alloc(sizeof(list));
     	init_list(this_p_list);
        password_id = 1;
     }
     this_p_item = cfg_alloc(sizeof (struct password_item));
     this_p_item->password = (yyvsp[(2) - (2)].t);
     this_p_item->genfrom = 0;
     this_p_item->gento = TIME_INFINITY;
     this_p_item->accfrom = 0;
     this_p_item->accto = TIME_INFINITY;
     this_p_item->id = password_id++;
     add_tail(this_p_list, &this_p_item->n);
   }
    break;

  case 174:
/* Line 1787 of yacc.c  */
#line 1217 "cf-parse.y"
    { }
    break;

  case 175:
/* Line 1787 of yacc.c  */
#line 1218 "cf-parse.y"
    { this_p_item->genfrom = (yyvsp[(3) - (5)].time); }
    break;

  case 176:
/* Line 1787 of yacc.c  */
#line 1219 "cf-parse.y"
    { this_p_item->gento = (yyvsp[(3) - (5)].time); }
    break;

  case 177:
/* Line 1787 of yacc.c  */
#line 1220 "cf-parse.y"
    { this_p_item->accfrom = (yyvsp[(3) - (5)].time); }
    break;

  case 178:
/* Line 1787 of yacc.c  */
#line 1221 "cf-parse.y"
    { this_p_item->accto = (yyvsp[(3) - (5)].time); }
    break;

  case 179:
/* Line 1787 of yacc.c  */
#line 1222 "cf-parse.y"
    { this_p_item->id = (yyvsp[(2) - (4)].i); if ((yyvsp[(2) - (4)].i) <= 0) cf_error("Password ID has to be greated than zero."); }
    break;

  case 180:
/* Line 1787 of yacc.c  */
#line 1231 "cf-parse.y"
    { cmd_show_status(); }
    break;

  case 181:
/* Line 1787 of yacc.c  */
#line 1234 "cf-parse.y"
    { cmd_show_memory(); }
    break;

  case 182:
/* Line 1787 of yacc.c  */
#line 1237 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_show, 0, 0); }
    break;

  case 183:
/* Line 1787 of yacc.c  */
#line 1240 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(4) - (5)].ps), proto_cmd_show, 0, 1); }
    break;

  case 185:
/* Line 1787 of yacc.c  */
#line 1244 "cf-parse.y"
    { (yyval.s) = NULL; }
    break;

  case 186:
/* Line 1787 of yacc.c  */
#line 1248 "cf-parse.y"
    { if_show(); }
    break;

  case 187:
/* Line 1787 of yacc.c  */
#line 1251 "cf-parse.y"
    { if_show_summary(); }
    break;

  case 188:
/* Line 1787 of yacc.c  */
#line 1255 "cf-parse.y"
    { rt_show((yyvsp[(3) - (4)].ra)); }
    break;

  case 189:
/* Line 1787 of yacc.c  */
#line 1258 "cf-parse.y"
    {
     (yyval.ra) = cfg_allocz(sizeof(struct rt_show_data));
     (yyval.ra)->pxlen = 256;
     (yyval.ra)->filter = FILTER_ACCEPT;
   }
    break;

  case 190:
/* Line 1787 of yacc.c  */
#line 1263 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[(2) - (2)].px).addr;
     (yyval.ra)->pxlen = (yyvsp[(2) - (2)].px).len;
   }
    break;

  case 191:
/* Line 1787 of yacc.c  */
#line 1269 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[(3) - (3)].px).addr;
     (yyval.ra)->pxlen = (yyvsp[(3) - (3)].px).len;
     (yyval.ra)->show_for = 1;
   }
    break;

  case 192:
/* Line 1787 of yacc.c  */
#line 1276 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyvsp[(3) - (3)].s)->class != SYM_TABLE) cf_error("%s is not a table", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->table = ((struct rtable_config *)(yyvsp[(3) - (3)].s)->def)->table;
   }
    break;

  case 193:
/* Line 1787 of yacc.c  */
#line 1281 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(3) - (3)].f);
   }
    break;

  case 194:
/* Line 1787 of yacc.c  */
#line 1286 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(2) - (2)].f);
   }
    break;

  case 195:
/* Line 1787 of yacc.c  */
#line 1291 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->verbose = 1;
   }
    break;

  case 196:
/* Line 1787 of yacc.c  */
#line 1295 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->primary_only = 1;
   }
    break;

  case 197:
/* Line 1787 of yacc.c  */
#line 1299 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->filtered = 1;
   }
    break;

  case 198:
/* Line 1787 of yacc.c  */
#line 1303 "cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->export_mode) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->export_mode = (yyvsp[(2) - (3)].i);
     (yyval.ra)->primary_only = 1;
     (yyval.ra)->export_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
    break;

  case 199:
/* Line 1787 of yacc.c  */
#line 1313 "cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->show_protocol) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->show_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
    break;

  case 200:
/* Line 1787 of yacc.c  */
#line 1321 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 1;
   }
    break;

  case 201:
/* Line 1787 of yacc.c  */
#line 1325 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 2;
   }
    break;

  case 202:
/* Line 1787 of yacc.c  */
#line 1332 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 203:
/* Line 1787 of yacc.c  */
#line 1333 "cf-parse.y"
    { (yyval.i) = 2; }
    break;

  case 204:
/* Line 1787 of yacc.c  */
#line 1339 "cf-parse.y"
    { roa_show((yyvsp[(3) - (4)].ro)); }
    break;

  case 205:
/* Line 1787 of yacc.c  */
#line 1342 "cf-parse.y"
    {
     (yyval.ro) = cfg_allocz(sizeof(struct roa_show_data));
     (yyval.ro)->mode = ROA_SHOW_ALL;
     (yyval.ro)->table = roa_table_default;
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
   }
    break;

  case 206:
/* Line 1787 of yacc.c  */
#line 1349 "cf-parse.y"
    {
     (yyval.ro) = (yyvsp[(1) - (3)].ro);
     if ((yyval.ro)->mode != ROA_SHOW_ALL) cf_error("Only one prefix expected");
     (yyval.ro)->prefix = (yyvsp[(3) - (3)].px).addr;
     (yyval.ro)->pxlen = (yyvsp[(3) - (3)].px).len;
     (yyval.ro)->mode = (yyvsp[(2) - (3)].i);
   }
    break;

  case 207:
/* Line 1787 of yacc.c  */
#line 1356 "cf-parse.y"
    {
     (yyval.ro) = (yyvsp[(1) - (3)].ro);
     (yyval.ro)->asn = (yyvsp[(3) - (3)].i);
   }
    break;

  case 208:
/* Line 1787 of yacc.c  */
#line 1360 "cf-parse.y"
    {
     (yyval.ro) = (yyvsp[(1) - (3)].ro);
     if ((yyvsp[(3) - (3)].s)->class != SYM_ROA) cf_error("%s is not a ROA table", (yyvsp[(3) - (3)].s)->name);
     (yyval.ro)->table = ((struct roa_table_config *)(yyvsp[(3) - (3)].s)->def)->table;
   }
    break;

  case 209:
/* Line 1787 of yacc.c  */
#line 1368 "cf-parse.y"
    { (yyval.i) = ROA_SHOW_PX; }
    break;

  case 210:
/* Line 1787 of yacc.c  */
#line 1369 "cf-parse.y"
    { (yyval.i) = ROA_SHOW_IN; }
    break;

  case 211:
/* Line 1787 of yacc.c  */
#line 1370 "cf-parse.y"
    { (yyval.i) = ROA_SHOW_FOR; }
    break;

  case 212:
/* Line 1787 of yacc.c  */
#line 1376 "cf-parse.y"
    { cmd_show_symbols((yyvsp[(3) - (4)].sd)); }
    break;

  case 213:
/* Line 1787 of yacc.c  */
#line 1379 "cf-parse.y"
    {
     (yyval.sd) = cfg_allocz(sizeof(struct sym_show_data));
   }
    break;

  case 214:
/* Line 1787 of yacc.c  */
#line 1382 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_TABLE; }
    break;

  case 215:
/* Line 1787 of yacc.c  */
#line 1383 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_FUNCTION; }
    break;

  case 216:
/* Line 1787 of yacc.c  */
#line 1384 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_FILTER; }
    break;

  case 217:
/* Line 1787 of yacc.c  */
#line 1385 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_PROTO; }
    break;

  case 218:
/* Line 1787 of yacc.c  */
#line 1386 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_TEMPLATE; }
    break;

  case 219:
/* Line 1787 of yacc.c  */
#line 1387 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_ROA; }
    break;

  case 220:
/* Line 1787 of yacc.c  */
#line 1388 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->sym = (yyvsp[(2) - (2)].s); }
    break;

  case 221:
/* Line 1787 of yacc.c  */
#line 1393 "cf-parse.y"
    { 
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
     (yyval.rot) = roa_table_default;
   }
    break;

  case 222:
/* Line 1787 of yacc.c  */
#line 1398 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].s)->class != SYM_ROA)
       cf_error("%s is not a ROA table", (yyvsp[(2) - (2)].s)->name);
     (yyval.rot) = ((struct roa_table_config *)(yyvsp[(2) - (2)].s)->def)->table;
   }
    break;

  case 223:
/* Line 1787 of yacc.c  */
#line 1407 "cf-parse.y"
    {
  if (! cli_access_restricted())
    { roa_add_item((yyvsp[(8) - (9)].rot), (yyvsp[(3) - (9)].px).addr, (yyvsp[(3) - (9)].px).len, (yyvsp[(5) - (9)].i), (yyvsp[(7) - (9)].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
    break;

  case 224:
/* Line 1787 of yacc.c  */
#line 1414 "cf-parse.y"
    {
  if (! cli_access_restricted())
    { roa_delete_item((yyvsp[(8) - (9)].rot), (yyvsp[(3) - (9)].px).addr, (yyvsp[(3) - (9)].px).len, (yyvsp[(5) - (9)].i), (yyvsp[(7) - (9)].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
    break;

  case 225:
/* Line 1787 of yacc.c  */
#line 1421 "cf-parse.y"
    {
  if (! cli_access_restricted())
    { roa_flush((yyvsp[(3) - (4)].rot), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
    break;

  case 226:
/* Line 1787 of yacc.c  */
#line 1429 "cf-parse.y"
    { rdump(&root_pool); cli_msg(0, ""); }
    break;

  case 227:
/* Line 1787 of yacc.c  */
#line 1431 "cf-parse.y"
    { sk_dump_all(); cli_msg(0, ""); }
    break;

  case 228:
/* Line 1787 of yacc.c  */
#line 1433 "cf-parse.y"
    { if_dump_all(); cli_msg(0, ""); }
    break;

  case 229:
/* Line 1787 of yacc.c  */
#line 1435 "cf-parse.y"
    { neigh_dump_all(); cli_msg(0, ""); }
    break;

  case 230:
/* Line 1787 of yacc.c  */
#line 1437 "cf-parse.y"
    { rta_dump_all(); cli_msg(0, ""); }
    break;

  case 231:
/* Line 1787 of yacc.c  */
#line 1439 "cf-parse.y"
    { rt_dump_all(); cli_msg(0, ""); }
    break;

  case 232:
/* Line 1787 of yacc.c  */
#line 1441 "cf-parse.y"
    { protos_dump_all(); cli_msg(0, ""); }
    break;

  case 233:
/* Line 1787 of yacc.c  */
#line 1443 "cf-parse.y"
    {
  cli_set_log_echo(this_cli, (yyvsp[(2) - (4)].i), (yyvsp[(3) - (4)].i));
  cli_msg(0, "");
}
    break;

  case 234:
/* Line 1787 of yacc.c  */
#line 1449 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 235:
/* Line 1787 of yacc.c  */
#line 1450 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 237:
/* Line 1787 of yacc.c  */
#line 1455 "cf-parse.y"
    { (yyval.i) = 4096; }
    break;

  case 238:
/* Line 1787 of yacc.c  */
#line 1456 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].i) < 256 || (yyvsp[(1) - (1)].i) > 65536) cf_error("Invalid log buffer size");
     (yyval.i) = (yyvsp[(1) - (1)].i);
   }
    break;

  case 239:
/* Line 1787 of yacc.c  */
#line 1463 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_disable, 1, 0); }
    break;

  case 240:
/* Line 1787 of yacc.c  */
#line 1465 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_enable, 1, 0); }
    break;

  case 241:
/* Line 1787 of yacc.c  */
#line 1467 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_restart, 1, 0); }
    break;

  case 242:
/* Line 1787 of yacc.c  */
#line 1469 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_reload, 1, CMD_RELOAD); }
    break;

  case 243:
/* Line 1787 of yacc.c  */
#line 1471 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_reload, 1, CMD_RELOAD_IN); }
    break;

  case 244:
/* Line 1787 of yacc.c  */
#line 1473 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_reload, 1, CMD_RELOAD_OUT); }
    break;

  case 245:
/* Line 1787 of yacc.c  */
#line 1477 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_debug, 1, (yyvsp[(3) - (4)].i)); }
    break;

  case 246:
/* Line 1787 of yacc.c  */
#line 1481 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_mrtdump, 1, (yyvsp[(3) - (4)].i)); }
    break;

  case 247:
/* Line 1787 of yacc.c  */
#line 1484 "cf-parse.y"
    { this_cli->restricted = 1; cli_msg(16, "Access restricted"); }
    break;

  case 248:
/* Line 1787 of yacc.c  */
#line 1487 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].s); (yyval.ps).patt = 0; }
    break;

  case 249:
/* Line 1787 of yacc.c  */
#line 1488 "cf-parse.y"
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
    break;

  case 250:
/* Line 1787 of yacc.c  */
#line 1489 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].t); (yyval.ps).patt = 1; }
    break;

  case 251:
/* Line 1787 of yacc.c  */
#line 1493 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].s); (yyval.ps).patt = 0; }
    break;

  case 252:
/* Line 1787 of yacc.c  */
#line 1494 "cf-parse.y"
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
    break;

  case 253:
/* Line 1787 of yacc.c  */
#line 1495 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].t); (yyval.ps).patt = 1; }
    break;

  case 254:
/* Line 1787 of yacc.c  */
#line 1503 "cf-parse.y"
    { (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_FILTER, NULL); cf_push_scope( (yyvsp[(2) - (2)].s) ); }
    break;

  case 255:
/* Line 1787 of yacc.c  */
#line 1504 "cf-parse.y"
    {
     (yyvsp[(2) - (4)].s)->def = (yyvsp[(4) - (4)].f);
     (yyvsp[(4) - (4)].f)->name = (yyvsp[(2) - (4)].s)->name;
     DBG( "We have new filter defined (%s)\n", (yyvsp[(2) - (4)].s)->name );
     cf_pop_scope();
   }
    break;

  case 256:
/* Line 1787 of yacc.c  */
#line 1513 "cf-parse.y"
    { f_eval_int((yyvsp[(2) - (2)].x)); }
    break;

  case 257:
/* Line 1787 of yacc.c  */
#line 1517 "cf-parse.y"
    { (yyval.i) = T_INT; }
    break;

  case 258:
/* Line 1787 of yacc.c  */
#line 1518 "cf-parse.y"
    { (yyval.i) = T_BOOL; }
    break;

  case 259:
/* Line 1787 of yacc.c  */
#line 1519 "cf-parse.y"
    { (yyval.i) = T_IP; }
    break;

  case 260:
/* Line 1787 of yacc.c  */
#line 1520 "cf-parse.y"
    { (yyval.i) = T_PREFIX; }
    break;

  case 261:
/* Line 1787 of yacc.c  */
#line 1521 "cf-parse.y"
    { (yyval.i) = T_PAIR; }
    break;

  case 262:
/* Line 1787 of yacc.c  */
#line 1522 "cf-parse.y"
    { (yyval.i) = T_QUAD; }
    break;

  case 263:
/* Line 1787 of yacc.c  */
#line 1523 "cf-parse.y"
    { (yyval.i) = T_EC; }
    break;

  case 264:
/* Line 1787 of yacc.c  */
#line 1524 "cf-parse.y"
    { (yyval.i) = T_STRING; }
    break;

  case 265:
/* Line 1787 of yacc.c  */
#line 1525 "cf-parse.y"
    { (yyval.i) = T_PATH_MASK; }
    break;

  case 266:
/* Line 1787 of yacc.c  */
#line 1526 "cf-parse.y"
    { (yyval.i) = T_PATH; }
    break;

  case 267:
/* Line 1787 of yacc.c  */
#line 1527 "cf-parse.y"
    { (yyval.i) = T_CLIST; }
    break;

  case 268:
/* Line 1787 of yacc.c  */
#line 1528 "cf-parse.y"
    { (yyval.i) = T_ECLIST; }
    break;

  case 269:
/* Line 1787 of yacc.c  */
#line 1529 "cf-parse.y"
    { 
	switch ((yyvsp[(1) - (2)].i)) {
	  case T_INT:
	  case T_PAIR:
	  case T_QUAD:
	  case T_EC:
	  case T_IP:
	       (yyval.i) = T_SET;
	       break;

	  case T_PREFIX:
	       (yyval.i) = T_PREFIX_SET;
	    break;

	  default:
		cf_error( "You can't create sets of this type." );
	}
   }
    break;

  case 270:
/* Line 1787 of yacc.c  */
#line 1550 "cf-parse.y"
    {
     struct f_val * val = cfg_alloc(sizeof(struct f_val)); 
     val->type = (yyvsp[(1) - (2)].i); 
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_VARIABLE | (yyvsp[(1) - (2)].i), val);
     DBG( "New variable %s type %x\n", (yyvsp[(2) - (2)].s)->name, (yyvsp[(1) - (2)].i) );
     (yyvsp[(2) - (2)].s)->aux2 = NULL;
     (yyval.s)=(yyvsp[(2) - (2)].s);
   }
    break;

  case 271:
/* Line 1787 of yacc.c  */
#line 1561 "cf-parse.y"
    { (yyval.s) = NULL; }
    break;

  case 272:
/* Line 1787 of yacc.c  */
#line 1562 "cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   }
    break;

  case 273:
/* Line 1787 of yacc.c  */
#line 1569 "cf-parse.y"
    { (yyval.s) = (yyvsp[(1) - (1)].s); }
    break;

  case 274:
/* Line 1787 of yacc.c  */
#line 1570 "cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   }
    break;

  case 275:
/* Line 1787 of yacc.c  */
#line 1577 "cf-parse.y"
    {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     f->name = NULL;
     f->root = (yyvsp[(1) - (1)].x);
     (yyval.f) = f;
   }
    break;

  case 276:
/* Line 1787 of yacc.c  */
#line 1586 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_FILTER) cf_error("No such filter.");
     (yyval.f) = (yyvsp[(1) - (1)].s)->def;
   }
    break;

  case 278:
/* Line 1787 of yacc.c  */
#line 1594 "cf-parse.y"
    {
     /* Construct 'IF term THEN ACCEPT; REJECT;' */
     struct filter *f = cfg_alloc(sizeof(struct filter));
     struct f_inst *i, *acc, *rej;
     acc = f_new_inst();		/* ACCEPT */
     acc->code = P('p',',');
     acc->a1.p = NULL;
     acc->a2.i = F_ACCEPT;
     rej = f_new_inst();		/* REJECT */
     rej->code = P('p',',');
     rej->a1.p = NULL;
     rej->a2.i = F_REJECT;
     i = f_new_inst();			/* IF */
     i->code = '?';
     i->a1.p = (yyvsp[(2) - (2)].x);
     i->a2.p = acc;
     i->next = rej;
     f->name = NULL;
     f->root = i;
     (yyval.f) = f;
  }
    break;

  case 279:
/* Line 1787 of yacc.c  */
#line 1618 "cf-parse.y"
    { DBG( "Have function parameters\n" ); (yyval.s)=(yyvsp[(2) - (3)].s); }
    break;

  case 280:
/* Line 1787 of yacc.c  */
#line 1619 "cf-parse.y"
    { (yyval.s)=NULL; }
    break;

  case 281:
/* Line 1787 of yacc.c  */
#line 1623 "cf-parse.y"
    {
     if ((yyvsp[(1) - (4)].s)) {
       /* Prepend instruction to clear local variables */
       (yyval.x) = f_new_inst();
       (yyval.x)->code = P('c','v');
       (yyval.x)->a1.p = (yyvsp[(1) - (4)].s);
       (yyval.x)->next = (yyvsp[(3) - (4)].x);
     } else
       (yyval.x) = (yyvsp[(3) - (4)].x);
   }
    break;

  case 282:
/* Line 1787 of yacc.c  */
#line 1636 "cf-parse.y"
    { DBG( "Beginning of function %s\n", (yyvsp[(2) - (2)].s)->name );
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_FUNCTION, NULL);
     cf_push_scope((yyvsp[(2) - (2)].s));
   }
    break;

  case 283:
/* Line 1787 of yacc.c  */
#line 1639 "cf-parse.y"
    {
     (yyvsp[(2) - (5)].s)->def = (yyvsp[(5) - (5)].x);
     (yyvsp[(2) - (5)].s)->aux2 = (yyvsp[(4) - (5)].s);
     DBG("Hmm, we've got one function here - %s\n", (yyvsp[(2) - (5)].s)->name); 
     cf_pop_scope();
   }
    break;

  case 284:
/* Line 1787 of yacc.c  */
#line 1652 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 285:
/* Line 1787 of yacc.c  */
#line 1653 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x)->next; (yyvsp[(1) - (1)].x)->next = NULL; }
    break;

  case 286:
/* Line 1787 of yacc.c  */
#line 1656 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); (yyvsp[(1) - (1)].x)->next = (yyvsp[(1) - (1)].x); }
    break;

  case 287:
/* Line 1787 of yacc.c  */
#line 1657 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyvsp[(2) - (2)].x)->next = (yyvsp[(1) - (2)].x)->next ; (yyvsp[(1) - (2)].x)->next = (yyvsp[(2) - (2)].x); }
    break;

  case 288:
/* Line 1787 of yacc.c  */
#line 1661 "cf-parse.y"
    {
     (yyval.x)=(yyvsp[(1) - (1)].x);
   }
    break;

  case 289:
/* Line 1787 of yacc.c  */
#line 1664 "cf-parse.y"
    {
     (yyval.x)=(yyvsp[(2) - (3)].x);
   }
    break;

  case 290:
/* Line 1787 of yacc.c  */
#line 1673 "cf-parse.y"
    { (yyval.v).type = T_IP; (yyval.v).val.px.ip = (yyvsp[(1) - (1)].a); }
    break;

  case 291:
/* Line 1787 of yacc.c  */
#line 1686 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[(1) - (1)].i); }
    break;

  case 292:
/* Line 1787 of yacc.c  */
#line 1687 "cf-parse.y"
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[(1) - (1)].i32); }
    break;

  case 293:
/* Line 1787 of yacc.c  */
#line 1688 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); }
    break;

  case 294:
/* Line 1787 of yacc.c  */
#line 1689 "cf-parse.y"
    { (yyval.v).type = pair_a((yyvsp[(1) - (1)].i)); (yyval.v).val.i = pair_b((yyvsp[(1) - (1)].i)); }
    break;

  case 295:
/* Line 1787 of yacc.c  */
#line 1693 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[(1) - (1)].i); }
    break;

  case 296:
/* Line 1787 of yacc.c  */
#line 1694 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = f_eval_int((yyvsp[(2) - (3)].x)); }
    break;

  case 297:
/* Line 1787 of yacc.c  */
#line 1695 "cf-parse.y"
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[(1) - (1)].i32); }
    break;

  case 298:
/* Line 1787 of yacc.c  */
#line 1696 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); }
    break;

  case 299:
/* Line 1787 of yacc.c  */
#line 1697 "cf-parse.y"
    { (yyval.v).type = pair_a((yyvsp[(1) - (1)].i)); (yyval.v).val.i = pair_b((yyvsp[(1) - (1)].i)); }
    break;

  case 300:
/* Line 1787 of yacc.c  */
#line 1701 "cf-parse.y"
    { (yyval.i) = f_eval_int((yyvsp[(1) - (1)].x)); check_u16((yyval.i)); }
    break;

  case 301:
/* Line 1787 of yacc.c  */
#line 1704 "cf-parse.y"
    { (yyval.i32) = pair((yyvsp[(1) - (1)].i), (yyvsp[(1) - (1)].i)); }
    break;

  case 302:
/* Line 1787 of yacc.c  */
#line 1705 "cf-parse.y"
    { (yyval.i32) = pair((yyvsp[(1) - (3)].i), (yyvsp[(3) - (3)].i)); }
    break;

  case 303:
/* Line 1787 of yacc.c  */
#line 1706 "cf-parse.y"
    { (yyval.i32) = 0xFFFF; }
    break;

  case 304:
/* Line 1787 of yacc.c  */
#line 1710 "cf-parse.y"
    {
     (yyval.e) = f_new_pair_set(pair_a((yyvsp[(2) - (5)].i32)), pair_b((yyvsp[(2) - (5)].i32)), pair_a((yyvsp[(4) - (5)].i32)), pair_b((yyvsp[(4) - (5)].i32)));
   }
    break;

  case 305:
/* Line 1787 of yacc.c  */
#line 1713 "cf-parse.y"
    {
     /* Hack: $2 and $4 should be pair_expr, but that would cause shift/reduce conflict */
     if ((pair_a((yyvsp[(2) - (11)].i32)) != pair_b((yyvsp[(2) - (11)].i32))) || (pair_a((yyvsp[(4) - (11)].i32)) != pair_b((yyvsp[(4) - (11)].i32))))
       cf_error("syntax error");
     (yyval.e) = f_new_pair_item(pair_b((yyvsp[(2) - (11)].i32)), (yyvsp[(8) - (11)].i), pair_b((yyvsp[(4) - (11)].i32)), (yyvsp[(10) - (11)].i)); 
   }
    break;

  case 306:
/* Line 1787 of yacc.c  */
#line 1722 "cf-parse.y"
    { (yyval.i32) = f_eval_int((yyvsp[(1) - (1)].x)); }
    break;

  case 307:
/* Line 1787 of yacc.c  */
#line 1725 "cf-parse.y"
    { (yyval.i) = EC_RT; }
    break;

  case 308:
/* Line 1787 of yacc.c  */
#line 1726 "cf-parse.y"
    { (yyval.i) = EC_RO; }
    break;

  case 309:
/* Line 1787 of yacc.c  */
#line 1727 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); }
    break;

  case 310:
/* Line 1787 of yacc.c  */
#line 1728 "cf-parse.y"
    { (yyval.i) = EC_GENERIC; }
    break;

  case 311:
/* Line 1787 of yacc.c  */
#line 1732 "cf-parse.y"
    { (yyval.e) = f_new_ec_item((yyvsp[(2) - (7)].i), 0, (yyvsp[(4) - (7)].i32), (yyvsp[(6) - (7)].i32), (yyvsp[(6) - (7)].i32)); }
    break;

  case 312:
/* Line 1787 of yacc.c  */
#line 1733 "cf-parse.y"
    { (yyval.e) = f_new_ec_item((yyvsp[(2) - (9)].i), 0, (yyvsp[(4) - (9)].i32), (yyvsp[(6) - (9)].i32), (yyvsp[(8) - (9)].i32)); }
    break;

  case 313:
/* Line 1787 of yacc.c  */
#line 1734 "cf-parse.y"
    {  (yyval.e) = f_new_ec_item((yyvsp[(2) - (7)].i), 0, (yyvsp[(4) - (7)].i32), 0, EC_ALL); }
    break;

  case 316:
/* Line 1787 of yacc.c  */
#line 1740 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (1)].v), (yyvsp[(1) - (1)].v)); }
    break;

  case 317:
/* Line 1787 of yacc.c  */
#line 1741 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (3)].v), (yyvsp[(3) - (3)].v)); }
    break;

  case 320:
/* Line 1787 of yacc.c  */
#line 1747 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (1)].v), (yyvsp[(1) - (1)].v)); }
    break;

  case 321:
/* Line 1787 of yacc.c  */
#line 1748 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (3)].v), (yyvsp[(3) - (3)].v)); }
    break;

  case 323:
/* Line 1787 of yacc.c  */
#line 1753 "cf-parse.y"
    { (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), (yyvsp[(3) - (3)].e)); }
    break;

  case 325:
/* Line 1787 of yacc.c  */
#line 1758 "cf-parse.y"
    { (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), (yyvsp[(3) - (3)].e)); }
    break;

  case 326:
/* Line 1787 of yacc.c  */
#line 1762 "cf-parse.y"
    {
     if (((yyvsp[(3) - (3)].i) < 0) || ((yyvsp[(3) - (3)].i) > MAX_PREFIX_LENGTH) || !ip_is_prefix((yyvsp[(1) - (3)].a), (yyvsp[(3) - (3)].i))) cf_error("Invalid network prefix: %I/%d.", (yyvsp[(1) - (3)].a), (yyvsp[(3) - (3)].i));
     (yyval.v).type = T_PREFIX; (yyval.v).val.px.ip = (yyvsp[(1) - (3)].a); (yyval.v).val.px.len = (yyvsp[(3) - (3)].i);
   }
    break;

  case 327:
/* Line 1787 of yacc.c  */
#line 1769 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); }
    break;

  case 328:
/* Line 1787 of yacc.c  */
#line 1770 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (2)].v); (yyval.v).val.px.len |= LEN_PLUS; }
    break;

  case 329:
/* Line 1787 of yacc.c  */
#line 1771 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (2)].v); (yyval.v).val.px.len |= LEN_MINUS; }
    break;

  case 330:
/* Line 1787 of yacc.c  */
#line 1772 "cf-parse.y"
    { 
     if (! ((0 <= (yyvsp[(3) - (6)].i)) && ((yyvsp[(3) - (6)].i) <= (yyvsp[(5) - (6)].i)) && ((yyvsp[(5) - (6)].i) <= MAX_PREFIX_LENGTH))) cf_error("Invalid prefix pattern range: {%d, %d}.", (yyvsp[(3) - (6)].i), (yyvsp[(5) - (6)].i));
     (yyval.v) = (yyvsp[(1) - (6)].v); (yyval.v).val.px.len |= LEN_RANGE | ((yyvsp[(3) - (6)].i) << 16) | ((yyvsp[(5) - (6)].i) << 8);
   }
    break;

  case 331:
/* Line 1787 of yacc.c  */
#line 1779 "cf-parse.y"
    { (yyval.trie) = f_new_trie(cfg_mem); trie_add_fprefix((yyval.trie), &((yyvsp[(1) - (1)].v).val.px)); }
    break;

  case 332:
/* Line 1787 of yacc.c  */
#line 1780 "cf-parse.y"
    { (yyval.trie) = (yyvsp[(1) - (3)].trie); trie_add_fprefix((yyval.trie), &((yyvsp[(3) - (3)].v).val.px)); }
    break;

  case 333:
/* Line 1787 of yacc.c  */
#line 1783 "cf-parse.y"
    { (yyval.e) = NULL; }
    break;

  case 334:
/* Line 1787 of yacc.c  */
#line 1784 "cf-parse.y"
    {
     /* Fill data fields */
     struct f_tree *t;
     for (t = (yyvsp[(2) - (4)].e); t; t = t->left)
       t->data = (yyvsp[(4) - (4)].x);
     (yyval.e) = f_merge_items((yyvsp[(1) - (4)].e), (yyvsp[(2) - (4)].e));
   }
    break;

  case 335:
/* Line 1787 of yacc.c  */
#line 1791 "cf-parse.y"
    { 
     struct f_tree *t = f_new_tree();
     t->from.type = t->to.type = T_VOID;
     t->right = t;
     t->data = (yyvsp[(3) - (3)].x);
     (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), t);
 }
    break;

  case 336:
/* Line 1787 of yacc.c  */
#line 1803 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 337:
/* Line 1787 of yacc.c  */
#line 1804 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); }
    break;

  case 338:
/* Line 1787 of yacc.c  */
#line 1808 "cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); }
    break;

  case 339:
/* Line 1787 of yacc.c  */
#line 1809 "cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); }
    break;

  case 340:
/* Line 1787 of yacc.c  */
#line 1813 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[(1) - (2)].i); }
    break;

  case 341:
/* Line 1787 of yacc.c  */
#line 1814 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; }
    break;

  case 342:
/* Line 1787 of yacc.c  */
#line 1815 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_QUESTION; (yyval.h)->val  = 0; }
    break;

  case 343:
/* Line 1787 of yacc.c  */
#line 1816 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN_EXPR; (yyval.h)->val = (uintptr_t) (yyvsp[(1) - (2)].x); }
    break;

  case 344:
/* Line 1787 of yacc.c  */
#line 1817 "cf-parse.y"
    { (yyval.h) = NULL; }
    break;

  case 345:
/* Line 1787 of yacc.c  */
#line 1821 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[(1) - (2)].i); }
    break;

  case 346:
/* Line 1787 of yacc.c  */
#line 1822 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; }
    break;

  case 347:
/* Line 1787 of yacc.c  */
#line 1823 "cf-parse.y"
    { (yyval.h) = NULL; }
    break;

  case 348:
/* Line 1787 of yacc.c  */
#line 1827 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_INT;  (yyval.x)->a2.i = (yyvsp[(1) - (1)].i); }
    break;

  case 349:
/* Line 1787 of yacc.c  */
#line 1828 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 1;  }
    break;

  case 350:
/* Line 1787 of yacc.c  */
#line 1829 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 0;  }
    break;

  case 351:
/* Line 1787 of yacc.c  */
#line 1830 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_STRING; (yyval.x)->a2.p = (yyvsp[(1) - (1)].t); }
    break;

  case 352:
/* Line 1787 of yacc.c  */
#line 1831 "cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); }
    break;

  case 353:
/* Line 1787 of yacc.c  */
#line 1832 "cf-parse.y"
    {NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); }
    break;

  case 354:
/* Line 1787 of yacc.c  */
#line 1833 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_QUAD;  (yyval.x)->a2.i = (yyvsp[(1) - (1)].i32); }
    break;

  case 355:
/* Line 1787 of yacc.c  */
#line 1834 "cf-parse.y"
    { DBG( "We've got a set here..." ); (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_SET; (yyval.x)->a2.p = build_tree((yyvsp[(2) - (3)].e)); DBG( "ook\n" ); }
    break;

  case 356:
/* Line 1787 of yacc.c  */
#line 1835 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_PREFIX_SET;  (yyval.x)->a2.p = (yyvsp[(2) - (3)].trie); }
    break;

  case 357:
/* Line 1787 of yacc.c  */
#line 1836 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = (yyvsp[(1) - (1)].i) >> 16; (yyval.x)->a2.i = (yyvsp[(1) - (1)].i) & 0xffff; }
    break;

  case 358:
/* Line 1787 of yacc.c  */
#line 1837 "cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; val->type = T_PATH_MASK; val->val.path_mask = (yyvsp[(1) - (1)].h); (yyval.x)->a1.p = val; }
    break;

  case 359:
/* Line 1787 of yacc.c  */
#line 1841 "cf-parse.y"
    { (yyval.x) = f_generate_dpair((yyvsp[(2) - (5)].x), (yyvsp[(4) - (5)].x)); }
    break;

  case 360:
/* Line 1787 of yacc.c  */
#line 1842 "cf-parse.y"
    { (yyval.x) = f_generate_ec((yyvsp[(2) - (7)].i), (yyvsp[(4) - (7)].x), (yyvsp[(6) - (7)].x)); }
    break;

  case 362:
/* Line 1787 of yacc.c  */
#line 1856 "cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
    break;

  case 363:
/* Line 1787 of yacc.c  */
#line 1879 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     switch ((yyvsp[(1) - (1)].s)->class) {
       case SYM_NUMBER:
	(yyval.x) = f_new_inst();
	(yyval.x)->code = 'c'; 
	(yyval.x)->aux = T_INT; 
	(yyval.x)->a2.i = (yyvsp[(1) - (1)].s)->aux;
	break;
       case SYM_IPA:
	{ NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; val->type = T_IP; val->val.px.ip = * (ip_addr *) ((yyvsp[(1) - (1)].s)->def); }
	break;
       case SYM_VARIABLE | T_BOOL:
       case SYM_VARIABLE | T_INT:
       case SYM_VARIABLE | T_PAIR:
       case SYM_VARIABLE | T_QUAD:
       case SYM_VARIABLE | T_EC:
       case SYM_VARIABLE | T_STRING:
       case SYM_VARIABLE | T_IP:
       case SYM_VARIABLE | T_PREFIX:
       case SYM_VARIABLE | T_PREFIX_SET:
       case SYM_VARIABLE | T_SET:
       case SYM_VARIABLE | T_PATH:
       case SYM_VARIABLE | T_PATH_MASK:
       case SYM_VARIABLE | T_CLIST:
       case SYM_VARIABLE | T_ECLIST:
	 (yyval.x)->code = 'V';
	 (yyval.x)->a1.p = (yyvsp[(1) - (1)].s)->def;
	 (yyval.x)->a2.p = (yyvsp[(1) - (1)].s)->name;
	 break;
       default:
	 cf_error("%s: variable expected.", (yyvsp[(1) - (1)].s)->name );
     }
   }
    break;

  case 364:
/* Line 1787 of yacc.c  */
#line 1915 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = OFFSETOF(struct rta, from);   (yyval.x)->a1.i = 1; }
    break;

  case 365:
/* Line 1787 of yacc.c  */
#line 1917 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = OFFSETOF(struct rta, gw);     (yyval.x)->a1.i = 1; }
    break;

  case 366:
/* Line 1787 of yacc.c  */
#line 1918 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_PREFIX;     (yyval.x)->a2.i = 0x12345678; /* This is actually ok - T_PREFIX is special-cased. */ }
    break;

  case 367:
/* Line 1787 of yacc.c  */
#line 1919 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_STRING;     (yyval.x)->a2.i = 0x12345678; /* T_STRING is also special-cased. */ }
    break;

  case 368:
/* Line 1787 of yacc.c  */
#line 1920 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTS;   (yyval.x)->a2.i = OFFSETOF(struct rta, source); }
    break;

  case 369:
/* Line 1787 of yacc.c  */
#line 1921 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_SCOPE; (yyval.x)->a2.i = OFFSETOF(struct rta, scope);  (yyval.x)->a1.i = 1; }
    break;

  case 370:
/* Line 1787 of yacc.c  */
#line 1922 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTC;   (yyval.x)->a2.i = OFFSETOF(struct rta, cast); }
    break;

  case 371:
/* Line 1787 of yacc.c  */
#line 1923 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTD;   (yyval.x)->a2.i = OFFSETOF(struct rta, dest);   (yyval.x)->a1.i = 1; }
    break;

  case 372:
/* Line 1787 of yacc.c  */
#line 1927 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); }
    break;

  case 373:
/* Line 1787 of yacc.c  */
#line 1928 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '+';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 374:
/* Line 1787 of yacc.c  */
#line 1929 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '-';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 375:
/* Line 1787 of yacc.c  */
#line 1930 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '*';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 376:
/* Line 1787 of yacc.c  */
#line 1931 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '/';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 377:
/* Line 1787 of yacc.c  */
#line 1932 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '&';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 378:
/* Line 1787 of yacc.c  */
#line 1933 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '|';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 379:
/* Line 1787 of yacc.c  */
#line 1934 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('=','='); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 380:
/* Line 1787 of yacc.c  */
#line 1935 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('!','=');     (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 381:
/* Line 1787 of yacc.c  */
#line 1936 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 382:
/* Line 1787 of yacc.c  */
#line 1937 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 383:
/* Line 1787 of yacc.c  */
#line 1938 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); }
    break;

  case 384:
/* Line 1787 of yacc.c  */
#line 1939 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); }
    break;

  case 385:
/* Line 1787 of yacc.c  */
#line 1940 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '~';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 386:
/* Line 1787 of yacc.c  */
#line 1941 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '!'; (yyval.x)->a1.p = (yyvsp[(2) - (2)].x); }
    break;

  case 387:
/* Line 1787 of yacc.c  */
#line 1942 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('d','e');  (yyval.x)->a1.p = (yyvsp[(3) - (4)].x); }
    break;

  case 388:
/* Line 1787 of yacc.c  */
#line 1944 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 389:
/* Line 1787 of yacc.c  */
#line 1945 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 390:
/* Line 1787 of yacc.c  */
#line 1946 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 391:
/* Line 1787 of yacc.c  */
#line 1948 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'P'; }
    break;

  case 392:
/* Line 1787 of yacc.c  */
#line 1950 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyval.x)->code = 'a'; }
    break;

  case 393:
/* Line 1787 of yacc.c  */
#line 1952 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyval.x)->code = P('e','a'); }
    break;

  case 394:
/* Line 1787 of yacc.c  */
#line 1954 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('c','p'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->aux = T_IP; }
    break;

  case 395:
/* Line 1787 of yacc.c  */
#line 1955 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'L'; (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 396:
/* Line 1787 of yacc.c  */
#line 1956 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('i','M'); (yyval.x)->a1.p = (yyvsp[(1) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); }
    break;

  case 397:
/* Line 1787 of yacc.c  */
#line 1957 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','f'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 398:
/* Line 1787 of yacc.c  */
#line 1958 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','l'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 399:
/* Line 1787 of yacc.c  */
#line 1968 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_PATH; }
    break;

  case 400:
/* Line 1787 of yacc.c  */
#line 1969 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_CLIST; }
    break;

  case 401:
/* Line 1787 of yacc.c  */
#line 1970 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_ECLIST; }
    break;

  case 402:
/* Line 1787 of yacc.c  */
#line 1971 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('A','p'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); }
    break;

  case 403:
/* Line 1787 of yacc.c  */
#line 1972 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'a'; }
    break;

  case 404:
/* Line 1787 of yacc.c  */
#line 1973 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'd'; }
    break;

  case 405:
/* Line 1787 of yacc.c  */
#line 1974 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'f'; }
    break;

  case 406:
/* Line 1787 of yacc.c  */
#line 1976 "cf-parse.y"
    { (yyval.x) = f_generate_roa_check((yyvsp[(3) - (4)].s), NULL, NULL); }
    break;

  case 407:
/* Line 1787 of yacc.c  */
#line 1977 "cf-parse.y"
    { (yyval.x) = f_generate_roa_check((yyvsp[(3) - (8)].s), (yyvsp[(5) - (8)].x), (yyvsp[(7) - (8)].x)); }
    break;

  case 408:
/* Line 1787 of yacc.c  */
#line 1982 "cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
    break;

  case 409:
/* Line 1787 of yacc.c  */
#line 2005 "cf-parse.y"
    { (yyval.i) = F_QUITBIRD; }
    break;

  case 410:
/* Line 1787 of yacc.c  */
#line 2006 "cf-parse.y"
    { (yyval.i) = F_ACCEPT; }
    break;

  case 411:
/* Line 1787 of yacc.c  */
#line 2007 "cf-parse.y"
    { (yyval.i) = F_REJECT; }
    break;

  case 412:
/* Line 1787 of yacc.c  */
#line 2008 "cf-parse.y"
    { (yyval.i) = F_ERROR; }
    break;

  case 413:
/* Line 1787 of yacc.c  */
#line 2009 "cf-parse.y"
    { (yyval.i) = F_NOP; }
    break;

  case 414:
/* Line 1787 of yacc.c  */
#line 2010 "cf-parse.y"
    { (yyval.i) = F_NONL; }
    break;

  case 415:
/* Line 1787 of yacc.c  */
#line 2014 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'p'; (yyval.x)->a1.p = (yyvsp[(1) - (1)].x); (yyval.x)->a2.p = NULL; }
    break;

  case 416:
/* Line 1787 of yacc.c  */
#line 2017 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 417:
/* Line 1787 of yacc.c  */
#line 2018 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 418:
/* Line 1787 of yacc.c  */
#line 2019 "cf-parse.y"
    {
     if ((yyvsp[(1) - (3)].x)) {
       (yyvsp[(1) - (3)].x)->next = (yyvsp[(3) - (3)].x);
       (yyval.x) = (yyvsp[(1) - (3)].x);
     } else (yyval.x) = (yyvsp[(3) - (3)].x);
   }
    break;

  case 419:
/* Line 1787 of yacc.c  */
#line 2027 "cf-parse.y"
    { 
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (1)].x);
     (yyval.x)->next = NULL;
   }
    break;

  case 420:
/* Line 1787 of yacc.c  */
#line 2034 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (3)].x);
     (yyval.x)->next = (yyvsp[(3) - (3)].x);
   }
    break;

  case 421:
/* Line 1787 of yacc.c  */
#line 2043 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 422:
/* Line 1787 of yacc.c  */
#line 2044 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 423:
/* Line 1787 of yacc.c  */
#line 2048 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = (yyvsp[(2) - (4)].x);
     (yyval.x)->a2.p = (yyvsp[(4) - (4)].x);
   }
    break;

  case 424:
/* Line 1787 of yacc.c  */
#line 2054 "cf-parse.y"
    {
     struct f_inst *i = f_new_inst();
     i->code = '?';
     i->a1.p = (yyvsp[(2) - (6)].x);
     i->a2.p = (yyvsp[(4) - (6)].x);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = i;
     (yyval.x)->a2.p = (yyvsp[(6) - (6)].x);
   }
    break;

  case 425:
/* Line 1787 of yacc.c  */
#line 2064 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll set value\n" );
     if (((yyvsp[(1) - (4)].s)->class & ~T_MASK) != SYM_VARIABLE)
       cf_error( "You may set only variables." );
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = (yyvsp[(1) - (4)].s);
     (yyval.x)->a2.p = (yyvsp[(3) - (4)].x);
   }
    break;

  case 426:
/* Line 1787 of yacc.c  */
#line 2073 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll return the value\n" );
     (yyval.x)->code = 'r';
     (yyval.x)->a1.p = (yyvsp[(2) - (3)].x);
   }
    break;

  case 427:
/* Line 1787 of yacc.c  */
#line 2079 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(2) - (5)].x);
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   }
    break;

  case 428:
/* Line 1787 of yacc.c  */
#line 2084 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(2) - (5)].x);
     if (!(yyval.x)->a1.i)
       cf_error( "This static attribute is read-only.");
     (yyval.x)->code = P('a','S');
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   }
    break;

  case 429:
/* Line 1787 of yacc.c  */
#line 2091 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('P','S');
     (yyval.x)->a1.p = (yyvsp[(3) - (4)].x);
   }
    break;

  case 430:
/* Line 1787 of yacc.c  */
#line 2096 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(4) - (6)].x);
     (yyval.x)->aux = EAF_TYPE_UNDEF | EAF_TEMP;
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = NULL;
   }
    break;

  case 431:
/* Line 1787 of yacc.c  */
#line 2102 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('p',','); (yyval.x)->a1.p = (yyvsp[(2) - (3)].x); (yyval.x)->a2.i = (yyvsp[(1) - (3)].i); }
    break;

  case 432:
/* Line 1787 of yacc.c  */
#line 2103 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (2)].x); }
    break;

  case 433:
/* Line 1787 of yacc.c  */
#line 2104 "cf-parse.y"
    {
      (yyval.x) = f_new_inst();
      (yyval.x)->code = P('S','W');
      (yyval.x)->a1.p = (yyvsp[(2) - (5)].x);
      (yyval.x)->a2.p = build_tree( (yyvsp[(4) - (5)].e) );
   }
    break;

  case 434:
/* Line 1787 of yacc.c  */
#line 2112 "cf-parse.y"
    { (yyval.x) = f_generate_empty((yyvsp[(2) - (5)].x)); }
    break;

  case 435:
/* Line 1787 of yacc.c  */
#line 2113 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('A','p'), 'x', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 436:
/* Line 1787 of yacc.c  */
#line 2114 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'a', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 437:
/* Line 1787 of yacc.c  */
#line 2115 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'd', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 438:
/* Line 1787 of yacc.c  */
#line 2116 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'f', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 439:
/* Line 1787 of yacc.c  */
#line 2122 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_bgp, sizeof(struct bgp_config), (yyvsp[(1) - (2)].i));
     BGP_CFG->hold_time = 240;
     BGP_CFG->connect_retry_time = 120;
     BGP_CFG->initial_hold_time = 240;
     BGP_CFG->compare_path_lengths = 1;
     BGP_CFG->igp_metric = 1;
     BGP_CFG->start_delay_time = 5;
     BGP_CFG->error_amnesia_time = 300;
     BGP_CFG->error_delay_time_min = 60;
     BGP_CFG->error_delay_time_max = 300;
     BGP_CFG->enable_refresh = 1;
     BGP_CFG->enable_as4 = 1;
     BGP_CFG->capabilities = 2;
     BGP_CFG->advertise_ipv4 = 1;
     BGP_CFG->interpret_communities = 1;
     BGP_CFG->default_local_pref = 100;
 }
    break;

  case 442:
/* Line 1787 of yacc.c  */
#line 2145 "cf-parse.y"
    { BGP_CFG->local_as = (yyvsp[(4) - (5)].i); }
    break;

  case 443:
/* Line 1787 of yacc.c  */
#line 2146 "cf-parse.y"
    { BGP_CFG->source_addr = (yyvsp[(3) - (6)].a); BGP_CFG->local_as = (yyvsp[(5) - (6)].i); }
    break;

  case 444:
/* Line 1787 of yacc.c  */
#line 2147 "cf-parse.y"
    {
     if (ipa_nonzero(BGP_CFG->remote_ip))
       cf_error("Only one neighbor per BGP instance is allowed");
     if (!ipa_has_link_scope((yyvsp[(3) - (7)].a)) != !(yyvsp[(4) - (7)].iface))
       cf_error("Link-local address and interface scope must be used together");

     BGP_CFG->remote_ip = (yyvsp[(3) - (7)].a);
     BGP_CFG->iface = (yyvsp[(4) - (7)].iface);
     BGP_CFG->remote_as = (yyvsp[(6) - (7)].i);
   }
    break;

  case 445:
/* Line 1787 of yacc.c  */
#line 2157 "cf-parse.y"
    { BGP_CFG->rr_cluster_id = (yyvsp[(5) - (6)].i32); }
    break;

  case 446:
/* Line 1787 of yacc.c  */
#line 2158 "cf-parse.y"
    { BGP_CFG->rr_client = 1; }
    break;

  case 447:
/* Line 1787 of yacc.c  */
#line 2159 "cf-parse.y"
    { BGP_CFG->rs_client = 1; }
    break;

  case 448:
/* Line 1787 of yacc.c  */
#line 2160 "cf-parse.y"
    { BGP_CFG->hold_time = (yyvsp[(4) - (5)].i); }
    break;

  case 449:
/* Line 1787 of yacc.c  */
#line 2161 "cf-parse.y"
    { BGP_CFG->initial_hold_time = (yyvsp[(5) - (6)].i); }
    break;

  case 450:
/* Line 1787 of yacc.c  */
#line 2162 "cf-parse.y"
    { BGP_CFG->connect_retry_time = (yyvsp[(5) - (6)].i); }
    break;

  case 451:
/* Line 1787 of yacc.c  */
#line 2163 "cf-parse.y"
    { BGP_CFG->keepalive_time = (yyvsp[(4) - (5)].i); }
    break;

  case 452:
/* Line 1787 of yacc.c  */
#line 2164 "cf-parse.y"
    { BGP_CFG->multihop = 64; }
    break;

  case 453:
/* Line 1787 of yacc.c  */
#line 2165 "cf-parse.y"
    { BGP_CFG->multihop = (yyvsp[(3) - (4)].i); if (((yyvsp[(3) - (4)].i)<1) || ((yyvsp[(3) - (4)].i)>255)) cf_error("Multihop must be in range 1-255"); }
    break;

  case 454:
/* Line 1787 of yacc.c  */
#line 2166 "cf-parse.y"
    { BGP_CFG->next_hop_self = 1; BGP_CFG->next_hop_keep = 0; }
    break;

  case 455:
/* Line 1787 of yacc.c  */
#line 2167 "cf-parse.y"
    { BGP_CFG->next_hop_keep = 1; BGP_CFG->next_hop_self = 0; }
    break;

  case 456:
/* Line 1787 of yacc.c  */
#line 2168 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_SELF; }
    break;

  case 457:
/* Line 1787 of yacc.c  */
#line 2169 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_DROP; }
    break;

  case 458:
/* Line 1787 of yacc.c  */
#line 2170 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_IGNORE; }
    break;

  case 459:
/* Line 1787 of yacc.c  */
#line 2171 "cf-parse.y"
    { BGP_CFG->gw_mode = GW_DIRECT; }
    break;

  case 460:
/* Line 1787 of yacc.c  */
#line 2172 "cf-parse.y"
    { BGP_CFG->gw_mode = GW_RECURSIVE; }
    break;

  case 461:
/* Line 1787 of yacc.c  */
#line 2173 "cf-parse.y"
    { BGP_CFG->compare_path_lengths = (yyvsp[(4) - (5)].i); }
    break;

  case 462:
/* Line 1787 of yacc.c  */
#line 2174 "cf-parse.y"
    { BGP_CFG->med_metric = (yyvsp[(4) - (5)].i); }
    break;

  case 463:
/* Line 1787 of yacc.c  */
#line 2175 "cf-parse.y"
    { BGP_CFG->igp_metric = (yyvsp[(4) - (5)].i); }
    break;

  case 464:
/* Line 1787 of yacc.c  */
#line 2176 "cf-parse.y"
    { BGP_CFG->prefer_older = (yyvsp[(4) - (5)].i); }
    break;

  case 465:
/* Line 1787 of yacc.c  */
#line 2177 "cf-parse.y"
    { BGP_CFG->deterministic_med = (yyvsp[(4) - (5)].i); }
    break;

  case 466:
/* Line 1787 of yacc.c  */
#line 2178 "cf-parse.y"
    { BGP_CFG->default_med = (yyvsp[(4) - (5)].i); }
    break;

  case 467:
/* Line 1787 of yacc.c  */
#line 2179 "cf-parse.y"
    { BGP_CFG->default_local_pref = (yyvsp[(4) - (5)].i); }
    break;

  case 468:
/* Line 1787 of yacc.c  */
#line 2180 "cf-parse.y"
    { BGP_CFG->source_addr = (yyvsp[(4) - (5)].a); }
    break;

  case 469:
/* Line 1787 of yacc.c  */
#line 2181 "cf-parse.y"
    { BGP_CFG->start_delay_time = (yyvsp[(5) - (6)].i); }
    break;

  case 470:
/* Line 1787 of yacc.c  */
#line 2182 "cf-parse.y"
    { BGP_CFG->error_amnesia_time = (yyvsp[(5) - (6)].i); }
    break;

  case 471:
/* Line 1787 of yacc.c  */
#line 2183 "cf-parse.y"
    { BGP_CFG->error_delay_time_min = (yyvsp[(5) - (8)].i); BGP_CFG->error_delay_time_max = (yyvsp[(7) - (8)].i); }
    break;

  case 472:
/* Line 1787 of yacc.c  */
#line 2184 "cf-parse.y"
    { BGP_CFG->disable_after_error = (yyvsp[(5) - (6)].i); }
    break;

  case 473:
/* Line 1787 of yacc.c  */
#line 2185 "cf-parse.y"
    { BGP_CFG->enable_refresh = (yyvsp[(5) - (6)].i); }
    break;

  case 474:
/* Line 1787 of yacc.c  */
#line 2186 "cf-parse.y"
    { BGP_CFG->enable_as4 = (yyvsp[(4) - (5)].i); }
    break;

  case 475:
/* Line 1787 of yacc.c  */
#line 2187 "cf-parse.y"
    { BGP_CFG->capabilities = (yyvsp[(3) - (4)].i); }
    break;

  case 476:
/* Line 1787 of yacc.c  */
#line 2188 "cf-parse.y"
    { BGP_CFG->advertise_ipv4 = (yyvsp[(4) - (5)].i); }
    break;

  case 477:
/* Line 1787 of yacc.c  */
#line 2189 "cf-parse.y"
    { BGP_CFG->password = (yyvsp[(3) - (4)].t); }
    break;

  case 478:
/* Line 1787 of yacc.c  */
#line 2190 "cf-parse.y"
    {
     this_proto->in_limit = cfg_allocz(sizeof(struct proto_limit));
     this_proto->in_limit->limit = (yyvsp[(4) - (5)].i);
     this_proto->in_limit->action = PLA_RESTART;
   }
    break;

  case 479:
/* Line 1787 of yacc.c  */
#line 2195 "cf-parse.y"
    { BGP_CFG->passive = (yyvsp[(3) - (4)].i); }
    break;

  case 480:
/* Line 1787 of yacc.c  */
#line 2196 "cf-parse.y"
    { BGP_CFG->interpret_communities = (yyvsp[(4) - (5)].i); }
    break;

  case 481:
/* Line 1787 of yacc.c  */
#line 2197 "cf-parse.y"
    { BGP_CFG->secondary = (yyvsp[(3) - (4)].i); }
    break;

  case 482:
/* Line 1787 of yacc.c  */
#line 2198 "cf-parse.y"
    { BGP_CFG->igp_table = (yyvsp[(4) - (5)].r); }
    break;

  case 483:
/* Line 1787 of yacc.c  */
#line 2199 "cf-parse.y"
    { BGP_CFG->ttl_security = (yyvsp[(4) - (5)].i); }
    break;

  case 484:
/* Line 1787 of yacc.c  */
#line 2210 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_ospf, sizeof(struct ospf_config), (yyvsp[(1) - (2)].i));
     init_list(&OSPF_CFG->area_list);
     init_list(&OSPF_CFG->vlink_list);
     OSPF_CFG->rfc1583 = DEFAULT_RFC1583;
     OSPF_CFG->tick = DEFAULT_OSPFTICK;
  }
    break;

  case 488:
/* Line 1787 of yacc.c  */
#line 2226 "cf-parse.y"
    { OSPF_CFG->rfc1583 = (yyvsp[(2) - (2)].i); }
    break;

  case 489:
/* Line 1787 of yacc.c  */
#line 2227 "cf-parse.y"
    { OSPF_CFG->ecmp = (yyvsp[(2) - (2)].i) ? DEFAULT_ECMP_LIMIT : 0; }
    break;

  case 490:
/* Line 1787 of yacc.c  */
#line 2228 "cf-parse.y"
    { OSPF_CFG->ecmp = (yyvsp[(2) - (4)].i) ? (yyvsp[(4) - (4)].i) : 0; if ((yyvsp[(4) - (4)].i) < 0) cf_error("ECMP limit cannot be negative"); }
    break;

  case 491:
/* Line 1787 of yacc.c  */
#line 2229 "cf-parse.y"
    { OSPF_CFG->tick = (yyvsp[(2) - (2)].i); if((yyvsp[(2) - (2)].i)<=0) cf_error("Tick must be greater than zero"); }
    break;

  case 493:
/* Line 1787 of yacc.c  */
#line 2233 "cf-parse.y"
    {
  this_area = cfg_allocz(sizeof(struct ospf_area_config));
  add_tail(&OSPF_CFG->area_list, NODE this_area);
  this_area->areaid = (yyvsp[(2) - (2)].i32);
  this_area->default_cost = DEFAULT_STUB_COST;
  this_area->type = OPT_E;
  this_area->transint = DEFAULT_TRANSINT;

  init_list(&this_area->patt_list);
  init_list(&this_area->net_list);
  init_list(&this_area->enet_list);
  init_list(&this_area->stubnet_list);
 }
    break;

  case 494:
/* Line 1787 of yacc.c  */
#line 2248 "cf-parse.y"
    { ospf_area_finish(); }
    break;

  case 497:
/* Line 1787 of yacc.c  */
#line 2257 "cf-parse.y"
    { this_area->type = (yyvsp[(2) - (2)].i) ? 0 : OPT_E; /* We should remove the option */ }
    break;

  case 498:
/* Line 1787 of yacc.c  */
#line 2258 "cf-parse.y"
    { this_area->type = OPT_N; }
    break;

  case 499:
/* Line 1787 of yacc.c  */
#line 2259 "cf-parse.y"
    { this_area->summary = (yyvsp[(2) - (2)].i); }
    break;

  case 500:
/* Line 1787 of yacc.c  */
#line 2260 "cf-parse.y"
    { this_area->default_nssa = (yyvsp[(3) - (3)].i); }
    break;

  case 501:
/* Line 1787 of yacc.c  */
#line 2261 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i); check_defcost((yyvsp[(3) - (3)].i)); }
    break;

  case 502:
/* Line 1787 of yacc.c  */
#line 2262 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i) | LSA_EXT_EBIT; check_defcost((yyvsp[(3) - (3)].i)); }
    break;

  case 503:
/* Line 1787 of yacc.c  */
#line 2263 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i);  check_defcost((yyvsp[(3) - (3)].i)); }
    break;

  case 504:
/* Line 1787 of yacc.c  */
#line 2264 "cf-parse.y"
    { this_area->translator = (yyvsp[(2) - (2)].i); }
    break;

  case 505:
/* Line 1787 of yacc.c  */
#line 2265 "cf-parse.y"
    { this_area->transint = (yyvsp[(3) - (3)].i); }
    break;

  case 506:
/* Line 1787 of yacc.c  */
#line 2266 "cf-parse.y"
    { this_nets = &this_area->net_list; }
    break;

  case 508:
/* Line 1787 of yacc.c  */
#line 2267 "cf-parse.y"
    { this_nets = &this_area->enet_list; }
    break;

  case 515:
/* Line 1787 of yacc.c  */
#line 2279 "cf-parse.y"
    {
     this_stubnet = cfg_allocz(sizeof(struct ospf_stubnet_config));
     add_tail(&this_area->stubnet_list, NODE this_stubnet);
     this_stubnet->px = (yyvsp[(1) - (1)].px);
     this_stubnet->cost = COST_D;
   }
    break;

  case 518:
/* Line 1787 of yacc.c  */
#line 2293 "cf-parse.y"
    { this_stubnet->hidden = (yyvsp[(2) - (2)].i); }
    break;

  case 519:
/* Line 1787 of yacc.c  */
#line 2294 "cf-parse.y"
    { this_stubnet->summary = (yyvsp[(2) - (2)].i); }
    break;

  case 520:
/* Line 1787 of yacc.c  */
#line 2295 "cf-parse.y"
    { this_stubnet->cost = (yyvsp[(2) - (2)].i); }
    break;

  case 521:
/* Line 1787 of yacc.c  */
#line 2299 "cf-parse.y"
    { ospf_iface_finish(); }
    break;

  case 522:
/* Line 1787 of yacc.c  */
#line 2300 "cf-parse.y"
    { ospf_iface_finish(); }
    break;

  case 526:
/* Line 1787 of yacc.c  */
#line 2309 "cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
    break;

  case 527:
/* Line 1787 of yacc.c  */
#line 2310 "cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Retransmit int must be greater than zero"); }
    break;

  case 528:
/* Line 1787 of yacc.c  */
#line 2311 "cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
    break;

  case 529:
/* Line 1787 of yacc.c  */
#line 2312 "cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; }
    break;

  case 530:
/* Line 1787 of yacc.c  */
#line 2313 "cf-parse.y"
    { OSPF_PATT->deadint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); }
    break;

  case 531:
/* Line 1787 of yacc.c  */
#line 2314 "cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); }
    break;

  case 532:
/* Line 1787 of yacc.c  */
#line 2315 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE ; }
    break;

  case 533:
/* Line 1787 of yacc.c  */
#line 2316 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE ; }
    break;

  case 534:
/* Line 1787 of yacc.c  */
#line 2317 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT ; }
    break;

  case 536:
/* Line 1787 of yacc.c  */
#line 2322 "cf-parse.y"
    {
  if (this_area->areaid == 0) cf_error("Virtual link cannot be in backbone");
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&OSPF_CFG->vlink_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->voa = this_area->areaid;
  OSPF_PATT->vid = (yyvsp[(3) - (3)].i32);
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->waitint = WAIT_DMH*HELLOINT_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->deadint = 0;
  OSPF_PATT->type = OSPF_IT_VLINK;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->autype = OSPF_AUTH_NONE;
  reset_passwords();
 }
    break;

  case 537:
/* Line 1787 of yacc.c  */
#line 2343 "cf-parse.y"
    { OSPF_PATT->cost = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Cost must be in range 1-65535"); }
    break;

  case 538:
/* Line 1787 of yacc.c  */
#line 2344 "cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
    break;

  case 539:
/* Line 1787 of yacc.c  */
#line 2345 "cf-parse.y"
    { OSPF_PATT->pollint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Poll int must be greater than zero"); }
    break;

  case 540:
/* Line 1787 of yacc.c  */
#line 2346 "cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Retransmit int must be greater than zero"); }
    break;

  case 541:
/* Line 1787 of yacc.c  */
#line 2347 "cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; }
    break;

  case 542:
/* Line 1787 of yacc.c  */
#line 2348 "cf-parse.y"
    { OSPF_PATT->deadint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); }
    break;

  case 543:
/* Line 1787 of yacc.c  */
#line 2349 "cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); }
    break;

  case 544:
/* Line 1787 of yacc.c  */
#line 2350 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
    break;

  case 545:
/* Line 1787 of yacc.c  */
#line 2351 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
    break;

  case 546:
/* Line 1787 of yacc.c  */
#line 2352 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
    break;

  case 547:
/* Line 1787 of yacc.c  */
#line 2353 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
    break;

  case 548:
/* Line 1787 of yacc.c  */
#line 2354 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTP ; }
    break;

  case 549:
/* Line 1787 of yacc.c  */
#line 2355 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTP ; }
    break;

  case 550:
/* Line 1787 of yacc.c  */
#line 2356 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
    break;

  case 551:
/* Line 1787 of yacc.c  */
#line 2357 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
    break;

  case 552:
/* Line 1787 of yacc.c  */
#line 2358 "cf-parse.y"
    { OSPF_PATT->real_bcast = (yyvsp[(3) - (3)].i); if (OSPF_VERSION != 2) cf_error("Real broadcast option requires OSPFv2"); }
    break;

  case 553:
/* Line 1787 of yacc.c  */
#line 2359 "cf-parse.y"
    { OSPF_PATT->ptp_netmask = (yyvsp[(3) - (3)].i); if (OSPF_VERSION != 2) cf_error("Real netmask option requires OSPFv2"); }
    break;

  case 554:
/* Line 1787 of yacc.c  */
#line 2360 "cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
    break;

  case 555:
/* Line 1787 of yacc.c  */
#line 2361 "cf-parse.y"
    { OSPF_PATT->priority = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<0) || ((yyvsp[(2) - (2)].i)>255)) cf_error("Priority must be in range 0-255"); }
    break;

  case 556:
/* Line 1787 of yacc.c  */
#line 2362 "cf-parse.y"
    { OSPF_PATT->strictnbma = (yyvsp[(3) - (3)].i) ; }
    break;

  case 557:
/* Line 1787 of yacc.c  */
#line 2363 "cf-parse.y"
    { OSPF_PATT->stub = (yyvsp[(2) - (2)].i) ; }
    break;

  case 558:
/* Line 1787 of yacc.c  */
#line 2364 "cf-parse.y"
    { OSPF_PATT->check_link = (yyvsp[(3) - (3)].i); }
    break;

  case 559:
/* Line 1787 of yacc.c  */
#line 2365 "cf-parse.y"
    { OSPF_PATT->ecmp_weight = (yyvsp[(3) - (3)].i) - 1; if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
    break;

  case 561:
/* Line 1787 of yacc.c  */
#line 2367 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE ; }
    break;

  case 562:
/* Line 1787 of yacc.c  */
#line 2368 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE ; }
    break;

  case 563:
/* Line 1787 of yacc.c  */
#line 2369 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT ; }
    break;

  case 564:
/* Line 1787 of yacc.c  */
#line 2370 "cf-parse.y"
    { OSPF_PATT->rxbuf = OSPF_RXBUF_LARGE ; }
    break;

  case 565:
/* Line 1787 of yacc.c  */
#line 2371 "cf-parse.y"
    { OSPF_PATT->rxbuf = OSPF_RXBUF_NORMAL ; }
    break;

  case 566:
/* Line 1787 of yacc.c  */
#line 2372 "cf-parse.y"
    { OSPF_PATT->rxbuf = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i) < OSPF_RXBUF_MINSIZE) || ((yyvsp[(3) - (3)].i) > OSPF_MAX_PKT_SIZE)) cf_error("Buffer size must be in range 256-65535"); }
    break;

  case 571:
/* Line 1787 of yacc.c  */
#line 2384 "cf-parse.y"
    {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(this_nets, NODE this_pref);
   this_pref->px.addr = (yyvsp[(1) - (1)].px).addr;
   this_pref->px.len = (yyvsp[(1) - (1)].px).len;
 }
    break;

  case 573:
/* Line 1787 of yacc.c  */
#line 2394 "cf-parse.y"
    { this_pref->hidden = 1; }
    break;

  case 574:
/* Line 1787 of yacc.c  */
#line 2395 "cf-parse.y"
    { this_pref->tag = (yyvsp[(2) - (2)].i); }
    break;

  case 577:
/* Line 1787 of yacc.c  */
#line 2404 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 578:
/* Line 1787 of yacc.c  */
#line 2405 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 579:
/* Line 1787 of yacc.c  */
#line 2409 "cf-parse.y"
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[(1) - (3)].a);
   this_nbma->eligible=(yyvsp[(2) - (3)].i);
 }
    break;

  case 580:
/* Line 1787 of yacc.c  */
#line 2418 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->pollint = POLLINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->priority = PRIORITY_D;
  OSPF_PATT->waitint = WAIT_DMH*HELLOINT_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->deadint = 0;
  OSPF_PATT->type = OSPF_IT_UNDEF;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->autype = OSPF_AUTH_NONE;
  OSPF_PATT->ptp_netmask = 2; /* not specified */
  reset_passwords();
 }
    break;

  case 582:
/* Line 1787 of yacc.c  */
#line 2441 "cf-parse.y"
    { set_instance_id((yyvsp[(2) - (2)].i)); }
    break;

  case 587:
/* Line 1787 of yacc.c  */
#line 2455 "cf-parse.y"
    { ospf_iface_finish(); }
    break;

  case 589:
/* Line 1787 of yacc.c  */
#line 2460 "cf-parse.y"
    { (yyval.t) = NULL; }
    break;

  case 590:
/* Line 1787 of yacc.c  */
#line 2466 "cf-parse.y"
    { ospf_sh(proto_get_named((yyvsp[(3) - (4)].s), &proto_ospf)); }
    break;

  case 591:
/* Line 1787 of yacc.c  */
#line 2469 "cf-parse.y"
    { ospf_sh_neigh(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); }
    break;

  case 592:
/* Line 1787 of yacc.c  */
#line 2472 "cf-parse.y"
    { ospf_sh_iface(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); }
    break;

  case 593:
/* Line 1787 of yacc.c  */
#line 2477 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 0, 1); }
    break;

  case 594:
/* Line 1787 of yacc.c  */
#line 2480 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(5) - (7)].s), &proto_ospf), 0, 0); }
    break;

  case 595:
/* Line 1787 of yacc.c  */
#line 2485 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 1, 1); }
    break;

  case 596:
/* Line 1787 of yacc.c  */
#line 2488 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(5) - (7)].s), &proto_ospf), 1, 0); }
    break;

  case 597:
/* Line 1787 of yacc.c  */
#line 2492 "cf-parse.y"
    { ospf_sh_lsadb((yyvsp[(4) - (5)].ld)); }
    break;

  case 598:
/* Line 1787 of yacc.c  */
#line 2495 "cf-parse.y"
    {
     (yyval.ld) = cfg_allocz(sizeof(struct lsadb_show_data));
   }
    break;

  case 599:
/* Line 1787 of yacc.c  */
#line 2498 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->scope = LSA_SCOPE_AS; }
    break;

  case 600:
/* Line 1787 of yacc.c  */
#line 2499 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->scope = LSA_SCOPE_AREA; (yyval.ld)->area = (yyvsp[(3) - (3)].i32); }
    break;

  case 601:
/* Line 1787 of yacc.c  */
#line 2500 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->scope = 1; /* hack, 0 is no filter */ }
    break;

  case 602:
/* Line 1787 of yacc.c  */
#line 2501 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->type = (yyvsp[(3) - (3)].i); }
    break;

  case 603:
/* Line 1787 of yacc.c  */
#line 2502 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->lsid = (yyvsp[(3) - (3)].i32); }
    break;

  case 604:
/* Line 1787 of yacc.c  */
#line 2503 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->router = SH_ROUTER_SELF; }
    break;

  case 605:
/* Line 1787 of yacc.c  */
#line 2504 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->router = (yyvsp[(3) - (3)].i32); }
    break;

  case 606:
/* Line 1787 of yacc.c  */
#line 2505 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->name = (yyvsp[(2) - (2)].s); }
    break;

  case 607:
/* Line 1787 of yacc.c  */
#line 2511 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_pipe, sizeof(struct pipe_config), (yyvsp[(1) - (2)].i));
     PIPE_CFG->mode = PIPE_TRANSPARENT;
  }
    break;

  case 610:
/* Line 1787 of yacc.c  */
#line 2520 "cf-parse.y"
    {
     if ((yyvsp[(4) - (5)].s)->class != SYM_TABLE)
       cf_error("Routing table name expected");
     PIPE_CFG->peer = (yyvsp[(4) - (5)].s)->def;
   }
    break;

  case 611:
/* Line 1787 of yacc.c  */
#line 2525 "cf-parse.y"
    { PIPE_CFG->mode = PIPE_OPAQUE; }
    break;

  case 612:
/* Line 1787 of yacc.c  */
#line 2526 "cf-parse.y"
    { PIPE_CFG->mode = PIPE_TRANSPARENT; }
    break;

  case 613:
/* Line 1787 of yacc.c  */
#line 2532 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_rip, sizeof(struct rip_proto_config), (yyvsp[(1) - (2)].i));
     rip_init_config(RIP_CFG);
   }
    break;

  case 616:
/* Line 1787 of yacc.c  */
#line 2541 "cf-parse.y"
    { RIP_CFG->infinity = (yyvsp[(3) - (4)].i); }
    break;

  case 617:
/* Line 1787 of yacc.c  */
#line 2542 "cf-parse.y"
    { RIP_CFG->port = (yyvsp[(3) - (4)].i); }
    break;

  case 618:
/* Line 1787 of yacc.c  */
#line 2543 "cf-parse.y"
    { RIP_CFG->period = (yyvsp[(3) - (4)].i); }
    break;

  case 619:
/* Line 1787 of yacc.c  */
#line 2544 "cf-parse.y"
    { RIP_CFG->garbage_time = (yyvsp[(4) - (5)].i); }
    break;

  case 620:
/* Line 1787 of yacc.c  */
#line 2545 "cf-parse.y"
    { RIP_CFG->timeout_time = (yyvsp[(4) - (5)].i); }
    break;

  case 621:
/* Line 1787 of yacc.c  */
#line 2546 "cf-parse.y"
    {RIP_CFG->authtype = (yyvsp[(3) - (4)].i); }
    break;

  case 623:
/* Line 1787 of yacc.c  */
#line 2548 "cf-parse.y"
    { RIP_CFG->honor = HO_ALWAYS; }
    break;

  case 624:
/* Line 1787 of yacc.c  */
#line 2549 "cf-parse.y"
    { RIP_CFG->honor = HO_NEIGHBOR; }
    break;

  case 625:
/* Line 1787 of yacc.c  */
#line 2550 "cf-parse.y"
    { RIP_CFG->honor = HO_NEVER; }
    break;

  case 627:
/* Line 1787 of yacc.c  */
#line 2555 "cf-parse.y"
    { (yyval.i)=AT_PLAINTEXT; }
    break;

  case 628:
/* Line 1787 of yacc.c  */
#line 2556 "cf-parse.y"
    { (yyval.i)=AT_MD5; }
    break;

  case 629:
/* Line 1787 of yacc.c  */
#line 2557 "cf-parse.y"
    { (yyval.i)=AT_NONE; }
    break;

  case 630:
/* Line 1787 of yacc.c  */
#line 2562 "cf-parse.y"
    { (yyval.i)=IM_BROADCAST; }
    break;

  case 631:
/* Line 1787 of yacc.c  */
#line 2563 "cf-parse.y"
    { (yyval.i)=0; }
    break;

  case 632:
/* Line 1787 of yacc.c  */
#line 2564 "cf-parse.y"
    { (yyval.i)=IM_QUIET; }
    break;

  case 633:
/* Line 1787 of yacc.c  */
#line 2565 "cf-parse.y"
    { (yyval.i)=IM_NOLISTEN; }
    break;

  case 634:
/* Line 1787 of yacc.c  */
#line 2566 "cf-parse.y"
    { (yyval.i)=IM_VERSION1 | IM_BROADCAST; }
    break;

  case 636:
/* Line 1787 of yacc.c  */
#line 2570 "cf-parse.y"
    { RIP_IPATT->metric = (yyvsp[(2) - (2)].i); }
    break;

  case 637:
/* Line 1787 of yacc.c  */
#line 2571 "cf-parse.y"
    { RIP_IPATT->mode |= (yyvsp[(2) - (2)].i); }
    break;

  case 642:
/* Line 1787 of yacc.c  */
#line 2585 "cf-parse.y"
    {
     this_ipatt = cfg_allocz(sizeof(struct rip_patt));
     add_tail(&RIP_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
     RIP_IPATT->metric = 1;
   }
    break;

  case 644:
/* Line 1787 of yacc.c  */
#line 2601 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_static, sizeof(struct static_config), (yyvsp[(1) - (2)].i));
     static_init_config((struct static_config *) this_proto);
  }
    break;

  case 647:
/* Line 1787 of yacc.c  */
#line 2610 "cf-parse.y"
    { STATIC_CFG->check_link = (yyvsp[(4) - (5)].i); }
    break;

  case 648:
/* Line 1787 of yacc.c  */
#line 2611 "cf-parse.y"
    { STATIC_CFG->igp_table = (yyvsp[(4) - (5)].r); }
    break;

  case 650:
/* Line 1787 of yacc.c  */
#line 2615 "cf-parse.y"
    {
     this_srt = cfg_allocz(sizeof(struct static_route));
     add_tail(&STATIC_CFG->other_routes, &this_srt->n);
     this_srt->net = (yyvsp[(2) - (2)].px).addr;
     this_srt->masklen = (yyvsp[(2) - (2)].px).len;
  }
    break;

  case 651:
/* Line 1787 of yacc.c  */
#line 2624 "cf-parse.y"
    {
     last_srt_nh = this_srt_nh;
     this_srt_nh = cfg_allocz(sizeof(struct static_route));
     this_srt_nh->dest = RTD_NONE;
     this_srt_nh->via = (yyvsp[(2) - (3)].a);
     this_srt_nh->via_if = (yyvsp[(3) - (3)].iface);
     this_srt_nh->if_name = (void *) this_srt; /* really */
   }
    break;

  case 652:
/* Line 1787 of yacc.c  */
#line 2632 "cf-parse.y"
    {
     this_srt_nh->masklen = (yyvsp[(3) - (3)].i) - 1; /* really */
     if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>256)) cf_error("Weight must be in range 1-256"); 
   }
    break;

  case 653:
/* Line 1787 of yacc.c  */
#line 2639 "cf-parse.y"
    { this_srt->mp_next = this_srt_nh; }
    break;

  case 654:
/* Line 1787 of yacc.c  */
#line 2640 "cf-parse.y"
    { last_srt_nh->mp_next = this_srt_nh; }
    break;

  case 655:
/* Line 1787 of yacc.c  */
#line 2644 "cf-parse.y"
    {
      this_srt->dest = RTD_ROUTER;
      this_srt->via = (yyvsp[(3) - (4)].a);
      this_srt->via_if = (yyvsp[(4) - (4)].iface);
   }
    break;

  case 656:
/* Line 1787 of yacc.c  */
#line 2649 "cf-parse.y"
    {
      this_srt->dest = RTD_DEVICE;
      this_srt->if_name = (yyvsp[(3) - (3)].t);
      rem_node(&this_srt->n);
      add_tail(&STATIC_CFG->iface_routes, &this_srt->n);
   }
    break;

  case 657:
/* Line 1787 of yacc.c  */
#line 2655 "cf-parse.y"
    {
      this_srt->dest = RTD_MULTIPATH;
   }
    break;

  case 658:
/* Line 1787 of yacc.c  */
#line 2658 "cf-parse.y"
    {
      this_srt->dest = RTDX_RECURSIVE;
      this_srt->via = (yyvsp[(3) - (3)].a);
   }
    break;

  case 659:
/* Line 1787 of yacc.c  */
#line 2663 "cf-parse.y"
    { this_srt->dest = RTD_BLACKHOLE; }
    break;

  case 660:
/* Line 1787 of yacc.c  */
#line 2664 "cf-parse.y"
    { this_srt->dest = RTD_UNREACHABLE; }
    break;

  case 661:
/* Line 1787 of yacc.c  */
#line 2665 "cf-parse.y"
    { this_srt->dest = RTD_BLACKHOLE; }
    break;

  case 662:
/* Line 1787 of yacc.c  */
#line 2666 "cf-parse.y"
    { this_srt->dest = RTD_UNREACHABLE; }
    break;

  case 663:
/* Line 1787 of yacc.c  */
#line 2667 "cf-parse.y"
    { this_srt->dest = RTD_PROHIBIT; }
    break;

  case 664:
/* Line 1787 of yacc.c  */
#line 2671 "cf-parse.y"
    { static_show(proto_get_named((yyvsp[(3) - (4)].s), &proto_static)); }
    break;

  case 726:
/* Line 1787 of yacc.c  */
#line 2679 "cf-parse.y"
    { bgp_check_config(BGP_CFG); }
    break;

  case 727:
/* Line 1787 of yacc.c  */
#line 2679 "cf-parse.y"
    { ospf_proto_finish(); }
    break;

  case 729:
/* Line 1787 of yacc.c  */
#line 2679 "cf-parse.y"
    { RIP_CFG->passwords = get_passwords(); }
    break;

  case 738:
/* Line 1787 of yacc.c  */
#line 2682 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_SOURCE); }
    break;

  case 739:
/* Line 1787 of yacc.c  */
#line 2682 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_METRIC); }
    break;

  case 740:
/* Line 1787 of yacc.c  */
#line 2682 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_KRT_PREFSRC); }
    break;

  case 741:
/* Line 1787 of yacc.c  */
#line 2682 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REALM); }
    break;

  case 742:
/* Line 1787 of yacc.c  */
#line 2683 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_GEN_IGP_METRIC); }
    break;

  case 743:
/* Line 1787 of yacc.c  */
#line 2683 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 744:
/* Line 1787 of yacc.c  */
#line 2684 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_BGP_ORIGIN, EA_CODE(EAP_BGP, BA_ORIGIN)); }
    break;

  case 745:
/* Line 1787 of yacc.c  */
#line 2685 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_AS_PATH, T_PATH, EA_CODE(EAP_BGP, BA_AS_PATH)); }
    break;

  case 746:
/* Line 1787 of yacc.c  */
#line 2686 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_CODE(EAP_BGP, BA_NEXT_HOP)); }
    break;

  case 747:
/* Line 1787 of yacc.c  */
#line 2687 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_MULTI_EXIT_DISC)); }
    break;

  case 748:
/* Line 1787 of yacc.c  */
#line 2688 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_LOCAL_PREF)); }
    break;

  case 749:
/* Line 1787 of yacc.c  */
#line 2689 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(EAP_BGP, BA_ATOMIC_AGGR)); }
    break;

  case 750:
/* Line 1787 of yacc.c  */
#line 2690 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_AGGREGATOR)); }
    break;

  case 751:
/* Line 1787 of yacc.c  */
#line 2691 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_COMMUNITY)); }
    break;

  case 752:
/* Line 1787 of yacc.c  */
#line 2692 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID, T_QUAD, EA_CODE(EAP_BGP, BA_ORIGINATOR_ID)); }
    break;

  case 753:
/* Line 1787 of yacc.c  */
#line 2693 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_CLUSTER_LIST)); }
    break;

  case 754:
/* Line 1787 of yacc.c  */
#line 2694 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_EC_SET, T_ECLIST, EA_CODE(EAP_BGP, BA_EXT_COMMUNITY)); }
    break;

  case 755:
/* Line 1787 of yacc.c  */
#line 2694 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC1); }
    break;

  case 756:
/* Line 1787 of yacc.c  */
#line 2694 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC2); }
    break;

  case 757:
/* Line 1787 of yacc.c  */
#line 2694 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_TAG); }
    break;

  case 758:
/* Line 1787 of yacc.c  */
#line 2694 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID | EAF_TEMP, T_QUAD, EA_OSPF_ROUTER_ID); }
    break;

  case 759:
/* Line 1787 of yacc.c  */
#line 2694 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_METRIC); }
    break;

  case 760:
/* Line 1787 of yacc.c  */
#line 2694 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_TAG); }
    break;


/* Line 1787 of yacc.c  */
#line 8091 "cf-parse.tab.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


/* Line 2048 of yacc.c  */
#line 2696 "cf-parse.y"

/* C Code from ../../conf/confbase.Y */

/* C Code from ../../sysdep/unix/config.Y */

/* C Code from ../../sysdep/unix/krt.Y */

/* C Code from ../../sysdep/linux/netlink.Y */

/* C Code from ../../nest/config.Y */

/* C Code from ../../proto/bgp/config.Y */

/* C Code from ../../proto/ospf/config.Y */

/* C Code from ../../proto/pipe/config.Y */

/* C Code from ../../proto/rip/config.Y */

/* C Code from ../../proto/static/config.Y */


